/* Programme de cration de personnage pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 8.2*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Fichier.h"
#include "Rand.h"
#include "Menu.h"
#include "Utilitaire.h"
#include "Jdr.h"
#include "Tri.h"

struct donnees_perso         /*Structure de donnes*/
{
    int av_pe;  //1 pour aventurier, 2 pour peuple
    int niveau_mini;
    int niveau_max;
    int niveau;
    int groupclas;
    int poids;
    int taille;
    int age;
    int cat_age;
    int alignement;
    int alignement_gen;
    int attaque;
    int bba;
    int JS_ref;
    int JS_vig;
    int JS_vol;
    int des_PV;
    int PV;
    int DV[3];  /*Le tableau des DV prend nombre de ds et nombre de face et bonus au pv*/
    int armure;
    int bouclier;
    int arme1;
    int arme2;
    int arme3;
    int XP;
    int grimoire; //Indique si grimoire doit tre cr
    int don[51];
    int competences[51];
    int nivo_competences[50];
    int caracteristique[6];
    int bonus_carac[6];
    int langue[20];
    char race[50];
    char race_nom[50]; /*Type de race  utiliser pour tirer le nom*/
    char classe[50];
    char profession[50];
    char sexe[20];
    char nom[255];
    char vision[100];
    char cat_taille[10];
    char compagnon[255];
    char chemin_perso[255];
    char arg_don[50][100];
    char arg_competences[50][100];
    char IMC[50];
    char dossier_pr[255];
    char dossier_sec[255];
};

struct donnees_sorts         /*Structure de donnes de sorts*/
{
    FILE* Fichier_sorts;
    FILE* Fichier_nb;
    int carac;
    int nbsortM[10];
    int nbsortC[10];
    int indextab[11];
    int *liste_sorts;
    char spe[50];
    char type[100];
    char type_perso[100];
    char domaine1[255];
    char domaine2[255];
    char interdit1[50];
    char interdit2[50];
    char nomfichier[255];
};

void pds_tail_age (struct donnees_perso *donnees);       /*Dtermine le poids, la taille et l'ge en fonction de la classe, la race et le sexe*/
void carac (struct donnees_perso *donnees);     /*Tire des carac puis les tries, stocke dans un tableau*/
void niveau (struct donnees_perso *donnees);  /*dtermine alatoirement le niveau*/
int PNJ_gen (struct donnees_perso *donnees, struct donnees_sorts *Dsorts);      /*Base du programme de gnration alatoire de personnage*/
void interpreteur_principal (struct donnees_perso *donnees, struct donnees_sorts *Dsorts);     /*Lit les fichiers de classe et de race*/
void calcul_pv (struct donnees_perso *donnees);    /*Calcul le nb de pv*/
void afficheur_txt(struct donnees_perso *donnees);  /*Affiche la feuille de personnage au format txt*/
int afficheur_html (struct donnees_perso *donnees, int indic);  /*Convertit le txt en html*/
char* string (struct donnees_perso *donnees, const char *type, int i, char* chaine);   /*Fait correspondre  chaque numro l'affichage exact*/
void Trait_physique (FILE* Fichier_txt, struct donnees_perso *donnees);    /*Dtermine les traits physiques du personnage et les inscrit dans le fichier texte*/
void calcul_XP(struct donnees_perso *donnees);  /*Calcul l'exprience rapport par le personnage*/
void Grimoire (struct donnees_perso *donnees, struct donnees_sorts *Dsorts);  /*Moteur principal de la gestion des sorts*/

void Criminel (struct donnees_perso *donnees, struct donnees_sorts *Dsorts, int choix);      /*Base du programme de cration de liste de Criminel*/
void increment_fichier (char* nom);     /*Incrmente le nom du dossier de criminels*/

void gen_population (struct donnees_perso *donnees, struct donnees_sorts *Dsorts, int choix); /*Moteur principal pour la gnration de population*/
void profession (struct donnees_perso *donnees, int type_pop);  /*Tire une profession alatoire et indique si c'est un aventurier*/

int verif_val_gen_alea (int* index, char* ligne, int alea);  /*gen_alea, dtermine si la ligne actuelle est celle correspondant au jet de d*/
int jet_de_des_gen_alea (int* index, char* ligne);       /*gen_alea, Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
char* string_gen_alea (int index, char* ligne); /*gen_alea, Affiche le rsultat*/
char* gen_alea (const char* nomfichier, char* ligne);      /*Appel le gen alea en ligne de commande*/

int main (int argc,char *argv[])
{
    Init_srand();   /*Init rand*/
    init_historique_saisie();
    struct donnees_perso donnees;
    struct donnees_sorts Dsorts;
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Cration de personnages","Programme de cration de personnages pour Donjons et dragons",color_sd("Creation de personnages",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    PNJ_gen(&donnees,&Dsorts);
    return 0;
}

int PNJ_gen (struct donnees_perso *donnees, struct donnees_sorts *Dsorts)
{
    FILE* fichier;
    FILE* fichiertxt;
    int i,nb_lance;
    int choix;
    char temp[10];
    char nomfichier[255];
    char chaine[255];
    char cpyniv[10];
    char cpyclasse[50];
    char cpyrace[50];
    char cpysexe[20];
    do
    {
        donnees->av_pe = 1;  //Par dfaut, aventurier
        donnees->dossier_pr[0] = '\0';  //Par dfaut, pas de dossier principal et secondaire
        donnees->dossier_sec[0] = '\0';
        putsacc("Cration de personnage:\n");
        putsacc("1) Personnage alatoire\n");
        puts("2) Choisir type de personnage");
        putsacc("3) Gnrateur de classe du peuple\n");
        puts("-");
        putsacc("4) Gnrer une nouvelle liste de criminels\n");
        putsacc("5) Reprendre la cration des criminels (En cas de bug)\n");
        puts("-");
        putsacc("6) Gnrer une nouvelle population (ville)\n");
        putsacc("7) Gnrer une nouvelle population (village)\n");
        putsacc("8) Reprendre la cration de la population (En cas de bug ou de modification)\n");
        choix = 0;
        while (choix == 0) /*Scurit erreur de saisi*/
        {
            printf("?: ");
            choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
                exit(0);
            switch (choix)
            {
                case 1:
                    strcpy(donnees->classe,"AleaA");
                    strcpy(donnees->race,"Alea");
                    strcpy(donnees->sexe,"Alea");
                    strcpy(temp,"1-25");
                    break;
                case 2: //Cration de personnage aventurier avec choix
                case 3: //Classe de peuple
                    if(choix == 2)  //Aventurier
                        strcpy(donnees->classe,Menu("Menu_classe.ini",chfunc,1,0));    /*Appel du menu de classe*/
                    if(choix == 3)  //Peuple
                    {
                        donnees->av_pe = 2;  //Mode peuple
                        strcpy(donnees->classe,Menu("Professions.ini",chfunc,1,0));    /*Appel du menu de classe de peuple*/
                    }
                    strcpy(temp,Menu("..\\Donnes\\Menu_niveau.ini",chfunc,1,0));    /*Appel du menu de niveau*/
                    if (!strcmp("Choix",temp))    /*Choix du niveau*/
                    {
                        do
                        {    /*Bcl erreur de saisie*/
                            putsacc("Choisit le niveau exact du personnage: ");
                            donnees->niveau = (int) interpret_calc("\0");
                        } while (donnees->niveau == NA || donnees->niveau == defo);
                    }
                    if (!strcmp("Tranche",temp))    /*Choix d'une tranche de niveaux*/
                    {
                        do
                        {    /*Bcl erreur de saisie*/
                            putsacc("Choisit le niveau minimum du personnage: ");
                            donnees->niveau_mini = (int) interpret_calc("\0");
                        } while (donnees->niveau_mini == NA || donnees->niveau_mini == defo);
                        do
                        {    /*Bcl erreur de saisie*/
                            putsacc("Choisit le niveau maximum du personnage: ");
                            donnees->niveau_max = (int) interpret_calc("\0");
                        } while (donnees->niveau_max == NA || donnees->niveau_max == defo);
                    }
                    strcpy(donnees->race,Menu("..\\Donnes\\Menu_race.ini",chfunc,1,0));    /*Appel du menu de race*/
                    strcpy(donnees->sexe,Menu("..\\Donnes\\Menu_sexe.ini",chfunc,1,0));    /*Appel du menu de sexe*/
                    break;
                case 4:
                case 5:
                    Criminel(donnees,Dsorts,choix);  //Lance le gnrateur de criminel
                    choix = -1;
                    break;
                case 6:
                case 7:
                case 8:
                    gen_population(donnees,Dsorts,choix);  //Lance le gnrateur de population
                    choix = -1;
                    break;
                default:
                    choix = 0;
            }
        }
        if(choix > 0)   //Criminel et population fixe choix  -1 pour sauter cette partie
        {
            strcpy(cpyniv,temp);
            strcpy(cpyclasse,donnees->classe);
            strcpy(cpyrace,donnees->race);
            strcpy(cpysexe,donnees->sexe);
            do
            {    /*Bcl erreur de saisie*/
                putsacc("Nombre de personnage identique  tirer: ");
                nb_lance = (int) interpret_calc("\0");
            } while (nb_lance == NA || nb_lance == defo);
            puts("");
            for(;nb_lance>0;nb_lance--)
            {
                strcpy(donnees->compagnon,"0");
                strcpy(temp,cpyniv);
                strcpy(donnees->classe,cpyclasse);
                strcpy(donnees->race,cpyrace);
                strcpy(donnees->sexe,cpysexe);
                /*Initialisation des tableaux d'entiers*/
                for(i=0;i<20;i++)
                    donnees->langue[i] = 0;
                for(i=0;i<50;i++)
                    donnees->don[i] = 0;
                for(i=0;i<50;i++)
                    donnees->competences[i] = 0;
                for(i=0;i<50;i++)
                    donnees->nivo_competences[i] = 0;
                /*Initialisation des tableaux pour les sorts*/
                donnees->grimoire = 0;
                for(i=0;i<11;i++)
                    Dsorts->indextab[i] = 0;
                for(i=0;i<10;i++)
                    Dsorts->nbsortC[i] = 0;
                for(i=0;i<10;i++)
                    Dsorts->nbsortM[i] = 0;
                /*Initialisation du tableau d'arguments des comptences et dons*/
                for(i=0;i<50;i++)
                    strcpy(donnees->arg_competences[i],"\0");
                for(i=0;i<50;i++)
                    strcpy(donnees->arg_don[i],"\0");
                if (strcmp("Choix",temp))    /*Dtermination alatoire du niveau*/
                {
                    if (strcmp("Tranche",temp))
                    {    /*Saisi des mini et maxi du niveau*/
                        donnees->niveau_mini = atoi(temp);    /*Lecture du niveau mini*/
                        Efface_char(temp,"-");
                        donnees->niveau_max = atoi(temp);        /*Lecture du niveau maxi*/
                    }
                    niveau(donnees);        /*Dtermine le niveau alatoirement*/
                }
                if (!strcmp("AleaA",donnees->classe))    /*Dtermination alatoire de la classe pour les aventuriers*/
                    strcpy(donnees->classe,gen_alea("..\\Cration de personnages\\Classe.tbl",chaine));
                if (!strcmp("AleaP",donnees->classe))    /*Dtermination alatoire de la classe pour le peuple*/
                    strcpy(donnees->classe,gen_alea("..\\Cration de personnages\\Professions.tbl",chaine));
                if (!strcmp("Alea",donnees->race))    /*Dtermination alatoire de la race*/
                    strcpy(donnees->race,gen_alea("..\\Cration de personnages\\Race.tbl",chaine));
                if (!strcmp("Alea",donnees->sexe))    /*Dtermination alatoire du sexe*/
                    strcpy(donnees->sexe,gen_alea("..\\Donnes\\Sexe.tbl",chaine));
/*Debug*/
//printf("classe=%s.\n", donnees->classe);
//printf("Race=%s.\n", donnees->race);
//printf("Sexe=%s.\n", donnees->sexe);

                donnees->groupclas = donnees->classe[strlen(donnees->classe)-1]-48;    /*Lecture du groupe de classe et conversion ascii->decimal*/
                donnees->classe[strlen(donnees->classe)-2] = '\0';    /*Efface le groupe de classe*/
                carac(donnees);    /*Tire les carac*/
                pds_tail_age(donnees);    /*Dtermine poids, taille et age*/
                /*Lecture de la race pour les noms*/
                sprintf(nomfichier,"..\\Donnes\\Races\\%s.txt", donnees->race);
                fichier = ouvre_fichier(nomfichier,"r");
                fgets(nomfichier,255,fichier)
;
                Efface_char(nomfichier,":");
                strcpy(donnees->race_nom,nomfichier);
                Efface_n(donnees->race_nom);      //Retire le \n
                fclose(fichier);
                /*Gnration du nom par name_gen en ligne de commande*/
                #ifdef WIN32    /*win*/
                    sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=2 Affichage=3", donnees->race_nom, donnees->sexe);
                #else /*linux*/
                    sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=2 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                #endif
                system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                fgets(chaine,255,fichier);
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
                sprintf(donnees->nom,"%s ", chaine); /*Copie le prnom*/
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
                strcat(donnees->nom,chaine); /*Copie le nom*/
                fclose(fichier);
                interpreteur_principal(donnees,Dsorts);    /*Gnre les donnes du personnage*/
                afficheur_txt(donnees);    /*Affiche le personnage*/
                putsacc("Personnage cre: ");
                putsacc(donnees->classe);
                printf(" niv.%d", donnees->niveau);
                if(donnees->grimoire == 1)
                {
                    Grimoire(donnees,Dsorts);   /*Gnre un grimoire pour le personnage*/
                    //Ajout des composantes  l'quipement
                    fichier = ouvre_fichier("..\\Grimoire\\Composantes.txt","r");
                    fichiertxt = ouvre_fichier(donnees->chemin_perso,"a+"); //Ouvre la feuille de perso par la fin
                    while(fgets(chaine,255,fichier) != NULL)
                        fprintf(fichiertxt,"%s",chaine);
                    fprintf(fichiertxt,">\n");
                    fclose(fichier);
                    fclose(fichiertxt);
                    putsacc(", + grimoire");
                }
                if(donnees->compagnon[0] != '0')    /*Un compagnon doit tre cr*/
                {
                    #ifdef WIN32    /*win*/
                        sprintf(chaine,"cd \"..\\Cratures\" && \"Generateur_de_creatures.exe\" perso=\"%s\" %s Affichage=3", donnees->chemin_perso, donnees->compagnon);
                    #else /*linux*/
                        sprintf(chaine,"cd \"../%s\" && \"./Generateur_de_creatures\" perso=\"%s\" %s Affichage=3", acc("Cratures",chfunc), donnees->chemin_perso, donnees->compagnon);
                    #endif
                    system(chaine);     /*Appelle le gnrateur de crature*/
                    putsacc(", + compagnon");
                }
                if(donnees->av_pe == 1)  //Seul les aventuriers bnficie de la feuille html
                    afficheur_html(donnees,0);
                putsacc(".\n\n");
            }
        }
    }while(1);
}

void Criminel (struct donnees_perso *donnees, struct donnees_sorts *Dsorts, int choix)
{
    FILE* fichier;
    FILE* fichiertxt;
    FILE* liste;
    FILE* liste_temp;
    FILE* fichier_format;
    int i, j, nb_lance, val, prime_b1, prime_b2;
    char chaine[255];
    char chaine2[255];
    int repart[50];
    switch (choix)
    {
        case 4:
            strcpy(donnees->dossier_pr,"Criminels");
            increment_fichier(donnees->dossier_pr);    /*Incrmente le nom du dossier*/
            #ifdef WIN32    /*win*/
            sprintf(chaine,"mkdir \"..\\Z Fichiers cres\\%s\"", donnees->dossier_pr);   /*Construit la commande de cration du dossier*/
            #else /*linux*/
            sprintf(chaine,"mkdir \"..\\Z Fichiers %s\\%s\"", acc("cres",chfunc), donnees->dossier_pr);   /*Construit la commande de cration du dossier*/
            #endif
            changeslash(chaine);    //Inerse les slash pour linux (le cas chant)
            system(chaine);
            #ifdef WIN32    /*win*/
            sprintf(chaine,"..\\Z Fichiers cres\\%s\\Liste des criminels recherchs.txt", donnees->dossier_pr);
            #else /*linux*/
            sprintf(chaine,"..\\Z Fichiers %s\\%s\\Liste des criminels %s.txt", acc("cres",chfunc),donnees->dossier_pr, acc("recherchs",chaine2));
            #endif
            liste = ouvre_fichier(chaine,"w");
            do
            {    /*Bcl erreur de saisie*/
                printf("Nombre de criminels:  ");
                nb_lance = (int) interpret_calc("\0");
            }while (nb_lance == NA || nb_lance == defo);
            for(i=0;i<50;i++)
                repart[i] = 0;
            i=0;
            fichier_format = ouvre_fichier("Format liste.txt","r");
            fgets(chaine,255,fichier_format);
            fgets(chaine,255,fichier_format);
            Efface_char(chaine,":");
            do
            {
                repart[i++] = atoi(chaine);
                if(strstr(chaine,",") != NULL)   /*Si il y a d'autre catgories*/
                    Efface_char(chaine,",");
                else
                    break;
            }while(1);
            val = i;    /*Val prend le nombre de catgories diffrentes*/
            for(j=0,i=0;i<val;i++)
                j += repart[i];
            if (j > 100)
            {
                puts("Erreur de rpartition des catgories, suprieur  100%%\n");
                Pause();
                exit(0);
            }
            for(i=0;i<val;i++)
                repart[i] = (int) floor(nb_lance * repart[i] /100);    /*Prend le pourcentage du nombre total de valeur*/
            for(j=0,i=0;i<val;i++)   /*Rutilise 'cent' pour calculer le nombre de points distribus*/
                j += repart[i];
            if(j < nb_lance)
                repart[0] += nb_lance - j;   /*Rajoute les points manquants dans la 1ere catgorie*/
            liste_temp = ouvre_fichier("Liste criminels.txt","w");
            putsacc("Cration de liste en cours...\n");
            for(i=0;i<val;i++)
            {
                fgets(chaine,255,fichier_format);
                Efface_char(chaine,":");
                j=0;
                do
                {      /*Lit le dossier secondaire*/
                    donnees->dossier_sec[j] = chaine[j];
                    j++;
                }while(chaine[j] != ':');
                donnees->dossier_sec[j] = '\0';  /*Termine la chaine*/
                fprintf(liste,"\n%s:\n", donnees->dossier_sec);
                Efface_char(chaine,"=");
                donnees->niveau_mini = atoi(chaine);
                Efface_char(chaine,"-");
                donnees->niveau_max = atoi(chaine);
                Efface_char(chaine,"=");
                prime_b1 = atoi(chaine);
                Efface_char(chaine,"-");
                prime_b2 = atoi(chaine);
                #ifdef WIN32    /*win*/
                sprintf(chaine,"mkdir \"..\\Z Fichiers cres\\%s\\%s\"", donnees->dossier_pr, donnees->dossier_sec);   /*Construit la commande de cration du dossier*/
                #else /*linux*/
                sprintf(chaine,"mkdir \"..\\Z Fichiers %s\\%s\\%s\"", acc("cres",chfunc), donnees->dossier_pr, donnees->dossier_sec);   /*Construit la commande de cration du dossier*/
                #endif
                changeslash(chaine);    //Inerse les slash pour linux (le cas chant)
                system(chaine);
                for(j=0;j<repart[i];j++)
                {
                    strcpy(donnees->classe,gen_alea("..\\Cration de personnages\\Classe criminels.tbl",chaine2));
                    strcpy(donnees->race,gen_alea("..\\Cration de personnages\\Race criminels.tbl",chaine2));
                    sprintf(chaine,"..\\Donnes\\Races\\%s.txt", donnees->race);
                    fichier = ouvre_fichier(chaine,"r");
                    /*Lecture de la race pour les noms*/
                    fgets(chaine,255,fichier);
                    Efface_char(chaine,":");
                    strcpy(donnees->race_nom,chaine);
                    Efface_n(donnees->race_nom);      //Retire le \n
                    fclose(fichier);
                    strcpy(donnees->sexe,gen_alea("..\\Donnes\\Sexe.tbl",chaine2));
                    /*Gnration du nom par name_gen en ligne de commande*/
                    #ifdef WIN32    /*win*/
                        sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=2 Affichage=3", donnees->race_nom, donnees->sexe);
                    #else /*linux*/
                        sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=2 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                    #endif
                    system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                    fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                    fgets(chaine,255,fichier);
                    fgets(chaine,255,fichier);
                    Efface_n(chaine);      //Retire le \n
                    sprintf(donnees->nom,"%s ", chaine); /*Copie le prnom*/
                    fgets(chaine,255,fichier);
                    Efface_n(chaine);      //Retire le \n
                    strcat(donnees->nom,chaine); /*Copie le nom*/
                    fclose(fichier);
                    niveau(donnees);        /*Dtermine le niveau alatoirement*/
                    fprintf(liste_temp,"%s:%s:%s:%s:%s:%s:lvl%d\n", donnees->dossier_pr, donnees->dossier_sec, donnees->classe, donnees->nom, donnees->race, donnees->sexe, donnees->niveau);
                    donnees->classe[strlen(donnees->classe)-2] = '\0';    /*Efface le groupe de classe*/
                    fprintf(liste,"%s, %s\t\t-> %dpo\n", donnees->nom, donnees->classe, NbAlea2b(prime_b1,prime_b2));
                    printf("%s\n", acc(donnees->classe,chfunc));
                }
            }
            fichier = ouvre_fichier("Format liste.txt","r+");
            fprintf(fichier,"Liste:0aaaaaaaaa");
            fclose(fichier);
            fclose(liste);
            fclose(liste_temp);
            putsacc("Liste de personnages cre.\n\n");
        case 5:
            liste_temp = ouvre_fichier("Liste criminels.txt","r");
            fichier = ouvre_fichier("Format liste.txt","r+");
            fgets(chaine,255,fichier);
            Efface_char(chaine,":");
            j = atoi(chaine);       /*Lit le nombre de perso dj cres*/
            fclose(fichier);
            for(i=0;i<j;i++)    /*Saute les persos dj cres*/
                fgets(chaine,255,liste_temp);
            while(!feof(liste_temp))
            {
                if(fgets(chaine,255,liste_temp)) /*Evite de rpter la dernire ligne*/
                {
                    j++;
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->dossier_pr[i] = chaine[i];    /*Copie le nom du dossier principal*/
                        i++;
                    }
                    donnees->dossier_pr[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->dossier_sec[i] = chaine[i];    /*Copie le nom du dossier secondaire*/
                        i++;
                    }
                    donnees->dossier_sec[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->classe[i] = chaine[i];    /*Copie la classe du perso*/
                        i++;
                    }
                    donnees->classe[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->nom[i] = chaine[i];    /*Copie le nom du perso*/
                        i++;
                    }
                    donnees->nom[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->race[i] = chaine[i];    /*Copie la race du perso*/
                        i++;
                    }
                    donnees->race[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->sexe[i] = chaine[i];    /*Copie le sexe du perso*/
                        i++;
                    }
                    donnees->sexe[i] = '\0';
                    Efface_char(chaine,":lvl");
                    donnees->niveau = atoi(chaine);    /*Lit le niveau du personnage*/
                    donnees->groupclas = donnees->classe[strlen(donnees->classe)-1]-48;    /*Lecture du groupe de classe et conversion ascii->decimal*/
                    donnees->classe[strlen(donnees->classe)-2] = '\0';    /*Efface le groupe de classe*/
                    /*Initialisation du tableau d'entiers*/
                    donnees->grimoire = 0;
                    strcpy(donnees->compagnon,"0");
                    for(i=0;i<20;i++)
                        donnees->langue[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->don[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->competences[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->nivo_competences[i] = 0;
                    /*Initialisation du tableau d'arguments*/
                    for(i=0;i<50;i++)
                        strcpy(donnees->arg_competences[i],"\0");
                    for(i=0;i<50;i++)
                        strcpy(donnees->arg_don[i],"\0");
/*debug*/
//printf("classe=%s.\n", donnees->classe);
//printf("race=%s.\n", donnees->race);
//printf("sexe=%s.\n", donnees->sexe);
                    carac(donnees);    /*Tire les carac*/
                    pds_tail_age(donnees);    /*Dtermine poids, taille et age*/
                    interpreteur_principal(donnees,Dsorts);    /*Gnre les donnes du personnage*/
                    afficheur_txt(donnees);    /*Affiche le personnage*/
                    putsacc("Personnage cre: ");
                    putsacc(donnees->classe);
                    if(donnees->grimoire == 1)
                    {
                        Grimoire(donnees,Dsorts);   /*Gnre un grimoire pour le personnage*/
                        //Ajout des composantes  l'quipement
                        fichier = ouvre_fichier("..\\Grimoire\\Composantes.txt","r");
                        fichiertxt = ouvre_fichier(donnees->chemin_perso,"a+"); //Ouvre la feuille de perso par la fin
                        while(fgets(chaine,255,fichier) != NULL)
                            fprintf(fichiertxt,"%s",chaine);
                        fprintf(fichiertxt,">\n");
                        fclose(fichier);
                        fclose(fichiertxt);
                        putsacc(", + grimoire");
                    }
                    if(donnees->compagnon[0] != '0')    /*Un compagnon doit tre cr*/
                    {
                        #ifdef WIN32    /*win*/
                            sprintf(chaine,"cd \"..\\Cratures\" && \"Generateur_de_creatures.exe\" perso=\"%s\" %s Affichage=3", donnees->chemin_perso, donnees->compagnon);
                        #else /*linux*/
                            sprintf(chaine,"cd \"../%s\" && \"./Generateur_de_creatures\" perso=\"%s\" %s Affichage=3", acc("Cratures",chfunc), donnees->chemin_perso, donnees->compagnon);
                        #endif
                        system(chaine);     /*Appelle le gnrateur de crature*/
                        putsacc(", + compagnon");
                    }
                    if(donnees->av_pe == 1)  //Seul les aventuriers bnficie de la feuille html
                        afficheur_html(donnees,0);
                    fichier = ouvre_fichier("Format liste.txt","r+");
                    fseek(fichier,6,0);  /*Dplace le curseur */
                    fprintf(fichier,"%daaaaa",j);          /* et incrmente le nombre de perso cres*/
                    fclose(fichier);
                    putsacc(".\n");
                }
            }
            fclose(liste_temp);
            break;
        default:
            choix = 0;
    }
    putsacc("\nCration de la liste de criminel acheve.\n\n");
    fichier = ouvre_fichier("Format liste.txt","r+");
    fprintf(fichier,"Liste:0aaaaaaaaa");
    fclose(fichier);
}

void gen_population (struct donnees_perso *donnees, struct donnees_sorts *Dsorts, int choix)
{
    FILE* fichier;
    FILE* fichiertxt;
    FILE* liste1;
    FILE* liste2;
    FILE* liste_temp;
    int i, j, nb_lance, cent=100, val, nbnom, type_pop;
    char chaine[255];
    char nom_famille[100];
    int repart[50];
    char repart_race[50][50];
    type_pop = 0;
    switch (choix)
    {
        case 6:
            type_pop = 1;   /*type_pop  1 indique une population de village, si = 2, indique une population de ville*/
        case 7:
            type_pop++; /*Si case 7, type_pop passe  1, si case 1, type_pop passe  2*/
            strcpy(donnees->dossier_pr,"Population");
            increment_fichier(donnees->dossier_pr);    /*Incrmente le nom du dossier*/
            #ifdef WIN32    /*win*/
            sprintf(chaine,"mkdir \"..\\Z Fichiers cres\\%s\"", donnees->dossier_pr);   /*Construit la commande de cration du dossier*/
            #else /*linux*/
            sprintf(chaine,"mkdir \"..\\Z Fichiers %s\\%s\"", acc("cres",chfunc), donnees->dossier_pr);   /*Construit la commande de cration du dossier*/
            #endif
            changeslash(chaine);    //Inerse les slash pour linux (le cas chant)
            system(chaine);
            sprintf(chaine,"..\\Z Fichiers cres\\%s\\Liste pop1.txt", donnees->dossier_pr);
            liste1 = ouvre_fichier(chaine,"w");
            sprintf(chaine,"..\\Z Fichiers cres\\%s\\Liste pop2.txt", donnees->dossier_pr);
            liste2 = ouvre_fichier(chaine,"w");
            fclose(liste1);
            fclose(liste2);
            do
            {    /*Bcl erreur de saisie*/
                printf("Nombre de personnes:  ");
                nb_lance = (int) interpret_calc("\0");
            } while (nb_lance == NA || nb_lance == defo);
            strcpy(chaine,Menu("Menu_alignement.ini",chfunc,1,0));
            donnees->alignement_gen = atoi(chaine);  /*Dtermine l'alignement gnral de la population*/
            for(i=0;i<50;i++)
                repart[i] = 0;
            i=0;
            do
            {
                strcpy(repart_race[i],Menu("..\\Donnes\\Menu_race.ini",chfunc,1,0));
                printf("Quel pourcentage de la population avec cette race? (reste %d%%): ", cent);
                val = (int) interpret_calc("\0");
                if (val > cent)
                {
                    puts("La valeur est trop grande!");
                }
                else
                {
                    repart[i++] = val;
                    cent -= val;
                }
            }while(cent != 0);
            val = i;    /*Val prend le nombre de race diffrentes*/
            for(i=0;i<val;i++)
                repart[i] = (int) floor(nb_lance * repart[i] /100);    /*Prend le pourcentage du nombre total de valeur*/
            for(cent=0,i=0;i<val;i++)   /*Rutilise 'cent' pour calculer le nombre de points distribus*/
                cent += repart[i];
            if(cent < nb_lance)
                repart[0] += nb_lance - cent;   /*Rajoute les points manquants dans la 1ere catgorie*/
            liste_temp = ouvre_fichier("Liste population nt.txt","w");
            putsacc("Cration de liste en cours...\n");
            fprintf(liste_temp,"0.Alignement gnral:%d\n", donnees->alignement_gen);   /*Inscrit l'alignement gnral*/
            for(i=0;i<val;i++)
            {
                nbnom=0;
                for(j=0;j<repart[i];j++)
                {
                    strcpy(donnees->race,repart_race[i]);
                    if (!nbnom && strcmp(repart_race[i],"Alea")) /*si nbnom=0 et race n'est pas alea*/
                    {
                        strcpy(donnees->sexe,gen_alea("..\\Donnes\\Sexe.tbl",chaine));   /*Dtermine le sexe pour le nom de famille*/
                        nbnom = NbAlea1b(6);    //1  6 membres de la mme famille
                        sprintf(chaine,"..\\Donnes\\Races\\%s.txt", donnees->race);
                        fichier = ouvre_fichier(chaine,"r");
                        /*Lecture de la race pour les noms*/
                        fgets(chaine,255,fichier);
                        Efface_char(chaine,":");
                        strcpy(donnees->race_nom,chaine);
                        Efface_n(donnees->race_nom);      //Retire le \n
                        fclose(fichier);
                        //Tire un nom de famille en utilisant name_gen
                        #ifdef WIN32    /*win*/
                            sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", donnees->race_nom, donnees->sexe);
                        #else /*linux*/
                            sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                        #endif
                        system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                        fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                        fgets(chaine,255,fichier);
                        fgets(chaine,255,fichier);
                        Efface_n(chaine);      //Retire le \n
                        strcpy(nom_famille,chaine); /*Copie le nom de famille*/
                        fclose(fichier);
                    }
                    nbnom--;  /*Un membre de la famille tir...*/
                    profession(donnees,type_pop);
                    if (!strcmp(repart_race[i],"Alea"))    /*Si race alatoire*/
                    {
                        strcpy(donnees->race,gen_alea("..\\Cration de personnages\\Race.tbl",chaine));   /*Dtermine la race*/
                        strcpy(donnees->sexe,gen_alea("..\\Donnes\\Sexe.tbl",chaine));   /*Dtermine le sexe pour le nom de famille*/
                        sprintf(chaine,"..\\Donnes\\Races\\%s.txt", donnees->race);
                        fichier = ouvre_fichier(chaine,"r");
                        /*Lecture de la race pour les noms*/
                        fgets(chaine,255,fichier);
                        Efface_char(chaine,":");
                        strcpy(donnees->race_nom,chaine);
                        Efface_n(donnees->race_nom);      //Retire le \n
                        fclose(fichier);
                        //Tire un nom de famille en utilisant name_gen
                        #ifdef WIN32    /*win*/
                            sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", donnees->race_nom, donnees->sexe);
                        #else /*linux*/
                            sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                        #endif
                        system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                        fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                        fgets(chaine,255,fichier);
                        fgets(chaine,255,fichier);
                        Efface_n(chaine);      //Retire le \n
                        strcpy(nom_famille,chaine); /*Copie le nom de famille*/
                        fclose(fichier);
                    }
                    strcpy(donnees->sexe,gen_alea("..\\Donnes\\Sexe.tbl",chaine));
                    //Tire un prnom en utilisant name_gen
                    #ifdef WIN32    /*win*/
                        sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", donnees->race_nom, donnees->sexe);
                    #else /*linux*/
                        sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                    #endif
                    system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                    fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                    fgets(chaine,255,fichier);
                    fgets(chaine,255,fichier);
                    Efface_n(chaine);      //Retire le \n
                    strcpy(donnees->nom,chaine); /*Copie le prnom*/
                    fclose(fichier);
                    strcat(donnees->nom," ");
                    sprintf(chaine,"..\\Donnes\\Races\\%s.txt", donnees->race);
                    fichier = ouvre_fichier(chaine,"r");
                    /*Lecture de la race pour les noms*/
                    fgets(chaine,255,fichier);
                    Efface_char(chaine,":");
                    strcpy(donnees->race_nom,chaine);
                    Efface_n(donnees->race_nom);      //Retire le \n
                    fclose(fichier);
                    if(!strcmp(repart_race[i],"Alea") || donnees->av_pe == 1) /*Si race est alea ou si c'est un aventurier*/
                    {
                        //Tire un nouveau nom de famille en utilisant name_gen
                        #ifdef WIN32    /*win*/
                            sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", donnees->race_nom, donnees->sexe);
                        #else /*linux*/
                            sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"%s\" Sexe=\"%s\" Nombre=1 Affichage=3", acc("alatoires",chfunc), donnees->race_nom, donnees->sexe);
                        #endif
                        system(chaine); /*Appelle le name_gen en lui donnant les arguments ncessaires*/
                        fichier = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r");
                        fgets(chaine,255,fichier);
                        fgets(chaine,255,fichier);
                        Efface_n(chaine);      //Retire le \n
                        strcat(donnees->nom,chaine); /*Copie le nom de famille*/
                        fclose(fichier);
                    }
                    else
                        strcat(donnees->nom,nom_famille);  /*Sinon prend le nom de famille normal*/
                    niveau(donnees);        /*Dtermine le niveau alatoirement*/
                    fprintf(liste_temp,"%d:%s:%s:%s:%s:%s:%s:lvl%d\n", donnees->av_pe,donnees->dossier_pr, donnees->profession, donnees->classe, donnees->nom, donnees->race, donnees->sexe, donnees->niveau);
                    donnees->classe[strlen(donnees->classe)-2] = '\0';    /*Efface le groupe de classe*/
                    printf("%s lvl%d\n", acc(donnees->classe,chfunc), donnees->niveau);
                }
            }
            fichier = ouvre_fichier("Donnes.ini","r+");
            fprintf(fichier,"Liste:0aaaaaaaaa");
            fclose(fichier);
            fclose(liste_temp);
            system("sort \"Liste population nt.txt\" > \"Liste population.txt\"");
            fichier = ouvre_fichier("Donnes.ini","r+");
            fprintf(fichier,"Liste:0aaaaaaaaa");
            fclose(fichier);
            putsacc("Liste de personnages cre.\n\n");
            putsacc("1) Crer les personnages.\n");
            putsacc("2) Modififier la liste des personnages  crer\n");
            choix = 0;
            while (choix == 0) /*Scurit erreur de saisi*/
            {
                printf("?: ");
                choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
                if(choix == QUIT)
                    exit(0);
                switch (choix)
                {
                    case 1:
                        break;  /*Passe directement  la cration*/
                    case 2:
                        #ifdef WIN32    /*win*/
                            system("start notepad Liste population.txt");  /*Ouvre la liste*/
                        #else /*linux*/
                            putsacc("Vous pouvez  prsent modifier la liste des personnages,\n/Cration de personnages/Liste population.txt\n");
                            Pause();
                        #endif
                        exit(0);     /*Puis quitte*/
                        break;
                    default:
                        choix = 0;
                }
            }
        case 8:
            liste_temp = ouvre_fichier("Liste population.txt","r");
            fgets(chaine,255,liste_temp);
            Efface_char(chaine,":");
            donnees->alignement_gen = atoi(chaine);   /*Lit l'alignement gnral*/
            fichier = ouvre_fichier("Donnes.ini","r+");
            fgets(chaine,255,fichier);
            Efface_char(chaine,":");
            j = atoi(chaine);       /*Lit le nombre de perso dj cres*/
            fclose(fichier);
            for(i=0;i<j;i++)    /*Saute les persos dj cres*/
                fgets(chaine,255,liste_temp);
            while(!feof(liste_temp))
            {
                if(fgets(chaine,255,liste_temp)) /*Evite de rpter la dernire ligne*/
                {
                    j++;
                    i=0;
                    donnees->av_pe = atoi(chaine);   /*Lit l'indicateur peuple/aventurier*/
                    Efface_char(chaine,":");
                    while(chaine[i] != ':')
                    {
                        donnees->dossier_pr[i] = chaine[i];    /*Copie le nom du dossier*/
                        i++;
                    }
                    donnees->dossier_pr[i] = '\0';
                    Efface_char(chaine,":");
                    sprintf(nom_famille,"..\\Z Fichiers cres\\%s\\Liste pop1.txt", donnees->dossier_pr); /*Rutilise nom_famille comme chaine*/
                    liste1 = ouvre_fichier(nom_famille,"a+");
                    sprintf(nom_famille,"..\\Z Fichiers cres\\%s\\Liste pop2.txt", donnees->dossier_pr);
                    liste2 = ouvre_fichier(nom_famille,"a+");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->profession[i] = chaine[i];    /*Copie la profession du perso*/
                        i++;
                    }
                    donnees->profession[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->classe[i] = chaine[i];    /*Copie la classe du perso*/
                        i++;
                    }
                    donnees->classe[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->nom[i] = chaine[i];    /*Copie le nom du perso*/
                        i++;
                    }
                    donnees->nom[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->race[i] = chaine[i];    /*Copie la race du perso*/
                        i++;
                    }
                    donnees->race[i] = '\0';
                    Efface_char(chaine,":");
                    i=0;
                    while(chaine[i] != ':')
                    {
                        donnees->sexe[i] = chaine[i];    /*Copie le sexe du perso*/
                        i++;
                    }
                    donnees->sexe[i] = '\0';
                    Efface_char(chaine,":lvl");
                    donnees->niveau = atoi(chaine);    /*Lit le niveau du personnage*/
                    donnees->groupclas = donnees->classe[strlen(donnees->classe)-1]-48;    /*Lecture du groupe de classe et conversion ascii->decimal*/
                    donnees->classe[strlen(donnees->classe)-2] = '\0';    /*Efface le groupe de classe*/
                    strcpy(donnees->compagnon,"0");
                    /*Initialisation des tableaux d'entiers*/
                    for(i=0;i<20;i++)
                        donnees->langue[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->don[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->competences[i] = 0;
                    for(i=0;i<50;i++)
                        donnees->nivo_competences[i] = 0;
                    /*Initialisation des tableaux pour les sorts*/
                    donnees->grimoire = 0;
                    for(i=0;i<11;i++)
                        Dsorts->indextab[i] = 0;
                    for(i=0;i<10;i++)
                        Dsorts->nbsortC[i] = 0;
                    for(i=0;i<10;i++)
                        Dsorts->nbsortM[i] = 0;
                    /*Initialisation du tableau d'arguments des comptences et dons*/
                    for(i=0;i<50;i++)
                        strcpy(donnees->arg_competences[i],"\0");
                    for(i=0;i<50;i++)
                        strcpy(donnees->arg_don[i],"\0");
                    carac(donnees);    /*Tire les carac*/
                    pds_tail_age(donnees);    /*Dtermine poids, taille et age*/
                    interpreteur_principal(donnees,Dsorts);    /*Gnre les donnes du personnage*/
                    afficheur_txt(donnees);    /*Affiche le personnage*/
                    putsacc("Personnage cre: ");
                    putsacc(donnees->classe);
                    printf(" niv.%d", donnees->niveau);
                    if(donnees->grimoire == 1)
                    {
                        Grimoire(donnees,Dsorts);   /*Gnre un grimoire pour le personnage*/
                        //Ajout des composantes  l'quipement
                        fichier = ouvre_fichier("..\\Grimoire\\Composantes.txt","r");
                        fichiertxt = ouvre_fichier(donnees->chemin_perso,"a+"); //Ouvre la feuille de perso par la fin
                        while(fgets(chaine,255,fichier) != NULL)
                            fprintf(fichiertxt,"%s",chaine);
                        fprintf(fichiertxt,">\n");
                        fclose(fichier);
                        fclose(fichiertxt);
                        putsacc(", + grimoire");
                    }
                    if(donnees->compagnon[0] != '0')    /*Un compagnon doit tre cr*/
                    {
                        #ifdef WIN32    /*win*/
                            sprintf(chaine,"cd \"..\\Cratures\" && \"Generateur_de_creatures.exe\" perso=\"%s\" %s Affichage=3", donnees->chemin_perso, donnees->compagnon);
                        #else /*linux*/
                            sprintf(chaine,"cd \"../%s\" && \"./Generateur_de_creatures\" perso=\"%s\" %s Affichage=3", acc("Cratures",chfunc), donnees->chemin_perso, donnees->compagnon);
                        #endif
                        system(chaine);     /*Appelle le gnrateur de crature*/
                        putsacc(", + compagnon");
                    }
                    if(donnees->av_pe == 1)  //Seul les aventuriers bnficie de la feuille html
                        afficheur_html(donnees,0);
                    putsacc(".\n");
                    strcpy(chaine,donnees->nom);
                    Efface_char(chaine," ");    /*Isole le nom de famille*/
                    if (donnees->av_pe == 1)  /*Aventurier*/
                    {
                        fprintf(liste1,"%s, %s, %s lvl%d\n", donnees->profession, donnees->classe, donnees->nom, donnees->niveau);
                        fprintf(liste2,"Famille %s, %s, %s, %s lvl%d\n", chaine, donnees->profession, donnees->classe, donnees->nom, donnees->niveau);
                    }
                    else
                    {     /*Peuple*/
                        fprintf(liste1,"%s, %s lvl%d\n", donnees->profession, donnees->nom, donnees->niveau);
                        fprintf(liste2,"Famille %s, %s, %s lvl%d\n", chaine, donnees->profession, donnees->nom, donnees->niveau);
                    }
                    fclose(liste1);
                    fclose(liste2);
                    fichier = ouvre_fichier("Donnes.ini","r+");
                    fseek(fichier,6,0);  /*Dplace le curseur */
                    fprintf(fichier,"%daaaaa",j);          /* et incrmente le nombre de perso cres*/
                    fclose(fichier);
                }
            }
            fclose(liste_temp);
            break;
        default:
            choix = 0;
    }
    #ifdef WIN32    /*win*/
    sprintf(chaine,"sort \"..\\Z Fichiers cres\\%s\\Liste pop1.txt\" > \"..\\Z Fichiers cres\\%s\\AA Liste de la population (tri profession).txt\"", donnees->dossier_pr, donnees->dossier_pr);    /*Construit la commande de tri*/
    #else /*linux*/
    sprintf(chaine,"sort \"..\\Z Fichiers %s\\%s\\Liste pop1.txt\" > \"..\\Z Fichiers %s\\%s\\AA Liste de la population (tri profession).txt\"", acc("cres",chfunc), donnees->dossier_pr, acc("cres",chfunc), donnees->dossier_pr);    /*Construit la commande de tri*/
    #endif
    changeslash(chaine);    //Inerse les slash pour linux (le cas chant)
    system(chaine);
    #ifdef WIN32    /*win*/
    sprintf(chaine,"sort \"..\\Z Fichiers cres\\%s\\Liste pop2.txt\" > \"..\\Z Fichiers cres\\%s\\AA Liste de la population (tri famille).txt\"", donnees->dossier_pr, donnees->dossier_pr);    /*Construit la commande de tri*/
    #else /*linux*/
    sprintf(chaine,"sort \"..\\Z Fichiers %s\\%s\\Liste pop2.txt\" > \"..\\Z Fichiers %s\\%s\\AA Liste de la population (tri famille).txt\"", acc("cres",chfunc), donnees->dossier_pr, acc("cres",chfunc), donnees->dossier_pr);    /*Construit la commande de tri*/
    #endif
    changeslash(chaine);    //Inerse les slash pour linux (le cas chant)
    system(chaine);
    #ifdef WIN32    /*win*/
    sprintf(chaine,"..\\Z Fichiers cres\\%s\\Liste pop1.txt", donnees->dossier_pr);    /*Construit le nom du fichier pour la supression*/
    #else /*linux*/
    sprintf(chaine,"..\\Z Fichiers %s\\%s\\Liste pop1.txt", acc("cres",chfunc), donnees->dossier_pr);    /*Construit le nom du fichier pour la supression*/
    #endif
    remove(chaine);
    #ifdef WIN32    /*win*/
    sprintf(chaine,"..\\Z Fichiers cres\\%s\\Liste pop2.txt", donnees->dossier_pr);    /*Construit le nom du fichier pour la supression*/
    #else /*linux*/
    sprintf(chaine,"..\\Z Fichiers %s\\%s\\Liste pop2.txt", acc("cres",chfunc), donnees->dossier_pr);    /*Construit le nom du fichier pour la supression*/
    #endif
    remove(chaine);
    putsacc("\nCration de toute la population acheve.\n\n");
    fichier = ouvre_fichier("Donnes.ini","r+");
    fprintf(fichier,"Liste:0aaaaaaaaa");
    fclose(fichier);
}

void interpreteur_principal (struct donnees_perso *donnees, struct donnees_sorts *Dsorts)
{
    FILE* Fichier;
    FILE* Fichier_temp;
    FILE* Fichier_nb_sorts;
    char chaine[255];
    char chaine2[255];
    char nomfichier[100] = "..\\Donnes\\Races\\";
    int modif_carac[6];
    int tableau[50];
    int i,j,val1,val2,totalcomp=0,totaldon=0;
    strcpy(Dsorts->spe,"General");    /*Par defaut, pas de spcialit pour les lanceurs de sorts*/
    strcpy(Dsorts->domaine1,"0");    /*Initialise les domaines et coles interdites*/
    strcpy(Dsorts->domaine2,"0");
    strcpy(Dsorts->interdit1,"0");
    strcpy(Dsorts->interdit2,"0");
    donnees->bba = 0;   //Base pour le bba
    for(i=0;i<6;i++)
        modif_carac[i] = 0;
    donnees->JS_ref = 0;    //Base pour les JS
    donnees->JS_vig = 0;
    donnees->JS_vol = 0;
    donnees->XP = donnees->niveau;    /*Base de l'XP*/
    if(donnees->av_pe == 2)  //Peuple
    {   //Pas de limitation d'alignement selon la classe pour le peuple
        /*Dtermination alatoire de l'alignement*/
        donnees->alignement = NbAlea1b(14);
    }
    /*Traitement du fichier de race*/
    strcat(nomfichier,donnees->race);
    strcat(nomfichier,".txt");
    Fichier = ouvre_fichier(nomfichier,"r");
    fgets(chaine,255,Fichier);    /*Saute la race pour le nom*/
    /*Lecture des modifications de carac par la race*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    do
    {
        if (chaine[0] == '.')
            break;        /*Si il n'y a pas de modificateur*/
        val1 = atoi(chaine);
        while(chaine[0] != '+' && chaine[0] != '-')
        {   /*Passe la valeur*/
            for(i=0;i<(int)strlen(chaine);i++)
                chaine[i] = chaine[i+1];
        }
        j=1;
        if (chaine[0] == '-')
            j=-1;    /*Si c'est un nombre ngatif*/
        for(i=0;i<(int)strlen(chaine);i++)
            chaine[i] = chaine[i+1];
        val2 = atoi(chaine);
        modif_carac[val1-1] = val2*j;
        if (strstr(chaine,",") != NULL)   /*Si il y a d'autre modificateur*/
            Efface_char(chaine,",");
        else
            break;
    } while (1);
    /*Lecture des catgories d'ges et ajustement ventuels*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    for(j=0,i=0;i<4;i++)
    {
        val1 = atoi(chaine);
        Efface_char(chaine,",");
        if (donnees->age >= val1)
            j++;
    }
    donnees->cat_age = j;
    if (j==1)
    {
        modif_carac[0] -= 1;   /*-1 en force, dex et con*/
        modif_carac[1] -= 1;
        modif_carac[2] -= 1;
        modif_carac[3] += 1;   /*+1 en int, sag et cha*/
        modif_carac[4] += 1;
        modif_carac[5] += 1;
    }
    if (j==2)
    {
        modif_carac[0] -= 3;   /*-3 en force, dex et con*/
        modif_carac[1] -= 3;
        modif_carac[2] -= 3;
        modif_carac[3] += 2;   /*+2 en int, sag et cha*/
        modif_carac[4] += 2;
        modif_carac[5] += 2;
    }
    if (j==3 || j==4)
    {
        modif_carac[0] -= 6;   /*-6 en force, dex et con*/
        modif_carac[1] -= 6;
        modif_carac[2] -= 6;
        modif_carac[3] += 3;   /*+3 en int, sag et cha*/
        modif_carac[4] += 3;
        modif_carac[5] += 3;
    }
    /*Lecture des langues de base*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    i=0;
    do
    {
        donnees->langue[i++] = atoi(chaine);
        if (strstr(chaine,",") != NULL)   /*Si il y a d'autres langues*/
            Efface_char(chaine,",");
        else
            break;
    } while (1);
    /*Lecture du type de vision*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    strcpy(donnees->vision,chaine);
    /*Lecture de la catgorie de taille*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    Efface_n(chaine);      //Retire le \n
    strcpy(donnees->cat_taille,chaine);
    //Lit les DV supplmentaires
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    donnees->DV[2] = 0;     //Bonus au pv null par defaut
    donnees->DV[0] = atoi(chaine);  /*Prend le nombre de ds*/
    if(donnees->DV[0] != 0)
    {
        Efface_char(chaine,"d");
        donnees->DV[1] = atoi(chaine);  /*Prend le nombre de face des ds*/
    }
    if(strstr(chaine,"+"))
    {   //Si bonus au pv
        Efface_char(chaine,"+");
        donnees->DV[2] = atoi(chaine);
    }
    donnees->XP += donnees->DV[0];	//Ajoute le nombre de DV  l'XP.
    /*Lecture des capacits spciales de la race*/
    fgets(chaine,255,Fichier);
    Fichier_temp = ouvre_fichier("..\\Donnes\\temp.tmp","w");
    fgets(chaine,255,Fichier);
    i=0;
    j=0;
    while (chaine[0] != '>')
    {
        if (strstr(chaine,"comptence+") != NULL)
        {
            Efface_char(chaine,"+");
            val1 = atoi(chaine);  /*Prend le bonus aux comptences*/
            if  (strstr(chaine,"(") == NULL)   /*Si il y n'y pas de parenthses*/
                totalcomp += val1;   /*ajouter au total de comptences*/
            else if (strstr(chaine,"par niveau") != NULL)   /*Si c'est des comptences par niveau*/
                totalcomp += val1*donnees->niveau;    /*ajouter au total de comptences * niveau*/
            else if (strstr(chaine,"*bint") != NULL)   /*Si c'est des comptences  multiplier par le bonus d'intelligence*/
                totalcomp += val1*donnees->bonus_carac[3];    /*ajouter au total de comptences*/
            else
            {
                Efface_char(chaine,"(");
                val2 = atoi(chaine);     /*Lit le numro de la comptence*/
                donnees->competences[i] = val2;
                donnees->nivo_competences[i++] += val1;
            }
        }
        else if (strstr(chaine,"JS+") != NULL)
        {
            Efface_char(chaine,"+");
            val1 = atoi(chaine);  /*Prend le bonus aux JS*/
            if (strstr(chaine,"ref") != NULL)
                donnees->JS_ref = val1;
            if (strstr(chaine,"vig") != NULL)
                donnees->JS_vig = val1;
            if (strstr(chaine,"vol") != NULL)
                donnees->JS_vol = val1;
        }
        else if (strstr(chaine,"bba+") != NULL)
        {
            Efface_char(chaine,"+");
            val1 = atoi(chaine);  /*Prend le bonus au bba*/
            donnees->bba = val1;
        }
        else if (strstr(chaine,"don+") != NULL)
        {
            Efface_char(chaine,"+");
            val1 = atoi(chaine);  /*Prend le bonus aux dons*/
            if (strstr(chaine,"(") == NULL)   /*Si il y n'y pas de parenthses*/
                totaldon += val1;      /*ajouter au total de dons*/
            else if (strstr(chaine,"par niveau") != NULL)   /*Si c'est des dons par niveau*/
                totaldon += val1*donnees->niveau;   /*ajouter au total de dons * niveau*/
            else
            {
                Efface_char(chaine,"(");
                val2 = atoi(chaine);     /*Lit le numro du don*/
                donnees->don[j++] = val2;
            }
        }
        else if (chaine[0] == 'X' && chaine[1] == 'P')
        {
            Efface_char(chaine,"P");
            if(chaine[0] == '+')
            {
                Efface_char(chaine,"+");
                donnees->XP += atoi(chaine);
                Efface_char(chaine,".");
                fprintf(Fichier_temp,"%s",chaine);
            }
            else
            {
                Efface_char(chaine,"-");
                donnees->XP -= atoi(chaine);
                Efface_char(chaine,".");
                fprintf(Fichier_temp,"%s",chaine);
            }
        }
        else
            fprintf(Fichier_temp,"%s",chaine);
        fgets(chaine,255,Fichier);
    }
    fclose(Fichier_temp);
    fclose(Fichier);
    /*Traitement du fichier de classe*/
    if(donnees->av_pe == 1)
        strcpy(nomfichier,"..\\Donnes\\Classes\\");    //Classe d'aventurier
    else
        strcpy(nomfichier,"..\\Donnes\\Classes populaires\\");    //Classe de peuple
    strcat(nomfichier,donnees->classe);
    strcat(nomfichier,".txt");
    Fichier = ouvre_fichier(nomfichier,"r");
    if(donnees->av_pe == 1)
    {   //L'alignement est lu dans la classe seulement pour les aventuriers
        /*Dtermination alatoire de l'alignement*/
        for(i=0;i<50;i++)
            tableau[i] = 0;
        fgets(chaine,255,Fichier);
        Efface_char(chaine,"{");
        i=0;
        do
        {
            tableau[i++] = atoi(chaine);
            if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                Efface_char(chaine,",");
            else
                break;    /*Si la boucle est termine*/
        } while(1);
        donnees->alignement = tableau[NbAlea1b(i)-1];    /*Tire un alignement au hasard dans la liste*/
    }
    /*Dtermine les caractristiques*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    for(i=0;i<6;i++)
        tableau[i] = donnees->caracteristique[i];    /*copie les carac*/
    for(i=5;i>=0;i--)
    {
        val1 = atoi(chaine);
        Efface_char(chaine,",");
        donnees->caracteristique[val1-1] = tableau[i];    /*Place la valeur restante la plus haute dans la carac lu (les valeurs tant classes de la plus basse  la plus haute*/
    }
    /*Affecte les modifications de caractristique due  la race et  l'ge*/
    for(i=0;i<6;i++)
        donnees->caracteristique[i] += modif_carac[i];        /*Ajoute chaque modif de carac*/
    /*Dtermine les modificateur de carac*/
    for(i=0;i<6;i++)
    {
        if(donnees->caracteristique[i] < 10)
            donnees->bonus_carac[i] = (donnees->caracteristique[i]-11)/2;
        else
            donnees->bonus_carac[i] = (donnees->caracteristique[i]-10)/2;
    }
    if(donnees->caracteristique[3] > 13)
        donnees->XP += 1;    /*intelligence suprieure  13*/
    /*Lit le bonus d'attaque et dtermine le bonus de base  l'attaque*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    donnees->attaque = atoi(chaine);
    if (donnees->attaque == 1)
        donnees->bba += (int) floor(donnees->niveau/2);
    if (donnees->attaque == 2)
        donnees->bba += (int) floor(donnees->niveau/1.31);
    if (donnees->attaque == 3)
        donnees->bba += (int) floor(donnees->niveau);
    if(donnees->bba > 15)
        donnees->XP += 1;    /*4 attaques ou +*/
    /*Lit le bonus du JS rflexe*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    val1 = atoi(chaine);
    if (val1 == 1)
        donnees->JS_ref += (int) floor(donnees->niveau/3);
    if (val1 == 2)
        donnees->JS_ref += (int) floor(donnees->niveau/2+2);
    /*Lit le bonus du JS vigueur*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    val1 = atoi(chaine);
    if (val1 == 1)
        donnees->JS_vig += (int) floor(donnees->niveau/3);
    if (val1 == 2)
        donnees->JS_vig += (int) floor(donnees->niveau/2+2);
    /*Lit le bonus du JS volont*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    val1 = atoi(chaine);
    if (val1 == 1)
        donnees->JS_vol += (int) floor(donnees->niveau/3);
    if (val1 == 2)
        donnees->JS_vol += (int) floor(donnees->niveau/2+2);
    /*Lit le d de vie de la classe*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,"d");
    donnees->des_PV = atoi(chaine);
    calcul_pv(donnees);    /*Dtermine les points de vie*/
    if(donnees->av_pe == 1)
    {   //Armure, arme et bouclier uniquement pour les aventuriers
        /*Dtermine l'armure du personnage*/
        fgets(chaine,255,Fichier);
        Efface_char(chaine,"{");
        for(i=0;i<50;i++)
            tableau[i] = 0;
        i=0;
        do
        {
            tableau[i++] = atoi(chaine);
            if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                Efface_char(chaine,",");
            else
                break;    /*Si la boucle est termine*/
        } while(1);
        donnees->armure = tableau[NbAlea1b(i)-1];    /*Tire une armure au hasard dans la liste*/
        /*Retire une armure si le personnage est de niveau 1*/
        fgets(chaine,255,Fichier);
        if (strstr(chaine,"NA") == NULL)
        {    /*Si il y a des armures pour niv1*/
            if (donnees->niveau == 1)    /*Si le personnage est de niveau 1*/
            {
                Efface_char(chaine,"{");
                for(i=0;i<50;i++)
                    tableau[i] = 0;
                i=0;
                do
                {
                    tableau[i++] = atoi(chaine);
                    if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                        Efface_char(chaine,",");
                    else
                        break;    /*Si la boucle est termine*/
                } while(1);
                donnees->armure = tableau[NbAlea1b(i)-1];    /*Tire une armure au hasard dans la liste*/
            }
        }
        donnees->arme1 = 0;
        donnees->arme2 = 0;
        donnees->arme3 = 0;
        /*Tire la 1ere arme du personnage*/
        fgets(chaine,255,Fichier);
        Efface_char(chaine,"{");
        for(i=0;i<50;i++)
            tableau[i] = 0;
        i=0;
        do
        {
            val1=1;
            if (chaine[0] == 'b')
            {
                val1 = -1;    /*Si l'arme se porte avec un bouclier*/
                for(j=0;j<(int)strlen(chaine);j++)
                    chaine[j] = chaine[j+1];     /*Saute le b*/
            }
            tableau[i++] = atoi(chaine)*val1;
            if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                Efface_char(chaine,",");
            else
                break;    /*Si la boucle est termine*/
        } while(1);
        donnees->arme1 = tableau[NbAlea1b(i)-1];    /*Tire une arme au hasard dans la liste*/
        /*Tire les 2 armes secondaires du personnage*/
        for(val2=0;val2<2;val2++)
        {
            fgets(chaine,255,Fichier);
            if (strstr(chaine,"NA") == NULL)
            {    /*Si il y a des armes secondaires*/
                if ((strstr(chaine,"lvl2+") != NULL && donnees->niveau > 1) || strstr(chaine,"lvl2+") == NULL)    /*Si le personnage doit avoir le niveau 2 ou + et que c'est le cas. Ou si il n'y a pas de restriction*/
                {
                    Efface_char(chaine,"%");
                    val1 = atoi(chaine);
                    if (NbAlea1b(100) <= val1)    /*Si le jet de % est russi*/
                    {
                        Efface_char(chaine,"{");
                        for(i=0;i<50;i++)
                            tableau[i] = 0;
                        i=0;
                        do
                        {
                            val1=1;
                            if (chaine[0] == 'b')
                            {
                                val1 = -1;    /*Si l'arme se porte avec un bouclier*/
                                for(j=0;j<(int)strlen(chaine);j++)
                                    chaine[j] = chaine[j+1];     /*Saute le b*/
                            }
                            tableau[i++] = atoi(chaine)*val1;
                            if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                                Efface_char(chaine,",");
                            else
                                break;
                        } while(1);
                        if (val2==0)
                            donnees->arme2 = tableau[NbAlea1b(i)-1];    /*Tire une arme au hasard dans la liste*/
                        if (val2==1)
                            donnees->arme3 = tableau[NbAlea1b(i)-1];    /*Tire une arme au hasard dans la liste*/
                    }
                }
            }
        }
        donnees->bouclier = 0;
        /*Dtermine le bouclier si le personnage en a un*/
        fgets(chaine,255,Fichier);
        if (strstr(chaine,"NA") == NULL)
        {    /*Si il y a des boucliers*/
            if (donnees->arme1 < 0 || donnees->arme2 < 0 || donnees->arme3 < 0)
            {        /*Si l'une des armes s'accompagne d'un bouclier*/
                if (donnees->arme1 < 0)
                    donnees->arme1 *= -1;   /*Rtabli les valeurs d'armes normales*/
                if (donnees->arme2 < 0)
                    donnees->arme2 *= -1;
                if (donnees->arme3 < 0)
                    donnees->arme3 *= -1;
                Efface_char(chaine,"{");
                for(i=0;i<50;i++)
                    tableau[i] = 0;
                i=0;
                do
                {
                    tableau[i++] = atoi(chaine);
                    if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                        Efface_char(chaine,",");
                    else
                        break;    /*Si la boucle est termine*/
                } while(1);
                donnees->bouclier = tableau[NbAlea1b(i)-1];    /*Tire un bouclier au hasard dans la liste*/
            }
        }
    }
    /*Dtermine les capacits spciales du personnage*/
    Fichier_temp = ouvre_fichier("..\\Donnes\\temp.tmp","a+");
    while(strstr(chaine,"#Capacits spciales:") == NULL)
    {    /*Recherche de la ligne correspondante*/
        fgets(chaine,255,Fichier);
    }
    fgets(chaine,255,Fichier);
    j=0;
    while (chaine[0] != '>')
    {
        Efface_char(chaine,".");
        if (donnees->niveau >= atoi(chaine))   /*Si le niveau du personnage est suprieur ou gal au niveau spcifi, il possde la capacit spciale*/
        {
            Efface_char(chaine,":");
            if (strstr(chaine,"don+") != NULL)        /*Si c'est un don en plus*/
            {
                if (strstr(chaine,"(") == NULL)   /*Si il y n'y pas de parenthses*/
                    totaldon++;      /*ajouter au total de dons*/
                else
                {
                    Efface_char(chaine,"(");
                    val1 = atoi(chaine);     /*Lit le numro du don*/
                    donnees->don[j++] = val1;
                }
            }
            else if (strstr(chaine,"T.alea:") != NULL)     /*Si on fait appel  une table alatoire*/
            {
                strcpy(nomfichier,chaine);    /*Copie la ligne*/
                strcpy(chaine,strstr(chaine,"T.alea:"));    /*Tronque la phrase*/
                Efface_char(chaine,":");
                i=0;
                while(chaine[i++] != 41);      /*41 = )       Dplace le curseur jusqu' la fin du nom de la table*/
                chaine[i-1] = '\0';
                strcpy((char*)tableau,chaine);    /*Copie temp*/
                sprintf(chaine,"..\\Donnes\\Tables alatoires\\%s", (char*)tableau);
                strcpy(chaine,gen_alea(chaine,chaine2));
                i=0;
                while(nomfichier[i] != 40)     /*40 = (*/
                    fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve avant l'appel de gen_alea*/
                fprintf(Fichier_temp,"%s",chaine);  /*Inscrit le rsultat de gen_alea*/
                while(nomfichier[i++] != 41);      /*41 = )*/
                while(nomfichier[i] != '\0')
                    fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve aprs l'appel de gen_alea*/
            }
            else if (strstr(chaine,"Tirer_dieu.") != NULL)     /*Le personnage est un prtre*/
            {
                Efface_char(chaine,".");
                Efface_n(chaine);      //Retire le \n
                sprintf(nomfichier,"..\\Donnes\\Tables alatoires\\%s", chaine);
                /*Tirer le dieu*/
                strcpy(chaine,gen_alea(nomfichier,chaine2));   /*Tire le dieu*/
                i=0;
                do
                {
                    nomfichier[i] = chaine[i];     /*nomfichier prend le nom du dieu*/
                    i++;
                }while(chaine[i] != ':');
                Efface_char(chaine,":");
                nomfichier[i] = '\0';
                fprintf(Fichier_temp,"Dieu: %s\n", chaine);  /*Affiche le dieu*/
                /*Redterminer l'alignement*/
                Fichier_nb_sorts = ouvre_fichier("..\\Donnes\\Alignement selon le dieu.ini","r");  /*Fichier_nb_sorts rutiliser pour l'alignement selon le dieu*/
                do
                {
                    fgets(chaine,255,Fichier_nb_sorts);     /*Repre la ligne du dieu*/
                }while(strstr(chaine,nomfichier) == NULL);
                fclose(Fichier_nb_sorts);
                Efface_char(chaine,"{");
                for(i=0;i<50;i++)
                    tableau[i] = 0;
                i=0;
                do
                {
                    tableau[i++] = atoi(chaine);
                    if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                        Efface_char(chaine,",");
                    else
                        break;    /*Si la boucle est termine*/
                } while(1);
                donnees->alignement = tableau[NbAlea1b(i)-1];    /*Retire un alignement au hasard dans la liste*/
                /*Tirer les 2 domaines*/
                sprintf(chaine,"..\\Donnes\\Domaines de sorts\\%s.tbl", nomfichier);
                strcpy(Dsorts->domaine1,gen_alea(chaine,chaine2));   /*Tire le 1er domaine*/
                do
                {
                    strcpy(Dsorts->domaine2,gen_alea(chaine,chaine2));   /*Tire le 2e domaine*/
                }while(!strcmp(Dsorts->domaine1,Dsorts->domaine2));  /*Retire tant que les 2 domaines sont identiques*/
                i=0;
                strcpy(chaine,Dsorts->domaine1);
                Dsorts->domaine1[0] = '#';
                do
                {
                    Dsorts->domaine1[i+1] = chaine[i];     /*Prend le nom du domaine uniquement*/
                    i++;
                }while(chaine[i] != ':');
                Efface_char(chaine,":");
                Dsorts->domaine1[i+1] = '\0';
                fprintf(Fichier_temp,"Domaines: %s\n", chaine);  /*Affiche le 1er domaine de sorts*/
                i=0;
                strcpy(chaine,Dsorts->domaine2);
                Dsorts->domaine2[0] = '#';
                do
                {
                    Dsorts->domaine2[i+1] = chaine[i];     /*Prend le nom du domaine uniquement*/
                    i++;
                }while(chaine[i] != ':');
                Efface_char(chaine,":");
                Dsorts->domaine2[i+1] = '\0';
                fprintf(Fichier_temp,"%s\n", chaine);  /*Affiche le 2e domaine de sorts*/
            }
            else if (strstr(chaine,"Ecoles_interdites") != NULL)     /*Pour les mages spcialistes*/
            {
                Efface_char(chaine,"=");
                Efface_n(chaine);      //Retire le \n
                strcpy(Dsorts->spe,chaine);
                do
                {
                    strcpy(Dsorts->interdit1,gen_alea("..\\Donnes\\Tables alatoires\\Ecoles de magie.tbl",chaine2));   /*Tire la 1ere cole interdite*/
                }while(!strcmp(Dsorts->interdit1,Dsorts->spe));  /*Retire tant que l'cole est celle de spcialisation*/
                do
                {
                    strcpy(Dsorts->interdit2,gen_alea("..\\Donnes\\Tables alatoires\\Ecoles de magie.tbl",chaine2));   /*Tire la 2e cole interdite*/
                }while(!strcmp(Dsorts->interdit2,Dsorts->spe) || !strcmp(Dsorts->interdit2,Dsorts->interdit1));  /*Retire tant que l'cole est celle de spcialisation ou la mme que la premire*/
            }
            else if (strstr(chaine,"Tirer_sorts") != NULL)     /*Si le personnage  des sorts*/
            {
                Efface_char(chaine,":");
                Efface_char(chaine,"v");    //Efface le v de niv
                sprintf(chaine2,"%d%s", donnees->niveau, chaine);  //Place dans chaine2 le niveau du personnage et place  la suite la fin de la chaine
                i=0;
                while(chaine2[i++] != '.');
                Efface_n(chaine2);
                chaine2[i-1] = '\0';   //Termine chaine2 au ., il reste donc seulement niv et le calcul ventuel qui le suit
                fprintf(Fichier_temp,"Niveau de lanceur de sort = %d\n", (int) floor(interpret_calc(chaine2)));  //Affiche le niveau de lanceur de sort
                Efface_char(chaine,".");
                i=0;
                do
                {
                    Dsorts->type_perso[i] = chaine[i];   /*Prend le type de perso*/
                    i++;
                }while(chaine[i] != '.');
                Dsorts->type_perso[i] = '\0';
                Efface_char(chaine,"=");
                Efface_n(chaine);      //Retire le \n
                strcpy(Dsorts->type,chaine);
                donnees->grimoire = 1;  /*Indique qu'un grimoire devra tre cr*/
                /*Dtermine le niveau de sorts max accessible par le perso pour le calcul de l'XP*/
                sprintf(chaine,"..\\Donnes\\Sorts\\%s\\Nb sorts %s.s", Dsorts->type_perso, Dsorts->type_perso);
                Dsorts->Fichier_nb = ouvre_fichier(chaine,"r");
                fgets(chaine,255,Dsorts->Fichier_nb);
                Efface_char(chaine,"=");
                val1 = atoi(chaine);      /*Val prend le niveau max de sorts dtaills*/
                val2 = donnees->niveau;
                if (donnees->niveau > val1)
                    val2 = val1; /*Si le niveau du perso est suprieur au niveau max dtaill, on prend le niveau max*/
                do
                {
                    fgets(chaine,255,Dsorts->Fichier_nb);
                    val1 = atoi(chaine);   /*Cherche la ligne du niveau du perso*/
                } while (val1 != val2);
                Efface_char(chaine,":");
                val2=0;
                for (i=0;i<10;i++)
                {
                    if(chaine[0] != '0')    /*si chiffre, b ou p, sorts de ce niveau*/
                        val2=i;
                    if (i < 9)  /*Evite l'erreur car il n'y  plus de virgule  la fin*/
                        Efface_char(chaine,",");
                }
                fclose(Dsorts->Fichier_nb);
                if(val2 <= 2)
                    donnees->XP += 1;  /*Sort de niveau 2 ou moins*/
                if(val2 <= 6)
                    donnees->XP += 2;  /*Sort de niveau 6 ou moins*/
                if(val2 >= 7)
                    donnees->XP += 4;  /*Sort de niveau 7 ou plus*/
            }
            else if (chaine[0] == 'X' && chaine[1] == 'P')
            {
                Efface_char(chaine,"P");
                if(chaine[0] == '+')
                {
                    Efface_char(chaine,"+");
                    donnees->XP += atoi(chaine);
                    Efface_char(chaine,".");
                    fprintf(Fichier_temp,"%s",chaine);
                }
                else
                {
                    Efface_char(chaine,"-");
                    donnees->XP -= atoi(chaine);
                    Efface_char(chaine,".");
                    fprintf(Fichier_temp,"%s",chaine);
                }
            }
            else if (strstr(chaine,"Gen.") != NULL)
            {
                strcpy(nomfichier,chaine);    /*Copie la ligne*/
                strcpy(chaine,strstr(chaine,"Gen."));    /*Tronque la phrase*/
                if(strstr(chaine,"Familier"))
                    val1=1; /*Gen familier*/
                if(strstr(chaine,"Compagnon animal"))
                    val1=2; /*Gen Compagnon animal*/
                if(strstr(chaine,"Destrier de paladin"))
                    val1=3; /*Gen Destrier*/
                Efface_char(chaine,",");
                val2=0; /*val2 correspond au malus_lvl*/
                if(val1==2) /*Compagnon animal*/
                {
                    if(chaine[0] == '/')
                    {   /*Indique malus lvl = divis par*/
                        Efface_char(chaine,"/");
                        i = atoi(chaine);
                        val2 = donnees->niveau/i;
                    }
                    else
                        val2 = atoi(chaine);
                    Efface_char(chaine,",");
                }
                strcpy(chaine2,"..\\Donnes\\Tables alatoires\\");
                if (strstr(chaine,"X.") != NULL)
                {   /*Mot cl X. remplac par la catgorie de taille du personnage*/
                    i=0;
                    j=strlen(chaine2);
                    while(chaine[i] != 'X' && chaine[i+1] != '.')
                        chaine2[j++] = chaine[i++]; /*Copie  la suite de chaine juqu'au XX*/
                    chaine2[j] = '\0';
                    strcat(chaine2,donnees->cat_taille);    /*Ajoute la catgorie de taille du perso*/
                    strcpy(chaine,strstr(chaine,"X."));    /*Tronque la phrase*/
                    Efface_char(chaine,"X");
                }
                strcat(chaine2,chaine);
                Efface_n(chaine2);      //Retire le \n
                strcpy(chaine,gen_alea(chaine2,chaine));
                i=0;
                while(1)
                {
                    if(nomfichier[i] == 'G' && nomfichier[i+1] == 'e' && nomfichier[i+2] == 'n' && nomfichier[i+3] == '.')
                        break;
                    fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve avant l'appel de Gen.*/
                }
                if(val1==1)
                {   /*Familier, supprime le bonus entre parenthse pour le gnrateur*/
                    fprintf(Fichier_temp,"%s\n",chaine);   /*Affiche le familier et son bonus pour le matre*/
                    if(strstr(chaine,"Pas de familier") != NULL)   /*Si pas de familier*/
                        val1=0;
                    else
                    {
                        i=0;
                        while(chaine[i++] != '(');  /*Cherche la parenthse dans la chaine*/
                            chaine[i-2] = '\0'; /*Annule la fin de la chaine,  partir de l'espace avant la parenthse*/
                    }
                }
                if(val1==2)
                {   /*Compagnon animal, vrifie le niveau requis et calcul le malus_lvl*/
                    Efface_char(chaine,"(");
                    while(donnees->niveau-val2 < atoi(chaine))
                    {  /*Tant que le personnage n'a pas le niveau recquis pour avoir le compagnon, un autre est tir*/
                        strcpy(chaine,gen_alea(chaine2,chaine));
                        Efface_char(chaine,"(");
                    }
                    Efface_char(chaine,"-");
                    val2 += atoi(chaine);   /*Ajoute le malus au niveau  celui dj existant*/
                    Efface_char(chaine,")");
                    fprintf(Fichier_temp,"%s\n",chaine);   /*Affiche le compagnon animal*/
                }
                if(val1==3)
                    fprintf(Fichier_temp,"%s\n",chaine);   /*Affiche le destrier*/
                if(val1 != 0) /*Si val1 == 0, Pas de familier, donc pas de cration*/
                {
                    if(val1 == 1)
                        strcpy(donnees->compagnon,"type=\"Familier.");
                    if(val1 == 2)
                        strcpy(donnees->compagnon,"type=\"Compagnon animal.");
                    if(val1 == 3)
                        strcpy(donnees->compagnon,"type=\"Destrier de paladin.");
                    strcat(donnees->compagnon,chaine);
                    strcat(donnees->compagnon,"\" malus=");
                    strcat(donnees->compagnon,inttochar (val2,chaine2));
                }
            }
            else
                fprintf(Fichier_temp,"%s",chaine);    /*Si c'est une capacit spciale, stocke directement dans le fichier temporaire*/
        }
        fgets(chaine,255,Fichier);
    }
    fclose(Fichier_temp);
    /*Dtermine les dons du personnage*/
    Fichier_temp = ouvre_fichier("Donnes.ini","r");
    totaldon += donnees->niveau/3+1;
    rewind(Fichier);
    while(strstr(chaine,"#Dons:") == NULL)
    {    /*Recherche de la ligne correspondante*/
        fgets(chaine,255,Fichier);
    }
    Efface_char(chaine,":");
    j=0;
    while(donnees->don[j++] != 0);  /*Dplace l'index jusq'aux cases vides*/
    j--;
    while(totaldon != 0)    /*Tant qu'il reste des dons*/
    {
        val1 = atoi(chaine);
        rewind(Fichier_temp);
        do
        {    /*Recherche du paragraphe des dons dans le fichier de donnes*/
            fgets(nomfichier,100,Fichier_temp);   /*on rutilise 'nomfichier' comme variable de chaine*/
        } while (strstr(nomfichier,"#Dons") == NULL);
        do
        {
            fgets(nomfichier,255,Fichier_temp);
            val2 = atoi(nomfichier);   /*Lit le numro de la ligne*/
            if (val2 == val1)   /*Si le numro ne correspond pas*/
                Efface_char(nomfichier,"(");
            else
                val2=0;
        } while (!val2); /*Bcl tant que le bon numro n'est pas trouv*/
        tableau[1] = 1;   /*Index 1:  0, indique que les conditions ne sont pas remplies*/
        do
        {
            if(nomfichier[0] == 'd')   /*don=*/
            {
                Efface_char(nomfichier,"=");
                val2 = atoi(nomfichier);
                for(i=0;i<50;i++)
                {
                    if (donnees->don[i] == val2)
                        i=99;    /*Vrifie si le personnage possde le don demand*/
                }
                if (i!=100)  /*Si le personnage ne possde pas le don*/
                    tableau[1] = 0;
            }
            if(nomfichier[0] == 'b')    /*bba=*/
            {
                Efface_char(nomfichier,"=");
                val2 = atoi(nomfichier);
                if (donnees->bba < val2)   /*Si le bba est infrieur*/
                    tableau[1] = 0;
            }
            if(nomfichier[0] == 'l')    /*lvl=*/
            {
                Efface_char(nomfichier,"=");
                val2 = atoi(nomfichier);
                if (donnees->niveau < val2)   /*Si le niveau est infrieur*/
                    tableau[1] = 0;
            }
            if(nomfichier[0] == 'c')      /*c=*/
            {
                Efface_char(nomfichier,"c");
                val2 = atoi(nomfichier);
                Efface_char(nomfichier,"=");
                if (donnees->caracteristique[val2-1] < atoi(chaine))
                    tableau[1] = 0;
            }
            if (strstr(nomfichier,",") != NULL)
                Efface_char(nomfichier,",");
            else
                break;
        } while(tableau[1]);
        if (tableau[1])   /*Si les conditions sont remplies, don OK*/
        {
            donnees->don[j] = val1;
            totaldon--;
            while (isdigit(chaine[0]))
            {            /*retire la valeur numrique de la chaine*/
                for (i=0;i<(int)strlen(chaine);i++)
                    chaine[i] = chaine[i+1];
            }
            if(chaine[0] == 40)     /*Si le don a un argument. 40=(*/
            {
                val1=0;
                while (chaine[0] != 41)     /*41=)*/
                {
                    donnees->arg_don[j][val1++] = chaine[0];    /*Ecrit l'argument caractre par caractre*/
                    for (i=0;i<(int)strlen(chaine);i++)
                        chaine[i] = chaine[i+1];
                }
                donnees->arg_don[j][val1++] = 41;    /*Termine l'argument par )*/
                donnees->arg_don[j][val1] = '\0';    /*Termine la string*/
            }
            j++;
        }
        if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
            Efface_char(chaine,",");
        else
            break;    /*Si la boucle est termine*/
    }
    donnees->don[50] = totaldon; /*Stocke le nombre de dons restant  la fin du tableau de dons*/
    fclose(Fichier_temp);
    /*Dtermine les comptences du personnages*/
    rewind(Fichier);
    while(strstr(chaine,"#Comptences") == NULL)
    {    /*Recherche de la ligne correspondante*/
        fgets(chaine,255,Fichier);
    }
    Efface_char(chaine,"(");
    val1 = atoi(chaine);   /*Prend le multiplicateur de comptence de la classe*/
    Efface_char(chaine,":");
    val2 = donnees->bonus_carac[3]; /*Prend le bonus d'intelligence*/
    if (val2 < 0)
        val2 = 0;    /*Le bonus d'intelligence ne peut pas baisser les points de comptences*/
    totalcomp += (val1+val2)*(3+donnees->niveau);     /*Calcul le total de points de comptences*/
    j=0;
    while(donnees->competences[j++] != 0);  /*Dplace l'index jusq'aux cases vides*/
    j--;
    while(totalcomp != 0)    /*Tant qu'il reste des points de comptences*/
    {
        tableau[0] = 0;    /*Indique que c'est une comptence de classe*/
        val1 = donnees->niveau+3;    /*Dtermine le niveau max de comptence*/
        if (chaine[0] == 'h')
        {        /*Si c'est une comptence hors classe*/
            tableau[0] = 1;    /*Indique que c'est une comptence hors classe*/
            Efface_char(chaine,"h");
        }
        val2 = atoi(chaine);
        for(i=0;i<50;i++)
        {
            if (donnees->competences[i] == val2)
            {
                if (donnees->arg_competences[i][0] == '\0')
                    break;    /*Vrifie si la comptence est dj dans le tableau et qu'elle n'a pas d'argument*/
            }
        }
        if (i == 50)     /*Si la comptence n'est pas trouve dans le tableau*/
            i = j++;   /*La comptence sera place  la suite dans le tableau*/
        donnees->competences[i] = val2;     /*Place ou replace la comptence dans le tableau*/
        if (val1 <= totalcomp)    /*Si la comptence peut tre mise au maximum*/
        {
            if (tableau[0])  /*Si la comptence est hors classe*/
            {
                totalcomp -= val1/2;   /*Les points placs sont soustrait une demi-fois*/
                val1 = val1/2;    /*Le maximum est divis par 2*/
            }
            donnees->nivo_competences[i] += val1;    /*La comptence est augmente du maximum de points*/
            totalcomp -= val1;   /*Les points placs sont soustrait du total*/
        }
        else   /*Si la comptence ne peut pas tre mise au maximum, points restant insuffisant*/
        {
            donnees->nivo_competences[i] += totalcomp;    /*La comptence est augmente du nombre de points restants*/
            totalcomp = 0;   /*Le total est mis  0*/
            break;
        }
        while (isdigit(chaine[0]))
        {            /*retire la valeur numrique de la chaine*/
            for (val2=0;val2<(int)strlen(chaine);val2++)
                chaine[val2] = chaine[val2+1];
        }
        if(chaine[0] == 40)     /*Si la comptence a un argument. 40=(*/
        {
            val1=0;
            while (chaine[0] != 41)     /*41=)*/
            {
                donnees->arg_competences[i][val1++] = chaine[0];    /*Ecrit l'argument caractre par caractre*/
                for (val2=0;val2<(int)strlen(chaine);val2++)
                    chaine[val2] = chaine[val2+1];
            }
            donnees->arg_competences[i][val1++] = 41;    /*Termine l'argument par )*/
            donnees->arg_competences[i][val1] = '\0';    /*Termine la string*/
        }
        if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
            Efface_char(chaine,",");
        else
            break;
    }
    donnees->competences[50] = totalcomp; /*Stocke le nombre de points de comptences restant  la fin du tableau de comptences*/
    /*Dtermine les langues que le personnage sait parler*/
    fgets(chaine,255,Fichier);
    Efface_char(chaine,":");
    val2=0;
    while(donnees->langue[val2++] != 0);  /*Dplace l'index jusq'aux cases vides*/
    val2--;
    for(i=0;i<donnees->bonus_carac[3];i++)   /*Bcl sur le bonus d'intelligence*/
    {
        val1 = atoi(chaine);
        for(j=0;j<20;j++)
        {
            if (donnees->langue[j] == val1)
                j=99;    /*Vrifie si la langue est dj connue*/
        }
        if (j==100)     /*La langue est dj connue par le personnage*/
            i--;
        else
            donnees->langue[val2++] = val1;     /*Place la langue dans le tableau*/
        if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
            Efface_char(chaine,",");
        else
            break;    /*Si la boucle est termine*/
    }
    /*Lecture de l'quipement du personnage*/
    Fichier_temp = ouvre_fichier("..\\Donnes\\temp.tmp","a+");
    while(strstr(chaine,"#Equipements:") == NULL)
    {    /*Recherche de la ligne correspondante*/
        fgets(chaine,255,Fichier);
    }
    fprintf(Fichier_temp,">\n");    /*Inscrit < dans le fichier temporaire*/
    fprintf(Fichier_temp,"%s",chaine);    /*Inscrit #Equipements: dans le fichier temporaire*/
    do
    {    /*Stocke l'quipement dans le fichier temporaire*/
        fgets(chaine,255,Fichier);
        if (strstr(chaine,"$po") != NULL || strstr(chaine,"$pc") != NULL)    /*Si mot cl or*/
        {
            strcpy(nomfichier,chaine);    /*Copie la ligne*/
            i=0;
            while(nomfichier[i] != '$')
                fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve avant le mot cl*/
            fprintf(Fichier_temp,"%d", NbAlea1b(donnees->niveau*100));    /*Inscrit l'argent que porte le PNJ (1d100 par niveau)*/
            if(donnees->av_pe == 1)
            {
                fprintf(Fichier_temp," po");    //pices d'or pour les aventurier
                while(nomfichier[i++] != 'o');      /*Efface jusqu'a o de $po*/
            }
            else
            {
                fprintf(Fichier_temp," pc");    //pices de cuivre pour le peuple
                while(nomfichier[i++] != 'c');      /*Efface jusqu'a c de $pc*/
            }
            while(nomfichier[i] != '\0')
                fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve aprs le mot cl*/
        }
        else if (strstr(chaine,"T.alea:") != NULL)     /*Si on fait appel  une table alatoire*/
        {
            strcpy(nomfichier,chaine);    /*Copie la ligne*/
            strcpy(chaine,strstr(chaine,"T.alea:"));    /*Tronque la phrase*/
            Efface_char(chaine,":");
            i=0;
            while(chaine[i++] != 41);      /*41 = )       Dplace le curseur jusqu' la fin du nom de la table*/
            chaine[i-1] = '\0';
            strcpy((char*)tableau,chaine);    /*Copie temp*/
            sprintf(chaine,"..\\Donnes\\Tables alatoires\\%s", (char*)tableau);
            strcpy(chaine,gen_alea(chaine,chaine2));
            i=0;
            while(nomfichier[i] != 40)     /*40 = (*/
                fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve avant l'appel de gen_alea*/
            fprintf(Fichier_temp,"%s",chaine);  /*Inscrit le rsultat de gen_alea*/
            while(nomfichier[i++] != 41);      /*41 = )*/
            while(nomfichier[i] != '\0')
                fprintf(Fichier_temp,"%c", nomfichier[i++]);      /*Copie au caractre ce qui se trouve aprs l'appel de gen_alea*/
        }
        else
            fprintf(Fichier_temp,"%s",chaine);
    } while (chaine[0] != '>');
    fprintf(Fichier_temp,"<\n");    /*Inscrit <  la fin du fichier temporaire*/
    fclose(Fichier_temp);
    fclose(Fichier);
}

void pds_tail_age (struct donnees_perso *donnees)
{
    FILE* fichier;
    float IMC;
    float IMCtab[6];
    float tailleM;
    char chaine[255];
    char classe[] = "#classe 0";
    int base_age,nb_d_age,face_d_age,max_age,base_taille,nb_d_taille,face_d_taille,base_poids,nb_d_poids,face_d_poids, factpoi=0, facttail=0, i, j;
    int enfant=0;
    fichier = ouvre_fichier("..\\Donnes\\Poids_taille_age.ini","r");
    if (donnees->groupclas == 0)    /*Age des enfants*/
    {
        donnees->groupclas = 1;
        enfant=1;
    }
    classe[8] = donnees->groupclas+48;    /*Prend le numro du groupe de classe*/
    while (strstr(chaine,donnees->race) == NULL)
    {    /*Recherche la ligne de la race*/
        fgets(chaine,255,fichier);
    }
    while (strstr(chaine,donnees->sexe) == NULL)
    {    /*Recherche la ligne du sexe*/
        fgets(chaine,255,fichier);
    }
    while (strstr(chaine,classe) == NULL)
    {    /*Recherche la ligne de la classe*/
        fgets(chaine,255,fichier);
    }
    fgets(chaine,255,fichier);            /*Saisi la ligne contenant les donnes*/
    for (i=0;i<10;i++)
    {    /*Relve les 9 donnes*/
        Efface_char(chaine,"=");
        switch (i)
        {
            case 0:
                base_age = atoi(chaine);     /*Base age*/
                break;
            case 1:
                nb_d_age = atoi(chaine);     /*Nb de ds age*/
                break;
            case 2:
                face_d_age = atoi(chaine);   /*Nb de face du ds age*/
                break;
            case 3:
                max_age = atoi(chaine);   /*Age maximum*/
                break;
            case 4:
                base_taille = atoi(chaine);     /*Base taille*/
                break;
            case 5:
                nb_d_taille = atoi(chaine);     /*Nb de ds taille*/
                break;
            case 6:
                face_d_taille = atoi(chaine);   /*Nb de face du ds taille*/
                break;
            case 7:
                base_poids = atoi(chaine);     /*Base poids*/
                break;
            case 8:
                nb_d_poids = atoi(chaine);     /*Nb de ds taille*/
                break;
            case 9:
                face_d_poids = atoi(chaine);   /*Nb de face du ds poids*/
                break;
        }
    }
    /*Lit les 6 valeur d'IMC*/
    Efface_char(chaine,"=");
    IMCtab[0] = atof(chaine);
    for (i=1;i<6;i++)
    {
        Efface_char(chaine,",");
        IMCtab[i] = atof(chaine);
    }
    for (i=0;i<nb_d_age;i++)     /*Calcul de l'age*/
        base_age += NbAlea1b(face_d_age);
    if(donnees->av_pe == 2) //Peuple
        donnees->age = base_age + 10;    /*Age, +10 ans*/
    else    //Aventurier
        donnees->age = base_age;
    if (donnees->niveau > 1)
    {   /*Si c'est un niveau 1 on garde uniquement la base*/
        if(donnees->av_pe == 2) //Peuple
            donnees->age = NbAlea2b(base_age+10+donnees->niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
        else    //Aventurier
            donnees->age = NbAlea2b(base_age+donnees->niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
        for(j=0;j<4;j++)
        {   /*Le jet prcdent sera donc effectu 5 fois*/
            if(donnees->av_pe == 2) //Peuple
                i = NbAlea2b(base_age+10+donnees->niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
            else    //Aventurier
                i = NbAlea2b(base_age+donnees->niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
            if(i < donnees->age)
                donnees->age = i;    /*On garde systmatiquement l'ge le plus jeune*/
        }
    }
    if(enfant)    /*Si enfant*/
        donnees->age = NbAlea1b(base_age);    /*L'ge de l'enfant = alea de l'ge de base*/
    for (i=0;i<nb_d_taille;i++)  /*Calcul du facteur taille*/
        facttail += NbAlea1b(face_d_taille);
    donnees->taille = base_taille+facttail;    /*Calcul de la taille*/
    if(enfant)    /*Si enfant*/
        donnees->taille = donnees->taille * donnees->age / base_age;    /*Taille enfant = taille * facteur de l'age par rapport  la base adulte*/
    for (i=0;i<nb_d_poids;i++)    /*Calcul du facteur poids*/
        factpoi += NbAlea1b(face_d_poids);
    donnees->poids = base_poids+(facttail*factpoi/5);    /*Calcul du poids, en fonction de la taille*/
    if(enfant)    /*Si enfant*/
        donnees->poids = donnees->poids * donnees->age / base_age;        /*Poids enfant = Poids * facteur de l'age par rapport  la base adulte*/
    tailleM = (float) donnees->taille/100;
    IMC = (donnees->poids/(tailleM*tailleM));    /*IMC = poids/taille au carr. Taille divis par 100 pour avoir en mtre*/
    if(IMC < IMCtab[0])
        strcpy(donnees->IMC,"Dnutrition");
    else if(IMC < IMCtab[1])
        strcpy(donnees->IMC,"Maigreur");
    else if(IMC < IMCtab[2])
        strcpy(donnees->IMC,"Corpulence normale");
    else if(IMC < IMCtab[3])
        strcpy(donnees->IMC,"Surpoids");
    else if(IMC < IMCtab[4])
        strcpy(donnees->IMC,"Obsit modre");
    else if(IMC < IMCtab[5])
        strcpy(donnees->IMC,"Obsit svre");
    else   /*Suprieur ou gal  IMCtab[5]*/
        strcpy(donnees->IMC,"Obsit massive");
    fclose(fichier);
}

void carac (struct donnees_perso *donnees)
{
    int jet_des[4];
    int tabcaractemp[6];
    int i, j, total, nb, min, index_min, nb_lancer;
    for(i=0;i<6;i++)
        donnees->caracteristique[i] = 0;    /*Initialise le tableau gnral*/
    if(donnees->av_pe == 2)
        nb_lancer = 1;  //Peuple
    else
        nb_lancer = 4;  //Aventurier
    for (nb=0;nb<nb_lancer;nb++)    /*Boucle sur le nombre de jet (4 jets, le plus lev est gard) (1 seul jet pour le peuple)*/
    {
        do    /*Relance tant que le jet n'est pas entre 75 et 90*/
        {
            for(i=0;i<6;i++)
                tabcaractemp[i] = 0;    /*Initialise le tableau temporaire*/
            for(i=0,total=0;i<6;i++)    /*6 carac*/
            {
                for (j=0,min=6;j<4;j++)  /*Technique des 4 ds*/
                {
                    jet_des[j] = NbAlea1b(6);
                    if (jet_des[j] < min)
                    {        /*Dtermine lequel des 4 ds est le plus petit*/
                        min = jet_des[j];
                        index_min = j;
                    }
                }
                jet_des[index_min] = 0;      /*Met la valeur du plus petit ds  0*/
                for (min=0;min<4;min++)
                {     /*Recopie les valeurs, except le 0*/
                    if (jet_des[min] != 0)
                    {
                        tabcaractemp[i] += jet_des[min]; /*Inscrit les valeurs dans le tableau*/
                        total += jet_des[min];       /*Ajoute au total*/
                    }
                }
            }
        } while ((total<75) || (total>90));
        if (total > (donnees->caracteristique[0]+donnees->caracteristique[1]+donnees->caracteristique[2]+donnees->caracteristique[3]+donnees->caracteristique[4]+donnees->caracteristique[5]))
        {        /*Dtermine si ce nouveau jet est le plus lev*/
            for(i=0;i<6;i++)
                donnees->caracteristique[i] = tabcaractemp[i];
        }
    }
    tri_int (donnees->caracteristique, 6);     /*tri le meilleur jet de carac*/
    /*Augmentation de la carac principale en fonction du niveau*/
    donnees->caracteristique[5] += (int) floor(donnees->niveau/4);
}

void niveau (struct donnees_perso *donnees)
{
    FILE* fichier;
    int max, val_max, val, b1, b2, nb_niveau, i=0,j;
    int *tab;
    char chaine[255];
    fichier = ouvre_fichier("..\\Donnes\\Niveau.niv","r");
    fgets(chaine,255,fichier);
    Efface_char(chaine,"=");
    max = atoi(chaine);
    fgets(chaine,255,fichier);
    Efface_char(chaine,"=");
    val_max = atoi(chaine);
    nb_niveau = donnees->niveau_max - donnees->niveau_mini + 1;
    ER = (int) (tab = (int*) calloc(nb_niveau+1,sizeof(int)));   /*Cre le tableau des niveaux*/
    Erreur(1);
    j = donnees->niveau_mini - 1;   /*Valeur de dbut de boucle de remplissage du tableau*/
    if (donnees->niveau_mini <= max)
    {    /*Dbut du tableau*/
        do
        {  /*Recherche du niveau mini - 1*/
            fgets(chaine,255,fichier);
            val = atoi(chaine);
        } while (val != donnees->niveau_mini - 1);
        do
        {
            j++;
            Efface_char(chaine,":");
            tab[i++] = atoi(chaine);
            fgets(chaine,255,fichier);
        }while(j <= 25 && j <= donnees->niveau_max);
    }
    if (donnees->niveau_mini > max || donnees->niveau_max > max)
    {    /*Si le niveau dpasse la limite*/
        while(strstr(chaine,"niv+1:") == NULL)
            fgets(chaine,255,fichier);     /*Recherche la ligne des niveaux suprieurs*/
        Efface_char(chaine,":");
        Efface_char(chaine,"+");
        val = atoi(chaine);     /*Prend la valeur de l'augmentation  chaque niveau*/
        do
        {
            val_max += val;
            j++;
            tab[i++] = val_max;
        }while(j <= donnees->niveau_max);
    }
    b1 = tab[0]+1;        /*Prend la 1ere case du tableau*/
    b2 = tab[i-1];      /*Prend la dernire case du tableau*/
    val = NbAlea2b(b1,b2);
    for(i=1;i<nb_niveau+1;i++)
    {    /*Cherche la valeur tire dans le tableau*/
        if (val <= tab[i])
            break;
    }
    donnees->niveau = i + donnees->niveau_mini - 1;
    free(tab);
    fclose(fichier);
}

void calcul_pv (struct donnees_perso *donnees)
{
    int temp,i,j,con,PV_race=0;
    donnees->PV = 0;
    for (j=0;j<3;j++)  /*Bcl sur le nb de lanc (3)*/
    {   /*Calcul des PV de race*/
        temp = 0;
        for(i=0;i<donnees->DV[0];i++)    /*Calcul des PV*/
            temp += NbAlea1b (donnees->DV[1]);
        if (temp > PV_race)    /*Si le rsultat est plus important que le maximum atteint*/
            PV_race = temp;        /*Devient le maximum*/
    }
    for (j=0;j<3;j++)  /*Bcl sur le nb de lanc (3)*/
    {   /*Calcul des PV de classe*/
        temp = donnees->des_PV;
        for(i=0;i<donnees->niveau-1;i++)    /*Calcul des PV*/
            temp += NbAlea1b (donnees->des_PV);
        if (temp > donnees->PV)    /*Si le rsultat est plus important que le maximum atteint*/
            donnees->PV = temp;        /*Devient le maximum*/
    }
    con = donnees->bonus_carac[2];    /*Prend le bonus de constitution*/
    if (con < 0)
        con = 0;   /*Un bonus ngatif ne baisse pas les PV*/
    donnees->PV += con*donnees->niveau;  /*Ajoute le modificateur de constitution*/
    donnees->PV += donnees->DV[2];  //Ajoute le bonus au pv de la race
    donnees->PV += PV_race; //Ajoute les PV de la race  ceux de la classe
    if(donnees->des_PV < 8)
        donnees->XP -= 1;    /*-1 XP si d de vie infrieur  8*/
    if(donnees->des_PV > 8)
        donnees->XP += 1;    /*+1 XP si d de vie suprieur  8*/
}

void afficheur_txt (struct donnees_perso *donnees)
{
    FILE* Fichier_temp;
    FILE* Fichier_txt;
    int i;
    char chaine[255];
    strcpy(donnees->chemin_perso,"..\\Z Fichiers cres\\");    //Construit le nom de la feuille de perso
    if(donnees->dossier_pr[0] != '\0')
    {
        strcat(donnees->chemin_perso,donnees->dossier_pr);    //Ajoute le dossier principal si il existe
        strcat(donnees->chemin_perso,"\\");
    }
    if(donnees->dossier_sec[0] != '\0')
    {
        strcat(donnees->chemin_perso,donnees->dossier_sec);    //Ajoute le dossier secondaire si il existe
        strcat(donnees->chemin_perso,"\\");
    }
    strcat(donnees->chemin_perso,donnees->nom);
    strcat(donnees->chemin_perso,", ");
    strcat(donnees->chemin_perso,donnees->classe);
    strcat(donnees->chemin_perso," lvl");
    strcat(donnees->chemin_perso,inttochar(donnees->niveau,chfunc));
    strcat(donnees->chemin_perso,".txtp");
    Fichier_txt = ouvre_fichier(donnees->chemin_perso,"w");
    fprintf(Fichier_txt,"Nom: %s\n", donnees->nom);
    fprintf(Fichier_txt,"Classe de personnage: %s\n", donnees->classe);
    fprintf(Fichier_txt,"Niveau: %d\n", donnees->niveau);
    fprintf(Fichier_txt,"Traits physiques:\n");
    fprintf(Fichier_txt," Race: %s\n", donnees->race);
    fprintf(Fichier_txt," Sexe: %s\n", donnees->sexe);
    fprintf(Fichier_txt," Poids: %dKg (%s)\n", donnees->poids, donnees->IMC);
    fprintf(Fichier_txt," Taille: %dcm (%s)\n", donnees->taille, donnees->cat_taille);
    fprintf(Fichier_txt," Age: %d ans", donnees->age);
    if (donnees->cat_age == 0)
        fprintf(Fichier_txt," (Jeune)\n");
    if (donnees->cat_age == 1)
        fprintf(Fichier_txt," (Age mr)\n");
    if (donnees->cat_age == 2)
        fprintf(Fichier_txt," (Grand ge)\n");
    if (donnees->cat_age == 3)
        fprintf(Fichier_txt," (Age vnrable)\n");
    if (donnees->cat_age == 4)
        fprintf(Fichier_txt," (Trop ag, il devrait tre mort!!!)\n");
    Trait_physique(Fichier_txt,donnees);
    fprintf(Fichier_txt,"Caractristiques:\n");
    fprintf(Fichier_txt,"Force: %d", donnees->caracteristique[0]);
    if (donnees->bonus_carac[0] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[0]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[0]);
    fprintf(Fichier_txt,"Dextrit: %d", donnees->caracteristique[1]);
    if (donnees->bonus_carac[1] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[1]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[1]);
    fprintf(Fichier_txt,"Constitution: %d", donnees->caracteristique[2]);
    if (donnees->bonus_carac[2] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[2]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[2]);
    fprintf(Fichier_txt,"Intelligence: %d", donnees->caracteristique[3]);
    if (donnees->bonus_carac[3] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[3]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[3]);
    fprintf(Fichier_txt,"Sagesse: %d", donnees->caracteristique[4]);
    if (donnees->bonus_carac[4] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[4]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[4]);
    fprintf(Fichier_txt,"Charisme: %d", donnees->caracteristique[5]);
    if (donnees->bonus_carac[5] < 0) /*Si bonus ngatif*/
        fprintf(Fichier_txt," (%d)\n", donnees->bonus_carac[5]);
    else
        fprintf(Fichier_txt," (+%d)\n", donnees->bonus_carac[5]);
    fprintf(Fichier_txt,"%s",donnees->vision);
    fprintf(Fichier_txt,"Alignement: %s\n", string(donnees,"#Alignements",0,chaine));
    fprintf(Fichier_txt,"Jet d'attaque: +%d", donnees->bba);
    i = donnees->bba;
    while (i >= 6)
    {
        i -= 5;
        fprintf(Fichier_txt,"\\+%d",i);
    }
    fprintf(Fichier_txt," (%s)\n", string(donnees,"#Attaque",0,chaine));
    fprintf(Fichier_txt,"Jet de sauvegarde:\n");
    fprintf(Fichier_txt," Rflexe: +%d\n", donnees->JS_ref);
    fprintf(Fichier_txt," Vigueur: +%d\n", donnees->JS_vig);
    fprintf(Fichier_txt," Volont: +%d\n", donnees->JS_vol);
    fprintf(Fichier_txt,"Points de vie: %d (DV=%d", donnees->PV, donnees->DV[0]);
    if(donnees->DV[0] > 0)
        fprintf(Fichier_txt,"d%d", donnees->DV[1]);
    fprintf(Fichier_txt,"+%dd%d+%d)\n", donnees->niveau, donnees->des_PV, donnees->DV[2]);
    if(donnees->av_pe == 1)  //Aventurier -> arme, armure et bouclier
    {
        fprintf(Fichier_txt,"Armure: %s\n", string(donnees,"#Armures",0,chaine));
        fprintf(Fichier_txt,"Arme principale: %s\n", string(donnees,"#Armes",1,chaine));
        if (donnees->arme2)
            fprintf(Fichier_txt,"Arme secondaire: %s\n", string(donnees,"#Armes",2,chaine));
        if (donnees->arme3)
            fprintf(Fichier_txt,"Arme tertiaire: %s\n", string(donnees,"#Armes",3,chaine));
        if (donnees->bouclier)
            fprintf(Fichier_txt,"Bouclier: %s\n", string(donnees,"#Boucliers",0,chaine));
        else
        {    /*Si bouclier, le test d'XP est effectu avec le bouclier*/
            if(donnees->bonus_carac[1] >= 5)
                donnees->XP += 1;   /*Esquive suprieur  20*/
        }
    }
    i=0;
    fprintf(Fichier_txt,"Langues parles:\n");
    while(donnees->langue[i])
    {
        fprintf(Fichier_txt,"%s\n", string(donnees,"#Langues",i++,chaine));
    }
    fprintf(Fichier_txt,">\nDons:\n");
    i=0;
    while(donnees->don[i])
    {
        fprintf(Fichier_txt,"%s %s\n", string(donnees,"#Dons",i,chaine), donnees->arg_don[i]);
        i++;
    }
    if (donnees->don[50] != 0)
        fprintf(Fichier_txt,"    !!! Il reste %d dons  rpartir !!!\n", donnees->don[50]);
    fprintf(Fichier_txt,">\nComptences:\n");
    i=0;
    while(donnees->competences[i])
    {
        fprintf(Fichier_txt,"%s %s +%d\n", string(donnees,"#Comptences",i,chaine), donnees->arg_competences[i], donnees->nivo_competences[i]);
        i++;
    }
    if (donnees->competences[50] != 0)
        fprintf(Fichier_txt,"    !!! Il reste %d points de comptences  rpartir !!!\n", donnees->competences[50]);
    fprintf(Fichier_txt,">\n");
    if(donnees->av_pe == 1)  //Objets magiques pour aventurier seulement
        fprintf(Fichier_txt,"%.0f objets magiques  dterminer.\n", floor(donnees->niveau/2)+NbAlea1b(donnees->niveau));
    calcul_XP(donnees);
    fprintf(Fichier_txt,"Points d'exprience: %d\n", donnees->XP);
    Fichier_temp = ouvre_fichier("..\\Donnes\\temp.tmp","r");
    fprintf(Fichier_txt,"Capacits spciales:\n");
    fgets(chaine,255,Fichier_temp);
    while (chaine[0] != '<')
    {    /*Affichage des capacits spciales et de l'quipement*/
        fprintf(Fichier_txt,"%s",chaine);
        fgets(chaine,255,Fichier_temp);
    }
    if(donnees->grimoire == 1)
    {
        fseek(Fichier_txt,-3,SEEK_END);      //Retourne en arrire jusqu' la fin de l'quipement
        fprintf(Fichier_txt," ");   //Efface le > de fin d'quipement, pour l'ajout des composantes de sorts
    }
    fclose(Fichier_temp);
    fclose(Fichier_txt);
}

int afficheur_html (struct donnees_perso *donnees, int indic)
{
    FILE* Fichier_source;
    FILE* Fichier_html;
    FILE* Fragments;
    FILE* Fichier_txt;
    char chaine[255];
    char chaine2[255];
    char nomfichier[255];
    int borne, i;
    strcpy(nomfichier,donnees->chemin_perso);
    Fichier_source = ouvre_fichier("..\\Donnes\\Sources html\\Source base.htm","r");
    if (indic == 0)
        Fichier_txt = ouvre_fichier(nomfichier,"r"); /*Ouvre le fichier normalement*/
    else
    { /*Ouvre le fichier sans s'arreter en cas d'erreur*/
        strcpy(chaine,invers_acc(nomfichier,chfunc));
        if ((Fichier_txt = fopen(chaine,"r")) == NULL)    /*Ouvre le fichier*/
        {
            printf("\n!!! Une erreur est survenue durant l'ouverture du fichier %s.\n", nomfichier);
            Pause();                /*Envoie un message d'erreur  l'utilisateur*/
            return 1;
        }
    }
    nomfichier[strlen(nomfichier)-4] = '\0';
    strcat(nomfichier,"html");
    Fichier_html = ouvre_fichier(nomfichier,"w");
    Fragments = ouvre_fichier("..\\Donnes\\Sources html\\Fragments.htm","r");
    do
    {
        fgets(chaine,255,Fichier_source);
        if (chaine[0] == '#')
        {
            for(i=0;i<(int)strlen(chaine);i++)
                chaine[i] = chaine[i+1];
            borne = atoi(chaine);
            rewind(Fichier_txt);
            switch (borne)
            {
                case 1:
                    /*Titre du fichier*/
                    if (strstr(nomfichier,"\\") != NULL)
                    {
                        strcpy(nomfichier,strrchr(nomfichier,'\\'));
                        Efface_char(nomfichier,"\\");
                    }
                    fprintf(Fichier_html,"%s",nomfichier);
                    borne=1;
                    break;
                case 2:
                    /*Classe de personnage*/
                    strcpy(chaine2,"Classe de personnage: ");
                    borne=0;
                    break;
                case 3:
                    /*Race du personnage*/
                    strcpy(chaine2,"Race: ");
                    borne=0;
                    break;
                case 4:
                    /*Sexe du personnage*/
                    strcpy(chaine2,"Sexe: ");
                    borne=0;
                    break;
                case 5:
                    /*Poids*/
                    strcpy(chaine2,"Poids: ");
                    borne=0;
                    break;
                case 6:
                    /*Taille*/
                    strcpy(chaine2,"Taille: ");
                    borne=0;
                    break;
                case 7:
                    /*Age*/
                    strcpy(chaine2,"Age: ");
                    borne=0;
                    break;
                case 8:
                    /*Alignement*/
                    strcpy(chaine2,"Alignement: ");
                    borne=0;
                    break;
                case 9:
                    /*Force*/
                    strcpy(chaine2,"Force: ");
                    borne=0;
                    break;
                case 10:
                    /*Dextrit*/
                    strcpy(chaine2,"Dextrit: ");
                    borne=0;
                    break;
                case 11:
                    /*Constitution*/
                    strcpy(chaine2,"Constitution: ");
                    borne=0;
                    break;
                case 12:
                    /*Intelligence*/
                    strcpy(chaine2,"Intelligence: ");
                    borne=0;
                    break;
                case 13:
                    /*Sagesse*/
                    strcpy(chaine2,"Sagesse: ");
                    borne=0;
                    break;
                case 14:
                    /*Charisme*/
                    strcpy(chaine2,"Charisme: ");
                    borne=0;
                    break;
                case 15:
                    /*Langues*/
                    strcpy(chaine2,"Langues parles:");
                    borne=-15;
                    break;
                case 16:
                    /*Vision*/
                    while(strstr(chaine,"Charisme: ") == NULL) /*C'est la ligne suivante*/
                    {    /*Recherche de la ligne correspondante*/
                        if (fgets(chaine,255,Fichier_txt) == NULL)
                        {
                            putsacc("Erreur de lecture dans le fichier au format .txtp, impossible de trouver \"Charisme: \"");
                            Pause();
                            exit(0);
                        }
                    }
                    fgets(chaine,255,Fichier_txt);
                    fprintf(Fichier_html,"%s",chaine);  /*Affiche la vision*/
                    borne=1;
                    break;
                case 17:
                    /*Capacits spciales*/
                    strcpy(chaine2,"Capacits spciales:");
                    borne=-17;
                    break;
                case 18:
                    /*Armure*/
                    strcpy(chaine2,"Armure: ");
                    borne=0;
                    break;
                case 19:
                    /*Bouclier*/
                    strcpy(chaine2,"Bouclier: ");
                    borne=19;
                    break;
                case 20:
                    /*Arme primaire*/
                    strcpy(chaine2,"Arme principale: ");
                    borne=0;
                    break;
                case 21:
                    /*Arme secondaire*/
                    strcpy(chaine2,"Arme secondaire: ");
                    borne=21;
                    break;
                case 22:
                    /*Arme tertiaire*/
                    strcpy(chaine2,"Arme tertiaire: ");
                    borne=22;
                    break;
                case 23:
                    /*Niveau*/
                    strcpy(chaine2,"Niveau: ");
                    borne=0;
                    break;
                case 24:
                    /*Points de vie*/
                    strcpy(chaine2,"Points de vie: ");
                    borne=0;
                    break;
                case 25:
                    /*Jet d'attaque*/
                    strcpy(chaine2,"Jet d'attaque: ");
                    borne=0;
                    break;
                case 26:
                    /*JS rflexe*/
                    strcpy(chaine2," Rflexe: ");
                    borne=0;
                    break;
                case 27:
                    /*JS vigueur*/
                    strcpy(chaine2," Vigueur: ");
                    borne=0;
                    break;
                case 28:
                    /*JS volont*/
                    strcpy(chaine2," Volont: ");
                    borne=0;
                    break;
                case 29:
                    /*Dons*/
                    strcpy(chaine2,"Dons:");
                    borne=-29;
                    break;
                case 30:
                    /*Comptences*/
                    strcpy(chaine2,"Comptences:");
                    borne=-30;
                    break;
                case 31:
                    /*Equipements*/
                    strcpy(chaine2,"#Equipements:");
                    borne=-31;
                    break;
                case 32:
                    /*Nombre d'objets magiques*/
                    while(strstr(chaine,"objets magiques  dterminer.") == NULL)
                    {    /*Recherche de la ligne correspondante*/
                        if (fgets(chaine,255,Fichier_txt) == NULL)
                        {
                            putsacc("Erreur de lecture dans le fichier au format .txtp, impossible de trouver \"objets magiques  dterminer.\"");
                            Pause();
                            exit(0);
                        }
                    }
                    fprintf(Fichier_html,"%s",chaine);  /*Affiche les objets magiques*/
                    borne=1;
                    break;
                case 33:
                    /*Traits physiques*/
                    strcpy(chaine2,"Age: ");
                    borne=-33;
                    break;
                case 34:
                    /*XP*/
                    strcpy(chaine2,"Points d'exprience: ");
                    borne=0;
                    break;
                case 35:
                    /*Nom du perso*/
                    strcpy(chaine2,"Nom:");
                    borne=0;
                    break;
            }
            rewind(Fichier_txt);
            if (borne==0)
            {
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        printf("Erreur de lecture dans le fichier au format .txtp, impossible de trouver \"");
                        putsacc(chaine2);
                        puts("\"");
                        Pause();
                        exit(0);
                    }
                }
                Efface_char(chaine,": ");
                fprintf(Fichier_html,"%s",chaine);
            }
            if (borne>1)
            {
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        borne=-1;  /*La chaine n'est pas trouve, pas d'affichage de ce type*/
                        break;
                    }
                }
                if (borne>1)
                {
                    Efface_char(chaine,": ");
                    while(borne != atoi(chaine2))
                    {    /*Recherche de la ligne correspondante dans les fragments html*/
                        fgets(chaine2,255,Fragments);
                        Efface_char(chaine2,"#");
                    }
                    fgets(chaine2,255,Fragments);
                    while(chaine2[0] != '#')    /*Boucle tant qu'il ne tombe pas sur les fragments suivants*/
                    {
                        if (chaine2[0] == '~')  /*Si il faut placer la string*/
                            fprintf(Fichier_html,"%s",chaine);
                        else
                            fprintf(Fichier_html,"%s",chaine2);
                        fgets(chaine2,255,Fragments);
                    }
                    rewind(Fragments);
                }
            }
            else if (borne<0)
            {
                borne *= -1;      /*Rtabli la valeur positive*/
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        printf("Erreur de lecture dans le fichier au format .txtp, impossible de trouver \"");
                        putsacc(chaine2);
                        puts("\"");
                        Pause();
                        exit(0);
                    }
                }
                fgets(chaine,255,Fichier_txt);
                while(chaine[0] != '>')
                {
                    while(borne != atoi(chaine2))
                    {    /*Recherche de la ligne correspondante dans les fragments html*/
                        fgets(chaine2,255,Fragments);
                        Efface_char(chaine2,"#");
                    }
                    fgets(chaine2,255,Fragments);
                    while(chaine2[0] != '#')    /*Boucle tant qu'il ne tombe pas sur les fragments suivants*/
                    {
                        if (chaine2[0] == '~')  /*Si il faut placer la string*/
                            fprintf(Fichier_html,"%s",chaine);
                        else
                            fprintf(Fichier_html,"%s",chaine2);
                        fgets(chaine2,255,Fragments);
                    }
                    rewind(Fragments);
                    fgets(chaine,255,Fichier_txt);
                }
            }
        }
        else
            fprintf(Fichier_html,"%s",chaine);
    }while(strstr(chaine,"</html>") == NULL);
    fclose(Fichier_source);
    fclose(Fichier_html);
    fclose(Fragments);
    fclose(Fichier_txt);
    return 0;
}

char* string (struct donnees_perso *donnees, const char *type, int i, char* chaine)
{   /*Fait correspondre les numros aux valeurs string*/
    FILE* fichier;
    int val,nb,indicXP=0;
    if (!strcmp(type,"#Attaque"))
        val = donnees->attaque;
    if (!strcmp(type,"#Jets de sauvegarde"))
    {
        if (i == 1)
            val = donnees->JS_ref;
        if (i == 2)
            val = donnees->JS_vig;
        if (i == 3)
            val = donnees->JS_vol;
    }
    if (!strcmp(type,"#Alignements"))
        val = donnees->alignement;
    if (!strcmp(type,"#Dons"))
    {
        indicXP=1;
        val = donnees->don[i];
    }
    if (!strcmp(type,"#Comptences"))
        val = donnees->competences[i];
    if (!strcmp(type,"#Langues"))
        val = donnees->langue[i];
    if (!strcmp(type,"#Armes"))
    {
        indicXP=1;
        if (i == 1)
            val = donnees->arme1;
        if (i == 2)
            val = donnees->arme2;
        if (i == 3)
            val = donnees->arme3;
    }
    if (!strcmp(type,"#Armures"))
    {
        indicXP=1;
        val = donnees->armure;
    }
    if (!strcmp(type,"#Boucliers"))
    {
        indicXP=1;
        val = donnees->bouclier;
    }
    fichier = ouvre_fichier("Donnes.ini","r");    /*Ouvre le fichier des donnes*/
    do
    {    /*Recherche du paragraphe des donnes*/
        fgets(chaine,255,fichier);
    } while (strstr(chaine,type) == NULL);
    do
    {
        fgets(chaine,255,fichier);
        nb = atoi(chaine);   /*Lit le numro de la ligne*/
        if (nb == val)   /*Si le numro correspond*/
        {
            Efface_char(chaine,":");
            Efface_n(chaine);      //Retire le \n
        }   /*Il reste le mot!*/
        else
            nb=-1;
    } while (nb==-1); /*Bcl tant que le bon numro n'est pas trouv*/
    fclose(fichier);
    if(indicXP == 1)
    {
        if(chaine[0] == 'j')
            donnees->XP += 1;  /*Projectiles*/
        if(chaine[0] == 'a')
        {
            Efface_char(chaine,"a");
            val = atoi(chaine);
            if (val >= 20)
                donnees->XP += 1;   /*Armure suprieur  20*/
        }
        if(chaine[0] == 'b')
        {
            Efface_char(chaine,"b");
            val = atoi(chaine);
            if(10+val+donnees->bonus_carac[1]*2 >= 20)   /*10+bouclier + esquive dex*/
                donnees->XP += 1;   /*Esquive suprieur  20*/
        }
        if (chaine[0] == 'X' && chaine[1] == 'P')
        {
            Efface_char(chaine,"+");
            donnees->XP += atoi(chaine);
        }
        Efface_char(chaine,".");
    }
    return(chaine);   /*Retourne la string*/
}

void Trait_physique (FILE* Fichier_txt, struct donnees_perso *donnees)
{
    FILE* fichiertable;     /*Pointe le mme fichier, mais sert  utiliser les tables alatoires*/
    FILE* Trait_physiques;  /*Pointe le mme fichier, mais sert aux lignes des diffrents traits physiques*/
    char chaine[255];
    char Trait[255];
    int index, alea, compt0, cpt0;    /*Pour gen alea*/
    sprintf(chaine,"..\\Donnes\\Traits physiques\\Trait physiques %s %s.tbl", donnees->race, donnees->sexe);
    fichiertable = ouvre_fichier(chaine,"r");
    Trait_physiques = ouvre_fichier(chaine,"r");
    fgets(Trait,255,Trait_physiques);    /*Saisi le premier trait physique*/
    do
    {
        Trait[0] = '#';    /*Remplace le '_' par un '#' pour la recherche des tables*/
        Efface_n(Trait);      //Retire le \n
        rewind(fichiertable);
        fgets(chaine,255,fichiertable);
        while (strcmp(chaine,Trait))    /*Repre la table du trait physique slectionn*/
        {
            fgets(chaine,255,fichiertable);
            if (chaine[0] == '#')
                Efface_n(chaine);      //Retire le \n
        }
        /*Gen alea modifi*/
        index=-1;
        compt0=0;
        fgets(chaine,255,fichiertable);
        alea = jet_de_des_gen_alea(&index,chaine);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            compt0++;
            while (verif_val_gen_alea (&index, chaine, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(chaine,255,fichiertable);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (chaine[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            compt0++;
            alea = jet_de_des_gen_alea(&index,chaine); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        strcpy(chaine,string_gen_alea (index,chaine));   /*Isole la chaine de caractre*/
        Trait[0] = ' ';    /*Remplace le '#' par un espace*/
        fprintf(Fichier_txt,"%s: ", Trait);
        fprintf(Fichier_txt,"%s.\n", chaine);
        fgets(Trait,255,Trait_physiques);    /*Saisi le trait physique suivant*/
    }while(Trait[0] != '.');
    fprintf(Fichier_txt,">\n");
    fclose(fichiertable);
    fclose(Trait_physiques);
}

void calcul_XP(struct donnees_perso *donnees)
{
    FILE* fichier;
    char chaine[255];
    int max,val,dif;
    fichier = ouvre_fichier("..\\Donnes\\XP.ini","r");
    fgets(chaine,255,fichier);
    Efface_char(chaine,"=");
    max = atoi(chaine);
    if(donnees->XP <= max)    /*XP dtaill*/
    {
        do
        {  /*Recherche de la ligne de l'XP*/
            fgets(chaine,255,fichier);
            val = atoi(chaine);
        } while (val != donnees->XP);
        Efface_char(chaine,":");
        donnees->XP = atoi(chaine);    /*Lit la valeur en XP*/
    }
    else    /*XP suprieur*/
    {
        dif = donnees->XP - max; /*dif prend la diffrence entre max et la valeur XP*/
        do
        {  /*Recherche de la ligne de l'XP max dtaill*/
            fgets(chaine,255,fichier);
            val = atoi(chaine);
        } while (val != max);
        Efface_char(chaine,":");
        donnees->XP = atoi(chaine);    /*Lit la valeur en XP maximum dtaille*/
        fgets(chaine,255,fichier);     /*Saisi la ligne suivante, XP suprieur*/
        Efface_char(chaine,":");
        Efface_char(chaine,"+");
        val = atoi(chaine); /*Rutilise max pour prendre la valeur d'XP suplmentaire*/
        donnees->XP += dif*val;    /*Augmente l'XP*/
    }
    fclose(fichier);
}

char* gen_alea (const char* nomfichier, char* ligne)
{
    FILE* temp;
    #ifdef WIN32    /*win*/
        sprintf(ligne,"cd \"..\\Gnrateur alatoire\" && Generateur_aleatoire.exe Table=\"%s\" Nombre=1 Affichage=3", nomfichier);
    #else /*linux*/
        sprintf(ligne,"cd \"../%s\" && ./Generateur_aleatoire Table=\"%s\" Nombre=1 Affichage=3", acc("Gnrateur alatoire",chfunc), nomfichier);
    #endif
    system(ligne); /*Appel le gnrateur alatoire en ligne de commande*/
    temp = ouvre_fichier("..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
    do
    {
        fgets(ligne,255,temp);  /*Lit le rsultat du gnrateur alatoire*/
    }while(ligne[0] == '#');    //Saute les titres
    Efface_n(ligne);      //Retire le \n
    fclose(temp);
    return ligne;
}

int verif_val_gen_alea (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int jet_de_des_gen_alea (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[++*index] == 'd'))      /*Si un d doit tre lanc*/
    {
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

char* string_gen_alea (int index, char* ligne)
{
    int i=0;
    char string[255];
    strcpy(string,ligne);
    while (index < (int)strlen(string))    /*Copie ce qui doit tre renvoy dans "string"*/
        ligne[i++] = string[index++];
    ligne[i] = '\0';    //termine la chaine
    Efface_n(ligne);
    return ligne;
}

void Grimoire (struct donnees_perso *donnees, struct donnees_sorts *Dsorts)
{
    char chemin[255];
    int i;
    int tab[50];
    char appel[255];
    //Dtermine le chemin du perso
    if(strstr(donnees->chemin_perso,"\\") != NULL)
    {
        i = index_ch(donnees->chemin_perso,"\\",tab);
        strcpy(chemin,donnees->chemin_perso);
        chemin[tab[i-1]] = '\0';     /*Termine la chaine aprs au dernier \*/
        changeslash(chemin);
    }
    else
        chemin[0] = '\0'; /*Chaine vide si pas de chemin*/
    //Cre la commande d'appel de Grimoire.exe
    #ifdef WIN32    /*win*/
        strcpy(appel,"cd ..\\Grimoire && Grimoire.exe Chemin=\"");
    #else /*linux*/
        strcpy(appel,"cd ../Grimoire && ./Grimoire Chemin=\"");
    #endif
    strcat(appel,chemin);   //Inscrit le chemin de la feuille de perso
    strcat(appel,"\" Nom=\"");
    strcat(appel,donnees->nom); //Inscrit le nom du perso
    strcat(appel,"\" Type=\"");
    strcat(appel,Dsorts->type_perso);   //Inscrit la classe
    strcat(appel,".");  //Sparateur des 2 parties de l'arg
    strcat(appel,Dsorts->type);     //Inscrit le type de perso
    strcat(appel,"\" Spe=\"");
    strcat(appel,Dsorts->spe);  //Inscrit la spe de mage
    strcat(appel,"\" OppDo1=\"");
    if(Dsorts->domaine1[0] == '0')  /*Si pas de domaine, affiche l'cole interdite*/
        strcat(appel,Dsorts->interdit1);
    else
        strcat(appel,Dsorts->domaine1);
    strcat(appel,"\" OppDo2=\"");
    if(Dsorts->domaine2[0] == '0')  /*Si pas de domaine, affiche l'cole interdite*/
        strcat(appel,Dsorts->interdit2);
    else
        strcat(appel,Dsorts->domaine2);
    strcat(appel,"\" Niveau=");
    strcat(appel,inttochar(donnees->niveau, chfunc));   //Inscrit le niveau, transform en char
    if (!strcmp(Dsorts->type_perso,"Assassin"))
        Dsorts->carac = donnees->caracteristique[3];
    if (!strcmp(Dsorts->type_perso,"Barde"))
        Dsorts->carac = donnees->caracteristique[5];
    if (!strcmp(Dsorts->type_perso,"Druide"))
        Dsorts->carac = donnees->caracteristique[4];
    if (!strcmp(Dsorts->type_perso,"Ensorceleur"))
        Dsorts->carac = donnees->caracteristique[5];
    if (!strcmp(Dsorts->type_perso,"Magicien"))
        Dsorts->carac = donnees->caracteristique[3];
    if (!strcmp(Dsorts->type_perso,"Paladin"))
        Dsorts->carac = donnees->caracteristique[4];
    if (!strcmp(Dsorts->type_perso,"Prtre"))
        Dsorts->carac = donnees->caracteristique[4];
    if (!strcmp(Dsorts->type_perso,"Rdeur"))
        Dsorts->carac = donnees->caracteristique[4];
    if (!strcmp(Dsorts->type_perso,"Combattant profane"))
        Dsorts->carac = donnees->caracteristique[3];
    strcat(appel," Bcarac=");
    strcat(appel,inttochar(Dsorts->carac, chfunc));     //Inscrit le bonus de carac, transform en char
    strcat(appel," Affichage=3");
    system(appel); /*Appel le gnrateur de grimoire en ligne de commande*/
}

void increment_fichier (char* nom)
{
    FILE* fichierincr;
    char chaine[255];
    int i;
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","w");
    listing_doss("..\\Z Fichiers cres",fichierincr,0,"",1); //Appel la commande de listing de dossier
    fclose(fichierincr);
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","r+");
    i=1;
    while(fgets(chaine,255,fichierincr))    /*Lit le fichier tant qu'il ne tombe pas sur une ligne virge*/
    {    /*incrmente de 1 chaque fois qu'il trouve le mme nom que le fichier  crer*/
        if (strstr(chaine,nom) != NULL)
            i++;
    }
    fprintf(fichierincr,":%s_%d",nom, i);    /*Cre le nom du fichier  partir de NOM et du numro d'incrmentation*/
    rewind(fichierincr);
    do
    {
        fgets(chaine,255,fichierincr); /*Recherche le nom du fichier inscrit  la fin du fichier*/
    }while(chaine[0] != ':');
    Efface_char(chaine,":");
    strcpy(nom,chaine);
    fclose(fichierincr);
}

void profession (struct donnees_perso *donnees, int type_pop)
{
    char chaine[255];
    char chaine2[255];
    int OK, i;
    do
    {
        if(type_pop == 1) /*Population de village*/
            strcpy(chaine,gen_alea("..\\Cration de personnages\\Professions_pop village.tbl",chaine));
        if(type_pop == 2) /*Population de ville*/
            strcpy(chaine,gen_alea("..\\Cration de personnages\\Professions_pop.tbl",chaine));
        OK = atoi(chaine);   /*Rutilise OK pour lire la proba de la profession*/
        if (NbAlea1b(100) > OK)
            OK = 0;  /*Le jet de pourcentage est suprieur  la proba, rebcl*/
    }while(!OK);
    Efface_char(chaine,":");
    i=0;
    do
    {    /*Lit la profession*/
        donnees->profession[i] = chaine[i];
        i++;
    }while(chaine[i] != ':');
    donnees->profession[i] = '\0';  /*Termine la string*/
    Efface_char(chaine,":");
    Efface_char(chaine,".");
    donnees->niveau_mini = atoi(chaine);
    Efface_char(chaine,"-");
    donnees->niveau_max = atoi(chaine);
    Efface_char(chaine,":");
    donnees->av_pe = 2;   /*Peuple par dfaut*/
    if (chaine[0] == 'A')
        donnees->av_pe = 1;    /*Aventurier*/
    Efface_char(chaine,":");
    if(chaine[0] == 'T')
    {    /*Table secondaire*/
        Efface_char(chaine,".");
        strcpy(donnees->classe,gen_alea(chaine,chaine2));  /*Tire la classe selon la nouvelle table*/
    }
    else
    {    /*Classe*/
        Efface_char(chaine,".");
        strcpy(donnees->classe,chaine);
    }
}
