/* Programme de cration de monstres et cratures.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "Utilitaire.h"
#include "Jdr.h"
#include "Rand.h"
#include "Menu.h"

void compagnons (char *type_compagnon, struct info_perso *perso, int malus_lvl);

void archetypes (char *type_archetype, struct info_perso *perso);
void gestion$ (char* chaine, struct info_perso *perso);
void Trlist (char* chaine, struct info_perso *perso, FILE* fichier);
void calcul_XP(struct info_perso *perso, int sens);

int main (int argc,char *argv[])
{
    struct info_perso perso;
    char type_creature[100];
    char feuille_perso[255];
    int malus_lvl, i=0;
    Init_srand();
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    if(argc == 5)
    {
        Efface_char(argv[4],"=");
        affichage_arg = atoi(argv[4]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre (argc,argv,"Gnrateur de crature","Programme de cration de crature pour Donjons et dragons",color_sd("Generateur de creature",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(argc>1)   /*Arguments*/
    {
        if(argc != 5)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Gnrateur de cratures.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        strcpy(feuille_perso,argv[1]); /*Prend le nom de la feuille de perso, en 1er argument*/
        Efface_char(argv[2],"=");
        strcpy(type_creature,argv[2]); /*Prend le type et race, en 1er argument*/
        Efface_char(argv[3],"=");
        malus_lvl = atoi(argv[3]); /*Prend le malus de niveau, en 2e argument*/
    }
    if(argc==1)
    {   /*Si pas d'argument*/
        strcpy(type_creature,Menu("Menu.ini",chfunc,1,0));
        putsacc("\nDonner le chemin et nom de la feuille de perso du personnage concern (.txtp):\nSi la feuille de perso est au format html, utiliser le convertisseur html->txtp prsent dans le dossier Utilitaires.\nSi il n'y a pas de feuille de perso, noter NA.\n?: ");
        getsfix(feuille_perso,255);
        if((feuille_perso[0] == 'N' || feuille_perso[0] == 'n') && (feuille_perso[1] == 'A' || feuille_perso[1] == 'a') && feuille_perso[2] == '\0')
        {
            saisie_feuille_perso(&perso);   /*Appelle la fonction qui demandera toutes les infos sur le perso*/
            i=1;    /*indique feuille perso saisie  la main*/
        }
        putsacc("\nIndiquer l'ventuel malus au niveau effectif: -");
        malus_lvl = (int) interpret_calc("\0");
    }
    if(i == 0)  /*Si la saisie du perso n'a pas t effectue  la main*/
        scan_feuille_perso(feuille_perso,&perso);
    if(strstr(type_creature,"Archtype."))
        archetypes(type_creature,&perso);
    else if (strstr(type_creature,"Compagnon animal.") || strstr(type_creature,"Destrier de paladin.") || strstr(type_creature,"Familier."))
        compagnons(type_creature,&perso,malus_lvl);
    if(affichage_arg < 3)
        putsacc("\nCration termine.");
    if(argc==1)   /*Si pas d'argument*/
        Pause();
    return 0;
}

void compagnons (char *type_compagnon, struct info_perso *perso, int malus_lvl)
{
    FILE* compagnon_source;
    FILE* compagnon_cible;
    FILE* fichier;
    char chaine[255];
    char chaine2[255];
    char race[100];
    int a,b,c, cat_niv, JS=1, DVb, DV, bconstit, i,j, don[51], tours, type;
    int nivo_comp[50];
    char arg_don[50][100];
    /*Dtermine le type du compagnon*/
    if(strstr(type_compagnon,"Compagnon animal"))
        type = 1;
    if(strstr(type_compagnon,"Destrier de paladin"))
        type = 2;
    if(strstr(type_compagnon,"Familier"))
        type = 3;
    strcpy(race,type_compagnon);
    Efface_char(race,".");  /*Isole la race du compagnon*/
    #ifdef WIN32    /*win*/
    sprintf(chaine,"cd \"..\\Noms alatoires\" && Name_gen.exe Race=\"");
    #else /*linux*/
    sprintf(chaine,"cd \"../Noms %s\" && ./Name_gen Race=\"", acc("alatoires",chfunc));
    #endif
    if(type==1)
        strcat(chaine,"Compagnon animal");
    if(type==2)
        strcat(chaine,"Destrier de paladin");
    if(type==3)
        strcat(chaine,"Familier");
    strcat(chaine,"\" Sexe=\"0\" Nombre=1 Affichage=3");
    system(chaine); /*Appelle le gen name*/
    compagnon_cible = ouvre_fichier("..\\Noms alatoires\\Sortie name_gen.txt","r"); /*Rutilise compagnon_cible pour lire le nom tir par le name_gen*/
    fgets(chaine2,255,compagnon_cible);
    fgets(chaine2,255,compagnon_cible);
    Efface_n(chaine2);      //Retire le \n
    fclose(compagnon_cible);
    strcpy(chaine,"..\\Donnes\\Cratures\\");
    if(type==1)
        strcat(chaine,"Compagnon animal\\");
    if(type==2)
        strcat(chaine,"Destrier de paladin\\");
    if(type==3)
        strcat(chaine,"Familier\\");
    strcat(chaine,race);
    strcat(chaine,".txt"); /*Crer le chemin du fichier source compagnon en fonction du type de compagnon*/
    compagnon_source = ouvre_fichier(chaine,"r");
    strcpy(chaine,perso->chemin);
    strcat(chaine,perso->nom);
    if(type==1)
        strcat(chaine,", compagnon animal ");
    if(type==2)
        strcat(chaine,", destrier ");
    if(type==3)
        strcat(chaine,", familier ");
    strcat(chaine,race);
    strcat(chaine,", ");
    strcat(chaine,chaine2); /*Place le nom du compagnon dans le nom de fichier*/
    strcat(chaine,".txt"); /*Crer le fichier cible  partir du nom du perso, du type de compagnon et de son nom*/
    compagnon_cible = ouvre_fichier(chaine,"w");
    cat_niv=1; /*Niveau infrieur  3*/
    if(type==1)
    {   /*Compagnon animal*/
        if(perso->niveau-malus_lvl >= 3)
            cat_niv=3;
        if(perso->niveau-malus_lvl >= 6)
            cat_niv=6;
        if(perso->niveau-malus_lvl >= 9)
            cat_niv=9;
        if(perso->niveau-malus_lvl >= 12)
            cat_niv=12;
        if(perso->niveau-malus_lvl >= 15)
            cat_niv=15;
        if(perso->niveau-malus_lvl >= 18)
            cat_niv=18;
    }
    if(type==2)
    {   /*Destrier de paladin*/
        if(perso->niveau-malus_lvl >= 5)
            cat_niv=5;
        if(perso->niveau-malus_lvl >= 8)
            cat_niv=8;
        if(perso->niveau-malus_lvl >= 11)
            cat_niv=11;
        if(perso->niveau-malus_lvl >= 15)
            cat_niv=15;
    }
    if(type==3)
    {   /*Familier*/
        if(perso->niveau-malus_lvl >= 3)
            cat_niv=3;
        if(perso->niveau-malus_lvl >= 5)
            cat_niv=5;
        if(perso->niveau-malus_lvl >= 7)
            cat_niv=7;
        if(perso->niveau-malus_lvl >= 9)
            cat_niv=9;
        if(perso->niveau-malus_lvl >= 11)
            cat_niv=11;
        if(perso->niveau-malus_lvl >= 13)
            cat_niv=13;
        if(perso->niveau-malus_lvl >= 15)
            cat_niv=15;
        if(perso->niveau-malus_lvl >= 17)
            cat_niv=17;
        if(perso->niveau-malus_lvl >= 19)
            cat_niv=19;
    }
    if(type <= 2)
    {   /*Si compagnon animal ou destrier, calcul des DV sup*/
        do
        {   /*Cherche la ligne des DV*/
            fgets(chaine,255,compagnon_source);
        }while(strstr(chaine,"%%PV") == NULL);
        Efface_char(chaine,"(");
        DVb = atoi(chaine); /*Lit le nombre de DV de base du compagnon*/
        DV=DVb;
        if(type==1)
        {   /*Compagnon animal*/
            switch (cat_niv)
            {
                case 3:
                    DV = DVb+2;
                    break;
                case 6:
                    DV = DVb+4;
                    break;
                case 9:
                    DV = DVb+6;
                    break;
                case 12:
                    DV = DVb+8;
                    break;
                case 15:
                    DV = DVb+10;
                    break;
                case 18:
                    DV = DVb+12;
                    break;
            }
        }
        if(type==2)
        {   /*Destrier*/
            switch (cat_niv)
            {
                case 5:
                    DV = DVb+2;
                    break;
                case 8:
                    DV = DVb+4;
                    break;
                case 11:
                    DV = DVb+6;
                    break;
                case 15:
                    DV = DVb+8;
                    break;
            }
        }
        rewind(compagnon_source);
    }
    while(fgets(chaine,255,compagnon_source) != NULL)
    {
        if(strstr(chaine,"%%") != NULL)
        {   /*Si il trouve %%, mot cl insr, donne  modifier!*/
            if(type==1)
            {   /*Force et dex pour compagnon animal*/
                if(strstr(chaine,"%%Force") != NULL)
                { /*La force et la dextrit du compagnon augmente avec le niveau du matre*/
                    for(JS=1;JS<3;JS++) /*Reprend JS pour force puis dextrit*/
                    {
                        Efface_char(chaine," ");
                        a = atoi(chaine); /*Lit le score de force ou dex du compagnon*/
                        switch (cat_niv)
                        {
                            case 3:
                                a += 1; /*Augmente la force ou dex*/
                                break;
                            case 6:
                                a += 2;
                                break;
                            case 9:
                                a += 3;
                                break;
                            case 12:
                                a += 4;
                                break;
                            case 15:
                                a += 5;
                                break;
                            case 18:
                                a += 6;
                                break;
                        }
                        if (JS==1) /*Force*/
                            fprintf(compagnon_cible,"Force: %d (",a);
                        else /*Dex*/
                            fprintf(compagnon_cible,"Dextrit: %d (", a);
                        if(a < 10) /*Calcul le modif de force ou dex*/
                            b = (a-11)/2;
                        else
                            b = (a-10)/2;
                        if(b>=0)
                            fprintf(compagnon_cible,"+");
                        fprintf(compagnon_cible,"%d)\n",b);
                        if(JS==1)
                            fgets(chaine,255,compagnon_source); /*Prend la ligne de dex*/
                    }
                    JS=1; /*Rinitialise JS*/
                }
            }
            if(type==2)
            {   /*Force pour destrier de paladin*/
                if(strstr(chaine,"%%Force") != NULL)
                { /*La force du destrier augmente avec le niveau du matre*/
                    Efface_char(chaine," ");
                    a = atoi(chaine); /*Lit le score de force du destrier*/
                    switch (cat_niv)
                    {
                        case 5:
                            a += 1; /*Augmente la force*/
                            break;
                        case 8:
                            a += 2;
                            break;
                        case 11:
                            a += 3;
                            break;
                        case 15:
                            a += 4;
                            break;
                    }
                    fprintf(compagnon_cible,"Force: %d (",a);
                    if(a < 10) /*Calcul le modif de force*/
                        b = (a-11)/2;
                    else
                        b = (a-10)/2;
                    if(b>=0)
                        fprintf(compagnon_cible,"+");
                    fprintf(compagnon_cible,"%d)\n",b);
                }
            }
            if(strstr(chaine,"%%Constitution") != NULL)
            {
                Efface_char(chaine,":");
                fprintf(compagnon_cible,"Constitution:%s",chaine);
                Efface_char(chaine,"(");
                if(chaine[0] == '-')
                {
                    a=-1; /*bonus constitution ngatif*/
                    Efface_char(chaine,"-");
                }
                else
                {
                    a=1; /*Bonus constitution positif*/
                    Efface_char(chaine,"+");
                }
                bconstit = atoi(chaine) * a;

            }
            if(strstr(chaine,"%%Intelligence") != NULL)
            {
                if(type==1)
                {   /*Pour compagnon animal, lit seulement l'int*/
                    Efface_char(chaine," ");
                    fprintf(compagnon_cible,"Intelligence: %s",chaine);
                    a = atoi(chaine); /*Lit le score d'intelligence du compagnon*/
                    if(a==1)
                        tours = 3;
                    else    /*int + leve*/
                        tours = 6;
                }
                else
                {   /*L'intelligence du destrier ou familier augmente selon le niveau du matre*/
                    if(type==2)
                    {   /*Catgorie de niveau pour destrier*/
                        switch (cat_niv)
                        {
                            case 5:
                                a=6; /*Intelligence du destrier*/
                                b=-2; /*Bonus associ*/
                                break;
                            case 8:
                                a=7;
                                b=-2;
                                break;
                            case 11:
                                a=8;
                                b=-1;
                                break;
                            case 15:
                                a=9;
                                b=-1;
                                break;
                        }
                    }
                    if(type==3)
                    {   /*Catgorie de niveau pour familier*/
                        switch (cat_niv)
                        {
                            case 1:
                                a=6; /*Intelligence du familier*/
                                b=-2; /*Bonus associ*/
                                break;
                            case 3:
                                a=7;
                                b=-2;
                                break;
                            case 5:
                                a=8;
                                b=-1;
                                break;
                            case 7:
                                a=9;
                                b=-1;
                                break;
                            case 9:
                                a=10;
                                b=0;
                                break;
                            case 11:
                                a=11;
                                b=0;
                                break;
                            case 13:
                                a=12;
                                b=1;
                                break;
                            case 15:
                                a=13;
                                b=1;
                                break;
                            case 17:
                                a=14;
                                b=2;
                                break;
                            case 19:
                                a=15;
                                b=2;
                        }
                    }
                    fprintf(compagnon_cible,"Intelligence: %d (",a);
                    if(b>=0)
                        fprintf(compagnon_cible,"+");
                    fprintf(compagnon_cible,"%d)\n",b);
                }
            }
            if(strstr(chaine,"%%Attaque") != NULL)
            {
                if(type <= 2)
                {   /*Pour destrier et compagnon animal, calcul en fonction des DV*/
                    a = (int) floor(DV/1.31);    /*Calcul le bba comme pour un prtre, attaque moyenne*/
                    fprintf(compagnon_cible,"Jet d'attaque: +%d", a);
                    while (a >= 6)
                    {
                        a -= 5; /*Inscrit les ventuelles attaques secondaire*/
                        fprintf(compagnon_cible,"\\+%d",a);
                    }
                    fprintf(compagnon_cible,"\n");
                }
                if(type == 3)
                {   /*Pour familier, prend celui du matre si plus lev*/
                    fprintf(compagnon_cible,"Jet d'attaque: ");
                    Efface_char(chaine,"+");
                    a = atoi(chaine); /*Lit le bonus additionnel propre au familier*/
                    for(b=1;b<perso->attaque[0]+1;b++)
                        fprintf(compagnon_cible,"+%d\\", perso->attaque[b]+a);
                    fprintf(compagnon_cible,"+%d\n", perso->attaque[b]+a);
                }
            }
            if(strstr(chaine,"%%JS") != NULL)
            {
                if(type <= 2)
                {   /*Pour destrier et compagnon animal, calcul en fonction des DV*/
                    if(JS==1) /*JS rflexe*/
                    {
                        a = (int) floor(DV/2+2);    /*Calcul le jet de sauvegarde, lv*/
                        fprintf(compagnon_cible," Rflexe: +%d\n", a);
                    }
                    if(JS==2) /*JS Vigueur*/
                    {
                        a = (int) floor(DV/2+2);    /*Calcul le jet de sauvegarde, lv*/
                        fprintf(compagnon_cible," Vigueur: +%d\n", a);
                    }
                    if(JS==3) /*JS volont*/
                    {
                        if(type == 1)
                            a = (int) floor(DV/3);    /*Calcul le jet de sauvegarde, faible*/
                        if(type == 2)
                            a = (int) floor(DV/2+2);    /*Calcul le jet de sauvegarde, lv*/
                        fprintf(compagnon_cible," Volont: +%d\n", a);
                    }
                }
                if(type == 3)
                {   /*Pour familier, prend celui du matre si plus lev*/
                    Efface_char(chaine,"(");
                    a = atoi(chaine); /*Lit le jet de sauvegarde du familier*/
                    if(JS==1) /*JS rflexe*/
                    {
                        b = perso->JS_ref;
                        fprintf(compagnon_cible," Rflexe: +");
                    }
                    if(JS==2) /*JS Vigueur*/
                    {
                        b = perso->JS_vig;
                        fprintf(compagnon_cible," Vigueur: +");
                    }
                    if(JS==3) /*JS volont*/
                    {
                        b = perso->JS_vol;
                        fprintf(compagnon_cible," Volont: +");
                    }
                    if(a > b) /*Si le jet de sauvegarde du familier est plus lv*/
                        fprintf(compagnon_cible,"%d\n",a); /*Utilise le jet de sauvegarde du familier*/
                    else
                        fprintf(compagnon_cible,"%d\n",b); /*Utilise le jet de sauvegarde du matre*/
                }
                JS++; /*Pour le %%JS suivant*/
            }
            if(strstr(chaine,"%%PV") != NULL)
            {
                if(type <= 2)
                {   /*Pour Destrier et compagnon animal, calcul du nombre de PV en fonction des DV*/
                    Efface_char(chaine,"d");
                    a = atoi(chaine); /*a prend le ds de vie*/
                    b=0;
                    if(strstr(chaine,"+"))
                    {
                        Efface_char(chaine,"+");
                        b = atoi(chaine); /*b prend l'ventuel bonus*/
                    }
                    for (JS=0,i=0;i<3;i++)  /*Bcl sur le nb de lanc, soit 3*/ /*JS sert de variable pv*/
                    {   /*Calcul de la base de PV*/
                        for (j=0,c=0;j<DVb;j++)    /*Calcul des PV*/
                            c += NbAlea1b (a);
                        c += b; /*Ajoute le bonus lut prcdemment*/
                        if (c > JS)    /*Si le rsultat est plus important que le maximum atteint*/
                            JS = c;        /*Devient le maximum*/
                    }
                    for (a=0,i=0;i<3;i++)  /*Bcl sur le nb de lanc, soit 3*/ /*JS sert de variable pv*/
                    {   /*Calcul des PV sup, li auc DV sup */
                        for (j=0,c=0;j<DV-DVb;j++)    /*Calcul des PV*/
                            c = c + NbAlea1b(8) + bconstit;  /*Les DV sup sont en d8*/
                        if (c > a)    /*Si le rsultat est plus important que le maximum atteint*/
                            a = c;        /*Devient le maximum*/
                    }
                    fprintf(compagnon_cible,"Points de vie: %d (%dDV)\n", (JS+a), DV); /*Les PV sont la somme des 2 jets*/
                }
                if(type == 3)   /*Pour familier, pv matre/2*/
                    fprintf(compagnon_cible,"Points de vie: %d\n", perso->PV/2); /*PV = PV du matre / 2*/
            }
            if(strstr(chaine,"%%Armure") != NULL)
            {
                Efface_char(chaine,"+");
                a = atoi(chaine);   /*Lit le bonus d'armure de base*/
                if(type==1)
                {   /*Catgorie de niveau pour compagnon animal*/
                    switch (cat_niv)
                    {
                        case 3:
                            a += 4; /*Bonus d'armure*/
                            break;
                        case 6:
                            a += 8;
                            break;
                        case 9:
                            a += 12;
                            break;
                        case 12:
                            a += 16;
                            break;
                        case 15:
                            a += 20;
                            break;
                        case 18:
                            a += 24;
                            break;
                    }
                }
                if(type==2)
                {   /*Catgorie de niveau pour destrier*/
                    switch (cat_niv)
                    {
                        case 5:
                            a += 8; /*Bonus d'armure*/
                            break;
                        case 8:
                            a += 12;
                            break;
                        case 11:
                            a += 16;
                            break;
                        case 15:
                            a += 20;
                            break;
                    }
                }
                if(type==3)
                {   /*Catgorie de niveau pour familier*/
                    switch (cat_niv)
                    {
                        case 1:
                            a += 2; /*Bonus d'armure*/
                        case 3:
                            a += 4;
                            break;
                        case 5:
                            a += 6;
                            break;
                        case 7:
                            a += 8;
                            break;
                        case 9:
                            a += 10;
                            break;
                        case 11:
                            a += 12;
                            break;
                        case 13:
                            a += 14;
                            break;
                        case 15:
                            a += 16;
                            break;
                        case 17:
                            a += 18;
                            break;
                        case 19:
                            a += 20;
                    }
                }
                fprintf(compagnon_cible,"Armure: CA = +%d (",a);
                Efface_char(chaine,"(");
                fprintf(compagnon_cible,"%s",chaine); /*Inscrit la fin de la ligne*/
            }
            if(strstr(chaine,"%%Dons") != NULL)
            {   /*Ajoute des dons en fonction des DV sup*/
                for(i=0;i<50;i++)
                    strcpy(arg_don[i],"\0");
                for(i=0;i<51;i++)
                    don[i]=0;   /*Initialise les tableaux*/
                i=0;
                fgets(chaine,255,compagnon_source);
                while(chaine[0] != '>')
                {   /*Lit les dons dj possd*/
                    don[i] = atoi(chaine);  /*Lit le numro du don*/
                    if(strstr(chaine,"("))  /*Si il trouve une parenthse, info sup aprs le don ou arg*/
                    {
                        Efface_char(chaine,"(");
                        Efface_n(chaine);      //Retire le \n
                        strcpy(arg_don[i],"(");
                        strcat(arg_don[i],chaine);  /*Copie les info dans l'arg*/
                    }
                    i++;
                    fgets(chaine,255,compagnon_source);
                }
                a = (DV/3+1)-(DVb/3+1); /*a = nb don sup. Soit don actuel - don qu'il devrait dj posseder*/
                fgets(chaine,255,compagnon_source);     /*Prend la liste de don dispo*/
                j=0;
                while(don[j++] != 0);  /*Dplace l'index jusq'aux cases vides*/
                j--;
                fichier = ouvre_fichier("..\\Cration de personnages\\Donnes.ini","r");    /*Ouvre le fichier des donnes*/
                while(a != 0)    /*Tant qu'il reste des dons*/
                {
                    c = atoi(chaine);
                    rewind(fichier);
                    do
                    {    /*Recherche du paragraphe des dons dans le fichier de donnes*/
                        fgets(chaine2,100,fichier);
                    } while (strstr(chaine2,"#Dons") == NULL);
                    do
                    {
                        fgets(chaine2,255,fichier);
                        b = atoi(chaine2);   /*Lit le numro de la ligne*/
                        if (b == c)   /*Si le numro ne correspond pas*/
                            Efface_char(chaine2,"(");
                        else
                            b=0;
                    } while (!b); /*Bcl tant que le bon numro n'est pas trouv*/
                    JS = 1;   /* 0, indique que les conditions ne sont pas remplies, JS sert de variable binaire*/
                    do
                    {
                        if(chaine2[0] == 'd')   /*don=*/
                        {
                            Efface_char(chaine2,"=");
                            b = atoi(chaine2);
                            for(i=0;i<50;i++)
                            {
                                if (don[i] == b)
                                    i=99;    /*Vrifie si le personnage possde le don demand*/
                            }
                            if (i!=100)  /*Si le personnage ne possde pas le don*/
                                JS = 0;
                        }
                        if(chaine2[0] == 'b')    /*bba=*/
                        {
                            /*La condition du bba est ignore pour plus de simplicit*/
                        }
                        if(chaine2[0] == 'l')    /*lvl=*/
                        {
                            Efface_char(chaine2,"=");
                            b = atoi(chaine2);
                            if (DV < b)   /*Si le niveau est infrieur*/
                                JS = 0;
                        }
                        if(chaine2[0] == 'c')      /*c=*/
                        {
                            /*La condition sur les carac est ignore pour plus de simplicit*/
                        }
                        if (strstr(chaine2,",") != NULL)
                            Efface_char(chaine2,",");
                        else
                            break;
                    } while(JS);
                    if (JS)   /*Si les conditions sont remplies, don OK*/
                    {
                        don[j] = b;
                        a--;
                        while (isdigit(chaine[0]))
                        {            /*retire la valeur numrique de la chaine*/
                            for (i=0;i<(int)strlen(chaine);i++)
                                chaine[i] = chaine[i+1];
                        }
                        if(chaine[0] == 40)     /*Si le don a un argument. 40=(*/
                        {
                            c=0;
                            while (chaine[0] != 41)     /*41=)*/
                            {
                                arg_don[j][c++] = chaine[0];    /*Ecrit l'argument caractre par caractre*/
                                for (i=0;i<(int)strlen(chaine);i++)
                                    chaine[i] = chaine[i+1];
                            }
                            arg_don[j][c++] = 41;    /*Termine l'argument par )*/
                            arg_don[j][c] = '\0';    /*Termine la string*/
                        }
                        j++;
                    }
                    if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                        Efface_char(chaine,",");
                    else
                        break;    /*Si la boucle est termine*/
                }
                don[50] = a; /*Stocke le nombre de dons restant  la fin du tableau de dons*/
                rewind(fichier);
                i=0;
                while(don[i])
                {
                    do
                    {    /*Recherche du paragraphe des comptences*/
                        fgets(chaine,255,fichier);
                    } while (strstr(chaine,"#Dons") == NULL);
                    do
                    {
                        fgets(chaine,255,fichier);
                        a = atoi(chaine);   /*Lit le numro de la ligne*/
                        if (a == don[i])   /*Si le numro correspond*/
                        {
                            Efface_char(chaine,":");
                            Efface_n(chaine);      //Retire le \n
                        }   /*Il reste le mot!*/
                        else
                            a=-1;
                    } while (a==-1); /*Bcl tant que le bon numro n'est pas trouv*/
                    Efface_char(chaine,".");
                    fprintf(compagnon_cible,"%s %s\n", chaine, arg_don[i]);
                    i++;
                    rewind(fichier);
                }
                fclose(fichier);
                if (don[50] != 0)
                    fprintf(compagnon_cible,"    !!! Il reste %d dons  rpartir !!!\n", don[50]);
            }
            if(strstr(chaine,"%%comp") != NULL)
            {
                if(type <= 2)
                {   /*Pour destrier et compagnon animal, ajoute des comptences en fonction des DV sup*/
                    for(i=0;i<50;i++)
                        strcpy(arg_don[i],"\0");
                    for(i=0;i<51;i++)
                        nivo_comp[i]=0;
                    for(i=0;i<51;i++)
                        don[i]=0;   /*Initialise les tableaux*/
                    i=0;
                    fgets(chaine,255,compagnon_source);
                    while(chaine[0] != '>')
                    {   /*Lit les comptences dj possd*/
                        don[i] = atoi(chaine);  /*Lit le numro de la comptence*/
                        Efface_char(chaine,"+");
                        nivo_comp[i] = atoi(chaine);    /*Prend le niveau de la comp*/
                        if(strstr(chaine,"("))  /*Si il trouve une parenthse, info sup aprs la comp ou arg*/
                        {
                            Efface_char(chaine,"(");
                            Efface_n(chaine);      //Retire le \n
                            strcpy(arg_don[i],"(");
                            strcat(arg_don[i],chaine);  /*Copie les info dans l'arg*/
                        }
                        i++;
                        fgets(chaine,255,compagnon_source);
                    }
                    a = 2*(DV-DVb); /*a = nb comp sup. le bonus d'int est nglig puisque les compagnons n'ont jamais plus de 10 en int*/
                    fgets(chaine,255,compagnon_source);
                    j=0;
                    while(don[j++] != 0);  /*Dplace l'index jusq'aux cases vides*/
                    j--;
                    while(a != 0)    /*Tant qu'il reste des points de comptences*/
                    {
                        b = DV+3;    /*Dtermine le niveau max de comptence*/
                        c = atoi(chaine);
                        for(i=0;i<50;i++)
                        {
                            if (don[i] == c)   /*Vrifie si la comptence est dj dans le tableau*/
                                break;
                        }
                        if (i == 50)     /*Si la comptence n'est pas trouve dans le tableau*/
                            i = j++;   /*La comptence sera place  la suite dans le tableau*/
                        don[i] = c;     /*Place ou replace la comptence dans le tableau*/
                        if (b <= a)    /*Si la comptence peut tre mise au maximum*/
                        {
                            nivo_comp[i] += b;    /*La comptence est augmente du maximum de points*/
                            a -= b;   /*Les points placs sont soustrait du total*/
                        }
                        else   /*Si la comptence ne peut pas tre mise au maximum, points restant insuffisant*/
                        {
                            nivo_comp[i] += a;    /*La comptence est augmente du nombre de points restants*/
                            a = 0;   /*Le total est mis  0*/
                            break;
                        }
                        while (isdigit(chaine[0]))
                        {            /*retire la valeur numrique de la chaine*/
                            for (c=0;c<(int)strlen(chaine);c++)
                                chaine[c] = chaine[c+1];
                        }
                        if(chaine[0] == 40)     /*Si la comptence a un argument. 40=(*/
                        {
                            b=0;
                            while (chaine[0] != 41)     /*41=)*/
                            {
                                arg_don[i][b++] = chaine[0];    /*Ecrit l'argument caractre par caractre*/
                                for (c=0;c<(int)strlen(chaine);c++)
                                    chaine[c] = chaine[c+1];
                            }
                            arg_don[i][b++] = 41;    /*Termine l'argument par )*/
                            arg_don[i][b] = '\0';    /*Termine la string*/
                        }
                        if (strstr(chaine,",") != NULL)    /*Si il y  d'autre valeurs*/
                            Efface_char(chaine,",");
                        else
                            break;
                    }
                    don[50] = a; /*Stocke le nombre de points de comptences restant  la fin du tableau de comptences*/
                    i=0;
                    fichier = ouvre_fichier("..\\Cration de personnages\\Donnes.ini","r");    /*Ouvre le fichier des donnes*/
                    while(don[i])
                    {
                        do
                        {    /*Recherche du paragraphe des comptences*/
                            fgets(chaine,255,fichier);
                        } while (strstr(chaine,"#Comptences") == NULL);
                        do
                        {
                            fgets(chaine,255,fichier);
                            a = atoi(chaine);   /*Lit le numro de la ligne*/
                            if (a == don[i])   /*Si le numro correspond*/
                            {
                                Efface_char(chaine,":");
                                Efface_n(chaine);      //Retire le \n
                            }   /*Il reste le mot!*/
                            else
                                a=-1;
                        } while (a==-1); /*Bcl tant que le bon numro n'est pas trouv*/
                        fprintf(compagnon_cible,"%s +%d %s\n", chaine, nivo_comp[i], arg_don[i]);
                        i++;
                        rewind(fichier);
                    }
                    fclose(fichier);
                    if (don[50] != 0)
                        fprintf(compagnon_cible,"    !!! Il reste %d points de comptences  rpartir !!!\n", don[50]);
                }
                if(type == 3)
                {   /*Pour les familier, ajoute les comptences du matre*/
                    a=0;
                    while(perso->competences[a][0] != '>')
                    {
                        fprintf(compagnon_cible,"%s +%d\n", perso->competences[a], perso->nivo_competences[a]);
                        a++;
                    }
                }
            }
            if(strstr(chaine,"%%DV") != NULL)   /*Familier uniquement*/
                fprintf(compagnon_cible,"DV=%d\n", perso->niveau-malus_lvl);
            if(strstr(chaine,"%%Tours") != NULL)
            {
                switch(cat_niv)
                {
                    case 1:
                        tours += 1; /*tours sup*/
                        break;
                    case 3:
                        tours += 2;
                        break;
                    case 6:
                        tours += 3;
                        break;
                    case 9:
                        tours += 4;
                        break;
                    case 12:
                        tours += 5;
                        break;
                    case 15:
                        tours += 6;
                        break;
                    case 18:
                        tours += 7;
                        break;
                }
                for(i=0;i<50;i++)
                    don[i] = 0; /*Initialise le tableau don qui servira pour les tours*/
                #ifdef WIN32    /*win*/
                system("cd \"..\\Gnrateur alatoire\" && Generateur_aleatoire.exe Table=\"..\\Donnes\\Tables alatoires\\Tours dressage.tbl\" Nombre=30 Affichage=3");
                #else /*linux*/
                        sprintf(chaine2,"cd \"../%s\" && ./Generateur_aleatoire Table=\"..\\",acc("Gnrateur alatoire",chfunc));
                        strcat(chaine2,acc("Donnes\\Tables alatoires",chfunc));
                        strcat(chaine2,"\\Tours dressage.tbl\" Nombre=30 Affichage=3");
                system(chaine2);
                #endif
                fichier = ouvre_fichier("..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
                for(i=0;i<tours;i++)
                {
                    if(fgets(chaine2,255,fichier) == NULL) /*Fin des tours tirs*/
                    {   /*Plus de tours tir, nouveau jet sur la table alatoire*/
                        fclose(fichier);
                        #ifdef WIN32    /*win*/
                        system("cd \"..\\Gnrateur alatoire\" && Generateur_aleatoire.exe Table=\"..\\Donnes\\Tables alatoires\\Tours dressage.tbl\" Nombre=30 Affichage=3");
                        #else /*linux*/
                        sprintf(chaine2,"cd \"../%s\" && ./Generateur_aleatoire Table=\"..\\",acc("Gnrateur alatoire",chfunc));
                        strcat(chaine2,acc("Donnes\\Tables alatoires",chfunc));
                        strcat(chaine2,"\\Tours dressage.tbl\" Nombre=30 Affichage=3");
                        system(chaine2);
                        #endif
                        fichier = ouvre_fichier("..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
                        fgets(chaine2,255,fichier);
                    }
                    a = atoi(chaine2);   /*Lit le numro du tour*/
                    for(j=0;j<50;j++)
                    {
                        if(don[j] == a) /*Si le tour est dj connu*/
                        {
                            j=-1;    /*Indique un tour dj pris*/
                            break;
                        }
                    }
                    if(j == -1)   /*tour dj pris*/
                        i--;    /*Annule le tour slectionn*/
                    else
                    {   /*Si le tour n'est pas encore dans la liste*/
                        don[i] = a; /*Stocke le numro du tour dans le tableau*/
                        Efface_char(chaine2,".");
                        fprintf(compagnon_cible,"%s",chaine2); /*inscrit le tour dans la feuille de perso*/
                    }
                    fgets(chaine2,255,fichier);
                    fgets(chaine2,255,fichier);
                    fgets(chaine2,255,fichier); /*Prend 3 lignes dans les tours tirs pour aller au suivant*/
                }
                fclose(fichier);
            }
            if(strstr(chaine,"%%CapSpe") != NULL)
            {
                if(type == 1)
                {   /*Cap sp de compagnon animal*/
                    switch (cat_niv)
                    {
                        case 18:
                        case 15:
                            fprintf(compagnon_cible,"Esquive extraordinaire (JS rflexe, 1/2 dgts ou rien)\n");
                        case 12:
                        case 9:
                            fprintf(compagnon_cible,"Attaques multiples (-2 aux attaques secondaires au lieu de -5). Si le compagnon n'a pas au moins 3 attaques. Il obtient  la place une 2e attaque  -5 avec son arme principale.\n");
                        case 6:
                            fprintf(compagnon_cible,"Dvotion (+4 JS contre enchantement)\n");
                        case 3:
                            fprintf(compagnon_cible,"Esquive totale (Aucun dgts si JS rf russi)\n");
                        case 1:
                            fprintf(compagnon_cible,"Transfert d'effet magique (Sort perso affecte aussi le compagnon si  1,50m)\n");
                            fprintf(compagnon_cible,"Lien (Diriger action libre, pousser action de mouvement. +4 empathie sauvage et dressage)\n");
                    }
                }
                if(type == 2)
                {   /*Cap sp de destrier*/
                    switch (cat_niv)
                    {
                        case 15:
                            fprintf(compagnon_cible,"Rsistance  la magie (%d)\n",perso->niveau-malus_lvl+5);
                        case 11:
                            fprintf(compagnon_cible,"Injonction (%d/jour, sur animaux mme famille)\n", perso->niveau-malus_lvl/2);
                        case 8:
                            fprintf(compagnon_cible,"Vitesse suprieure (+3m)\n");
                        case 5:
                            fprintf(compagnon_cible,"Esquive extraordinaire (JS rflexe, 1/2 dgts ou rien)\n");
                            fprintf(compagnon_cible,"Lien tlpathique (1,5km)\n");
                            fprintf(compagnon_cible,"Transfert d'effet magique (Sort perso affecte aussi le destrier si  1,50m)\n");
                            fprintf(compagnon_cible,"Transfert de jet de sauvegarde (JS du matre si mieux...)\n");
                    }
                }
                if(type == 3)
                {   /*Cap sp de familier*/
                    switch (cat_niv)
                    {
                        case 19:
                        case 17:
                        case 15:
                        case 13:
                            fprintf(compagnon_cible,"Scrutation sur le familier (1/jour)\n");
                        case 11:
                            fprintf(compagnon_cible,"Rsistance  la magie (%d)\n",perso->niveau-malus_lvl+5);
                        case 9:
                        case 7:
                            fprintf(compagnon_cible,"Communication avec les animaux du mme type\n");
                        case 5:
                            fprintf(compagnon_cible,"Communication avec le matre (Communication verbale, mais incomprhensible)\n");
                        case 3:
                            fprintf(compagnon_cible,"Conduit (Le familier transmet les attaques de contact)\n");
                    }
                }
            }
        }
        else /*Si pas de mot cl, copie directe*/
            fprintf(compagnon_cible,"%s",chaine);
    }
    fclose(compagnon_cible);
    fclose(compagnon_source);
}

void archetypes (char *type_archetype, struct info_perso *perso)
{
    FILE* archetype_source;
    FILE* archetype_cible;
    FILE* donnees_file;
    char chaine[255];
    char ligne[255];
    char car;
    int i, j, k, val1, val2, val3, val4, DVsup;
    calcul_XP(perso,-1);    //Convertit la valeur d'XP en numro d'XP pour le recalcul de l'XP
    Efface_char(type_archetype,".");
    sprintf(chaine,"..\\Donnes\\Cratures\\Archtype\\%s.txt", type_archetype); /*Crer le chemin du fichier source compagnon en fonction du type de compagnon*/
    archetype_source = ouvre_fichier(chaine,"r");
    //Lit puis affiche les indication sur la crature de base autorise
    fgets(ligne,255,archetype_source);
    Efface_char(ligne,":");
    puts("");
    putsacc(ligne);
    //Ajoute l'archtype  la race du personnage
    strcat(perso->race,", ");
    strcat(perso->race,type_archetype);
    //Lit les modifications de taille
    fgets(ligne,255,archetype_source);
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        if(!strcmp(perso->cat_taille,"I"))
            val1 = 1;
        if(!strcmp(perso->cat_taille,"Min"))
            val1 = 2;
        if(!strcmp(perso->cat_taille,"TP"))
            val1 = 3;
        if(!strcmp(perso->cat_taille,"P"))
            val1 = 4;
        if(!strcmp(perso->cat_taille,"M"))
            val1 = 5;
        if(!strcmp(perso->cat_taille,"G"))
            val1 = 6;
        if(!strcmp(perso->cat_taille,"TG"))
            val1 = 7;
        if(!strcmp(perso->cat_taille,"Gig"))
            val1 = 8;
        if(!strcmp(perso->cat_taille,"C"))
            val1 = 9;
        if(strstr(ligne,"%%+") && strstr(ligne,"cat"))  //Mot cl %%+xcat
        {   //Augmente de x catgorie de taille
            Efface_char(ligne,"+");
            val1 += atoi(ligne);
        }
        if(strstr(ligne,"%%-") && strstr(ligne,"cat"))  //Mot cl %%-xcat
        {   //Diminue de x catgorie de taille
            Efface_char(ligne,"-");
            val1 -= atoi(ligne);
        }
        if(val1 < 1)
            val1 = 1;
        if(val1 > 9)
            val1 = 9;
        switch(val1)
        {
            case 1:
                strcpy(perso->cat_taille,"I");
                break;
            case 2:
                strcpy(perso->cat_taille,"Min");
                break;
            case 3:
                strcpy(perso->cat_taille,"TP");
                break;
            case 4:
                strcpy(perso->cat_taille,"P");
                break;
            case 5:
                strcpy(perso->cat_taille,"M");
                break;
            case 6:
                strcpy(perso->cat_taille,"G");
                break;
            case 7:
                strcpy(perso->cat_taille,"TG");
                break;
            case 8:
                strcpy(perso->cat_taille,"Gig");
                break;
            case 9:
                strcpy(perso->cat_taille,"C");
                break;
        }
    }
//Lit les modifications de carac
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        for(i=0;i<6;i++)    //Parcours les 5 autres valeurs
        {
            car = ligne[0];
            switch (car)
            {
                case '.':
                    //Pas de modification de la carac
                    break;
                case '+':
                    Efface_char(ligne,"+");
                    val1 = atoi(ligne);
                    perso->caracteristique[i] += val1; //Augmente la carac de la valeur indique
                    break;
                case '-':
                    Efface_char(ligne,"-");
                    val1 = atoi(ligne);
                    perso->caracteristique[i] -= val1; //Rduit la carac de la valeur indique
                    break;
                case '>':
                    Efface_char(ligne,">");
                    val1 = atoi(ligne);
                    if(perso->caracteristique[i] <= val1)  //Si la carac est infrieure ou gale  la valeur
                        perso->caracteristique[i] = val1+1;    //La carac passe au minimum autoris, cad valeur+1
                    break;
                case '<':
                    Efface_char(ligne,"<");
                    val1 = atoi(ligne);
                    if(perso->caracteristique[i] >= val1)  //Si la carac est suprieure ou gale  la valeur
                        perso->caracteristique[i] = val1-1;    //La carac passe au maximum autoris, cad valeur-1
                    break;
                case '0':   //Une valeur  0 indique une carac inexistante
                case '1':
                case '2':
                case '3':
                case '4':
                        perso->caracteristique[i] = atoi(ligne);    //La carac prend directement la valeur indique
                    break;
            }
            if(i<5)
                Efface_char(ligne,"\\");
        }
        //Recaclcul les modif de carac
        for(i=0;i<6;i++)
        {
            if(perso->caracteristique[i] < 10)
                perso->bonus_carac[i] = (perso->caracteristique[i]-11)/2;
            else
                perso->bonus_carac[i] = (perso->caracteristique[i]-10)/2;
        }
    }
//Lit les modifications de DV
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        if(strstr(ligne,"%%DV->+") && strstr(ligne,"cat"))  //Mot cl %%DV->+xcaty
        {   //Recalcule l'ensemble des PV, les DV raciaux augmente de x catgories avec un maximum de y.
            car = 'R';  //R = retirage des PV
            Efface_char(ligne,"+");
            val1 = atoi(ligne);   //val1 prend augmentation DV
            Efface_char(ligne,"t");
            val2 = atoi(ligne);   //j prend max DV
            for(;val1>0;val1--)
            {   //bcl sur nombre de catgorie de dv en +
                switch (perso->DV[1])
                {   //Selon la catgorie de DV actuelle, passe  la catgorie suivante
                    case 4:
                        perso->DV[1] = 6;
                        break;
                    case 6:
                        perso->DV[1] = 8;
                        break;
                    case 8:
                        perso->DV[1] = 10;
                        break;
                    case 10:
                        perso->DV[1] = 12;
                        break;
                    case 12:
                        perso->DV[1] = 20;
                        break;
                }
                if(perso->DV[1] > val2)    //Si dpasse le maximum autoris
                    perso->DV[1] = val2;   //Fixe au maximum
            }
        }
        else if(strstr(ligne,"%%DV->alld"))  //Mot cl %%DV->alldx
        {   //Recalcule l'ensemble des PV, tous les DV (raciaux et classes) deviennent des ds  x faces.
            car = 'R';  //R = retirage des PV
            Efface_char(ligne,"d");
            val1 = atoi(ligne);    //i prend le nouveau d de vie
            if(perso->DV[3] < 8)    //DV d'origine infrieur  la normale
            {
                if(val1 == 8)
                    perso->XP += 1;
                if(val1 > 8)
                    perso->XP += 2;
            }
            if(perso->DV[3] == 8)    //DV d'origine normaux
            {
                if(val1 < 8)
                    perso->XP -= 1;
                if(val1 > 8)
                    perso->XP += 1;
            }
            if(perso->DV[3] > 8)    //DV d'origine suprieur  la normale
            {
                if(val1 < 8)
                    perso->XP -= 2;
                if(val1 == 8)
                    perso->XP -= 1;
            }
            perso->DV[1] = val1;   //Change le DV racial
            perso->DV[3] = val1;   //Change le DV de classe

        }
        else if(strstr(ligne,"%%DV->+") && strstr(ligne,"d"))  //Mot cl %%DV->+xdy+z
        {   //Ajoute des DV raciaux.
            car = 'A';  //A = Ajout de PV
            Efface_char(ligne,"+");
            val1 = atoi(ligne);    //val1 prend le nb de ds racial
            Efface_char(ligne,"d");
            val2 = atoi(ligne);    //val2 prend le nb de face du d racial
            Efface_char(ligne,"+");
            val3 = atoi(ligne);    //val3 prend le bonus au pv
            perso->DV[0] += val1;  //Ajoute au total de DV raciaux
            perso->DV[4] += val3;    //Ajoute le bonus aux PV
            DVsup = val1;   //Pour le calcul des comptences sur DVsup
            perso->XP += val1;  //XP augmente en fonction du nb de DV sup
        }
        else if(strstr(ligne,"%%DV->null+d"))  //Mot cl %%DV->null+dx((*+-/)y)
        {   //Annule tous les PV actuel. recalcule les DV raciaux en ds  x faces. Pas de DV de classe. minimum 1dv. Avant le calcul les DV raciaux sont soumis  l'opration suivant le ds.
            car = 'R';  //R = retirage des PV
            perso->XP -= perso->DV[0];  //Retire de l'XP les DV raciaux
            perso->XP -= perso->DV[2];  //Retire de l'XP les DV de classe
            if(perso->DV[3] < 8)
                perso->XP += 1;     //Annule les modif d'XP li au ds de vie
            if(perso->DV[3] > 8)
                perso->XP -= 1;     //Annule les modif d'XP li au ds de vie
            if(perso->DV[0] == 0)   //Si DV raciaux nul
                perso->DV[0] = 1;   //Fixe  1DV, minimum.
            if(strstr(ligne,"("))
            {   //Si (, alors calcul sur les DV raciaux
                strcpy(chaine,ligne);   //Copie la chaine pour le calcul des DV raciaux
                Efface_char(chaine,"(");
                switch (chaine[0])
                {
                    case '+':
                        Efface_char(chaine,"+");
                        perso->DV[0] += atoi(chaine);
                        break;
                    case '-':
                        Efface_char(chaine,"-");
                        perso->DV[0] -= atoi(chaine);
                        break;
                    case '*':
                        Efface_char(chaine,"*");
                        perso->DV[0] *= atoi(chaine);
                        break;
                    case '/':
                        Efface_char(chaine,"/");
                        perso->DV[0] /= atoi(chaine);
                        break;
                }
            }
            Efface_char(ligne,"d");
            perso->DV[1] = atoi(ligne); //Remplace les DV raciaux
            perso->DV[2] = 0; //Annule les DV de classe
            perso->DV[3] = 0;
            perso->DV[4] = 0; //Annule le bonus
            perso->XP += perso->DV[0];  //Ajoute  l'XP le nb de DV
            if(perso->DV[1] < 8)
                perso->XP -= 1;
            if(perso->DV[1] > 8)
                perso->XP += 1;
        }
        //Calcul des PV
        if(car == 'R')   //Remplacement de PV au lieu d'ajout
            perso->PV = 0;
        val4 = 0;   //val4 prendra les PV de race
        if(car == 'A')   //Ajout de PV au lieu de remplacement
        {   //calcul les PV  l'aide de valeur diffrentes (val1,val2 et val3)
            for (j=0;j<3;j++)  /*Bcl sur le nb de lanc (3)*/
            {   /*Calcul des PV de race*/
                k = 0;
                for(i=0;i<val1;i++)    /*Calcul des PV*/
                    k += NbAlea1b (val2);
                if (k > val4)    /*Si le rsultat est plus important que le maximum atteint*/
                    val4 = k;        /*Devient le maximum*/
            }
            val4 += val3;   //Ajoute le bonus aux PV
        }
        else
        {   //Si c'est pas un ajout, continue le tirage des PV
            for (j=0;j<3;j++)  /*Bcl sur le nb de lanc (3)*/
            {   /*Calcul des PV de race*/
                k = 0;
                for(i=0;i<perso->DV[0];i++)    /*Calcul des PV*/
                    k += NbAlea1b (perso->DV[1]);
                if (k > val4)    /*Si le rsultat est plus important que le maximum atteint*/
                    val4 = k;        /*Devient le maximum*/
            }
            val4 += perso->DV[4];   //Ajoute le bonus aux PV
            for (j=0;j<3;j++)  /*Bcl sur le nb de lanc (3)*/
            {   /*Calcul des PV de classe*/
                k = perso->DV[3]; //La base n'est pas 0, mais le d (puisque lvl1 = max pv)
                for(i=0;i<perso->DV[2]-1;i++)    /*Calcul des PV*/
                    k += NbAlea1b (perso->DV[3]);
                if (k > perso->PV)    /*Si le rsultat est plus important que le maximum atteint*/
                    perso->PV = k;        /*Devient le maximum*/
            }
            k = perso->bonus_carac[2];    /*Prend le bonus de constitution*/
            if (k < 0)
                k = 0;   /*Un bonus ngatif ne baisse pas les PV*/
            perso->PV += perso->niveau;  /*Ajoute le modificateur de constitution*/
        }
        perso->PV += val4; //Ajoute les PV de la race  ceux de la classe
    }
//Lit les modifications du bba
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        if(perso->attaque[1] > 15)
            perso->XP -= 1;    /*4 attaques ou +, annule le bonus d'XP*/
        if(ligne[0] == '-')
        {
            Efface_char(ligne,"-");
            val1 = (int) interpret_calc(ligne);  //Lecture + calcul du texte
            perso->attaque[1] -= val1;   //la 2e valeur du tableau attaque correspond au premier jet d'attaque (donc bba full)
        }
        if(ligne[0] == '+')
        {
            Efface_char(ligne,"+");
            val1 = (int) interpret_calc(ligne);  //Lecture + calcul du texte
            perso->attaque[1] += val1;   //la 2e valeur du tableau attaque correspond au premier jet d'attaque (donc bba full)
        }
        if(isdigit(ligne[0]))   //Si c'est un chiffre, saisie directe de chiffre
        {   //le bba est fix  la valeur indiqu
            val1 = (int) interpret_calc(ligne);  //Lecture + calcul du texte
            perso->attaque[1] = val1;   //la 2e valeur du tableau attaque correspond au premier jet d'attaque (donc bba full)
        }
        //recalcul des attaques
        val1 = perso->attaque[1];
        i=2;
        while (val1 >= 6)
        {
            val1 -= 5;
            perso->attaque[i++] = val1;
        }
        perso->attaque[0] = i-2;    //Nb d'attaque
        if(perso->attaque[1] > 15)
            perso->XP += 1;    /*4 attaques ou +*/
    }
//Lit les modifications de jet de sauvegardes
    for(i=0;i<3;i++)
    {
        do
        {   //Recherche la prochaine ligne
            fgets(ligne,255,archetype_source);
        }while(ligne[0] != '#');
        Efface_char(ligne,":");
        if(ligne[0] != 'N' && ligne[1] != 'A')
        {
            Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
            while(strstr(ligne,"$") != NULL)
                gestion$(ligne,perso);    //De mme pour gestion$
            if(ligne[0] == '-')
            {
                Efface_char(ligne,"-");
                val1 -= (int) interpret_calc(ligne);  //Lecture + calcul du texte
            }
            if(ligne[0] == '+')
            {
                Efface_char(ligne,"+");
                val1 += (int) interpret_calc(ligne);  //Lecture + calcul du texte
            }
            if(isdigit(ligne[0]))   //Si c'est un chiffre, saisie directe de chiffre
            {   //le JS est fix  la valeur indiqu
                val1 = (int) interpret_calc(ligne);  //Lecture + calcul du texte
            }
            if(strstr(ligne,"Faible"))
            {
                j = perso->DV[0]+perso->DV[2];   //DV de classe + DV de race
                val1 = (int) floor(j/3);
            }
            if(strstr(ligne,"Elev"))
            {
                j = perso->DV[0]+perso->DV[2];   //DV de classe + DV de race
                val1 = (int) floor(j/2+2);
            }
            if(i==0)
                perso->JS_ref = val1;
            if(i==1)
                perso->JS_vig = val1;
            if(i==2)
                perso->JS_vol = val1;
        }
    }
//Lit les modifications CA
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        Efface_n(ligne);      //Retire le \n
        if(perso->armure[0] == '>') //Si pas d'armure
            strcpy(perso->armure,ligne);    //Copie directe
        else    //Si armure
        {
            strcat(perso->armure," ,");
            strcat(perso->armure,ligne);    //Ajoute aprs l'armure
        }
    }
//Lit les attaques supplmentaires
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    car='N';
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        car='O';
        i=0;
        while(perso->Capacite_spe[i++][0] != '>');  //Cherche la fin du tableau des capacit spe
        fgets(ligne,255,archetype_source);
        while(ligne[0] == '.')
        {   //Si la ligne suivante est une attaque supplmentaire
            Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
            while(strstr(ligne,"$") != NULL)
                gestion$(ligne,perso);    //De mme pour gestion$
            strcpy(perso->Capacite_spe[i-1],"#attsup");
            Efface_n(ligne);      //Retire le \n
            strcat(perso->Capacite_spe[i-1],ligne);
            perso->Capacite_spe[i++][0] = '>';
            do
            {
                fgets(ligne,255,archetype_source);
            }while(ligne[0] == '-');
        };
    }
//Lit les modifications de comptences
    if(car == 'N')    //Le paramtre prcdent tait sur NA
        fgets(ligne,255,archetype_source);  //Prend la ligne suivante pour viter de rester sur la mme ligne
    while(ligne[0] != '#')
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    };
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        if(strstr(ligne,"%%+pcomp("))  //Mot cl %%+pcomp(x)
        {   //ajoute des points de comptences non distribus en fonction des DV raciaux
            i=0;
            while(perso->competences[i++][0] != '>');  //Cherche la fin du tableau des comptences
            Efface_char(ligne,"(");
            val1 = atoi(ligne); //Lit la valeur du mot cl
            val2 = perso->bonus_carac[3];
            if (val2 < 0)
                val2 = 0;    /*Le bonus d'intelligence ne peut pas baisser les points de comptences*/
            val3 = (val1+val2)*(perso->DV[0]+3);   //(x+mod int)*(DV+3)
            sprintf(perso->competences[i-1],"    !!! Il reste %d points de comptences  rpartir !!!", val3);
            perso->competences[i][0] = '>';
        }
        else if(strstr(ligne,"%%+pcompsup("))  //Mot cl %%+pcompsup(x)
        {   //ajoute des points de comptences non distribus en fonction des DV sup. Ce mot cl est li au mot cl %%DV->+xdy+z
            i=0;
            while(perso->competences[i++][0] != '>');  //Cherche la fin du tableau des comptences
            Efface_char(ligne,"(");
            val1 = atoi(ligne); //Lit la valeur du mot cl
            val2 = perso->bonus_carac[3];
            if (val2 < 0)
                val2 = 0;    /*Le bonus d'intelligence ne peut pas baisser les points de comptences*/
            val3 = (val1+val2)*(DVsup+3);   //(x+mod int)*(DVsup+3)
            sprintf(perso->competences[i-1],"    !!! Il reste %d points de comptences  rpartir !!!", val3);
            perso->competences[i][0] = '>';
        }
        else if(strstr(ligne,"%%+comp"))  //Mot cl %%+compx+y,x+y,etc.
        {   //ajoute une ou plusieurs comptences.
            Efface_char(ligne,"p");
            donnees_file = ouvre_fichier("..\\Cration de personnages\\Donnes.ini","r");
            do
            {
                val1 = atoi(ligne);     //Lit le numro de la comptence
                rewind(donnees_file);
                do
                {    /*Recherche du paragraphe des donnes*/
                    fgets(chaine,255,donnees_file);
                } while (strstr(chaine,"#Comptences") == NULL);  //Cherche le paragraphe des comptences dans le fichier donnees.ini
                do
                {   //Chaine va prendre le nom de la comptence
                    fgets(chaine,255,donnees_file);
                    val2 = atoi(chaine);   /*Lit le numro de la ligne*/
                    if (val2 == val1)   /*Si le numro correspond*/
                    {
                        Efface_char(chaine,":");
                        Efface_n(chaine);      //Retire le \n
                    }   /*Il reste le mot!*/
                    else
                        val2=-1;
                } while (val2==-1); /*Bcl tant que le bon numro n'est pas trouv*/
                strcat(chaine,"  ");    //Ajoute 2 espaces  la fin de la comptence pour la comparaison avec celles dj notes
                Efface_char(ligne,"+");
                val3 = atoi(ligne);     //Lit le bonus de la comptence
                i=0;
                do
                {
                    if(!strcmp(perso->competences[i],chaine))
                    {
                        perso->nivo_competences[i] += val3;     //Ajoute le bonus  la comptence.
                        i=0;
                        break;
                    }
                }while(perso->competences[i++][0] != '>');
                if(i)
                {   //Si comptence non trouve
                    strcpy(perso->competences[i-1],chaine);     //Ajoute la comptence  la suite
                    perso->nivo_competences[i-1] = val3;
                    perso->competences[i][0] = '>';     //Dplace la fin des comptences
                }
                if(strstr(ligne,",") != NULL)   //Si d'autres comptences
                    Efface_char(ligne,",");     //Passe  la comptence suivante
                else
                    break;  //Sinon quitte la boucle
            }while(1);
            fclose(donnees_file);
        }
        else if(strstr(ligne,"%%null"))  //Mot cl %%null ou %%null+
        {   //Annule les comptences, et en ajoute ventuellement de nouvelles
            perso->competences[0][0] = '>';     //Place la fin des comptences au dbut du tableau. Donc plus de comptences!
            if(strstr(ligne,"+") != NULL)   //Si +, mot cl %%null+
            {   //Ajoute de nouvelle comptence
                Efface_char(ligne,"+");
                i=0;    //Index des comptences
                donnees_file = ouvre_fichier("..\\Cration de personnages\\Donnes.ini","r");
                do
                {
                    val1 = atoi(ligne);     //Lit le numro de la comptence
                    rewind(donnees_file);
                    do
                    {    /*Recherche du paragraphe des donnes*/
                        fgets(chaine,255,donnees_file);
                    } while (strstr(chaine,"#Comptences") == NULL);  //Cherche le paragraphe des comptences dans le fichier donnees.ini
                    do
                    {   //Chaine va prendre le nom de la comptence
                        fgets(chaine,255,donnees_file);
                        val2 = atoi(chaine);   /*Lit le numro de la ligne*/
                        if (val2 == val1)   /*Si le numro correspond*/
                        {
                            Efface_char(chaine,":");
                            Efface_n(chaine);      //Retire le \n
                        }   /*Il reste le mot!*/
                        else
                            val2=-1;
                    } while (val2==-1); /*Bcl tant que le bon numro n'est pas trouv*/
                    strcat(chaine,"  ");    //Ajoute 2 espaces  la fin de la comptence pour la comparaison avec celles dj notes
                    Efface_char(ligne,"+");
                    val3 = atoi(ligne);     //Lit le bonus de la comptence
                    strcpy(perso->competences[i],chaine);     //Ajoute la comptence  la suite
                    perso->nivo_competences[i] = val3;
                    perso->competences[++i][0] = '>';     //Dplace la fin des comptences
                    if(strstr(ligne,",") != NULL)   //Si d'autres comptences
                        Efface_char(ligne,",");     //Passe  la comptence suivante
                    else
                        break;  //Sinon quitte la boucle
                }while(1);
                fclose(donnees_file);
            }
        }
    }
//Lit les modifications de dons
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    car='N';
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        i=1;
        if(strstr(ligne,"null") != NULL)
        {
            perso->don[0][0] = '>';     //Place la fin des don au dbut du tableau. Donc plus de don!
            if(strstr(ligne,"null+") == NULL)   //Si c'est pas le mot cl null+, mais simplement null.
                i=0;    //Pas de tirage de don
        }
        if(i)
        {
            car='O';
            i=0;
            while(perso->don[i++][0] != '>');     //Cherche la fin des dons dans le tableau
            fgets(ligne,255,archetype_source);
            while(ligne[0] == '.')  //Lit tous les dons
            {
                Efface_char(ligne,".");
                Efface_n(ligne);      //Retire le \n
                strcpy(perso->don[i-1],ligne);
                perso->don[i++][0] = '>';
                fgets(ligne,255,archetype_source);
            };
        }
    }
//Lit les modifications de type
    if(car == 'N')    //Le paramtre prcdent tait sur NA
        fgets(ligne,255,archetype_source);  //Prend la ligne suivante pour viter de rester sur la mme ligne
    while(ligne[0] != '#')
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    };
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        i=0;
        while(perso->Capacite_spe[i++][0] != '>');     //Cherche la fin des capacits spciales dans le tableau
        if(ligne[0] == '+')
        {
            Efface_char(ligne,"+");
            strcpy(perso->Capacite_spe[i-1],"La crature acquiert le type supplmentaire ");
            Efface_n(ligne);      //Retire le \n
            strcat(perso->Capacite_spe[i-1],ligne);
            perso->Capacite_spe[i][0] = '>';
        }
        else
        {
            strcpy(perso->Capacite_spe[i-1],"Le type de la crature devient ");
            Efface_n(ligne);      //Retire le \n
            strcat(perso->Capacite_spe[i-1],ligne);
            perso->Capacite_spe[i][0] = '>';
        }
    }
//Lit les modifications de VD
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
        while(strstr(ligne,"$") != NULL)
            gestion$(ligne,perso);    //De mme pour gestion$
        i=0;
        while(perso->Capacite_spe[i++][0] != '>');     //Cherche la fin des capacits spciales dans le tableau
        Efface_n(ligne);      //Retire le \n
        strcpy(perso->Capacite_spe[i-1],ligne);
        perso->Capacite_spe[i][0] = '>';
    }
//Lit les capacits spciales supplmentaires
    do
    {   //Recherche la prochaine ligne
        fgets(ligne,255,archetype_source);
    }while(ligne[0] != '#');
    Efface_char(ligne,":");
    if(ligne[0] != 'N' && ligne[1] != 'A')
    {
        i=0;
        while(perso->Capacite_spe[i++][0] != '>');     //Cherche la fin des capacits spciales dans le tableau
        fgets(ligne,255,archetype_source);
        while(ligne[0] != '>')
        {
            Trlist(ligne,perso,archetype_source);    //Effectue trlist au sein de la bcl
            while(strstr(ligne,"$") != NULL)
                gestion$(ligne,perso);    //De mme pour gestion$
            if(ligne[0] != '-')
            {   //Si la ligne commence par -, elle sera considr comme un lment d'un trlist
                Efface_n(ligne);      //Retire le \n
                strcpy(perso->Capacite_spe[i-1],ligne);
                perso->Capacite_spe[i++][0] = '>';
            }
            fgets(ligne,255,archetype_source);
        };
    }
    if(perso->XP <= 0)
        perso->XP = 1;  //Evite un bug en cas d'XP nul ou ngatif
    calcul_XP(perso,1);
    fclose(archetype_source);
//Ecriture du ficher cible
    sprintf(chaine,"%s%s, %s lvl%d, %s.txtp", perso->chemin, perso->nom, perso->classe, perso->niveau, type_archetype); /*Crer le fichier cible  partir du nom du perso et du type d'archtype*/
    archetype_cible = ouvre_fichier(chaine,"w");
    fprintf(archetype_cible,"Nom: %s\n", perso->nom);
    fprintf(archetype_cible,"Classe de personnage: %s\n", perso->classe);
    fprintf(archetype_cible,"Niveau: %d\n", perso->niveau);
    fprintf(archetype_cible,"Traits physiques:\n");
    fprintf(archetype_cible," Race: %s\n", perso->race);
    fprintf(archetype_cible," Sexe: %s\n", perso->sexe);
    fprintf(archetype_cible," Poids: %dKg%s\n", perso->poids, perso->IMC);
    fprintf(archetype_cible," Taille: %dcm (%s)\n", perso->taille, perso->cat_taille);
    fprintf(archetype_cible," Age: %d ans%s\n", perso->age, perso->cat_age);
    i=0;
    while(perso->Traits_physiques[i][0] != '>')
    {
        fprintf(archetype_cible,"%s\n", perso->Traits_physiques[i]);
        i++;
    }
    fprintf(archetype_cible,">\nCaractristiques:\n");
    fprintf(archetype_cible,"Force: %d", perso->caracteristique[0]);
    if (perso->bonus_carac[0] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[0]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[0]);
    fprintf(archetype_cible,"Dextrit: %d", perso->caracteristique[1]);
    if (perso->bonus_carac[1] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[1]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[1]);
    fprintf(archetype_cible,"Constitution: %d", perso->caracteristique[2]);
    if (perso->bonus_carac[2] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[2]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[2]);
    fprintf(archetype_cible,"Intelligence: %d", perso->caracteristique[3]);
    if (perso->bonus_carac[3] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[3]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[3]);
    fprintf(archetype_cible,"Sagesse: %d", perso->caracteristique[4]);
    if (perso->bonus_carac[4] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[4]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[4]);
    fprintf(archetype_cible,"Charisme: %d", perso->caracteristique[5]);
    if (perso->bonus_carac[5] < 0) /*Si bonus ngatif*/
        fprintf(archetype_cible," (%d)\n", perso->bonus_carac[5]);
    else
        fprintf(archetype_cible," (+%d)\n", perso->bonus_carac[5]);
    fprintf(archetype_cible,"%s",perso->vision);
    fprintf(archetype_cible,"\nAlignement: %s\n", perso->alignement);
    fprintf(archetype_cible,"Jet d'attaque: +%d", perso->attaque[1]);
    for(i=2;i<perso->attaque[0]+2;i++)
        fprintf(archetype_cible,"\\+%d", perso->attaque[i]);
    fprintf(archetype_cible,"\nJet de sauvegarde:\n");
    fprintf(archetype_cible," Rflexe: +%d\n", perso->JS_ref);
    fprintf(archetype_cible," Vigueur: +%d\n", perso->JS_vig);
    fprintf(archetype_cible," Volont: +%d\n", perso->JS_vol);
    fprintf(archetype_cible,"Points de vie: %d (DV=%d", perso->PV, perso->DV[0]);
    if(perso->DV[0] > 0)
        fprintf(archetype_cible,"d%d", perso->DV[1]);
    fprintf(archetype_cible,"+%dd%d+%d)\n", perso->DV[2], perso->DV[3], perso->DV[4]);
    if (perso->armure[0] != '>')
        fprintf(archetype_cible,"Armure: %s\n", perso->armure);
    if (perso->arme1[0] != '>')
        fprintf(archetype_cible,"Arme principale: %s\n", perso->arme1);
    if (perso->arme2[0] != '>')
        fprintf(archetype_cible,"Arme secondaire: %s\n", perso->arme2);
    if (perso->arme3[0] != '>')
        fprintf(archetype_cible,"Arme tertiaire: %s\n", perso->arme3);
    i=0;
    while(perso->Capacite_spe[i][0] != '>')
    {
        if(strstr(perso->Capacite_spe[i++],"#attsup.") != NULL)   //Si c'est une attaque supplmentaire
        {
            strcpy(chaine,perso->Capacite_spe[i-1]);
            Efface_char(chaine,".");
            fprintf(archetype_cible,"Attaque supplmentaire: %s\n", chaine);
        }
    }
    if (perso->bouclier[0] != '>')
        fprintf(archetype_cible,"Bouclier: %s\n", perso->bouclier);
    i=0;
    fprintf(archetype_cible,"Langues parles:\n");
    while(perso->langue[i][0] != '>')
        fprintf(archetype_cible,"%s\n", perso->langue[i++]);
    fprintf(archetype_cible,">\nDons:\n");
    i=0;
    while(perso->don[i][0] != '>')
        fprintf(archetype_cible,"%s\n", perso->don[i++]);
    fprintf(archetype_cible,">\nComptences:\n");
    i=0;
    while(perso->competences[i][0] != '>')
    {
        if(strstr(perso->competences[i],"!!! Il reste ") != NULL)   //Reste x points  rpartir, affichage sans bonus comp!
            fprintf(archetype_cible,"%s\n", perso->competences[i]);
        else
            fprintf(archetype_cible,"%s +%d\n", perso->competences[i], perso->nivo_competences[i]);
        i++;
    }
    fprintf(archetype_cible,">\n%d objets magiques  dterminer.\n", perso->nb_objets_magiques);
    fprintf(archetype_cible,"Points d'exprience: %d\n", perso->XP);
    fprintf(archetype_cible,"Capacits spciales:\n");
    i=0;
    while(perso->Capacite_spe[i][0] != '>')
    {
        if(strstr(perso->Capacite_spe[i++],"#attsup.") == NULL)   //Si c'est pas une attaque supplmentaire, affiche en cap sp
            fprintf(archetype_cible,"%s\n", perso->Capacite_spe[i-1]);
    }
    fprintf(archetype_cible,">\n#Equipements:\n");
    i=0;
    while(perso->Equipement[i][0] != '>')
        fprintf(archetype_cible,"%s\n", perso->Equipement[i++]);
    fprintf(archetype_cible,">\n");
    fclose(archetype_cible);
}

void gestion$ (char* chaine, struct info_perso *perso)
{
    char chaine2 [255];
    int val, i,j, xp=0;
    strcpy(chaine2,chaine);
    Efface_char(chaine,"$");
    i=0;
    while(chaine[i++] != '$');       //Dplace le curseur jusqu' la fin du mot cl
    chaine[i] = '\0';
    if(!strcmp(chaine,"DV$"))
        val =  perso->DV[0]+perso->DV[2];   //DV de classe + DV de race
    if(!strcmp(chaine,"DVrace$"))
        val =  perso->DV[2];    //DV de race seulement
    if(!strcmp(chaine,"bfor$"))
        val =  perso->bonus_carac[0];
    if(!strcmp(chaine,"bdex$"))
        val =  perso->bonus_carac[1];
    if(!strcmp(chaine,"bcon$"))
        val =  perso->bonus_carac[2];
    if(!strcmp(chaine,"bint$"))
        val =  perso->bonus_carac[3];
    if(!strcmp(chaine,"bsag$"))
        val =  perso->bonus_carac[4];
    if(!strcmp(chaine,"bcha$"))
        val =  perso->bonus_carac[5];
    if(strstr(chaine,"XP") != NULL)    //Mot cl $XP+x$
    {
        Efface_char(chaine,"P");
        if(chaine[0] == '+')
        {
            Efface_char(chaine,"+");
            perso->XP += atoi(chaine);  //Augmente l'XP de la valeur indique
        }
        else if(chaine[0] == '-')
        {
            Efface_char(chaine,"-");
            perso->XP -= atoi(chaine);  //Diminue l'XP de la valeur indique
        }
        xp=1;
    }
    i=0;
    while(chaine2[i] != '$')
    {
        chaine[i] = chaine2[i];   //Copie au caractre ce qui se trouve avant le mot cl $
        i++;
    }
    for(j=i;j<i+10;j++)
        chaine[j] = '\0';   //Ecrit 10 fin de chaine  l'emplacement de la valeur
    if(!xp) //Le mot cl xp n'affiche pas sa valeur
        strcat(chaine,inttochar(val,chfunc));    //Inscrit la valeur correspond au mot cl
    j=i;
    while(chaine[j++] != '\0');     //Dplace l'index j jusqu' la fin de l'affichage de la valeur
    j--;i++;
    while(chaine2[i++] != '$'); //dplace l'index i jusqu' la fin du mot cl
    while(chaine2[i] != '\0')
        chaine[j++] = chaine2[i++];   //Copie au caractre ce qui se trouve aprs le mot cl $
    chaine[j] = '\0';   //Termine la chaine
}

void Trlist (char* chaine, struct info_perso *perso, FILE* fichier)
{
    char chaine2 [255];
    char chaine3 [255];
    char ligne [255];
    int valT, index;
    long position;
    if(strstr(chaine,"%%Trniv"))
    {
        position = ftell(fichier);  //Prend la position du fichier avant le scan trlist
        strcpy(chaine2,chaine);
        index = index_ch_first(chaine,"%%Trniv");   //Index de %%Trniv
        chaine[index] = '\0';   //Tronque la fin de la chaine  partir de %%Trniv
        strcpy(chaine2,strstr(chaine2,"%%Trniv"));
        Efface_char(chaine2,"v");
        valT = perso->DV[0]+perso->DV[2];   //DV de classe + DV de race
        fgets(ligne,255,fichier);
        while(ligne[0] == '-')
        {
            if(ligne[1] == '+') //Ligne[1] = + ou r, + ajoute tout  la suite.
            {   //La ligne sera ajoute  la liste si le niveau est correct
                Efface_char(ligne," ");
                if(valT >= atoi(ligne))
                {
                    Efface_char(ligne,"=");
                    Efface_n(ligne);      //Retire le \n
                    strcat(chaine,ligne);   //Ajoute  la suite
                    chaine3[0] = '\0';   //Rend chaine3 nul, pour la strcat utilis par 'r'
                    if(strlen(chaine) > 255)
                    {
                        #ifdef WIN32    /*win*/
                            system("color FC");
                        #endif
                        putsacc("\nERREUR, dpassement de la capacit de stockage de la chaine de caractres\nDcouper le Trniv en plusieurs parties pour viter cette erreur");
                        DPause();
                        exit(1);
                    }
                }
            }
            if(ligne[1] == 'r') //Ligne[1] = + ou r, r correpond  une seule valeur.
            {   //La ligne sera seule ajoute  la liste si le niveau est correct
                Efface_char(ligne," ");
                if(valT >= atoi(ligne))
                {
                    Efface_char(ligne,"=");
                    Efface_n(ligne);      //Retire le \n
                    strcpy(chaine3,ligne);  //Chaine3 est remplac chaque fois par les ventuelles nouvelles valeur
                }
            }
            fgets(ligne,255,fichier);
        }
        strcat(chaine,chaine3);     //Uniquement pour ajouter la chaine lue par 'r'
        strcat(chaine,chaine2);     //Ajoute la fin de la chaine d'origine
        fseek(fichier,position,SEEK_SET);   //Replace le curseur du fichier avant le trlist
    }
    if(strstr(chaine,"%%Trtail"))
    {
        position = ftell(fichier);  //Prend la position du fichier avant le scan trlist
        strcpy(chaine2,chaine);
        index = index_ch_first(chaine,"%%Trtail");   //Index de %%Trtail
        chaine[index] = '\0';   //Tronque la fin de la chaine  partir de %%Trtail
        strcpy(chaine2,strstr(chaine2,"%%Trtail"));
        Efface_char(chaine2,"l");
        if(!strcmp(perso->cat_taille,"I"))
            valT = 1;
        if(!strcmp(perso->cat_taille,"Min"))
            valT = 2;
        if(!strcmp(perso->cat_taille,"TP"))
            valT = 3;
        if(!strcmp(perso->cat_taille,"P"))
            valT = 4;
        if(!strcmp(perso->cat_taille,"M"))
            valT = 5;
        if(!strcmp(perso->cat_taille,"G"))
            valT = 6;
        if(!strcmp(perso->cat_taille,"TG"))
            valT = 7;
        if(!strcmp(perso->cat_taille,"Gig"))
            valT = 8;
        if(!strcmp(perso->cat_taille,"C"))
            valT = 9;
        fgets(ligne,255,fichier);
        while(ligne[0] == '-')
        {
            if(ligne[1] == '+') //Ligne[1] = + ou r, + ajoute tout  la suite.
            {   //La ligne sera ajoute  la liste si la catgorie de taille est correcte
                Efface_char(ligne," ");
                if(valT >= atoi(ligne))
                {
                    Efface_char(ligne,"=");
                    Efface_n(ligne);      //Retire le \n
                    strcat(chaine,ligne);   //Ajoute  la suite
                    chaine3[0] = '\0';   //Rend chaine3 nul, pour le strcat utilis par 'r'
                    if(strlen(chaine) > 255)
                    {
                        #ifdef WIN32    /*win*/
                            system("color FC");
                        #endif
                        putsacc("\nERREUR, dpassement de la capacit de stockage de la chaine de caractres\nDcouper le Trtail en plusieurs parties pour viter cette erreur");
                        DPause();
                        exit(1);
                    }
                }
            }
            if(ligne[1] == 'r') //Ligne[1] = + ou r, r correpond  une seule valeur.
            {   //La ligne sera seule ajoute  la liste si la catgorie de taille est correcte
                Efface_char(ligne," ");
                if(valT >= atoi(ligne))
                {
                    Efface_char(ligne,"=");
                    Efface_n(ligne);      //Retire le \n
                    strcpy(chaine3,ligne);  //Chaine3 est remplac chaque fois par les ventuelles nouvelles valeur
                }
            }
            fgets(ligne,255,fichier);
        }
        strcat(chaine,chaine3);     //Uniquement pour ajouter la chaine lue par 'r'
        strcat(chaine,chaine2);     //Ajoute la fin de la chaine d'origine
        fseek(fichier,position,SEEK_SET);   //Replace le curseur du fichier avant le trlist
    }
}

void calcul_XP(struct info_perso *perso, int sens)
{
    FILE* fichier;
    char chaine[255];
    int max,val,dif;
    fichier = ouvre_fichier("..\\Donnes\\XP.ini","r");
    fgets(chaine,255,fichier);
    val = atoi(chaine);
    Efface_char(chaine,"=");
    max = atoi(chaine);
    if(sens == 1)
    {
        if(perso->XP <= max)    /*XP dtaill*/
        {
            do
            {  /*Recherche de la ligne de l'XP*/
                fgets(chaine,255,fichier);
                val = atoi(chaine);
            } while (val != perso->XP);
            Efface_char(chaine,":");
            perso->XP = atoi(chaine);    /*Lit la valeur en XP*/
        }
        else    /*XP suprieur*/
        {
            dif = perso->XP - max; /*dif prend la diffrence entre max et la valeur XP*/
            do
            {  /*Recherche de la ligne de l'XP max dtaill*/
                fgets(chaine,255,fichier);
                val = atoi(chaine);
            } while (val != max);
            Efface_char(chaine,":");
            perso->XP = atoi(chaine);    /*Lit la valeur en XP maximum dtaille*/
            fgets(chaine,255,fichier);     /*Saisi la ligne suivante, XP suprieur*/
            Efface_char(chaine,":");
            Efface_char(chaine,"+");
            val = atoi(chaine); /*val prend la valeur d'XP suplmentaire*/
            perso->XP += dif*val;    /*Augmente l'XP*/
        }
    }
    else if(sens == -1)
    {
        if(perso->XP != 0)  //Si XP=0, pas d'XP indiqu, XP reste  0
        {
            do
            {  /*Recherche de la ligne de l'XP max*/
                fgets(chaine,255,fichier);
            } while (atoi(chaine) != max);
            val = max; //val prend le numro d'XP max
            Efface_char(chaine,":");
            max = atoi(chaine); //val prend l'xp max indique
            rewind(fichier);
            fgets(chaine,255,fichier);  //Saute la premire ligne
            if(perso->XP <= max)    /*XP dtaill*/
            {
                do
                {  /*Recherche de la ligne de l'XP*/
                    fgets(chaine,255,fichier);
                    dif = atoi(chaine); //dif prend le numro d'XP
                    Efface_char(chaine,":");
                    val = atoi(chaine); //val prend la valeur d'XP
                } while (val != perso->XP);
                perso->XP = dif;    /*Lit la valeur en XP*/
            }
            else    /*XP suprieur*/
            {
                dif = perso->XP - max; /*dif prend la diffrence entre max et la valeur XP*/
                do
                {  /*Recherche de la ligne de l'XP suprieur*/
                    fgets(chaine,255,fichier);
                } while (chaine[0] != '+');
                Efface_char(chaine,":");
                Efface_char(chaine,"+");
                perso->XP = val;  //Donnees->xp prend le numro max d'XP
                val = atoi(chaine); /*val prend la valeur d'XP suplmentaire*/
                perso->XP += dif/val;    /*Augmente le numro d'XP*/
            }
        }
    }
    fclose(fichier);
}
