/* Programme d'valuation des gemmes pour donjons et dragons 2.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Jdr.h"

void Gemmes_ad (void);
void Gemmes_sd (void);
int Valeur (void);
int Tranche (int tranch);

int verif_val (int* index, char* ligne, int alea);  /*dtermine si la ligne actuelle est celle correspondant au jet de d*/
int jet_de_des (int* index, char* ligne);       /*Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
char* string_gen_alea (int index, char* ligne); /*gen_alea, lit le rsultat*/
char* moteur_principal (int valeur, char* ligne);   /*Gestion de la table de gnration alatoire*/

int main (int argc,char *argv[])
{
    int choix;
    Init_srand ();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Gemmes","Module d'valuation des gemmes pour Donjons et dragon",color_sd("Gemmes",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    putsacc("1) Tirer les gemmes avec les dtails du lancer.\n");
    putsacc("2) Tirer les gemmes sans les dtails.\n");
    do
    {
        printf("?: ");
        choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
        if(choix == QUIT)
            exit(0);
        switch (choix)
        {
            case 1:
                Gemmes_ad();
                break;
            case 2:
                Gemmes_sd();
                break;
            default:
                Fuck();
                choix = 0;
                break;
        }
    } while (!choix);
    return 0;
}

void Gemmes_ad (void)
{
    int modif, tranch, pourcentmodif, nb;
    float valeur;
    char gemme[255];
    do
    {    /*Bcl erreur de saisi*/
        printf("Combien de gemmes voulez-vous? ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    for(;nb>0;nb--)
    {
        tranch = Valeur();        /*Dtermine la tranche de valeur*/
        valeur = Tranche(tranch); /*Dtermine la valeur de base*/
        printf("Valeur initiale: %.0f\n", valeur);
        do
        {
            modif = NbAlea1b(6);
            switch (modif)
            {
                case 1:
                    tranch+=1;
                    putsacc("La gemme monte  la tranche de valeur suprieure\n");
                    valeur = Tranche(tranch);
                    printf("Valeur: %.0f\n", valeur);
                    break;
                case 2:
                    valeur*=2;
                    printf("La gemme double sa valeur\n");
                    printf("Valeur: %.0f\n", valeur);
                    break;
                case 3:
                    pourcentmodif = NbAlea1b(6);
                    valeur+=valeur*pourcentmodif*0.1;
                    printf("La gemme augmente sa valeur de %d%%\n", pourcentmodif*10);
                    printf("Valeur: %.0f\n", valeur);
                    break;
                case 4:
                    pourcentmodif = NbAlea1b(4);
                    valeur-=valeur*pourcentmodif*0.1;
                    printf("La gemme diminue sa valeur de %d%%\n", pourcentmodif*10);
                    printf("Valeur: %.0f\n", valeur);
                    break;
                case 5:
                    valeur/=2;
                    putsacc("La gemme perd la moiti de sa valeur\n");
                    printf("Valeur: %.0f\n", valeur);
                    break;
                case 6:
                    tranch-=1;
                    putsacc("La gemme descend  la tranche de valeur infrieure\n");
                    valeur = Tranche(tranch);
                    printf("Valeur: %.0f\n", valeur);
                    break;
            }
        } while (modif == 1 || modif == 6);
        printf("\nValeur finale de la gemme: %.0f po.\n", valeur);
        strcpy(gemme,moteur_principal((int) valeur,gemme));
        putsacc(gemme);
        puts("");
        Pause();
    }
}

void Gemmes_sd (void)
{
    FILE* fichier;
    int modif, tranch, pourcentmodif, nb;
    float valeur;
    do
    { /*Bcl erreur de saisie*/
        printf("Combien de gemmes voulez-vous? ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    fichier = ouvre_fichier("..\\Z Fichiers cres\\Gemmes.txt","w");
    putsacc("Les rsultats de ce jet ont t stocks dans le fichier Gemmes.txt\n");
    printf("\nValeur des %d gemmes: ", nb);
    for (;nb>0;nb--)
    {
        tranch = Valeur();        /*Dtermine la tranche de valeur*/
        valeur = Tranche(tranch); /*Dtermine la valeur de base*/
        do
        {
            modif = NbAlea1b(6);
            switch (modif)
            {
                case 1:
                    tranch+=1;
                    valeur = Tranche(tranch);
                    break;
                case 2:
                    valeur*=2;
                    break;
                case 3:
                    pourcentmodif = NbAlea1b(6);
                    valeur+=valeur*pourcentmodif*0.1;
                    break;
                case 4:
                    pourcentmodif = NbAlea1b(4);
                    valeur-=valeur*pourcentmodif*0.1;
                    break;
                case 5:
                    valeur/=2;
                    break;
                case 6:
                    tranch-=1;
                    valeur = Tranche(tranch);
                    break;
            }
        } while (modif == 1 || modif == 6);
        printf("%.0f   ", valeur);
        fprintf(fichier,"%.0f   ", valeur);
    }
    printf("\n");
    fclose(fichier);
    Pause();
}

int Valeur (void)
{
    int jet, valreturn;
    jet = NbAlea1b(100);
    if (jet<=10)
        valreturn = 2;
    if (jet>10 && jet<=25)
        valreturn = 3;
    if (jet>25 && jet<=75)
        valreturn = 4;
    if (jet>75 && jet<=90)
        valreturn = 5;
    if (jet>90 && jet<=99)
        valreturn = 6;
    if (jet==100)
        valreturn = 7;
    return valreturn;
}

int Tranche (int tranch)
{
    int valreturn;
    switch (tranch)
    {
        case 2:
            valreturn = 10;
            break;
        case 3:
            valreturn = 50;
            break;
        case 4:
            valreturn = 100;
            break;
        case 5:
            valreturn = 500;
            break;
        case 6:
            valreturn = 1000;
            break;
        case 7:
            valreturn = 5000;
            break;
        case 8:
            valreturn = 10000;
            break;
        default:
            if (tranch<=1)
                valreturn = 5;
            if (tranch>=9)
                valreturn = 20000;
    }
    return valreturn;
}

char* moteur_principal (int valeur, char* ligne)
{
    FILE* fichiertable;
    int tabdes[10];
    int index, alea, compt0, cpt0, nbdes;
    for (nbdes=0;nbdes<10;nbdes++)        /*rutilise nbdes pour initialis le tableau de jet*/
        tabdes[nbdes]=0;
    nbdes=0;
    index=-1;
    compt0=0;
    fichiertable = ouvre_fichier("Type gemmes.tbl","r");
    fgets(ligne,255,fichiertable);
    do
    {
        alea = 0;
        if (ligne[0] == '#')
        {
            Efface_char(ligne,"#");
            alea = atoi(ligne);
            if (ligne[0] == '+')   /*Valeur de gemme max*/
                alea = 1000000000;   /*Donne une valeur trs haute pour passer la condition*/
        }
        fgets(ligne,255,fichiertable);
    } while(valeur > alea);    /*Tant que la valeur de la gemme est suprieure  l'index de nom de gemme*/
    alea = jet_de_des(&index,ligne);      /*jet alatoire du 1er d de la table*/
    while (alea != 0)        /*Tant qu'un d est lanc*/
    {
        tabdes[nbdes++] = alea;
        compt0++;
        while (verif_val (&index, ligne, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
        {
            fgets(ligne,255,fichiertable);
            index = 0;
            for(cpt0=0;(cpt0<compt0) && (ligne[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                index+=2;
            index--;
        }
        compt0++;
        alea = jet_de_des(&index,ligne); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
    }
    strcpy(ligne,string_gen_alea (index,ligne));   /*Rutilise ligne pour recevoir la valeur*/
    return ligne;
}

int verif_val (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int jet_de_des (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[*index+1] == 'd'))      /*Si un d doit tre lanc*/
    {
        ++*index;
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

char* string_gen_alea (int index, char* ligne)
{
    int i=0;
    char string[100];
    strcpy(string,ligne);
    while (index < (int)strlen(string))    /*Copie ce qui doit tre renvoy dans "string"*/
        ligne[i++] = string[index++];
    ligne[i-1] = '\0';
    return ligne;
}
