/* Programme de gestion de combattants pour donjons et dragons 3.5 modifi.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

struct donnees_combat         /*Structure de donnes*/
{
    char nom[51][11];  /*Nom des combattants (limit  10 caractres), max 51 combattants*/
    char degats[51][255];  /*Dgts*/
    int battaques[51][10];  /*jets d'attaques*/
    int nbatt[51];  /*Nb d'attaques*/
    int defaut[51][4];  /*Saisie par defaut: esquive,b perf, rsistance, b dgts*/
    int binit[51];   /*Bonus d'initiative*/
    int init[51];   /*Jet d'initiative*/
    int num;
};

int interpret_attaque(char *attaque, int *bonus_att); /*Interprete les bonus d'attaques, et stocke les diffrents bonus dans le tableau, renvoi le nombre de jets*/
void degats (struct donnees_combat *cmb); /*Copie modifie du programme de dgts, sans la boucle*/
void attaque_simple (struct donnees_combat *cmb); /*Copie modifie du programme d'attaque simple, sans la boucle*/
void store_combattants (struct donnees_combat *cmb); //Ecrit le fichier texte contenant les combattants

int main (int argc,char *argv[])
{
    struct donnees_combat cmb;
    FILE* combattants;
    char saisie[50];
    char chaine[255];
    int copie_battaques[10];
    int i,j,k;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre(argc,argv,"Gestion combattant","Programme de simplification des combats 3.5",color_sd("Gestion combattant 3.5",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    /*Initialisation des tableaux*/
    for(i=0;i<51;i++)
        cmb.nom[i][0] = '\0';
    for(i=0;i<51;i++)
        cmb.degats[i][0] = '\0';
    for(i=0;i<51;i++)
        cmb.nbatt[i] = 0;
    for(i=0;i<51;i++)
    {
        for(j=0;j<4;j++)
            cmb.defaut[i][j] = 0;
    }
    for(i=0;i<51;i++)
        cmb.binit[i] = 0;
    /*Lecture du fichier Combattants.st*/
    combattants = ouvre_fichier("Combattants.st","r");
    fgets(chaine,255,combattants);
    fclean(chaine,combattants);
    while(chaine[0] == '#')
    {
        Efface_char(chaine,"#");
        cmb.num = atoi(chaine)-1;   /*Lit le numro du combattant*/
        fgets(chaine,255,combattants);
        fclean(chaine,combattants);      //Retire le \n
        Efface_char(chaine,":");
        strcpy(cmb.nom[cmb.num],chaine);    /*Copie le nom du combattant*/
        fgets(chaine,255,combattants);
        fclean(chaine,combattants);
        Efface_char(chaine,":");    /*Lit les jets d'attaques*/
        cmb.nbatt[cmb.num] = index_ch(chaine,"/",cmb.init)+1; /*Donne le nombre de \ dans la chaine (soit le nombre de jet d'attaque-1) et stocke dans j. cmb.init est utilis pour la fonction, mais ne sert  rien ici*/
        cmb.battaques[cmb.num][0] = 1;  /*Bonus d'attaque  1*/
        if(chaine[0] == '-')
        {
            cmb.battaques[cmb.num][0] = -1;  /*Bonus d'attaque  -1, pour bonus ngatif*/
            Efface_char(chaine,"-");
        }
        else
            Efface_char(chaine,"+");
        cmb.battaques[cmb.num][0] *= atoi(chaine);  /*Lit le bonus d'attaque et le multiplie par 1 ou -1 si ngatif*/
        for(i=1;i<cmb.nbatt[cmb.num];i++)
        {
            Efface_char(chaine,"/"); /*passe  l'attaque suivante*/
            cmb.battaques[cmb.num][i] = 1;  /*Bonus d'attaque  1*/
            if(chaine[0] == '-')
            {
                cmb.battaques[cmb.num][i] = -1;  /*Bonus d'attaque  -1, pour bonus ngatif*/
                Efface_char(chaine,"-");
            }
            else
                Efface_char(chaine,"+");
            cmb.battaques[cmb.num][i] *= atoi(chaine);  /*Lit le bonus d'attaque et le multiplie par 1 ou -1 si ngatif*/
        }
        fgets(chaine,255,combattants);
        fclean(chaine,combattants);
        Efface_char(chaine,":");
        cmb.binit[cmb.num] = 1;  /*Bonus d'init  1*/
        if(chaine[0] == '-')
        {
            cmb.binit[cmb.num] = -1;  /*Bonus d'init  -1, pour bonus ngatif*/
            Efface_char(chaine,"-");
        }
        cmb.binit[cmb.num] *= atoi(chaine);  /*Lit le bonus d'initiative*/
        fgets(chaine,255,combattants);
        fclean(chaine,combattants);
    }
    fclose(combattants);
    for(i=0;i<51;i++)
        cmb.init[i] = 0;   /*Initialise le tableau (utilis auparavant)*/
    do
    {
        printf("Ajouter un nouveau combattant: N\n");
        putsacc("Supprimer un combattant: S suivi du numro du combattant  supprimer\n");
        putsacc("Modifier un combattant: M suivi du numro du combattant  modifier\n");
        printf("Round suivant (nouveau jet d'initiative): R\n");
        putsacc("Attaquer avec un combattant: Indiquer simplement le numro du combattant!\n\n");
        i=0;
        k=0;
        while(i<51)
        {   /*Affiche les diffrents combattants*/
            if(cmb.nom[i][0] != '\0')
            {
                k++;
                if(i<9)
                    printf(" ");
                printf("%d) %s (init=%d)", i+1, acc(cmb.nom[i],chfunc), cmb.init[i]);
                if(k<3)
                {
                    for(j=strlen(cmb.nom[i]);j<13;j++)
                        printf(" ");
                }
                else
                {   /*Tous les 3 nom affichs, reviens  la ligne*/
                    k=0;
                    printf("\n");
                }
            }
            i++;
        }
        printf("\n?: ");
        strcpy(saisie,nomajloc_gestion_combattant(chfunc));
        if(strstr(saisie,"q") != NULL || strstr(saisie,"Q") != NULL)
            break;
        if(saisie[0] == '\0')   /*Si aucune entre*/
            continue;
        else if(saisie[0] == 'm' || saisie[0] == 'M')
        {   /*Modifier combattant*/
            saisie[0] = 'M';    /*S'assure que c'est un M majuscule*/
            Efface_char(saisie,"M");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            printf("Modification du combattant ");
            if(cmb.num < 9)
                printf("0");
            printf("%d                              ", cmb.num+1);
            for(i=0;i<(int)strlen(cmb.nom[cmb.num]);i++)
                printf(" ");
            printf("|\n");
            putsacc("Nom du combattant (10 caractres max) ");
            printf("(Defaut=%s): ", acc(cmb.nom[cmb.num],chfunc));
            getsfix(chaine,255);
            if(chaine[0] != '\0')
            {   /*Si un nouveau nom est entr*/
                chaine[10] = '\0';  /*Limite la chaine  10 caractres max*/
                strcpy(cmb.nom[cmb.num],chaine);
            }
            printf("Bonus d'attaque (Pas de calcul !) (Defaut:");
            for(i=0;i<cmb.nbatt[cmb.num];i++) /*bcl sur le nombre d'attaque pour l'affichage*/
            {
                if(i>0)
                    printf("\\");
                if(cmb.battaques[cmb.num][i] >= 0)
                    printf("+");
                printf("%d", cmb.battaques[cmb.num][i]);
            }
            printf("): +");
            for(i=0;i<10;i++)
                copie_battaques[i] = cmb.battaques[cmb.num][i];  /*Copie de sauvegarde des jets d'attaque par defaut*/
            j = cmb.nbatt[cmb.num];  /*Copie de sauvegarde du nombre de jets d'attaque par defaut*/
            cmb.nbatt[cmb.num] = interpret_attaque(saisie,cmb.battaques[cmb.num]);
            if(cmb.nbatt[cmb.num] == 0) /*Pas de saisie, valeur par defaut*/
            {   /*Reprend les copies*/
                for(i=0;i<10;i++)
                    cmb.battaques[cmb.num][i] = copie_battaques[i];
                cmb.nbatt[cmb.num] = j;
            }
            do
            {    /*Boucle d'erreur de saisie*/
                printf("Modificateur d'initiative (Defaut=%d): ", cmb.binit[cmb.num]);
                j = (int) interpret_calc("\0");
            } while (j == NA);
            if(j != defo)  /*Si nouveau bonus d'initiative*/
                cmb.binit[cmb.num] = j; /*Devient la valeur par defaut*/
        }
        else if(saisie[0] == 'n' || saisie[0] == 'N')
        {   /*Nouveau combattant*/
            for(cmb.num=0;cmb.num<51;cmb.num++)
            {
                if(cmb.nom[cmb.num][0] == '\0')
                    break;  /*Cherche un espace libre pour le nouveau combattant*/
            }
            if(cmb.num>50)
                putsacc("Aucun espace disponible, supprimer des combattants au pralable\n");
            else
            {
                printf("Nouveau combattant                               |\n");
                putsacc("Nom du combattant (10 caractres max): ");
                getsfix(chaine,255);
                chaine[10] = '\0';  /*Limite la chaine  10 caractres max*/
                strcpy(cmb.nom[cmb.num],chaine);
                printf("Bonus d'attaque (Pas de calcul !): +");
                cmb.nbatt[cmb.num] = interpret_attaque(saisie,cmb.battaques[cmb.num]);
                do
                {
                    printf("Modificateur d'initiative: ");
                    cmb.binit[cmb.num] = (int) interpret_calc("\0");
                } while (cmb.binit[cmb.num] == NA || cmb.binit[cmb.num] == defo);
            }
            store_combattants(&cmb);
        }
        else if(saisie[0] == 'r' || saisie[0] == 'R')
        {   /*Nouveau round*/
            puts("Nouveau round");
            for(i=0;i<51;i++)
                cmb.init[i] = NbAlea1b(20)+cmb.binit[i];    /*Effectue les jets d'initiatives pour tous les combattants*/
        }
        else if(saisie[0] == 's' || saisie[0] == 'S')
        {   /*Supprimer un combattant*/
            saisie[0] = 'S';    /*S'assure que c'est un S majuscule*/
            Efface_char(saisie,"S");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  supprimer*/
            cmb.nom[cmb.num][0] = '\0';   /*Supprime le combattant*/
            printf("Suppression du combattant %d\n", cmb.num+1);
            store_combattants(&cmb);
        }
        else
        {   /*Choix d'un combattant*/
            cmb.num = atoi(saisie)-1;   /*Lit le numro du combattant*/
            printf("Attaque de %s, combattant %d\n", cmb.nom[cmb.num], cmb.num+1);
            attaque_simple(&cmb);   /*Appel la fonction d'attaque*/
        }
        puts("------------------------------------------------------------------------------");
    }while(1);
    store_combattants(&cmb);
    return 0;
}

void degats (struct donnees_combat *cmb)
{
    int bonus, total, val, *des=NULL, i;
    total=0;
    printf("%s (.d.) (Defaut:%s): ", acc("Jet de dgts:\nType de ds",chfunc), cmb->degats[cmb->num]);
    des = interpret_des(des,"0",chfunc);
    if(chfunc[0] == '\0')   //Valeur par dfaut, pas de saisie de l'utilisateur
        des = interpret_des(des,cmb->degats[cmb->num],chfunc); //Utilisation de la valeur par dfaut
    else    //Saisie par l'utilisateur des ds de dgts
        strcpy(cmb->degats[cmb->num],chfunc);   //Copie la saisie de l'utilisateur et devient la valeur par dfaut
    do
    {    /*Bcl erreur de saisie*/
        printf("Bonus de %s (Defaut=+%d): : +", acc("dgts",chfunc), cmb->defaut[cmb->num][3]);
        bonus = (int) interpret_calc("\0");
    } while (bonus == NA);
    if(bonus == defo)  /*Si pas d'entre, valeur par defaut*/
        bonus = cmb->defaut[cmb->num][3];
    else /*Si bonus spcifi*/
        cmb->defaut[cmb->num][3] = bonus; /*Devient la valeur par defaut*/
    puts("");
    for (i=1;i<=des[0];i++)
    {    /*Calcul les dgts*/
        val = NbAlea1b(des[i]);
        printf("%d  ", val);
        total += val;
    }
    printf("\nJet naturel= %d\n", total);
    printf("%s %d\n", acc("Jet modifi=",chfunc), total+bonus);
    free(des);
}

void attaque_simple (struct donnees_combat *cmb)
{
    int loc, i, CA, jet_att;
    char saisie[50];
    int copie_battaques[10];
    printf("\nBonus d'attaque (Pas de calcul !) (Defaut:");
    for(i=0;i<cmb->nbatt[cmb->num];i++) /*bcl sur le nombre d'attaque pour l'affichage*/
    {
        if(i>0)
            printf("\\");
        if(cmb->battaques[cmb->num][i] >= 0)
            printf("+");
        printf("%d", cmb->battaques[cmb->num][i]);
    }
    printf("): +");
    for(i=0;i<10;i++)
        copie_battaques[i] = cmb->battaques[cmb->num][i];  /*Copie de sauvegarde des jets d'attaque par defaut*/
    loc = cmb->nbatt[cmb->num];  /*Copie de sauvegarde du nombre de jets d'attaque par defaut*/
    cmb->nbatt[cmb->num] = interpret_attaque(saisie,cmb->battaques[cmb->num]);
    if(cmb->nbatt[cmb->num] == 0) /*Pas de saisie, valeur par defaut*/
    {   /*Reprend les copies*/
        for(i=0;i<10;i++)
            cmb->battaques[cmb->num][i] = copie_battaques[i];
        cmb->nbatt[cmb->num] = loc;
    }
    do
    {    /*Boucle d'erreur de saisie*/
        printf("CA de l'adversaire (Defaut=%d): ", cmb->defaut[cmb->num][0]);
        CA = (int) interpret_calc("\0");
    } while (CA == NA);
    if(CA == defo)  /*Si pas d'entre, valeur par defaut*/
        CA = cmb->defaut[cmb->num][0];
    else /*Si esquiv spcifie*/
        cmb->defaut[cmb->num][0] = CA; /*Devient la valeur par defaut*/
    for (i=0;i<cmb->nbatt[cmb->num];i++)
    {
        jet_att = NbAlea1b(20);   /*Effectue le jet de d20 du jet d'attaque*/
        if (jet_att > 1)  /*Si c'est pas un critique*/
        {
            printf("\nJet naturel= %d\n", jet_att);
            printf("Confirmation critique: ");
            if (NbAlea1b(20) + cmb->battaques[cmb->num][i] < CA)
                printf("non\n");
            else
                printf("OK !\n");
            printf("%s %d\n", acc("Jet modifi=",chfunc), jet_att+cmb->battaques[cmb->num][i]);
            if (jet_att+cmb->battaques[cmb->num][i] < CA)
            {
                putsacc("\nL'attaque a rate l'adversaire\n");
            }
            else
            {
                putsacc("\n***** Attaque russie, l'adversaire est bless *****\n");
                loc = NbAlea1b(20);   /*Jet de lacalisation*/
                printf("Localisation de l'impact: %d  (pour un %s: ", loc, acc("humanode",chfunc));
                if (loc <= 5)        /*Localisation humanode*/
                    puts("Jambes)\n");
                if (loc >= 6 && loc <= 12)
                    puts("Torse)\n");
                if (loc >= 13 && loc <= 15)
                    puts("Bras gauche)\n");
                if (loc >= 16 && loc <= 18)
                    puts("Bras droit)\n");
                if (loc == 19 || loc == 20)
                    putsacc("Tte (partie sensible!))\n");
                degats(cmb);
            }
        }
        else
            printf("!!!!!! Echec critique !!!!!!        Jet critique= %d\n", NbAlea1b(20));
        Pause();
    }
}

int interpret_attaque(char *attaque, int *bonus_att)
{
    int i, j;
    strcpy(attaque,nomajloc_attaque(chfunc));
    i=0;
    if(attaque[0] == '\0')  /*Pas de saisie*/
        return 0;
    for(j=0;j<10;j++)
    {
        if (attaque[0] == '-')        /*Si la valeur est ngative*/
        {
            Efface_char(attaque,"-");
            bonus_att[i++] = atoi(attaque) * -1;     /*Lit le bonus d'attaque et le stocke dans le tableau*/
        }
        else
            bonus_att[i++] = atoi(attaque);     /*Lit le bonus d'attaque et le stocke dans le tableau*/
        if (strstr(attaque,"/") == NULL && strstr(attaque,"\\") == NULL)    /*Si il n'y  plus d'attaque*/
            return i;       /*Renvoi le nombre d'attaque*/
        if (strstr(attaque,"/") != NULL)
            Efface_char(attaque,"/");   /*Se prpare  saisir le prochaine attaque*/
        if (strstr(attaque,"\\") != NULL)
            Efface_char(attaque,"\\");   /*Se prpare  saisir le prochaine attaque*/
        if (attaque[0] == '+')        /*Si l'utilisateur  mis +*/
            Efface_char(attaque,"+");
    }
    return i;
}

void store_combattants (struct donnees_combat *cmb)
{
    FILE* combattants;
    int i,j;
    combattants = ouvre_fichier("Combattants.st","w"); /*Ecrit les donnes dans le fichier en quittant*/
    i=0;
    while(i<51)
    {   /*Inscrit les diffrents combattants*/
        if(cmb->nom[i][0] != '\0')
        {
            fprintf(combattants,"#%d\n",i+1);
            fprintf(combattants,"Nom:%s\n", cmb->nom[i]);
            fprintf(combattants,"Attaques:");
            for(j=0;j<cmb->nbatt[i];j++)
            {
                if(cmb->battaques[i][j] > 0)
                    fprintf(combattants,"+");
                fprintf(combattants,"%d", cmb->battaques[i][j]);
                if(j<cmb->nbatt[i]-1)
                    fprintf(combattants,"/");
            }
            fprintf(combattants,"\n");
            fprintf(combattants,"Bonus d'initiative:%d\n",cmb->binit[i]);
        }
        i++;
    }
    fclose(combattants);
}
