/* Programme de cration de grimoire 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 6.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "Fichier.h"
#include "Rand.h"
#include "Menu.h"
#include "Utilitaire.h"
#include "Jdr.h"

struct arguments         /*Structure de donne des arguments*/
{
    int nbarg;
    char arg1[255];
    char arg2[100];
};

void selection_mage (int niveau, char spe[], char type[], char interdit1[], char interdit2[], int *nbsortM, int *indextab, int *sorts, FILE* Fichier_sorts);   /*Effectue la slection des sorts profanes pour les magiciens*/
void selection_profane_connus (int niveau, char type[], int *nbsortC, int *indextab, int *sorts, FILE* Fichier_sorts);   /*Effectue la slection des sorts profanes*/
void selection_pretre (int niveau, char domaine1[], char domaine2[], int *indextab, int *sorts, FILE* Fichier_sorts);   /*Effectue la slection des sorts divin pour les prtres*/
int verif_double(int niveau, int valeur, int *nbsortM, int *indextab, int *sorts);   /*Vrifie que le sort slectionn n'est pas dja dans le tableau, pour ce niveau*/
int verif_interdit(int valeur, int *sort_interdit);   /*Vrifie que le sort slectionn n'est pas interdit*/
void afficheur_sorts(int *nbsortM, int *nbsortC, int *indextab, int *sorts, int nivo, char interdit1[],char interdit2[], char domaine1[], char domaine2[], char nomfichier[], struct arguments *arg);   /*Affiche les sorts correspondant aux numros*/
void bonus_carac (int *nbsortM, int carac);  /*Dtermine les sorts en bonus donn par les carac lev*/
void nombres_sorts (int *nbsortM, int nivo, FILE* Fichier_nb);   /*Dtermine le nombre de sorts*/
void nombres_sorts_connus (int *nbsortC, int nivo, FILE* Fichier_nb);   /*Dtermine le nombre de sorts connus*/
void increment_fichier (char* nom, int niveau);

int main (int argc,char *argv[])
{
    struct arguments arg;
    FILE* Fichier_nb;
    FILE* Fichier_sorts;
    char nomfichier[255];
    char spe[50];
    char type[50];
    char classe[100];
    char interdit_domaine1[50];
    char interdit_domaine2[50];
    char domaine1[50] = "0";
    char domaine2[50] = "0";
    char interdit1[50] = "0";
    char interdit2[50] = "0";
    char ligne[255];
    int nivo, carac, nbsortM[10], nbsortC[10], val, i, j, *sorts, indextab[11];
    char choix;
    Init_srand();
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    arg.nbarg = argc;
    if(argc == 10)
    {
        Efface_char(argv[9],"=");
        affichage_arg = atoi(argv[9]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre (argc,argv,"Cration de grimoire","Programme de cration de grimoire et autres sorts pour Donjons et dragons",color_sd("Creation de grimoire",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(arg.nbarg>1)
    {   /*Si arguments, remplissage de la structure*/
        if(argc != 10)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Grimoire.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        strcpy(arg.arg1,argv[1]);   /*Chemin de la feuille de perso*/
        Efface_char(argv[2],"=");
        strcpy(arg.arg2,argv[2]);   /*Nom du personnage*/
        //argv[3] est rcupr plus tard, au lieu du menu
        Efface_char(argv[4],"=");
        strcpy(spe,argv[4]);   /*Spcialisation de mage ventuelle*/
        Efface_char(argv[5],"=");
        strcpy(interdit_domaine1,argv[5]);   /*Ecole oppose 1 ou domaine 1*/
        Efface_char(argv[6],"=");
        strcpy(interdit_domaine2,argv[6]);   /*Ecole oppose 2 ou domaine 2*/
        Efface_char(argv[7],"=");
        nivo = atoi(argv[7]);   /*Niveau de lanceur de sort*/
        Efface_char(argv[8],"=");
        carac = atoi(argv[8]);   /*Valeur de carac associe*/
    }
    if(argc==1)
    {   /*Si pas d'argument*/
        do
        {     /*bcl de gestion d'erreur*/
            printf("Niveau du lanceur de sorts: ");
            nivo = (int) interpret_calc("\0");
        } while (nivo == NA || nivo == defo);
        do
        {     /*bcl de gestion d'erreur*/
            putsacc("Valeur de caractristique associe aux sorts: ");
            carac = (int) interpret_calc("\0");
        } while (carac == NA || carac == defo);
    }
    do
    {
        if(argc==1)   /*Si pas d'argument*/
            strcpy(ligne,Menu("Menu grimoire.ini",chfunc,1,0));  /*Appel du menu principal de Grimoire*/
        else    /*Arguments*/
        {
            strcpy(ligne,argv[3]);  /*Prend l'arg3 qui correspond  ce qu'aurais renvoy le menu*/
            Efface_char(ligne,"=");
        }
        strcpy(type,ligne);
        Efface_char(type,".");
        i=0;
        while(ligne[i] != '.')
        {
            classe[i] = ligne[i];
            i++;
        }
        classe[i] = '\0';
        choix='0';
        if(!strcmp(classe,"Assassin"))
            choix = '1';
        if(!strcmp(classe,"Barde"))
            choix = '2';
        if(!strcmp(classe,"Druide"))
            choix = '3';
        if(!strcmp(classe,"Ensorceleur"))
            choix = '4';
        if(!strcmp(classe,"Magicien"))
            choix = '5';
        if(!strcmp(classe,"Paladin"))
            choix = '6';
        if(!strcmp(classe,"Prtre"))
            choix = '7';
        if(!strcmp(classe,"Rdeur"))
            choix = '8';
        if(!strcmp(classe,"Combattant profane"))
            choix = '9';
        switch (choix)
        {
            case 'q':
            case 'Q':
                exit(0);
                break;
            case '1':    /*Assassin*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Assassin\\Sorts de niv.0.txt");
                strcpy(spe,"General");
                strcpy(type,"General");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Assassin\\Nb sorts Assassin.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    val += (nbsortM[i-1])*2;
                    indextab[i] = val;
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                val += (nbsortM[i-1])*2;
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_mage(i,spe,type,interdit1,interdit2,nbsortM,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau et le type*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '2':    /*Barde*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Barde\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Barde\\Nb sorts Barde.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Barde\\Sorts connus Barde.s","r");
                nombres_sorts_connus(nbsortC,nivo,Fichier_nb);  /*Calcul le nombre de sorts connus*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    val += nbsortC[i-1];
                    indextab[i] = val;
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortC[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_profane_connus(i,type,nbsortC,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau et le type*/
                    fclose(Fichier_sorts);
                }
                break;
            case '3':    /*Druide*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Druide\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Druide\\Nb sorts Druide.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                for(val=0,i=0;i<10;i++)
                {
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    do
                    {
                        fgets(ligne,255,Fichier_sorts);
                    } while (ligne[0] != '#');      /*Recherche le paragraphe commenant par #*/
                    fgets(ligne,255,Fichier_sorts);
                    Efface_char(ligne,"=");
                    val += atoi(ligne);
                    indextab[i+1] = val;
                    fclose(Fichier_sorts);
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_pretre(i,domaine1,domaine2,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '4':    /*Ensorceleur*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Ensorceleur\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Ensorceleur\\Nb sorts Ensorceleur.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Ensorceleur\\Sorts connus Ensorceleur.s","r");
                nombres_sorts_connus(nbsortC,nivo,Fichier_nb);  /*Calcul le nombre de sorts connus*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    val += nbsortC[i-1];
                    indextab[i] = val;
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                val += nbsortC[i-1];
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortC[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_profane_connus(i,type,nbsortC,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau et le type*/
                    fclose(Fichier_sorts);
                }
                break;
            case '5':    /*Magicien*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Magicien\\Sorts de niv.0.txt");
                if(argc==1)   /*Si pas d'argument*/
                    strcpy(spe,Menu("..\\Donnes\\Sorts\\Magicien\\Spcialisation.ini",chfunc,1,0)); /*Choix de la sp*/
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Magicien\\Nb sorts Magicien.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                if (strcmp(spe,"General"))    /*Si spe est diffrent de General, donc mage spe*/
                {
                    if(argc==1)
                    {   /*Si pas d'argument*/
                        putsacc("Choisit les 2 coles en opposition du mage:");
                        strcpy(interdit1,Menu("..\\Donnes\\Sorts\\Magicien\\Ecoles opposes.ini",chfunc,1,0));
                        strcpy(interdit2,Menu("..\\Donnes\\Sorts\\Magicien\\Ecoles opposes.ini",chfunc,1,0));
                    }
                    else
                    {   /*Arguments*/
                        strcpy(interdit1,interdit_domaine1);    /*Prend les valeurs donnes en arg*/
                        strcpy(interdit2,interdit_domaine2);
                    }
                    for(i=0;i<10;i++)
                    {
                        if (nbsortM[i])    /*Si y il a des sorts pour ce niveau*/
                        {
                            val = nbsortM[i];
                            val++;    /*Augmente de 1 chaque nombre de sorts*/
                            nbsortM[i] = val;
                        }
                    }
                }
                indextab[0] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    val += (nbsortM[i-1])*2;
                    indextab[i] = val;
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                val += (nbsortM[i-1])*2;
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_mage(i,spe,type,interdit1,interdit2,nbsortM,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau et le type*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '6':    /*Paladin*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Paladin\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Paladin\\Nb sorts Paladin.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                indextab[1] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    do
                    {
                        fgets(ligne,255,Fichier_sorts);
                    } while (ligne[0] != '#');      /*Recherche le paragraphe commenant par #*/
                    fgets(ligne,255,Fichier_sorts);
                    Efface_char(ligne,"=");
                    val += atoi(ligne);
                    indextab[i+1] = val;
                    fclose(Fichier_sorts);
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=1;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_pretre(i,domaine1,domaine2,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '7':    /*Prtre*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Prtre\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Prtre\\Nb sorts Prtre.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                if(argc==1)
                {   /*Si pas d'argument*/
                    printf("Choisit les 2 domaines de sorts:");
                    strcpy(domaine1,Menu("..\\Donnes\\Sorts\\Prtre\\Domaines.ini",chfunc,1,0));
                    strcpy(domaine2,Menu("..\\Donnes\\Sorts\\Prtre\\Domaines.ini",chfunc,1,0));
                }
                else
                {   /*Arguments*/
                    strcpy(domaine1,interdit_domaine1);    /*Prend les valeurs donnes en arg*/
                    strcpy(domaine2,interdit_domaine2);
                }
                indextab[0] = 0;
                for(val=0,i=0;i<10;i++)
                {
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    do
                    {
                        fgets(ligne,255,Fichier_sorts);
                    } while (ligne[0] != '#');      /*Recherche le paragraphe commenant par #*/
                    fgets(ligne,255,Fichier_sorts);
                    Efface_char(ligne,"=");
                    j = atoi(ligne);   /*Prend la fin des sorts de domaines*/
                    fgets(ligne,255,Fichier_sorts);
                    Efface_char(ligne,"=");
                    val += atoi(ligne) - j + 3; /*Nb sorts = total - sorts domaines+1 + 2 sorts de domaines*/
                    indextab[i+1] = val;
                    fclose(Fichier_sorts);
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    if(i)   //Pas pour le niveau 0
                        nbsortM[i] += 1;    //Ajoute un sort de plus en mmoire pour le sort de domaine
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_pretre(i,domaine1,domaine2,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '8':    /*Rdeur*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Rdeur\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Rdeur\\Nb sorts Rdeur.s","r");
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                indextab[1] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    do
                    {
                        fgets(ligne,255,Fichier_sorts);
                    } while (ligne[0] != '#');      /*Recherche le paragraphe commenant par #*/
                    fgets(ligne,255,Fichier_sorts);
                    Efface_char(ligne,"=");
                    val += atoi(ligne);
                    indextab[i+1] = val;
                    fclose(Fichier_sorts);
                }        /*Met dans indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=1;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_pretre(i,domaine1,domaine2,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            case '9':    /*Combattant profane*/
                strcpy(nomfichier,"..\\Donnes\\Sorts\\Combattant profane\\Sorts de niv.0.txt");
                Fichier_nb = ouvre_fichier("..\\Donnes\\Sorts\\Combattant profane\\Nb sorts Combattant profane.s","r");
                strcpy(spe,"General");  /*Les combattants profanes n'ont pas de spe*/
                nombres_sorts(nbsortM,nivo,Fichier_nb);  /*Calcul le nombre de sorts en mmoire*/
                fclose(Fichier_nb);
                bonus_carac(nbsortM,carac);  /*Calcul les sorts en bonus*/
                indextab[0] = 0;
                for(val=0,i=1;i<10;i++)
                {
                    val += (nbsortM[i-1])*2;
                    indextab[i] = val;
                }        /*Met dans Dsorts->indextab, les index  partir duquel commencera chaque niveau dans le tableau de sort. val prend la valeur total du tableau*/
                val += (nbsortM[i-1])*2;
                indextab[i] = val;
                ER = (int) (sorts = (int*) calloc(val,sizeof(int)));
                Erreur(1);
                for(i=0;i<10;i++)
                {
                    if (nbsortM[i] == 0)
                        break;  /*Si il n'y a plus de sorts  dterminer, arrte la slection des sorts*/
                    nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
                    Fichier_sorts = ouvre_fichier(nomfichier,"r");
                    selection_mage(i,spe,type,interdit1,interdit2,nbsortM,indextab,sorts,Fichier_sorts);    /*Fait la slection suivant le niveau et le type*/
                    fclose(Fichier_sorts);
                }
                for(i=0;i<10;i++)
                    nbsortC[i] = nbsortM[i];
                break;
            default:
                choix = '0';
        }
    }while(choix == '0'); /*Scurit erreur de saisi*/
    afficheur_sorts(nbsortM,nbsortC,indextab,sorts,nivo,interdit1,interdit2,domaine1,domaine2,nomfichier,&arg);
    free(sorts);
    if(argc==1)
    {   /*Si pas d'argument*/
        Pause();
    }
    return 0;
}

void bonus_carac (int *nbsortM, int carac)
{
    FILE* Fichier;
    char chaine[255];
    int val,i;
    Fichier = ouvre_fichier("..\\Donnes\\Sorts\\Bonus carac.s","r");
    do
    {
        fgets(chaine,255,Fichier);
        val = atoi(chaine);   /*Cherche la ligne de la carac*/
    } while (val != carac);
    Efface_char(chaine,":");
    for (i=0;i<10;i++)
    {
        if (nbsortM[i] > 0) /*Si le personnage  des sorts de ce niveau*/
        {
            if (nbsortM[i] == 1000) /*Mot cl b, pas de sorts mais on prend quand mme les bonus*/
                nbsortM[i] = 0;
            nbsortM[i] += atoi(chaine);  /*Ajoute le nombre de sorts en bonus de chaque niveau*/
        }
        if (i < 9)
            Efface_char(chaine,",");
    }
    fclose(Fichier);
}

void nombres_sorts (int *nbsortM, int nivo, FILE* Fichier_nb)
{
    char chaine[255];
    int val, i;
    fgets(chaine,255,Fichier_nb);
    Efface_char(chaine,"=");
    val = atoi(chaine);      /*Val prend le niveau max de sorts dtaills*/
    if (nivo <= val)
    {
        do
        {
            fgets(chaine,255,Fichier_nb);
            val = atoi(chaine);   /*Cherche la ligne du niveau*/
        } while (val != nivo);
        Efface_char(chaine,":");
        for (i=0;i<10;i++)
        {
            nbsortM[i] = 0; /*Initialisation*/
            nbsortM[i] = atoi(chaine);
    		if (chaine[0] == 'b') /*Si on  le mot cl b, uniquement sort en bonus*/
       			nbsortM[i] = 1000; /*Indique mot cl b*/
    		if (chaine[0] == 'p') /*Si on  le mot cl p, pas de sorts de ce niveau*/
       			nbsortM[i] = -1; /*Indique mot cl p*/
            if (i == 9)
                break;    /*Quitte la boucle afin d'viter le while qui va tourner infiniment*/
            Efface_char(chaine,",");
        }
    }
    else
    {      /*Si c'est des niveaux suprieurs  la normale*/
        while(strstr(chaine,"niv+1:") == NULL)
            fgets(chaine,255,Fichier_nb);     /*Recherche la ligne des niveaux suprieurs*/
        Efface_char(chaine,":");
        for (i=0;i<10;i++)
        {
    		if (chaine[0] == 'b') /*Si on  le mot cl b, uniquement sort en bonus*/
       			nbsortM[i] = 1000; /*Indique mot cl b*/
    		else if (chaine[0] == 'p') /*Si on  le mot cl p, pas de sorts de ce niveau*/
       			nbsortM[i] = -1; /*Indique mot cl p*/
   			else if (atoi(chaine) == 0)    /*Si le facteur =0, alors il n'y pas de sorts pour ce niveau*/
                nbsortM[i] = 0;
   			else
                nbsortM[i] = (int)floor(nivo/atof(chaine));   /*Le nombre de sorts = niveau / par facteur et arrondi  l'infrieur. On force le float  devenir un entier*/
            if (i < 9)  /*Evite l'erreur car il n'y  plus de virgule  la fin*/
                Efface_char(chaine,",");
        }
    }
}

void nombres_sorts_connus (int *nbsortC, int nivo, FILE* Fichier_nb)
{
    char chaine[255];
    int val, i;
    fgets(chaine,255,Fichier_nb);
    Efface_char(chaine,"=");
    val = atoi(chaine);      /*Val prend le niveau max de sorts dtaills*/
    if (nivo <= val)
    {
        do
        {
            fgets(chaine,255,Fichier_nb);
            val = atoi(chaine);   /*Cherche la ligne du niveau*/
        } while (val != nivo);
        Efface_char(chaine,":");
        for (i=0;i<10;i++)
        {
            nbsortC[i] = atoi(chaine);  /*Lit le nombre de sorts de chaque niveau*/
    		if (chaine[0] == 'p') /*Si on  le mot cl p, pas de sorts de ce niveau*/
       			nbsortC[i] = -1; /*Indique mot cl p*/
            if (i < 9)
                Efface_char(chaine,",");
        }
    }
    else
    {      /*Si c'est des niveaux suprieurs  la normale*/
        while(strstr(chaine,"niv+1:") == NULL)
            fgets(chaine,255,Fichier_nb);     /*Recherche la ligne des niveaux suprieurs*/
        Efface_char(chaine,":");
        for (i=0;i<10;i++)
        {
    		if (chaine[0] == 'p') /*Si on  le mot cl p, pas de sorts de ce niveau*/
       			nbsortC[i] = -1; /*Indique mot cl p*/
   			else if (atoi(chaine) == 0)    /*Si le facteur =0, alors il n'y pas de sorts pour ce niveau*/
                nbsortC[i] = 0;
   			else
                nbsortC[i] = (int)floor(nivo/atof(chaine));   /*Le nombre de sorts = niveau / par facteur et arrondi  l'infrieur. On force le float  devenir un entier*/
            if (i < 9)  /*Evite l'erreur car il n'y  plus de virgule  la fin*/
                Efface_char(chaine,",");
        }
    }
}

void selection_mage (int niveau, char spe[], char type[], char interdit1[], char interdit2[], int *nbsortM, int *indextab, int *sorts, FILE* Fichier_sorts)
{
    char ligne[255];
    int i,j,nb,index,val,b1,b2,totalalea,total;
    int *valalea;
    int *sort_interdit;
    nb = nbsortM[niveau];    /*Prend le nb de sort pour ce niveau*/
    index = indextab[niveau];    /*Prend la base de l'index pour ce niveau*/
    do
    {
        fgets(ligne,255,Fichier_sorts);
    } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
    fgets(ligne,255,Fichier_sorts);
    Efface_char(ligne,"=");
    total = atoi(ligne);       /*Prend le nombre total de sort pour ce niveau*/
    rewind(Fichier_sorts);
    ER = (int) (valalea = (int*) calloc(total,sizeof(int)));
    Erreur(1);
    ER = (int) (sort_interdit = (int*) calloc(total,sizeof(int)));
    Erreur(1);
    if (strcmp(spe,"General"))    /*Si spe est diffrent de General, donc mage spe*/
    {
        /*Cration du tableau des sorts interdit*/
        for(i=0,val=1;i<2;i++)    /*Boucle 2 fois, pour les 2 coles.*//*val sert d'index*/
        {
            do
            {
                fgets(ligne,255,Fichier_sorts);
            } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
            if (i==0)
            {  /*1ere cole interdite*/
                do
                {
                    fgets(ligne,255,Fichier_sorts);
                } while (strstr(ligne,interdit1) == NULL);      /*Recherche la ligne de l'cole interdite du mage*/
            }
            if (i==1)
            {  /*2e cole interdite*/
                do
                {
                    fgets(ligne,255,Fichier_sorts);
                } while (strstr(ligne,interdit2) == NULL);      /*Recherche la ligne de la 2e cole interdite du mage*/
            }
            Efface_char(ligne,":");
            if (ligne[1] != '-' && ligne[2] != '-')
            {       /*Si c'est une slection simple (pas de jet alatoire)*/
                sort_interdit[val++] = atoi(ligne);            /*stocke la valeur dans le tableau d'interdit*/
            }
            else
            {            /*Si c'est une slection entre 2 bornes*/
                b1 = atoi(ligne);
                Efface_char(ligne,"-");
                b2 = atoi(ligne);
                totalalea = b2-b1+1;  /*Dtermine le nombre total de valeur dans la fourchette*/
                for(j=b1;j<=b2;j++)
                    sort_interdit[val++] = j;    /*stocke la valeur dans le tableau d'interdit*/
            }
            rewind(Fichier_sorts);
        }
        sort_interdit[0] = val-1;   /*La premire case du tableau contient le nombre de sorts interdits*/
        /*Fin de la cration du tableau d'interdits*/
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (strstr(ligne,spe) == NULL);      /*Recherche la ligne de la spcialit du mage*/
        for(i=0;i<2;i++)     /*Boucle 2 fois*/
            Efface_char(ligne,":");
        while (nb > 0)
        {
            if (ligne[1] != '-' && ligne[2] != '-')
            {       /*Si c'est une slection simple (pas de jet alatoire)*/
                val = atoi(ligne);            /*Lit la valeur*/
                if(verif_double(niveau,val,nbsortM,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
                {
                    sorts[index] = -val;     //Stocke la valeur dans le tableau, passe en ngatif pour reconnaitre un sort de l'cole de spcialisation
                    index++;      /*Passe  la case suivante dans le tableau*/
                    nb--;         /*1 sort de moins  placer*/
                    if (strstr(ligne,",") != NULL)
                        Efface_char(ligne,",");
                    else     /*Si il n'y pas de virgule, fin de la ligne, quitte la boucle*/
                        break;
                }
            }
            else
            {            /*Si c'est une slection alatoire entre 2 bornes*/
                b1 = atoi(ligne);
                Efface_char(ligne,"-");
                b2 = atoi(ligne);
                totalalea = b2-b1+1;  /*Dtermine le nombre total de valeur dans la fourchette*/
                do
                {
                    val = NbAlea2b(b1,b2);
                    if(verif_double(niveau,val,nbsortM,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
                    {
                        sorts[index] = -val;     //Stocke la valeur dans le tableau, passe en ngatif pour reconnaitre un sort de l'cole de spcialisation
                        index++;      /*Passe  la case suivante dans le tableau*/
                        nb--;         /*1 sort de moins  placer*/
                    }
                    totalalea--;  /*1 sort a t pris, ou ignor, dans la fourchette de valeur*/
                } while(nb > 0 && totalalea > 0);
                break;     /*Quitte la boucle gnrale*/
            }
        }
    }
    if (strcmp(type,"General"))    /*Si type est diffrent de General, donc type de mage  considrer*/
    {
        rewind(Fichier_sorts);
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (strstr(ligne,type) == NULL);      /*Recherche la ligne du type du mage*/
        Efface_char(ligne,":");
        if (nb > 0)
        {
            for(i=0;i<(int)strlen(ligne);i++)        /*Passe le d*/
                ligne[i] = ligne[i+1];
            totalalea = atoi(ligne);      /*totalalea utilis comme nombre de valeur dans l'alatoire*/
            strcpy(ligne,strstr(ligne,"{"));   /*Passe la valeur de totalalea*/
            for(j=0;j<totalalea;j++)
            {
                for(i=0;i<(int)strlen(ligne);i++)      /*Passe le , ou {*/
                    ligne[i] = ligne[i+1];
                valalea[j] = atoi(ligne);
                if (strstr(ligne,",") != NULL)    /*Si ce n'est pas la fin*/
                    strcpy(ligne,strstr(ligne,","));
            }
            b1 = totalalea;     /*b1 utilis comme valeur de l'aleatoire*/
            while(nb > 0 && totalalea > 0)
            {
                do
                {
                    i = NbAlea1b(b1)-1;
                    val = valalea[i];
                } while (!val);  /*Si val = 0, sort interdit, relance le d*/
                if ((strcmp(spe,"General") && verif_interdit(val,sort_interdit)) || !(strcmp(spe,"General")))
                {/*Si mage spe et sort autoris ou si mage gnral*/
                    if(verif_double(niveau,val,nbsortM,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
                    {
                        sorts[index] = val;     /*Stocke la valeur dans le tableau*/
                        index++;      /*Passe  la case suivante dans le tableau*/
                        nb--;         /*1 sort de moins  placer*/
                    }
                    valalea[i] = 0;  /*Si le sort est pris ou dj pris, le sort est remplac par 0*/
                    totalalea--;  /*1 sort a t pris dans la fourchette de valeur*/
                }
                else
                {  /*Si le sort est interdit*/
                    valalea[i] = 0;  /*Le numero de sort est remplac par 0*/
                    totalalea--;    /*1 sort a t ignor*/
                }
            }
        }
    }
    /*Boucle gnrale considrant tous les sorts*/
    totalalea = total;    /*Prend la valeur du nombre total de sorts*/
    while(nb > 0 && totalalea > 0)
    {
        val = NbAlea1b(total);    /*Prend un sort au hasard dans la liste de tous les sort de ce niveau*/
        if ((strcmp(spe,"General") && verif_interdit(val,sort_interdit)) || !(strcmp(spe,"General")))
        {/*Si mage spe et sort autoris ou si mage gnral*/
            if(verif_double(niveau,val,nbsortM,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
            {
                sorts[index++] = val;     /*Stocke la valeur dans le tableau, et passe  la case suivante*/
                nb--;         /*1 sort de moins  placer*/
            }
        }
        totalalea--;  /*1 sort a t pris dans la fourchette de valeur*/
    }
    /*Boucle de remplissage du grimoire par des sorts alatoires*/
    nb = nbsortM[niveau];    /*Reprend le nb de sort pour ce niveau*/
    totalalea = total;    /*Prend la valeur du nombre total de sorts*/
    while(nb > 0 && totalalea > 0)
    {
        val = NbAlea1b(total);    /*Prend un sort au hasard dans la liste de tous les sort de ce niveau*/
        if ((strcmp(spe,"General") && verif_interdit(val,sort_interdit)) || !(strcmp(spe,"General")))
        {/*Si mage spe et sort autoris ou si mage gnral*/
            if(verif_double(niveau,val,nbsortM,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
            {
                sorts[index++] = val;     /*Stocke la valeur dans le tableau, et passe  la case suivante*/
                nb--;         /*1 sort de moins  placer*/
            }
        }
        totalalea--;  /*1 sort a t pris dans la fourchette de valeur*/
    }
    free(valalea);
    free(sort_interdit);
}

void selection_profane_connus (int niveau, char type[], int *nbsortC, int *indextab, int *sorts, FILE* Fichier_sorts)
{
    char ligne[255];
    int i,j,nb,index,val,b1,totalalea,total;
    int *valalea;
    nb = nbsortC[niveau];    /*Prend le nb de sort pour ce niveau*/
    index = indextab[niveau];    /*Prend la base de l'index pour ce niveau*/
    do
    {
        fgets(ligne,255,Fichier_sorts);
    } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
    fgets(ligne,255,Fichier_sorts);
    Efface_char(ligne,"=");
    total = atoi(ligne);       /*Prend le nombre total de sort pour ce niveau*/
    rewind(Fichier_sorts);
    ER = (int) (valalea = (int*) calloc(total,sizeof(int)));
    Erreur(1);
    if (strcmp(type,"General"))    /*Si type est diffrent de General, donc type  considrer*/
    {
        rewind(Fichier_sorts);
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (ligne[0] != '#');      /*Recherche le paragraphe comenant par #*/
        do
        {
            fgets(ligne,255,Fichier_sorts);
        } while (strstr(ligne,type) == NULL);      /*Recherche la ligne du type*/
        Efface_char(ligne,":");
        if (nb > 0)
        {
            for(i=0;i<(int)strlen(ligne);i++)        /*Passe le d*/
                ligne[i] = ligne[i+1];
            totalalea = atoi(ligne);      /*totalalea utilis comme nombre de valeur dans l'alatoire*/
            strcpy(ligne,strstr(ligne,"{"));   /*Passe la valeur de totalalea*/
            for(j=0;j<totalalea;j++)
            {
                for(i=0;i<(int)strlen(ligne);i++)      /*Passe le , ou {*/
                    ligne[i] = ligne[i+1];
                valalea[j] = atoi(ligne);
                if (strstr(ligne,",") != NULL)    /*Si ce n'est pas la fin*/
                    strcpy(ligne,strstr(ligne,","));
            }
            b1 = totalalea;     /*b1 utilis comme valeur de l'aleatoire*/
            while(nb > 0 && totalalea > 0)
            {
                do
                {
                    i = NbAlea1b(b1)-1;
                    val = valalea[i];
                } while (!val);  /*Si val = 0, sort interdit, relance le d*/
                if(verif_double(niveau,val,nbsortC,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
                {
                    sorts[index] = val;     /*Stocke la valeur dans le tableau*/
                    index++;      /*Passe  la case suivante dans le tableau*/
                    nb--;         /*1 sort de moins  placer*/
                }
                valalea[i] = 0;  /*Si le sort est pris ou dj pris, le sort est remplac par 0*/
                totalalea--;  /*1 sort a t pris dans la fourchette de valeur*/
            }
        }
    }
    /*Boucle gnrale considrant tous les sorts*/
    totalalea = total;    /*Prend la valeur du nombre total de sorts*/
    while(nb > 0 && totalalea > 0)
    {
        val = NbAlea1b(total);    /*Prend un sort au hasard dans la liste de tous les sort de ce niveau*/
        if(verif_double(niveau,val,nbsortC,indextab,sorts))  /*Si vrif_double renvoi 1, OK*/
        {
            sorts[index++] = val;     /*Stocke la valeur dans le tableau, et passe  la case suivante*/
            nb--;         /*1 sort de moins  placer*/
        }
        totalalea--;  /*1 sort a t pris dans la fourchette de valeur*/
    }
    free(valalea);
}

void selection_pretre (int niveau, char domaine1[], char domaine2[], int *indextab, int *sorts, FILE* Fichier_sorts)
{
    char ligne[255];
    int i,index,val,total;
    index = indextab[niveau];    /*Prend la base de l'index pour ce niveau*/
    do
    {
        fgets(ligne,255,Fichier_sorts);
    } while (ligne[0] != '#');      /*Recherche le paragraphe commenant par #*/
    val=1;
    if(domaine1[0] != '0')
    {    /*Si il y  des sorts de domaines*/
        fgets(ligne,255,Fichier_sorts);
        Efface_char(ligne,"=");
        val = atoi(ligne);       /*Prend le nombre total de sort de domaines*/
    }
    fgets(ligne,255,Fichier_sorts);
    Efface_char(ligne,"=");
    total = atoi(ligne);       /*Prend le nombre total de sort pour ce niveau*/
    if(domaine1[0] != '0' && niveau)    /*Niveau != 0*/
    {    /*Si il y  des sorts de domaines*/
        rewind(Fichier_sorts);
        do
        {
            fgets(ligne,255,Fichier_sorts);
        }while(strstr(ligne,domaine1) ==  NULL);
        Efface_char(ligne,"=");
        sorts[index++] = atoi(ligne);
        rewind(Fichier_sorts);
        do
        {
            fgets(ligne,255,Fichier_sorts);
        }while(strstr(ligne,domaine2) ==  NULL);
        Efface_char(ligne,"=");
        Efface_char(ligne,"=");
        sorts[index++] = atoi(ligne);
    }
    for(i=val;i<=total;i++)
        sorts[index++] = i;
}

int verif_double(int niveau, int valeur, int *nbsortM, int *indextab, int *sorts)
{
    int index;
    for(index=indextab[niveau];index<indextab[niveau]+(nbsortM[niveau])*2;index++)
    {
        if (sorts[index] == valeur || sorts[index] == valeur*-1)
            return 0;   //Vrifie si le sort est dj dans la liste des sorts choisi (et test les valeurs ngatives pour les sorts de spcialisations
    }
    return 1;
}

int verif_interdit(int valeur, int *sort_interdit)   /*Vrifie que le sort slectionn n'est pas interdit*/
{
    int i;
    for(i=1;i<=sort_interdit[0];i++)
    {
        if(sort_interdit[i] == valeur)
            return 0;
    }
    return 1;
}

void afficheur_sorts(int *nbsortM, int *nbsortC, int *indextab, int *sorts, int nivo, char interdit1[],char interdit2[], char domaine1[], char domaine2[], char nomfichier[], struct arguments *arg)
{
    FILE* Fichier;
    FILE* grimoire;
    FILE* equip;
    int i,j,type,val;
    char comp[255];
    char ligne[255] = "Liste de sorts";
    if(arg->nbarg > 1)
    {   /*Arguments*/
        sprintf(ligne,"%s\\%s sorts.txt", arg->arg1, arg->arg2);    //Copie le chemin du perso et Ajoute le nom du perso
    }
    else
    {   /*Pas d'arguments*/
        increment_fichier(ligne,nivo);
        strcat(ligne,"txt");
    }
    grimoire = ouvre_fichier(ligne,"w");
    if (interdit1[0] != '0')
    {
        fprintf(grimoire,"Ecole en opposition: ");
        fprintf(grimoire,"%s, %s\n", interdit1, interdit2);
    }
    if (domaine1[0] != '0')
    {
        fprintf(grimoire,"Domaine de sorts: ");
        fprintf(grimoire,"%s, %s\n", domaine1, domaine2);
    }
    equip = ouvre_fichier("Composantes.txt","w");
    for(i=0;i<10;i++)
    {    /*Boucle sur les niveaux de sorts*/
        if (nbsortC[i] == 0)
            break;        /*Si il n'y a plus de sort  tirer, quitte la boucle*/
        if (nbsortC[i] == -1)
            continue;        /*Si il n'y a pas de sort de ce niveau*/
        if (interdit1[0] != '0' || (domaine1[0] != '0' && i))    //Si prsence d'cole interdite, donc mage spcialiste ou domaine et prtre pour sort au dessus de 0
        {
            nbsortM[i] = nbsortM[i]-1;   //rduit le nombre de sort en mmoire de 1 pour l'ajouter de manire visible
            fprintf(grimoire,">Sorts de niveau %d: %d+1 sorts en mmoire\n", i, nbsortM[i]);
        }
        else
            fprintf(grimoire,">Sorts de niveau %d: %d sorts en mmoire\n", i, nbsortM[i]);
        nomfichier[strlen(nomfichier)-5] = i+48;    /*Dtermine le nom du fichier  ouvrir en fonction du niveau*/
        Fichier = ouvre_fichier(nomfichier,"r");
        for(j=indextab[i];j<indextab[i+1];j++)
        {
            if (sorts[j] == 0)
                break;
            if (sorts[j] < 0)   //Sort de l'cole de spcialisation
            {
                fprintf(grimoire,"  "); //Retrait de 2 espaces supplmentaire
                sorts[j] = sorts[j]*-1; //Rend  nouveau la valeur positive.
            }
            do
            {   /*Recherche le sort correpondant au numro*/
                fgets(ligne,255,Fichier);
            } while(atoi(ligne) != sorts[j]);
            Efface_char(ligne,":");
            while(strstr(ligne,"#!."))    //Gestion des composantes coteuse
            {
                strcpy(comp,strstr(ligne,"#!."));  //Copie la ligne et la tronque
                ligne[index_ch_first(ligne,"#")] = '\0';   //Efface les composantes
                Efface_char(comp,".");
                type=1;  //Par dfaut, composante matrielle M
                if(comp[0] == 'F')
                    type=2; //Composante de type focaliseur F
                Efface_char(comp,".");
                val = atoi(comp);   //Relve le prix de la composante
                Efface_char(comp,".");
                if(type==1)
                    strcat(ligne,"M=");
                else
                    strcat(ligne,"F=");
                strcat(ligne,comp);
                if(type==1) //Composante M
                {
                    if(val<50)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<51) || nivo>1) //Si lvl1, 50%, sinon 100%
                        {
                            if(nivo==1)
                                val = NbAlea1b(10);     //Donne 1d10 composantes
                            else
                                val = NbAlea1b(20);     //Donne 1d20 composantes
                        }
                    }
                    else if(val<200)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<48) || (nivo>1 && NbAlea1b(100)<96)) //Si lvl1, 48%, sinon 95%
                        {
                            if(nivo==1)
                                val = NbAlea1b(5);     //Donne 1d5 composantes
                            else
                                val = NbAlea1b(10);     //Donne 1d10 composantes
                        }
                    }
                    else if(val<500)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<46) || (nivo>1 && NbAlea1b(100)<91)) //Si lvl1, 45%, sinon 90%
                        {
                            if(nivo==1)
                                val = NbAlea1b(4);     //Donne 1d4 composantes
                            else
                                val = NbAlea1b(8);     //Donne 1d8 composantes
                        }
                    }
                    else if(val<1000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<41) || (nivo>1 && NbAlea1b(100)<81)) //Si lvl1, 40%, sinon 80%
                        {
                            if(nivo==1)
                                val = NbAlea1b(2);     //Donne 1d10 composantes
                            else
                                val = NbAlea1b(4);     //Donne 1d20 composantes
                        }
                    }
                    else if(val<5000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<31) || (nivo>1 && NbAlea1b(100)<61)) //Si lvl1, 30%, sinon 60%
                            val = 1;     //Donne 1 composante
                    }
                    else if(val>=5000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<16) || (nivo>1 && NbAlea1b(100)<31)) //Si lvl1, 15%, sinon 30%
                            val = 1;     //Donne 1 composante
                    }
                }
                else    //Composante F
                {
                    if(val<200)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<51) || nivo>1) //Si lvl1, 50%, sinon 100%
                            val = 1;     //Donne 1 composante
                    }
                    else if(val<500)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<48) || (nivo>1 && NbAlea1b(100)<96)) //Si lvl1, 47%, sinon 95%
                            val = 1;     //Donne 1 composante
                    }
                    else if(val<1000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<46) || (nivo>1 && NbAlea1b(100)<91)) //Si lvl1, 45%, sinon 90%
                            val = 1;     //Donne 1 composante
                    }
                    else if(val<5000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<41) || (nivo>1 && NbAlea1b(100)<81)) //Si lvl1, 40%, sinon 80%
                            val = 1;     //Donne 1 composante
                    }
                    else if(val>=5000)
                    {
                        val=0;
                        if((nivo==1 && NbAlea1b(100)<26) || (nivo>1 && NbAlea1b(100)<51)) //Si lvl1, 25%, sinon 50%
                            val = 1;     //Donne 1 composante
                    }
                }
                if(strstr(comp,"#!."))    //Si il y a une autre composante sur la mme ligne
                    comp[index_ch_first(comp,"#")] = '\0';   //Efface la suite
                else
                    Efface_n(comp);
                    comp[strlen(comp)-1] = '\0';   //Efface \n et la parenthse fermante
                if(val>0)   //Composante ok
                    fprintf(equip,"%d* %s\n", val, comp);   //Inscrit la composante
            }
            fprintf(grimoire,"  %s", ligne);   /*Ecrit le sort dans le fichier*/
            rewind(Fichier);
        }
        fclose(Fichier);
        fprintf(grimoire,"\n"); /*Saute une ligne*/
    }
    fclose(equip);
    fclose(grimoire);
    if(affichage_arg < 3)
        putsacc("Liste de sorts termine.\n");
}

void increment_fichier (char* nom, int niveau)
{
    FILE* fichierincr;
    char chaine[255];
    int i;
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","w");
    listing_doss("..\\Z Fichiers cres",fichierincr,0,"",0); //Appel la commande de listing de dossier
    fclose(fichierincr);
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","r+");
    i=1;
    while(fgets(chaine,255,fichierincr))    /*Lit le fichier tant qu'il ne tombe pas sur une ligne virge*/
    {    /*incrmente de 1 chaque fois qu'il trouve le mme nom que le fichier  crer*/
        if (strstr(chaine,nom) != NULL)
            i++;
    }
    fprintf(fichierincr,":..\\Z Fichiers cres\\%s lvl%d_%d.",nom, niveau, i);    /*Cre le nom du fichier  partir de NOM et du numro d'incrmentation*/
    rewind(fichierincr);
    do
    {
        fgets(chaine,255,fichierincr); /*Recherche le nom du fichier inscrit  la fin du fichier*/
    }while(chaine[0] != ':');
    Efface_char(chaine,":");
    strcpy(nom,chaine);
    fclose(fichierincr);
}
