/* Programme de gnration alatoire.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Jdr.h"
#include "Menu.h"

struct arguments         /*Structure de donne des arguments*/
{
    FILE* sortie;
    int nbarg;
    int arg2;
};

int verif_val (char* ligne, int alea);  /*dtermine si la ligne actuelle est celle correspondant au jet de d*/
int jet_de_des (char* ligne);       /*Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
int afficheur (char* ligne, char* nomfichier, int* nblanC, int tabdes[10], struct arguments *arg); /*Affiche le rsultat*/
void moteur_principal (char* nomfichier, struct arguments *arg);   /*Gestion de la table de gnration alatoire*/

int main (int argc,char *argv[])
{
    struct arguments arg;
    char nomfichier[255];
    Init_srand();
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    arg.nbarg = argc;
    if(argc == 4)
    {
        Efface_char(argv[3],"=");
        affichage_arg = atoi(argv[3]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre(argc,argv,"Gnrateur alatoire","Programme de gnration alatoire",color_sd("Generateur aleatoire",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(arg.nbarg>1)
    {   /*Si arguments, remplissage de la structure*/
        if(argc != 4)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Gnrateur_alatoire.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        strcpy(nomfichier,argv[1]);   /*Chemin de fichier*/
        Efface_char(argv[2],"=");
        arg.arg2 = atoi(argv[2]);   /*Nb de lanc*/
    }
    if(argc==1)   /*Si pas d'argument*/
        strcpy(nomfichier,Menu("Menu_gen alea.ini",chfunc,1,0));
    arg.sortie = ouvre_fichier("Sortie gen_alea.txt","w");
    moteur_principal(nomfichier,&arg);
    fclose(arg.sortie);
    if(argc==1)   /*Si pas d'argument*/
        Pause();
    return 0;
}

void moteur_principal (char* nomfichier, struct arguments *arg)
{
    FILE* fichiertable;
    char ligne[255];
    char fichierorig[255];
    int tabdes[10];
    int nblanC, alea, chgtabl=0, compt0, cpt0, nbdes, i;
    strcpy(fichierorig,nomfichier);    /*Backup du chemin du fichier d'origine*/
    if(arg->nbarg==1)
    {   /*Si pas d'argument*/
        do
        {    /*Bcl erreur de saisie*/
            printf("Combien de lancer voulez-vous effectuer? ");
            nblanC = (int) interpret_calc("\0");
        } while (nblanC == NA || nblanC == defo);
        printf("\n\n");
    }
    else    /*Arguments*/
        nblanC = arg->arg2;
    while (nblanC-- > 0)    /*Compte le nb de jet*/
    {
        if (chgtabl == 0) /*Si la table ne change pas*/
        {
            for (nbdes=0;nbdes<10;nbdes++)        /*rutilise nbdes pour initialis le tableau de jet*/
                tabdes[nbdes]=0;
            nbdes=0;
            strcpy(nomfichier,fichierorig);        /*Reprend le fichier d'origine*/
        }
        fichiertable = ouvre_fichier (nomfichier,"r");
        compt0=0;
        fgets(ligne,255,fichiertable);
        alea = jet_de_des(ligne);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            tabdes[nbdes++] = alea;
            compt0++;
            while (verif_val (ligne, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(ligne,255,fichiertable);
                for(i=0,cpt0=0;(cpt0<compt0) && (ligne[i]=='0');cpt0++,i+=2);  //Saute les 0 de la table inutilis pour retrouver la profondeur d'arborescence
                ligne[--i] = '!';   //le ! servira de point d'effacement
                Efface_char(ligne,"!");     //Efface les 0 inutiles
            }
            compt0++;
            if (ligne[0] == '#' || ligne[0] == '>')
            {   //Le # indique un titre
                if (ligne[0] == '>')
                {                /*Indique une info avec suite*/
                    Efface_char(ligne," "); //Efface > et l'espace le suivant
                    Efface_n(ligne);
                    strcat(ligne," ");
                }
                if(affichage_arg < 3)
                    putsacc(ligne);                        /*Affiche ligne*/
                fprintf(arg->sortie,"%s",ligne);  /*Duplique la sortie dans le fichier texte*/
                fgets(ligne,255,fichiertable);  //Prend la ligne suivante
                for(i=0,cpt0=0;(cpt0<compt0) && (ligne[i]=='0');cpt0++,i+=2);  //Saute les 0 de la table inutilis pour retrouver la profondeur d'arborescence
                ligne[--i] = '!';   //le ! servira de point d'effacement
                Efface_char(ligne,"!");     //Efface les 0 inutiles
            }
            alea = jet_de_des(ligne); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        chgtabl = afficheur (ligne,nomfichier,&nblanC,tabdes,arg);  /*Appele l'afficheur*/
        fclose(fichiertable);
    }
}

int verif_val (char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2, i;
    val1 = atoi(ligne); //Lit la premire valeur
    i=0;
    while(isdigit(ligne[i++])); //Dplace i aprs le nombre
    if(ligne[i-1] == '-')   //Seconde valeur
    {
        Efface_char(ligne,"-");
        val2 = atoi(ligne); //Lit la 2e valeur
    }
    else    //Si pas de 2e valeur
        val2 = val1;
    Efface_char(ligne,":");
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int jet_de_des (char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne, i;
    if ((ligne[0] == 'd') && (ligne[1] == 'd'))      /*Si un d doit tre lanc*/
    {
        for(i=0;i<(int)strlen(ligne);i++)
            ligne[i] = ligne[i+2];  //Efface dd
        borne = atoi(ligne);    //Lit la valeur du d
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        Efface_char(ligne,":"); //Efface le d
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

int afficheur (char* ligne, char* nomfichier, int* nblanC, int tabdes[10], struct arguments *arg)
{ /*Rend 1 si il change de table*/
    int i,j, chtabl=0;
    char afich[255];
    if ((ligne[0] == 't') && (ligne[1] == 't') && (ligne[2] == '+'))
        chtabl = 1;        /*Si il y a un changement de table pour afficher la suite du texte*/
    if ((ligne[0] == 't') && (ligne[1] == 't') && (ligne[2] == '0'))
        chtabl = 2;        /*Si il y a un changement de table sans affichage*/
    if ((ligne[0] == 't') && (ligne[1] == 't'))
    {        /*Si il y a un changement de table*/
        if (chtabl != 2)
        {
            Efface_char(ligne," ");
            i=0;j=0;
            while (ligne[j] != ':')      /*Copie affichage suivant le mot cl tt (tt,tt+)*/
                afich[i++] = ligne[j++];
            afich[i] = '\0';
            if(affichage_arg < 3)
                putsacc(afich);
            fprintf(arg->sortie,"%s",afich);  /*Duplique la sortie dans le fichier texte*/
            if (chtabl == 1)
            {
                if(affichage_arg < 3)
                    printf(" ");     /*Si suite  l'affichage, espace*/
                fprintf(arg->sortie," ");  /*Duplique la sortie dans le fichier texte*/
            }
            if (chtabl == 0)
            {
                if(affichage_arg < 3)
                    printf("\n");    /*si changement de table simple, retour ligne*/
                fprintf(arg->sortie,"\n");  /*Duplique la sortie dans le fichier texte*/
            }
        }
        i=0;
        Efface_char(ligne,":");     //Efface tout avant le nom de la nouvelle table
        Efface_n(ligne);      //Retire le \n
        strcpy(nomfichier,ligne);   //Copie le nouveau chemin de la table
        ++*nblanC; /*Augmente le nb de lanc  effectuer, pour relancer sur la nouvelle table*/
        return 1; /*Renvoi 1 pour signaler un changement de table*/
    }
    else
    {
        if(affichage_arg < 3)
        {
            putsacc(ligne);
            putsacc("\n    >>Jets de ds:");
        }
        fprintf(arg->sortie,"%s",ligne);  /*Duplique la sortie dans le fichier texte*/
        fprintf(arg->sortie,"\n    >>Jets de ds:");  /*Duplique la sortie dans le fichier texte*/
        for (i=0;tabdes[i] != 0;i++)
        {
            if(affichage_arg < 3)
                printf(" %d", tabdes[i]);
            fprintf(arg->sortie," %d", tabdes[i]);  /*Duplique la sortie dans le fichier texte*/
        }
        if(affichage_arg < 3)
            printf(".\n\n");
        fprintf(arg->sortie,".\n\n");  /*Duplique la sortie dans le fichier texte*/
        return 0;
    }
}
