/* Programme de dtermination des objets magiques pour donjons et dragons.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.01. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Jdr.h"
#include "Menu.h"

void principale (char* nomfichier, char* sortie);     /*Gestion de la table d'objet*/
int jet_de_des (int* index, char* ligne);       /*Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
int verif_val (int* index, char* ligne, int alea);  /*dtermine si la ligne actuelle est celle correspondant au jet de d*/
int afficheur (int index, char* ligne, char* nomfichier, int* nblanC, int tabdes[10], FILE* sortie_txt); /*Affiche l'objet magique trouv*/
void increment_fichier (char* nom);

int main (int argc,char *argv[])
{
    char nomfichier [255] = "0";
    char sortie[255] = "Objets_magiques";
    Init_srand ();    /*Initialisation du random*/
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Objets magiques","Module d'objets magiques pour Donjons et Dragons",color_sd("Objets magiques",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    strcpy(nomfichier,Menu("Menu objets magiques.ini",chfunc,1,0));    /*appel le gestionnaire du menu et recupre le nom du fichier choisi*/
    increment_fichier(sortie);
    principale(nomfichier,sortie);
    Pause();
    return 0;
}

void principale (char* nomfichier, char* sortie)
{
    FILE* fichiertable;
    FILE* sortie_txt;
    char ligne[255];
    char fichierorig[255];
    int tabdes[10];
    int nblanC, index, alea, chgtabl=0, compt0, cpt0, nbdes, puissalea=0, choix;
    char puiss;
    strcpy(fichierorig,nomfichier);    /*Backup du chemin du fichier d'origine*/
    do
    {
        puts("Puissance des objets magiques:");
        puts("1) Puissance faible.");
        puts("2) Puissance moyenne.");
        putsacc("3) Puissance leve.\n");
        putsacc("4) Puissance alatoire.\n");
        printf("?: ");
        choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
        if(choix == QUIT)
            exit(0);
        puiss = choix+48;
        if (puiss=='4')
            puissalea = 1;
    } while ((puiss<'1') || (puiss>'4'));
    do
    {    /*Bcl erreur de saisie*/
        printf("Combien d'objets magiques voulez-vous? ");
        nblanC = (int) interpret_calc("\0");
    } while (nblanC == NA || nblanC == defo);
    sortie_txt = ouvre_fichier(sortie,"w");
    printf("\n\n");
    while (nblanC-- > 0)    /*Compte le nb de jet*/
    {
        if (puissalea == 1 && chgtabl == 0)
        {
            alea =  NbAlea1b(3);
            puiss = '1';
            switch (alea)
            {
                case 3:
                    puiss++;
                case 2:
                    puiss++;
            }
        }
        if (chgtabl == 0) /*Si la table ne change pas*/
        {
            for (nbdes=0;nbdes<10;nbdes++)        /*rutilise nbdes pour initialis le tableau de jet*/
                tabdes[nbdes]=0;
            nbdes=0;
            strcpy(nomfichier,fichierorig);        /*Reprend le fichier d'origine*/
        }
        fichiertable = ouvre_fichier (nomfichier,"r");
        index=-1;
        compt0=0;
        fgets(ligne,255,fichiertable);
        if ((ligne[0] == 'p') && (ligne[1] == 'p'))
        {
            while ((ligne[0] != 'p') || (ligne[1] != 'p') || (ligne[2] != puiss))
                fgets(ligne,255,fichiertable);
            compt0++;
            index=3;
        }
        alea = jet_de_des(&index,ligne);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            tabdes[nbdes++] = alea;
            compt0++;
            while (verif_val (&index, ligne, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(ligne,255,fichiertable);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (ligne[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            compt0++;
            if (ligne[index+1] == '#' || ligne[index+1] == '>')
            {
                if (ligne[index+1] == '#')
                {                /*Indique le nom d'un nouveau tableau d'objet*/
                    strcpy(ligne,strstr(ligne,"#"));
                    for (index=0;index<=(int)strlen(ligne);index++)
                        ligne[index] = ligne[index+2];
                }
                if (ligne[index+1] == '>')
                {                /*Indique un objet magique, avec suite...*/
                    strcpy(ligne,strstr(ligne,">"));
                    for (index=0;index<(int)strlen(ligne)-3;index++)
                        ligne[index] = ligne[index+2];
                    #ifdef WIN32 //win
                    ligne[index] = ' ';   /*Retire le \n*/
                    ligne[index+1] = '\0';
                    #else   //linux
                    ligne[index-1] = ' ';   /*Retire le \n*/
                    ligne[index] = '\0';
                    #endif
                }
                putsacc(ligne);                        /*Affiche ligne*/
                fprintf(sortie_txt,"%s",ligne);        //Duplique la sortie dans le fichier texte
                fgets(ligne,255,fichiertable);
                index=0;
                for(cpt0=0;(cpt0<compt0) && (ligne[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            alea = jet_de_des(&index,ligne); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        chgtabl = afficheur (index,ligne,nomfichier,&nblanC,tabdes,sortie_txt);  /*Appele l'afficheur et vrifie le changement de table*/
        fclose(fichiertable);
    }
    fclose(sortie_txt);
}

int jet_de_des (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[*index+1] == 'd'))      /*Si un d doit tre lanc*/
    {
        ++*index;
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

int verif_val (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int afficheur (int index, char* ligne, char* nomfichier, int* nblanC, int tabdes[10], FILE* sortie_txt)
{ /*Rend 1 si il change de table*/
    int i=0, chtabl=0;
    char *objet;
    ER = (int) (objet = (char*) calloc(strlen(ligne),sizeof(char)));
    Erreur(1);
    if ((ligne[index] == 't') && (ligne[index+1] == 't') && (ligne[index+2] == '+'))
        chtabl = 1;        /*Si il y a un changement de table pour afficher la suite de l'objet*/
    if ((ligne[index] == 't') && (ligne[index+1] == 't') && (ligne[index+2] == '0'))
        chtabl = 2;        /*Si il y a un changement de table sans affichage*/
    if ((ligne[index] == 't') && (ligne[index+1] == 't'))
    {        /*Si il y a un changement de table*/
        switch (chtabl)    /*Augmentation de l'index*/
        {
            case 0:
            case 2:
                index+=3;
                break;
            case 1:
                index+=4;
                break;
        }
        if (chtabl != 2)
        {
            while (ligne[index] != ':')      /*copie nom objet magique*/
                objet[i++] = ligne[index++];
            objet[i]  ='\0';
            putsacc(objet);
            fprintf(sortie_txt,"%s",objet);
            if (chtabl == 1)
            {
                printf(" ");     /*Si suite  l'objet, espace*/
                fprintf(sortie_txt," ");
            }
            if (chtabl == 0)
            {
                printf("\n");    /*si changement de table simple, retour ligne*/
                fprintf(sortie_txt,"\n");
            }
        }
        index++;
        i=0;
        while (index < (int)strlen(ligne)-1)         /*Change table  utiliser*/
            nomfichier[i++] = ligne[index++];
        #ifdef WIN32    //win
        nomfichier[i] = '\0';
        #else //linux
        nomfichier[i-1] = '\0';
        #endif
        ++*nblanC; /*Augmente le nb de lanc  effectuer, pour relancer sur la nouvelle table*/
        free(objet);
        return 1; /*Renvoi 1 pour signaler un changement de table*/
    }
    else
    {
        i=0;
        while (index < (int)strlen(ligne))    /*Affiche objet magique*/
            objet[i++] = ligne[index++];
        putsacc(objet);
        fprintf(sortie_txt,"%s",objet);
        putsacc("    >>Jets de ds:");
        fprintf(sortie_txt,"    >>Jets de ds:");
        for (i=0;tabdes[i] != 0;i++)
        {
            printf(" %d", tabdes[i]);
            fprintf(sortie_txt," %d", tabdes[i]);
        }
        printf(".\n\n");
        fprintf(sortie_txt,".\n\n");
        free(objet);
        return 0;
    }
}

void increment_fichier (char* nom)
{
    FILE* fichierincr;
    char chaine[255];
    int i;
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","w");
    listing_doss("..\\Z Fichiers cres",fichierincr,0,"",0); //Appel la commande de listing de dossier
    fclose(fichierincr);
    fichierincr = ouvre_fichier("..\\Donnes\\incr.tmp","r+");
    i=1;
    while(fgets(chaine,255,fichierincr))    /*Lit le fichier tant qu'il ne tombe pas sur une ligne vierge*/
    {    /*incrmente de 1 chaque fois qu'il trouve le mme nom que le fichier  crer*/
        if (strstr(chaine,nom) != NULL)
            i++;
    }
    fprintf(fichierincr,":..\\Z Fichiers cres\\%s_%d.txt",nom , i);    /*Cre le nom du fichier  partir de NOM et du numro d'incrmentation*/
    rewind(fichierincr);
    do
    {
        fgets(chaine,255,fichierincr); /*Recherche le nom du fichier inscrit  la fin du fichier*/
    }while(chaine[0] != ':');
    Efface_char(chaine,":");
    strcpy(nom,chaine);
    fclose(fichierincr);
}
