/* Programme de gnration alatoire de piges.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Jdr.h"

struct donnees_piege         /*Structure de donnes*/
{
    int indic[4];   /*Tableau contenant des donnes binaires d'indication: 0=DD JS, 1=poison, 2=dgts, 3=gnrer rarm et dcl*/
    char type[255];
    char rearmement[100];
    char declencheur[100];
    char poison[255];
    char degats[50];
    int DD_JS;
    int DD_desamorc;
    int DD_detect;
    int niveau;
    int prix_piege;
    int prix_poison;
    int multiplicateur_prix;
    int multiplicateur_prix_temp;
    int FP_temp;
    int FP;
    int FP_mini;
    int FP_maxi;
};

char* gen_alea (const char* nomfichier, char* ligne);      /*Appel le gen alea en ligne de commande*/
void interpreteur (char* ligne, struct donnees_piege *piege, int tabl); /*Traite les chaines renvoyes*/
void afficheur (struct donnees_piege *piege);    /*Affiche le rsultat*/

int main (int argc,char *argv[])
{
    Init_srand();
    init_historique_saisie();
    struct donnees_piege piege;
    char chaine[255];
    int nb,i,ok,bcl_inf;
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre(argc,argv,"Gnrateur de piges","Programme de gnration alatoire de piges pour DD3.5",color_sd("Generateur de pieges",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {    /*Bcl erreur de saisie*/
        putsacc("Nombre de piges  gnrer: ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    do
    {    /*Bcl erreur de saisie*/
        putsacc("FP minimum du pige (par dfaut, FP non utilis): ");
        piege.FP_mini = (int) interpret_calc("\0");
    } while (piege.FP_mini == NA);
    if(piege.FP_mini != defo)
    {
        do
        {    /*Bcl erreur de saisie*/
            putsacc("FP maximum du pige: ");
            piege.FP_maxi = (int) interpret_calc("\0");
        } while (piege.FP_maxi == NA || piege.FP_maxi == defo);
    }
    putsacc("\nCration des piges en cours...\n\n");
    for(bcl_inf=nb*20;nb>0;nb--)
    {
        ok=1;   //Par dfaut le pige est valid pour le FP
        for(i=0;i<4;i++)
            piege.indic[i] = 0;
        piege.indic[3] = 1;  /*Par dfaut gnre dclencheur et rarmement*/
        piege.multiplicateur_prix = 0;
        piege.multiplicateur_prix_temp = 0;
        piege.prix_poison = 0;
        piege.niveau = -1;   /*Initialisation*/
        piege.FP = 0;
        piege.FP_temp = 0;
        i=0;
        do
        {
            if(i>=21)
                ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
            if(ok)
                interpreteur(gen_alea("..\\Piges\\Piges.tbl",chaine),&piege,1);
            i++;
            if(piege.FP_mini == defo)
                i=0;    //Pas de gestion du FP, on passe sans se poser de question
            else
            {   //Gestion du FP du pige
                if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                    i=0;    //Le pige passe cette tape
            }
        }while(ok && i);
        piege.FP += piege.FP_temp;
        piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
        if (piege.indic[3])
        {
            i=0;
            do
            {
                if(i>=21)
                    ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
                if(ok)
                    interpreteur(gen_alea("..\\Piges\\Dclencheur.tbl",chaine),&piege,2);
                i++;
                if(piege.FP_mini == defo)
                    i=0;    //Pas de gestion du FP, on passe sans se poser de question
                else
                {   //Gestion du FP du pige
                    if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                        i=0;    //Le pige passe cette tape
                }
            }while(ok && i);
            piege.FP += piege.FP_temp;
            piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
            i=0;
            do
            {
                if(i>=21)
                    ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
                if(ok)
                    interpreteur(gen_alea("..\\Piges\\Rarmement.tbl",chaine),&piege,3);
                i++;
                if(piege.FP_mini == defo)
                    i=0;    //Pas de gestion du FP, on passe sans se poser de question
                else
                {   //Gestion du FP du pige
                    if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                        i=0;    //Le pige passe cette tape
                }
            }while(ok && i);
            piege.FP += piege.FP_temp;
            piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
        }
        if (piege.indic[1])
        {
            i=0;
            do
            {
                if(i>=21)
                    ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
                if(ok)
                    interpreteur(gen_alea("..\\Piges\\Poisons.tbl",chaine),&piege,4);
                i++;
                if(piege.FP_mini == defo)
                    i=0;    //Pas de gestion du FP, on passe sans se poser de question
                else
                {   //Gestion du FP du pige
                    if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                        i=0;    //Le pige passe cette tape
                }
            }while(ok && i);
            piege.FP += piege.FP_temp;
            piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
        }
        if (piege.indic[0])
        {
            i=0;
            do
            {
                if(i>=21)
                    ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
                if(ok)
                {
                    piege.DD_JS = NbAlea2b(10,40);   /*Dtermine le DD du JS*/
                    if(piege.DD_JS < 15)    //Modifie le FP en fonction du DD du JS rflxe
                        piege.FP_temp -= 1;
                    if(piege.DD_JS > 25)
                        piege.FP_temp += 1;
                    if(piege.DD_JS > 30)
                        piege.FP_temp += 1;
                }
                i++;
                if(piege.FP_mini == defo)
                    i=0;    //Pas de gestion du FP, on passe sans se poser de question
                else
                {   //Gestion du FP du pige
                    if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                        i=0;    //Le pige passe cette tape
                }
            }while(ok && i);
            piege.FP += piege.FP_temp;
            piege.multiplicateur_prix += piege.DD_JS/10;    /*Ajoute multiplicateur*/
        }
        i=0;
        do
        {
            if(i>=21)
                ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
            if(ok)
            {
                piege.DD_desamorc = NbAlea2b(10,40);   /*Dtermine le DD de dsamorage*/
                if(piege.DD_desamorc < 15)    //Modifie le FP en fonction du DD de dsamorage
                    piege.FP_temp -= 1;
                if(piege.DD_desamorc > 25)
                    piege.FP_temp += 1;
                if(piege.DD_desamorc > 30)
                    piege.FP_temp += 1;
            }
            i++;
            if(piege.FP_mini == defo)
                i=0;    //Pas de gestion du FP, on passe sans se poser de question
            else
            {   //Gestion du FP du pige
                if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                    i=0;    //Le pige passe cette tape
            }
        }while(ok && i);
        piege.FP += piege.FP_temp;
        piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
        piege.multiplicateur_prix += piege.DD_desamorc/10;    /*Ajoute multiplicateur*/
        i=0;
        do
        {
            if(i>=21)
                ok=0;   //Au dela de 20 echec conscutif pour obtenir un FP valable, annule et reprend au dbut.
            if(ok)
            {
                piege.DD_detect = NbAlea2b(10,40);   /*Dtermine le DD de dtection*/
                if(piege.DD_detect < 15)    //Modifie le FP en fonction du DD de dtection
                    piege.FP_temp -= 1;
                if(piege.DD_detect > 25)
                    piege.FP_temp += 1;
                if(piege.DD_detect > 30)
                    piege.FP_temp += 1;
            }
            i++;
            if(piege.FP_mini == defo)
                i=0;    //Pas de gestion du FP, on passe sans se poser de question
            else
            {   //Gestion du FP du pige
                if(piege.FP+piege.FP_temp >=piege.FP_mini && piege.FP+piege.FP_temp <=piege.FP_maxi)    //Si le FP est dans la tranche demande
                    i=0;    //Le pige passe cette tape
            }
        }while(ok && i);
        piege.FP += piege.FP_temp;
        piege.multiplicateur_prix += piege.multiplicateur_prix_temp;
        piege.multiplicateur_prix += piege.DD_detect/10;    /*Ajoute multiplicateur*/
        piege.prix_piege += piege.prix_poison;    /*Ajoute le prix du poison*/
        piege.prix_piege *= piege.multiplicateur_prix;    /*Multiplie le tout pour obtenir le prix final*/
        if(!ok) //Le pige n'est pas valable pour le FP, pige annul.
            nb++;
        else
            afficheur(&piege);  //Pige valable
        bcl_inf--;
        if(bcl_inf <= 0)
        {   //Si le boucle for tourne en moyenne 20 fois pour chaque pige, le programme annule le FP afin d'viter des boucles infinies
            putsacc("\nLes piges, dans la tranche de FP demande, semblent trop difficile  crer.\nCration des piges suivant sans tenir compte du FP.\n");
            piege.FP_mini = defo;  //Ignore le FP
            bcl_inf=nb*2;
        }
    }
    Pause();
    return 0;
}

void interpreteur (char* ligne, struct donnees_piege *piege, int tabl)
{
    int i=0;
    switch (tabl)
    {
        case 1:
            /*Traitement du type de pige*/
            while(ligne[i] != ':')
            {
                piege->type[i] = ligne[i];
                i++;
            }
            piege->type[i] = '\0';
            do
            {
                Efface_char(ligne,":");
                if (ligne[0] == 'n')   /*niv*/
                {
                    Efface_char(ligne,"v");
                    piege->niveau = NbAlea2b(atoi(ligne),25);    /*Dtermine le niveau entre niveau mini et 25*/
                }
                if (ligne[0] == 'p')   /*poison*/
                    piege->indic[1] = 1;
                if (ligne[0] == 'D')   /*DD*/
                    piege->indic[0] = 1;
                if (ligne[0] == 'd')   /*dgt=*/
                {
                    piege->indic[2] = 1;
                    Efface_char(ligne,"=");
                    i=0;
                    while(ligne[i] != ':' && i<(int)strlen(ligne))
                    {
                        piege->degats[i] = ligne[i];      /*Lit les dgts*/
                        i++;
                    }
                    piege->degats[i] = '\0';
                }
                if (ligne[0] == 'S')   /*Seul*/
                    piege->indic[3] = 0;
                if (ligne[0] == '+')   /*Prix*/
                {
                    Efface_char(ligne,"+");
                    piege->prix_piege = atoi(ligne);    /*Dtermine le prix de base du pige*/
                }
            } while(strstr(ligne,":") != NULL);
            break;
        case 2:
            /*Traitement du dclencheur*/
            while(ligne[i] != ':')
            {
                piege->declencheur[i] = ligne[i];
                i++;
            }
            piege->declencheur[i] = '\0';
            Efface_char(ligne,":");
            if (ligne[0] == '*')
            {
                Efface_char(ligne,"*");
                piege->multiplicateur_prix_temp = atoi(ligne);    /*Ajoute multiplicateur du dclencheur*/
            }
            break;
        case 3:
            /*Traitement du rarmement*/
            while(ligne[i] != ':')
            {
                piege->rearmement[i] = ligne[i];
                i++;
            }
            piege->rearmement[i] = '\0';
            Efface_char(ligne,":");
            if (ligne[0] == '*')
            {
                Efface_char(ligne,"*");
                piege->multiplicateur_prix_temp = atoi(ligne);    /*Ajoute multiplicateur du rarmement*/
            }
            break;
        case 4:
            /*Traitement du poison*/
            while(ligne[i] != ':')
            {
                piege->poison[i] = ligne[i];
                i++;
            }
            piege->poison[i] = '\0';
            Efface_char(ligne,":");
            if (ligne[0] == '+')
            {
                Efface_char(ligne,"+");
                piege->prix_poison = atoi(ligne);    /*Lit le prix du poison*/
            }
            break;
    }
    //Dans tous les cas, lit le FP  la fin
    Efface_char(ligne,"FP=");
    piege->FP_temp = atoi(ligne);   //Ajoute le FP

}

void afficheur (struct donnees_piege *piege)
{
    putsacc("\nType de pige: ");
    putsacc(piege->type);
    if (piege->niveau != -1)
    {
        putsacc("\nNiveau du crateur du pige:");
        printf(" %d.", piege->niveau);
    }
    if (piege->indic[2])
    {
        putsacc("\nDgts: ");
        putsacc(piege->degats);
    }
    if (piege->indic[3])
    {
        putsacc("\nDclencheur: ");
        putsacc(piege->declencheur);
        putsacc("\nRarmement: ");
        putsacc(piege->rearmement);
    }
    if (piege->indic[1])
    {
        printf("\nPoison: ");
        putsacc(piege->poison);
    }
    if (piege->indic[0])
        printf("\nDD du jet de sauvegarde: %d.", piege->DD_JS);
    putsacc("\nDD du jet de dsamorage:");
    printf(" %d.", piege->DD_desamorc);
    printf(" DD du jet de fouille: %d.", piege->DD_detect);
    putsacc("\nFP du pige: ");
    printf("%d.", piege->FP);
    putsacc("\nPrix du pige:");
    printf(" %d po.\n", piege->prix_piege);
}

char* gen_alea (const char* nomfichier, char* ligne)
{
    FILE* temp;
    #ifdef WIN32    /*win*/
        sprintf(ligne,"cd \"..\\Gnrateur alatoire\" && Generateur_aleatoire.exe Table=\"%s\" Nombre=1 Affichage=3", nomfichier);
    #else /*linux*/
        sprintf(ligne,"cd \"../%s\" && ./Generateur_aleatoire Table=\"%s\" Nombre=1 Affichage=3", linux_acc("Gnrateur alatoire",chfunc),nomfichier);
    #endif
    system(ligne); /*Appel le gnrateur alatoire en ligne de commande*/
    temp = ouvre_fichier("..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
    do
    {
        fgets(ligne,255,temp);  /*Lit le rsultat du gnrateur alatoire*/
    }while(ligne[0] == '#');    //Saute les titres
    Efface_n(ligne);      //Retire le \n
    fclose(temp);
    return ligne;
}
