/* Programme de gestion des dplacements pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <math.h>
#include <string.h>
#include "Utilitaire.h"
#include "Jdr.h"

void Distance (float vit, float tps);
float Temps (float vit, float dist, int heure);
void Vitesse (float dist, float tps);

int main (int argc,char *argv[])
{
    float vit, tps, dist;
    int heure, i, nuit, temps;
    char cmdsys[255];
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Dplacements","Module de dplacement Donjons et dragon",color_sd("Deplacements",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    putsacc("Il y a 3 paramtres  prendre en compte: La vitesse de dplacement, le temps de voyage et la distance  parcourir.\n");
    putsacc("Noter 0 pour la valeur recherche.\n\n");
    do
    {    /*Bcl erreur de saisi*/
        putsacc("Vitesse de dplacement (Vitesse DD3 en mtre): ");
        vit = interpret_calc("\0");
        if (vit == defo)
            vit = 0;
    } while (vit == NA);
    do
    {    /*Bcl erreur de saisi*/
        printf("Temps de voyage (En minute): ");
        tps = interpret_calc("\0");
        if (tps == defo)
            tps = 0;
    } while (tps == NA);
    do
    {    /*Bcl erreur de saisi*/
        putsacc("Heures de voyage par jour (12 par dfaut): ");
        heure = (int) interpret_calc("\0");
        if (heure == defo)
            heure = 12;
    } while (heure == NA);
    do
    {    /*Bcl erreur de saisi*/
        putsacc("Distance parcourue (En kilomtre): ");
        dist = interpret_calc("\0");
        if (dist == defo)
            dist = 0;
    } while (dist == NA);
    if (vit == 0)
        Vitesse(dist,tps);
    else if (tps == 0)
        tps = Temps(vit,dist,heure);
    else if (dist == 0)
        Distance(vit,tps);
    putsacc("\nTirer rencontres alatoires sur route correspondante? (O/N, oui par defaut):");
    i = getchar();
    if(i != 10)
        getchar();
    if (i != 78 && i != 110)
    {
        temps = (int) tps;
        nuit = (int) temps/heure; /*Le nombre de nuit = temps de trajet divis par temps de trajet par jour, arrondi  l'infrieur*/
        #ifdef WIN32    /*win*/
            sprintf(cmdsys,"cd \"..\\Rencontres alatoires\" && Rencontre_aleatoire.exe proba=1 table=\"Routes.tbl\" heure=%d nuit=%d Affichage=2", temps, nuit);
        #else /*linux*/
            sprintf(cmdsys,"cd \"../Rencontres %s\" && ./Rencontre_aleatoire proba=1 table=\"Routes.tbl\" heure=%d nuit=%d Affichage=2", acc("alatoires",chfunc), temps, nuit);
        #endif
        system(cmdsys);
    }
    Pause();
    return 0;
}

void Distance (float vit, float tps)
{
    float dist;
    dist = (tps/60)*(vit*10*60/1000);    /* tps/60=Tps en heure, (vit*10*60)/1000=vit en Km/h. */
    printf("%s %.0fm.\n", acc("Vitesse de dplacement:",chfunc), vit);
    printf("Temps de voyage: %.0fmin.\n", tps);
    printf("\nDistance parcourue: %.1fKm (soit %.0fm)\n", dist, dist*1000);
}

float Temps (float vit, float dist, int heure)
{
    float tps;
    int jour = 0;
    tps = dist/(vit*10*60/1000);    /* tps en heure, (vit*10*60)/1000=vit en Km/h. */
    printf("%s %.0fm.\n", acc("Vitesse de dplacement:",chfunc), vit);
    printf("Distance parcourue: %.0fKm.\n", dist);
    printf("\nTemps de voyage: environ %.1fmin (soit %.0f heures et %.0fmin)\n", tps*60, floor(tps), ((tps-floor(tps))*100)*60/100);
    while (tps >= heure)                                                                           /*= isole partie aprs , Multiplie par 100 pour passer avant , Puis prend en pourcentage de 60 minutes*/
    {
        tps -= heure;
        jour++;
    }
    if (jour)
        printf("-> %d jours de marche et %.2f heures.\n", jour, tps);
    return (tps+jour*heure);
}

void Vitesse (float dist, float tps)
{
    float vit;
    vit = dist/(tps/60);    /* vit en Km/h. */
    printf("Temps de voyage: %.0fmin.\n", tps);
    printf("Distance parcourue: %.0fKm.\n", dist);
    printf("\n%s %.0fm (soit %.1fKm/h)\n", acc("Vitesse de dplacement:",chfunc), vit/60/10*1000, vit);
}
