/* Programme d'valuation des points de vie pour donjons et dragons 3.5 modifi.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

void stades (int pv);
int calcul_pv (int nblance, int* des, int bonus);

int main (int argc,char *argv[])
{
    int nblance, bonus, nb, i, *rez, *des=NULL;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Points de vie","Module de dtermination des points de vie",color_sd("Points de vie",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {    /*Bcl erreur saisie*/
        putsacc("Nombre de cratures: ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    do
    {    /*Bcl erreur saisie*/
        putsacc("Nombre de jets pour chaque crature (5 par defaut): ");
        nblance = (int) interpret_calc("\0");
        if (nblance == defo)    /*par defaut, nblance = 5*/
            nblance = 5;
    } while (nblance == NA);
    putsacc("PV: Type de ds (.d.): ");
    des = interpret_des(des,"0",chfunc);
    do
    {    /*Bcl erreur saisie*/
        putsacc("PV: Bonus: +");
        bonus = (int) interpret_calc("\0");
    } while (bonus == NA || bonus == defo);
    ER = (int) (rez = (int*) calloc(nb,sizeof(int)));
    Erreur(1);
    for (i=0;i<nb;i++)    /*Remplis le tableau avec les PV des cratures*/
        rez[i] = calcul_pv (nblance,des,bonus);
    puts("");
    for(i=0;i<nb;i++)
    {    /*Affiche les points de vie de chaque crature et les stades de blessures correspondant*/
        printf("%s %d: %d pv", acc("Crature",chfunc), i+1,rez[i]);
        stades(rez[i]);
    }
    free(rez);
    free(des);
    Pause();
    return 0;
}

int calcul_pv (int nblance, int* des, int bonus)
{
    int pv,temp,i;
    for (pv=0;nblance>0;nblance--)  /*Bcl sur le nb de lanc*/
    {
        for (i=1,temp=0;i<=des[0];i++)    /*Calcul des PV*/
            temp += NbAlea1b (des[i]);
        temp += bonus;
        if (temp > pv)    /*Si le rsultat est plus important que le maximum atteint*/
            pv = temp;        /*Devient le maximum*/
    }
    return (pv);     /*Retourne le meilleur jet de PV obtenu*/
}

void stades (int pv)
{
    float div;
    div = (float) pv/5;        /*Affiche les 4 stades de blessures*/
    printf("          %d / %d / %d / %d\n", (int)(div*4),(int)(div*3),(int)(div*2),(int)div);
}
