/* Programme de dtermination des rencontres alatoires pour donjons et dragons.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "Jdr.h"
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Menu.h"

#define choixtabl "Choisissez la table de rencontre alatoire  utiliser:"

struct arguments         /*Structure de donne des arguments*/
{
    FILE* sortie;
    int nbarg;
    int arg1;
    char arg2[255];
    int arg3;
    int arg4;
};

void principale (char* nomfichier, int indic, struct arguments *arg);     /*Gestion de la table de rencontre*/
int jet_de_des (int* index, char* ligne);       /*Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
int verif_val (int* index, char* ligne, int alea);  /*dtermine si la ligne actuelle est celle correspondant au jet de d*/
int afficheur (int index, char* ligne, char* nomfichier, int* nblanC, struct arguments *arg); /*Affiche le rsultat du jet sur la table de rencontre*/

int main (int argc,char *argv[])
{
    FILE* fichier;
    struct arguments arg;
    char nomfichier [100] = "0";
    char chaine[255];
    int choix, proba, heure, i;
    double voyage, nuit;
    Init_srand ();    /*Initialisation du random*/
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    arg.nbarg = argc;
    if(argc == 6)
    {
        Efface_char(argv[5],"=");
        affichage_arg = atoi(argv[5]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre(argc,argv,"Rencontres alatoires","Module de rencontres alatoires pour Donjons et Dragons",color_sd("Rencontres aleatoires",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(arg.nbarg>1)
    {   /*Si arguments, remplissage de la structure*/
        if(argc != 6)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Rencontre_alatoire.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        arg.arg1 = atoi(argv[1]);
        Efface_char(argv[2],"=");
        strcpy(arg.arg2,argv[2]);
        Efface_char(argv[3],"=");
        arg.arg3 = atoi(argv[3]);
        Efface_char(argv[4],"=");
        arg.arg4 = atoi(argv[4]);
    }
    arg.sortie = ouvre_fichier("Sortie rencontre aleatoire.txt","w");
    if(arg.nbarg==1)
    {   /*Si pas d'argument*/
        putsacc("1) Rencontres alatoires avec probabilits.\n");
        putsacc("2) Tirer des rencontres alatoires.\n");
    }
    do
    {
        if(arg.nbarg==1)
        {   /*Si pas d'argument*/
            printf("?: ");
            choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
                exit(0);
            puts("");
        }
        else   /*Arguments*/
        {
            choix = arg.arg1;
            if(choix == 0) /*Si pas de proba, remplacer par 2 pour le choix de menu*/
                choix = 2;
        }
        switch (choix)
        {        /*Choix du menu*/
            case 1:
                if(arg.nbarg==1) /*Si pas d'argument*/
                    strcpy(nomfichier,Menu("Menu_RA.ini",chfunc,1,0));    /*Appel le gestionnaire du menu et recupre le nom du fichier choisi*/
                else   /*Arguments*/
                    strcpy(nomfichier,arg.arg2);
                fichier = ouvre_fichier("Probabilit.txt","r");
                fgets(chaine,255,fichier);
                while (strstr(chaine,nomfichier) == NULL)
                {   /*Recherche de la ligne correspondante dans le fichier de probabilit*/
                    fgets(chaine,255,fichier);
                }
                Efface_char(chaine,"=");
                proba = atoi(chaine);
                Efface_char(chaine,"=");
                heure = atoi(chaine);
                if(arg.nbarg==1)
                {   /*Si pas d'argument*/
                    do
                    {    /*Bcl erreur de saisie*/
                        printf("Nombre d'heure de voyage: ");
                        voyage = interpret_calc("\0");
                    } while (voyage == NA || voyage == defo);
                    do
                    {    /*Bcl erreur de saisie*/
                        printf("Nombre de nuit durant le voyage: ");
                        nuit = interpret_calc("\0");
                    } while (nuit == NA || nuit == defo);
                }
                else
                {   /*Arguments*/
                    voyage = arg.arg3;
                    nuit = arg.arg4;
                }
                voyage = ceil((voyage+nuit*12)/heure);  /*Arrondi  la valeur sup. nuit = 12h*/
                for(i=0;i<voyage;i++)
                {
                    if(affichage_arg < 3)
                        printf("%de tranche de %d heures\n", i+1, heure);
                    fprintf(arg.sortie,"%de tranche de %d heures\n", i+1, heure);
                    if (NbAlea1b(100) <= proba)
                        principale(nomfichier,0,&arg);
                    else
                    {
                        if(affichage_arg < 3)
                            putsacc("!   Pas de rencontres alatoires\n");
                        fprintf(arg.sortie,"!   Pas de rencontres alatoires\n");
                    }
                }
                break;
            case 2:
                if(arg.nbarg==1) /*Si pas d'argument*/
                    strcpy(nomfichier,Menu("Menu_RA.ini",chfunc,1,0));    /*Appel le gestionnaire du menu et recupre le nom du fichier choisi*/
                else   /*Arguments*/
                    strcpy(nomfichier,arg.arg2);
                principale(nomfichier,1,&arg);
                break;
            default:
                Fuck();
                choix = 0;
        }
    } while (!choix);   /*Erreur de menu*/
    fclose(arg.sortie);
    if(arg.nbarg==1) /*Si pas d'argument*/
        Pause();
    return 0;
}

void principale (char* nomfichier, int indic, struct arguments *arg)
{
    FILE* fichiertable;
    char ligne[255];
    char ligneFP[10];
    char fichierorig[100];
    char pourcent[3] = "0";
    int nblanC, index, alea, compt0, chgtabl=0, cpt0, ok, bcl_inf;
    float FP, FP_mini, FP_maxi;
    strcpy(fichierorig,nomfichier);    /*Backup du chemin du fichier d'origine*/
    nblanC = 1; /*Sert pour le jet avec proba*/
    if (indic)
    {    /*Si c'est un jet sans proba*/
        if(arg->nbarg==1)
        {   /*Si pas d'argument*/
            do
            {    /*Bcl erreur de saisie*/
                printf("Combien de jets voulez-vous effectuer? ");
                nblanC = (int) interpret_calc("\0");
            } while (nblanC == NA || nblanC == defo);
        }
        else   /*Arguments*/
            nblanC = arg->arg3;
    }
    do
    {    /*Bcl erreur de saisie*/
        putsacc("FP minimum de la rencontre (par dfaut, FP non utilis): ");
        FP_mini = interpret_calc("\0");
    } while (FP_mini == NA);
    if(FP_mini != defo)
    {
        do
        {    /*Bcl erreur de saisie*/
            putsacc("FP maximum de la rencontre: ");
            FP_maxi = interpret_calc("\0");
        } while (FP_maxi == NA || FP_maxi == defo);
    }
    bcl_inf=nblanC*50;
    while (nblanC-- > 0)    /*Compte le nb de jet*/
    {
        ok=1;   //Par dfaut le FP est valable
        if (chgtabl == 0) /*Si la table ne change pas*/
            strcpy(nomfichier,fichierorig);        /*Reprend le fichier d'origine*/
        fichiertable = ouvre_fichier (nomfichier,"r");
        index=-1;
        compt0=0;
        if(affichage_arg < 3)
            puts("");
        fprintf(arg->sortie,"\n");
        fgets(ligne,255,fichiertable);
        if (ligne[0] == '%')        /*Si possibilit de jet sur table Tout type*/
        {
            pourcent[1] = ligne[1];
            pourcent[2] = ligne[2];
            pourcent[3] = '\0';            /*Lit la valeur du pourcentage*/
            fgets(ligne,255,fichiertable);
            if (NbAlea1b(100) <= atoi(pourcent)) /*Vrifie le jet de pourcentage*/
            {
                fclose(fichiertable);    /*Change la table de rencontre*/
                fichiertable = ouvre_fichier ("Campagne ou Tous type de terrain.tbl","r");
                fgets(ligne,255,fichiertable);
            }
        }
        alea = jet_de_des(&index,ligne);      /*jet alatoire du 1er d de la table*/
        if(affichage_arg < 3)
            putsacc("Jets de ds: ");
        fprintf(arg->sortie,"Jets de ds: ");
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            if(affichage_arg < 3)
                printf("%d ", alea);        /*Afficher la valeur du jet de d*/
            fprintf(arg->sortie,"%d ", alea);
            compt0++;        /*Augmente le nb de 0 de la table*/
            while (verif_val (&index, ligne, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(ligne,255,fichiertable);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (ligne[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            alea = jet_de_des(&index,ligne); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
            compt0++;
        }
        if(FP_mini != defo) //FP de la rencontre considr
        {
            if(strstr(ligne,"FP="))
            {   //Si un FP est indiqu pour cette rencontre
                strcpy(ligneFP,strstr(ligne,"FP="));
                Efface_char(ligneFP,"=");
                FP = atof(ligneFP); //Lit le FP de la rencontre
                if(FP < FP_mini || FP > FP_maxi)
                {
                    ok=0;   //FP non valable, cette rencontre est ignore
                    nblanC++;   //Ignore cette rencontre
                }
            }
        }
        bcl_inf--;
        if(bcl_inf <= 0)
        {   //Si le boucle tourne en moyenne 50 fois pour chaque rencontre, le programme annule le FP afin d'viter des boucles infinies
            putsacc("\nLes rencontres, dans la tranche de FP demande, semblent trop difficile  trouver.\nDtermination des rencontres suivantes sans tenir compte du FP.\n");
            FP_mini = defo;  //Ignore le FP
            bcl_inf=nblanC*2;
        }
        if(ok)  //Si le FP n'est pas invalide
            chgtabl = afficheur (index,ligne,nomfichier,&nblanC,arg);  /*Appele l'afficheur et vrifie le changement de table*/
        fclose(fichiertable);
    }
}

int jet_de_des (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[*index+1] == 'd'))      /*Si un d doit tre lanc*/
    {
        ++*index;
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

int verif_val (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int afficheur (int index, char* ligne, char* nomfichier, int* nblanC, struct arguments *arg)
{ /*Rend 1 si il change de table*/
    char phrases[4][26] = {{"Nom de la crature:      "},{"Probabilit de rencontre:"},{"Milieu naturel:          "},{"Evenement rencontr:     "}};
    char table[96];                        /*Initialise les phrases  afficher*/
    char creature[255];
    int i,j;
    for (i=0;i<((int)strlen(nomfichier)-4);i++)    /*rcupre le nom de la table utilise*/
        table[i] = nomfichier[i];
    table[i] = '\0';
    if (((ligne[index] != 't') || (ligne[index+1] != 't')) && (ligne[index] != '*') && (strstr(ligne,"Aucune creature rencontree !") == NULL))
    {            /*Si une crature est rencontre*/
        if(affichage_arg < 3)
            printf("\nRencontre sur table %s", acc(table,chfunc)); /*Affiche table utilise*/
        fprintf(arg->sortie,"\nRencontre sur table %s", table);
        for (i=0;i<3;i++)        /*Affiche les 3 caractristiques de la crature*/
        {
            if (index < (int)strlen(ligne))
            {
                if(affichage_arg < 3)
                    printf("\n%s", acc(phrases[i],chfunc));
                fprintf(arg->sortie,"\n%s", phrases[i]);
                j=0;
                while ((ligne[index] != ':') && (index < (int)strlen(ligne)))
                    creature[j++] = ligne[index++];
                creature[j] = '\0';
                if(affichage_arg < 3)
                    putsacc(creature);
                fprintf(arg->sortie,"%s",creature);
                index++;
            }
        }
        if(strstr(ligne,"FP="))
        {   //Affiche le FP de la crature
            Efface_char(ligne,"FP=");
            printf("\nFP: %.1f",atof(ligne));
            fprintf(arg->sortie,"%s",creature);
        }
        if(affichage_arg < 3)
            puts("");
        fprintf(arg->sortie,"\n");
    }
    else
    {
        if (ligne[index] == '*')
        {        /*Si la rencontre est un venement*/
            if(affichage_arg < 3)
                printf("\nRencontre sur table %s", acc(table,chfunc));
            fprintf(arg->sortie,"\nRencontre sur table %s", table);
            index+=2;
            for (i=3;i>=1;i-=2)            /*Affiche l'venement et sa raret (si il y a)*/
            {
                if (index < (int)strlen(ligne))
                {
                    if(affichage_arg < 3)
                        printf("\n%s ", acc(phrases[i],chfunc));
                    fprintf(arg->sortie,"\n%s ", phrases[i]);
                    j=0;
                    while ((ligne[index] != ':') && (index < (int)strlen(ligne)))
                        creature[j++] = ligne[index++];
                    creature[j] = '\0';
                    if(affichage_arg < 3)
                        putsacc(creature);
                    fprintf(arg->sortie,"%s",creature);
                    index++;
                }
            }
            if(affichage_arg < 3)
                puts("");
            fprintf(arg->sortie,"\n");
        }
        if (strstr(ligne,"Aucune creature rencontree !") != NULL)
        {        /*Pas de crature rencontre*/
                if(affichage_arg < 3)
                    printf("\nRencontre sur table %s", acc(table,chfunc));
                fprintf(arg->sortie,"\nRencontre sur table %s", table);
                if(affichage_arg < 3)
                    putsacc("\nAucune crature rencontre !\n");
                fprintf(arg->sortie,"\nAucune crature rencontre !\n");
        }
        if ((ligne[index] == 't') && (ligne[++index] == 't'))
        {        /*Si il y a un changement de table*/
                index+=2;
                i=0;
                if(affichage_arg < 3)
                    printf("\nChangement de table: ");
                fprintf(arg->sortie,"\nChangement de table: ");
                while (index < (int)strlen(ligne)-1)         /*Change table  utiliser*/
                    nomfichier[i++] = ligne[index++];
                nomfichier[i] = '\0';
                Efface_n(nomfichier);
                ++*nblanC; /*Augmente le nb de lanc  effectuer, pour relancer sur la nouvelle table*/
                return 1; /*Renvoi 1 pour signaler un changement de table*/
        }
    }
    return 0;
}
