/* Programme d'valuation des trsor pour donjons et dragons 2 et 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <ctype.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Jdr.h"

void tresor2 (char type, int pourcent);
void tresor3 (void);
void afficheur3 (char* pieces, char* biens, char* objets, int type[3]); /*Affiche les trsors trouvs*/
int jet_de_des (int* index, char* ligne);       /*Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
int verif_val (int* index, char* ligne, int alea);  /*dtermine si la ligne actuelle est celle correspondant au jet de d*/

int main (int argc,char *argv[])
{
    Init_srand();
    init_historique_saisie();
    char type,pc;
    int pourcent = 1;
    int choix;
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Trsor DD","Module d'valuation des trsors pour donjons et dragons 2 et 3.5",color_sd("Tresor DD",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    putsacc("Choisis le type de trsor  tirer:\n");
    putsacc("1) Trsor 2e ditions.\n");
    putsacc("2) Trsor 3e ditions.\n");
    do
    {
        printf("?: ");
        choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
        if(choix == QUIT)
            exit(0);
        puts("");
        switch (choix)
        {        /*Choix du menu*/
            case 1: /*Trsor 2e dition*/
                do
                { /*Bcl erreur de saisie*/
                    do
                    {     /*bcl de gestion d'erreur*/
                        putsacc("Type de trsor  tirer (A  Z): ");
                        scf = scanf("%c", &type);
                        getchar();
                    } while (!scf);
                    type = toupper(type);            /*Met en majuscule*/
                } while (type < 'A' || type > 'Z');
                putsacc("Utiliser les probabilits (O/N, oui par defaut): ");
                pc = getchar();
                switch (pc)
                {
                    case 10:
                        pourcent=1;
                        break;
                    case 'N':
                    case 'n':
                        pourcent=0;
                        getchar();
                        break;
                    default:
                        pourcent=1;
                        getchar();
                }
                tresor2(type,pourcent); /*Lance le moteur de gnration de 2e dition*/
                break;
            case 2:
                tresor3(); /*Lance le moteur de gnration de 3.5*/
                break;
            default:
                Fuck();
                choix = -1;
        }
    } while (choix == -1);   /*Erreur de menu*/
    Pause();
    return 0;
}

void tresor2 (char type, int pourcent)
{
    FILE* fichier;
    char chaine[100];
    char temp[100];
    char objetmag[50] = "NULL";
    char tresor[7][19] = {{"Pices de cuivre "},{"Pices d'argent  "},{"Pices d'or      "},{"Pices de platine"},{"Gemmes           "},{"Objets d'art     "},{"Objets magiques  "}};
    int T, mini, maxi, proba, index=2, i,j;
    fichier = ouvre_fichier("Trsor 2.t","r");
    do
    {    /*Recherche la ligne du type de trsor*/
        fgets(chaine,100,fichier);
    } while (chaine[0] != type);
    for (T=0;T<7;T++)    /*Bcl sur les 7 trsors*/
    {
        if (chaine[index] == '0') /*Si mini = 0: Pas de trsor de ce type*/
        {
            index+=2;
            if (index>(int)strlen(chaine))
                break;     /*Alors fin de ligne*/
            continue;      /*Reboucl pour passer au trsor suivant*/
        }
        for (i=index,j=0;i<=(int)strlen(chaine);i++)
            temp[j++] = chaine[i];        /*temp prend la suite de la phrase pour l'analyser*/
        mini = atoi(temp);           /*Lit la valeur mini*/
        while (chaine[index++] != ':');        /*Dplace l'index jusqu'au :*/
        Efface_char(temp,":");
        maxi = atoi(temp);            /*Lit la valeur maxi*/
        while (chaine[index++] != ':');        /*Dplace l'index jusqu'au :*/
        Efface_char(temp,":");
        proba = atoi(temp);            /*Lit la valeur proba*/
        while (chaine[index++] != ':');        /*Dplace l'index jusqu'au :*/
        if (T==6)        /*Si c'est un objet magique*/
        {
            strcpy(objetmag,strstr(temp,":"));        /*Lit le type d'objet magique*/
            for (i=0;i<(int)strlen(objetmag);i++)
                objetmag[i] = objetmag[i+1];          /*Retire les :*/
            Efface_n(objetmag);      //Retire le \n
        }
        if (!pourcent)            /*Si pourcent est  0: soit pas de pourcentage*/
            proba=100;        /*Probabilit ramene  100%*/
        if (NbAlea1b(100)<=proba)      /*Test de probabilit*/
        {
            printf("\n%s %d-%d: %d", acc(tresor[T],chfunc), mini, maxi, NbAlea2b(mini,maxi));   /*Affiche type de trsor puis rsultat*/
            if (strcmp(objetmag,"NULL"))     /*Si type d'objet magique spcifi*/
                printf(" %s\n",objetmag);    /*Affiche type d'objet*/
        }
    }
}

void tresor3 (void)
{
    FILE* table;
    int nivo, type[3];
    char pieces[100];
    char biens[100];
    char objets[100];
    char ligne[255];
    int index=-1, compt0, cpt0, alea, i;
    do
    {    /*Bcl erreur de saisie*/
        putsacc("Niveau du trsor  dterminer (FP): ");
        nivo = (int) interpret_calc("\0");
    } while (nivo == NA || nivo == defo);
    putsacc("Choix du type de trsor:\n");
    puts("1) Normal.");
    putsacc("2) Pices.\n");
    puts("3) Biens.");
    puts("4) Objets.");
    putsacc("5) Pices et biens.\n");
    putsacc("6) Pices et objets.\n");
    puts("7) Biens et objets.");
    do
    {
        printf("?: ");
        type[0] = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
        if(type[0] == QUIT)
            exit(0);
        puts("");
        switch (type[0])
        {        /*Choix du menu*/
            case 1:
                type[0] = 1; /*Pices*/
                type[1] = 1; /*Biens*/
                type[2] = 1; /*Objets*/
                break;
            case 2:
                type[0] = 1;
                type[1] = 0;
                type[2] = 0;
                break;
            case 3:
                type[0] = 0;
                type[1] = 1;
                type[2] = 0;
                break;
            case 4:
                type[0] = 0;
                type[1] = 0;
                type[2] = 1;
                break;
            case 5:
                type[0] = 1;
                type[1] = 1;
                type[2] = 0;
                break;
            case 6:
                type[0] = 1;
                type[1] = 0;
                type[2] = 1;
                break;
            case 7:
                type[0] = 0;
                type[1] = 1;
                type[2] = 1;
                break;
            default:
                Fuck();
                type[0] = -1;
        }
    } while (type[0] == -1);   /*Erreur de menu*/
    table = ouvre_fichier ("Trsor 3.t","r");
    do
    {
        fgets(ligne,255,table); /*Recherche du niveau du trsor*/
    }while(atoi(ligne) != nivo);
    for(i=0;i<3;i++)
    {
        fgets(ligne,255,table); /*Saute la ligne du #:*/
        index=-1;
        compt0=1;
        Efface_char(ligne,":");
        alea = jet_de_des(&index,ligne);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            compt0++;
            while (verif_val (&index, ligne, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(ligne,255,table);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (ligne[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            compt0++;
            alea = jet_de_des(&index,ligne); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        if(i==0)
            strcpy(pieces,ligne);
        if(i==1)
            strcpy(biens,ligne);
        if(i==2)
            strcpy(objets,ligne);
        if (i<2)    /*Si c'est pas le dernier trsor*/
        {
            do
            {
                fgets(ligne,255,table); /*Recherche du prochain type de trsor*/
            }while(ligne[2] != '#');
        }
    }
    for(i=0;i<3;i++)
    {
        if(i==0)
            strcpy(ligne,pieces);
        if(i==1)
            strcpy(ligne,biens);
        if(i==2)
            strcpy(ligne,objets);
        do
        {   /*Efface tout avant le dernier :*/
            Efface_char(ligne,":");
        }while(strstr(ligne,":") != NULL);
        if(i==0)
            strcpy(pieces,ligne);
        if(i==1)
            strcpy(biens,ligne);
        if(i==2)
            strcpy(objets,ligne);
    }
    afficheur3(pieces,biens,objets,type);  /*Appelle l'afficheur*/
    fclose(table);
}

void afficheur3(char* pieces, char* biens, char* objets, int type[3])
{
    int i=0, val, b1, b2;
    char ligne[100];
    for(i=0;i<3;i++)
    {   /*Bcl sur les 3 types de trsor*/
        if (!type[i])   /*Si type = 0, ce type de trsor n'est pas considr*/
            continue;   /*Saute ce type de trsor*/
        if(i==0)
            strcpy(ligne,pieces);
        if(i==1)
            strcpy(ligne,biens);
        if(i==2)
            strcpy(ligne,objets);
        val=0;
        if(ligne[0] == '~') /*Si le trsor contient une variable*/
        {
            Efface_char(ligne,"~");
            b1 = atoi(ligne);
            Efface_char(ligne,"-");
            b2 = atoi(ligne);
            val = NbAlea2b(b1,b2);
            if(strstr(ligne,"+"))   /*Si on trouve un +, pour les FP au-del de 20*/
            {
                Efface_char(ligne,"+");
                val += atoi(ligne); /*Ajoute ce qui suit +  la valeur tir alatoirement*/
            }
            Efface_char(ligne,"."); /*Efface jusqu'au point aprs les valeurs*/
        }
        if(i==0)
            putsacc("Pices: ");
        if(i==1)
            printf("Biens: ");
        if(i==2)
            printf("Objets: ");
        if(val) /*Si val sup  0*/
            printf("%d", val);
        putsacc(ligne);
    }
}

int jet_de_des (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[*index+1] == 'd'))      /*Si un d doit tre lanc*/
    {
        ++*index;
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

int verif_val (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}
