/* Programme de gestion de temps pour le jeu de rle.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 4.2.2*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Unda tempus.

Unda tempus est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Unda tempus est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "Utilitaire.h"
#include "Fichier.h"
#include "Rand.h"
#include "Menu.h"
#include "Developpez.com.h"

struct data_tps         /*Structure de donne de temps*/
{
    int heure;
    float minute;
    float facteur;
    double base;
    float lune;
    int date;
    int jsemaine;
    int mois;
    int jmois;
    int saison;
    int nb_mois;
    int nb_semaine;
    int sens_lune;
    int temperature;
    int vent;
    int sens_vent;
    int precipitation;
    int max_temp;
    int max_vent;
    int max_precip;
    char climat[255];
    int jfete;
    char nom_fete[255];
    int alea_meteo; //Temps restant avant volution de la mto
    int chg_meteo;  //Indique un changement de la mto
    int nuit;      //0 = jour, 1 = Lever crpuscule astronomique, 2 = Lever crpuscule nautique, 3 = Lever crpucule civil, 4 = Coucher crpuscule civil, 5 = Coucher crpuscule nautique, 6 = Coucher crpucule astronomique, 7 = nuit
};

struct crepuscule         /*Structure de donne du crpuscule*/
{
    double latitude; //Latitude angulaire
    double longitude; //Longitude angulaire
    int jour; //Rang du jour (numro du jour sur l'anne)
    int decal_h;    //Dcalage horaire
    int m_decal_h;
    int H_ete;
    int Aut_H_ete;
    double lever[3];    //Heure du soleil compltement lev;    0:Valeur numrique brut/1:Heures/2:Minutes
    double coucher[3];  //Heure du soleil  son dbut du couch
    double duree[3];    //Dure du jour
    double debut_crep_astro[3]; //Dbut crpuscule astronomique; Dbut du lever du soleil
    double fin_crep_astro[3]; //Fin crpuscule astronomique; Fin du couch du soleil
    double debut_crep_naut[3]; //Dbut crpuscule nautique
    double fin_crep_naut[3]; //Fin crpuscule nautique
    double debut_crep_civil[3]; //Dbut crpuscule civil
    double fin_crep_civil[3]; //Fin crpuscule civil
    double duree_aube[3];
    double duree_tombe_nuit[3];
    int crep_nuit;  //Indique quel crpuscule entame vritablement la nuit. 1: astronomique, 2: nautique, 3: civil, 0: Le soleil ne se couche pas, impossible de calculer
    float evo_crep; //% du lever du soleil ou % du coucher du soleil
};

void passage_temps (struct data_tps *tps, struct crepuscule *crep);  /*Fait dfiler le temps et gre le changement d'heure, de date, de mois, de saison et de mto*/
void afficheur (struct data_tps *tps, struct crepuscule *crep);      /*Affiche les donne  l'ecran*/
int choix_utilis (struct data_tps *tps, struct crepuscule *crep);   /*Gre les commandes de l'utilisateur*/
void meteo (struct data_tps *tps, int chang);      /*Modifie la mto*/
int string (int s, struct data_tps *tps); /*Transforme les int en string et les affiches*/
void definir (int s, struct data_tps *tps, struct crepuscule *crep); /*Interface de dfinition de la date et de la mto*/
void definir_max (struct data_tps *tps, struct crepuscule *crep);  /*Dfinit les maximums pour chaque donnes, lu dans le fichier de climat*/
void details_mois (struct data_tps *tps, struct crepuscule *crep);   /*Dtermine pour le mois, le nombre de jour, et la saison. Calcul galement le rang du jour (numro du jour sur la semaine)*/
void Khepri (struct crepuscule *crep);  //Fonction charge du calcul des cycles jour/nuit et des crpuscules.
void Nuit_crepuscules (struct data_tps *tps, struct crepuscule *crep);  //Dtermine jour ou nuit et le crpuscule en cours et son avancement
void Horloge_vague (struct data_tps *tps, struct crepuscule *crep); //Donne une indication de temps peu variable
void afficheur_liste (struct data_tps *tps, struct crepuscule *crep);      //Affiche toutes les informations sous forme de liste
void option_affichage ();   //Permet de changer les options d'affichage du programme

int main (int argc,char *argv[])
{
    FILE* fichier;
    struct data_tps tps;
    struct crepuscule crep;
    char chaine[255];
    int i;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        system("color 75");
        system("title Unda tempus 4.2.2");
    #else /*linux*/
        startxterm (argc,argv,"Unda tempus 4.2.2","75");
    #endif
    tps.base=GetClock();  /*met  jour la base*/
    fichier = ouvre_fichier ("Mois.ini","r");
    fgets(chaine,255,fichier);
    Efface_char(chaine,"=");
    tps.nb_mois = atoi(chaine);
    fclose(fichier);
    fichier = ouvre_fichier ("Semaine.ini","r");
    fgets(chaine,255,fichier);
    Efface_char(chaine,"=");
    tps.nb_semaine = atoi(chaine);
    fclose(fichier);
    fichier = ouvre_fichier ("Temps semi_tps.st","r");
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.heure = atoi(chaine);    /*Lit l'heure dans le fichier*/
    Efface_char(chaine,"H");
    tps.minute = atof(chaine);    /*Lit les minutes dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.date = atoi(chaine);    /*Lit la date dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.jsemaine = atoi(chaine);    /*Lit le jour de la semaine*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.mois = atoi(chaine);    /*Lit le mois dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.saison = atoi(chaine);    /*Lit la saison dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.facteur = atof(chaine);    /*Lit le facteur dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.lune = atof(chaine);    /*Lit la lune dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.sens_lune = atoi(chaine);    /*Lit le sens de la lune dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.temperature = atoi(chaine);    /*Lit la temperature dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.vent = atoi(chaine);    /*Lit le vent dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.sens_vent = atoi(chaine);    /*Lit le sens du vent*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    tps.precipitation = atoi(chaine);    /*Lit la prcipitation dans le fichier*/
    fgets(chaine,255,fichier);
    Efface_char(chaine,":");
    Efface_n(chaine);      //Retire le \n
    strcpy(tps.climat,chaine);    /*Lit le nom du fichier de climat dans le fichier*/
    fclose(fichier);
    definir_max (&tps,&crep);    /*Dfinit les maximum de chaques donnes*/
    details_mois(&tps,&crep);
    Khepri(&crep);  //Calcul le cycle jour/nuit du jour
    tps.alea_meteo = NbAlea1b(6); /*La mto changera dans 1d6 heures aprs le dmarrage du programme*/
    tps.chg_meteo = 0;
    do    /*Tourne en boucle infinie*/
    {
        afficheur(&tps,&crep);
        i = choix_utilis(&tps,&crep);
        fichier = ouvre_fichier ("Temps semi_tps.st","w");
        fprintf(fichier,"Heure:%dH%f\n", tps.heure,tps.minute);
        fprintf(fichier,"Date:%d\n", tps.date);
        fprintf(fichier,"jour de la semaine:%d\n", tps.jsemaine);
        fprintf(fichier,"Mois:%d\n", tps.mois);
        fprintf(fichier,"Saison:%d\n", tps.saison);
        fprintf(fichier,"Facteur:%f\n", tps.facteur);
        fprintf(fichier,"Lune:%f\n", tps.lune);
        fprintf(fichier,"Sens lune:%d\n", tps.sens_lune);
        fprintf(fichier,"Temperature:%d\n", tps.temperature);
        fprintf(fichier,"Vent:%d\n", tps.vent);
        fprintf(fichier,"Sens vent:%d\n", tps.sens_vent);
        fprintf(fichier,"Precipitation:%d\n", tps.precipitation);
        fprintf(fichier,"Climat:%s\n", tps.climat);
        fclose(fichier); /*Ecrit les donnes dans le fichier  chaque boucle*/
        if (i)        /*Signal d'arret envoy*/
            exit (EXIT_SUCCESS);
    }
    while (1);
    return 0;
}

void passage_temps (struct data_tps *tps, struct crepuscule *crep)
{
    double time_sec;
    float seconde;
    int met=0;
    int Jlune=0;
    time_sec = GetClock() - tps->base;  /*calcul le temps depuis la dernire mise  jour*/
    seconde = (float) time_sec;
    tps->minute += seconde*(tps->facteur)/60;  /*Augmente le temps en fonction du facteur*/
    while (tps->minute >= 59.5)
    {    /*Bcl change heure*/
        tps->minute -= 60;
        tps->heure += 1;
        tps->alea_meteo -= 1; /*Le nb d'heures avant le changement de mto se rduit de 1*/
    }
    while (tps->minute < 0)
    {    /*Bcl change heure ngatif*/
        tps->minute += 60;
        tps->heure -= 1;
        tps->alea_meteo += 1; /*Le nb d'heures avant le changement de mto augmente de 1*/
    }
    while (tps->heure >= 24)
    {    /*Bcl change jour + meteo*/
        tps->heure -= 24;
        tps->date += 1;
        Jlune += 1;
        tps->jsemaine += 1;
        met=1;    /*La mto doit changer*/
        details_mois(tps,crep);   /*Vrifie les jours de ftes*/
        Khepri(crep);  //Calcul le cycle jour/nuit du jour
    }
    while (tps->heure < 0)
    {    /*Bcl change jour ngatif + meteo*/
        tps->heure += 24;
        tps->date -= 1;
        Jlune -= 1;
        tps->jsemaine -= 1;
        met=1;    /*La mto doit changer*/
        details_mois(tps,crep);   /*Vrifie les jours de ftes*/
        Khepri(crep);  //Calcul le cycle jour/nuit du jour
    }
    tps->base=GetClock();    /*Mise  jour du temps coul*/
    while (tps->date < 1)
    {    /*Bcl change mois ngatif*/
        tps->jfete = 0;
        tps->mois -= 1;
        while (tps->mois < 1)
            tps->mois += tps->nb_mois;    /*Bcl change anne ngatif*/
        details_mois(tps,crep);     /*Prend les caractristiques du mois*/
        tps->date += tps->jmois;
    }
    while (tps->date > tps->jmois)
    {    /*Bcl change mois*/
        tps->jfete = 0;
        tps->date -= tps->jmois;
        tps->mois += 1;
        while (tps->mois > tps->nb_mois)
            tps->mois -= tps->nb_mois;    /*Bcl change anne*/
        details_mois(tps,crep);     /*Prend les caractristiques du mois*/
    }
    while (tps->jsemaine < 1)
    {    /*Bcl change jour de semaine ngatif*/
        tps->jsemaine += tps->nb_semaine;
    }
    while (tps->jsemaine > tps->nb_semaine)
    {    /*Bcl change jour de semaine*/
        tps->jsemaine -= tps->nb_semaine;
    }
    if (Jlune<0)
    {   /*Si les jours reculent. La lune repart en sens inverse*/
        for(;Jlune<0;Jlune++)
        {   /*Bcl sur le nombre de jour pass*/
            tps->lune -= 6.78*tps->sens_lune;
            if(tps->lune >= 100)
            {
                tps->lune = 100;
                tps->sens_lune = -1;
            }
            if(tps->lune <= 0)
            {
                tps->lune = 0;
                tps->sens_lune = 1;
            }
        }
    }
    if (Jlune>0)
    {   /*Si les jours avancent.*/
        for(;Jlune>0;Jlune--)
        {   /*Bcl sur le nombre de jour pass*/
            tps->lune = tps->lune + (6.78*tps->sens_lune);
            if(tps->lune >= 100)
            {
                tps->lune = 100;
                tps->sens_lune = -1;
            }
            if(tps->lune <= 0)
            {
                tps->lune = 0;
                tps->sens_lune = 1;
            }
        }
    }
    if(tps->alea_meteo <= 0)    /*Si le temps avant le changement de mto est arriv  son terme*/
    {
        met=1;  /*La mto devra changer*/
        tps->alea_meteo = NbAlea1b(6); /*La mto changera dans 1d6 heures*/
    }
    if (met==1)
        meteo (tps,0);
}

void afficheur (struct data_tps *tps, struct crepuscule *crep)
{   /*Affichage  l'cran*/
    FILE* effets_store;
    FILE* file_affich;
    char chaine[255];
    int i, affich[16];
    file_affich = ouvre_fichier("Affichage.ini","r");
    for(i=0;i<16;i++)
    {
        fgets(chaine,255,file_affich);
        Efface_char(chaine,"=");
        affich[i] = atoi(chaine);   //Lit les indications d'affichage
    }
    fclose(file_affich);
    system(CLEARSCREEN);
    for(i=0;i<80;i++)
        printf("-");
    if(affich[0])   //Affichage de la vitesse du temps
        printf("\n          *************    Vitesse du temps: %.3f", tps->facteur);
    else
        printf("\n          *************\t\t\t\t");
    if(affich[1])   //Affichage des heures de lever/coucher/dure
    {
        printf("\t(");  //Affichage soleil lev, dbut du couch, dure du jour
        printf("%.0fh",crep->lever[1]);
        if (floor(crep->lever[2]) < 10)
            printf("0");
        printf("%.0f/", floor(crep->lever[2]));
        printf("%.0fh",crep->coucher[1]);
        if (floor(crep->coucher[2]) < 10)
            printf("0");
        printf("%.0f/", floor(crep->coucher[2]));
        printf("%.0fh",crep->duree[1]);
        if (floor(crep->duree[2]) < 10)
            printf("0");
        printf("%.0f)", floor(crep->duree[2]));
    }
    printf("\n          *************");
    Nuit_crepuscules(tps,crep); //Dtermine si jour/nuit/lever/coucher et l'avancement des crpuscules le cas chant
    if(affich[2])   //Affichage du moment de la journe (jour/nuit/crpuscules)
    {
        if(tps->nuit == 0)   //Jour
            putsacc("            Journe.");
        else if(tps->nuit == 7)   //Nuit
        {
            if(crep->crep_nuit != 1)    //Si un crpuscule n'existe pas, le nuit n'est pas full. Indique le % de nuit
                printf("            Nuit %0.f%%. ",crep->evo_crep);
            else
                printf("            Nuit. ");
        }
        else if(tps->nuit < 4)   //Lever du soleil
            printf("    %s du soleil %0.f%%. ", acc("Lev",chfunc),crep->evo_crep);
        else if(tps->nuit > 3)   //Coucher du soleil
            printf("  %s du soleil %0.f%%. ", acc("Couch",chfunc),crep->evo_crep);
    }
    else
        printf("            ");
    if(affich[3])   //Affichage du cycle de lune
    {
        if(tps->nuit != 0 || tps->lune > 99)   //Pas jour ou si c'est la pleine lune
        {   //Si il ne fait pas jour, affiche la lune.
            if(tps->lune < 1)
                printf("Nouvelle lune (%.0f%%)",tps->lune);
            else if(tps->lune > 45 && tps->lune < 55)
                printf("Quartier de lune (%.0f%%)",tps->lune);
            else if(tps->lune > 99)
                printf("Pleine lune (%.0f%%)",tps->lune);
            else    //Affiche lune pleine  x% si pas d'affichage spcifique
                printf("Lune pleine %s %.0f%%",acc("",chfunc),tps->lune);
            if(tps->lune <= 33)
                putsacc(", -3 dtection");
            if(tps->lune > 33 && tps->lune < 67)
                putsacc(", -2 dtection");
            if(tps->lune >= 67 && tps->nuit != 0)    //N'affiche pas le malus pour la pleine lune en plein jour
                putsacc(", -1 dtection");
        }
    }
    printf("\n          **         **            ");
    if(affich[4])   //Affichage de la date du jour
        printf("Date: %d", tps->date);
    if(affich[5])   //Affichage du jour de la semaine
    {
        if(affich[4])   //Si date affiche avant
            printf(", ");
        else
            printf("Jour: ");
        string(6,tps);
    }
    if(affich[6])   //Affichage des jours de ftes
    {
        if (tps->date == tps->jfete)    /*Si c'est un jour de fte*/
            printf("   %s", acc(tps->nom_fete,chfunc));    /*Affiche le nom du jour de fte*/
    }
    if(affich[7])   //Affichage Heures et minutes
    {
        printf("\n          **  ");
        if (tps->heure < 10)
            printf("0");
        printf("%dH", tps->heure);
        if (floor(tps->minute) < 10)
            printf("0");
        printf("%.0f", floor(tps->minute));
        printf("  **            ");
    }
    else if(affich[10]) //Si pas d'affichage de l'heure mais affichage de l'horloge vague, l'horloge vague remplace l'heure
        Horloge_vague(tps,crep);
    else
        printf("\n          **         **            ");
    if(affich[8])   //Affichage mois
    {
        printf("Mois: (%d), ", tps->mois);
        string (1,tps);
    }
    if(tps->chg_meteo)  //Seulement si la mto  change
    {
        effets_store = ouvre_fichier("Effets.txt","w");    //Vide le fichier des effets de la mto
        fclose(effets_store);
    }
    if(affich[9])   //Affichage de la saison
    {
        if(affich[8])   //Si mois affich avant
            printf(", ");
        else
            printf("Saison: ");
        string(5,tps);
    }
    if(affich[10] && affich[7])    //Affichage de l'horloge vague, si elle n'est pas dj affiche  la ligne du dessus.
        Horloge_vague(tps,crep);
    else
        printf("\n          **         **             ");
    if(affich[11])   //Affichage de la temprature
        string (2,tps);
    printf("\n          *************             ");
    if(affich[12])   //Affichage du vent
        string (3,tps);
    if(affich[13])   //Affichage du sens du vent
    {
        if(tps->vent > 1) /*Le vent n'est pas nul*/
        {
            switch (tps->sens_vent)
            {
                case 1:
                    printf(" (N)");
                    break;
                case 2:
                    printf(" (NE)");
                    break;
                case 3:
                    printf(" (E)");
                    break;
                case 4:
                    printf(" (SE)");
                    break;
                case 5:
                    printf(" (S)");
                    break;
                case 6:
                    printf(" (SO)");
                    break;
                case 7:
                    printf(" (O)");
                    break;
                case 8:
                    printf(" (NO)");
                    break;
            }
        }
    }
    printf("\n          *************             ");
    if(affich[14])   //Affichage des prcipitations
        string (4,tps);
    puts("");
    //Tous les effets mto ayant t dtermins, raz de la variable indiquant un changement de mto
    tps->chg_meteo = 0;
    if(affich[15])   //Affichage des effets mto
    {
        effets_store = ouvre_fichier("Effets.txt","r");
        while(!feof(effets_store))
        {
            if(fgets(chaine,255,effets_store))  //Evite de dupliquer la dernire ligne
                printf("%s", chaine);
        }
        fclose(effets_store);
    }
}

int choix_utilis (struct data_tps *tps, struct crepuscule *crep)
{   //Gre les choix de l'utilisateur selon le menu gnral
    float temp;
    char choix[50];
    strcpy(choix,Menu("Menu_gnral.ini",chfunc,0,1));    //Prend le choix de l'utilisateur selon le menu gnral
    passage_temps (tps,crep);        /*Actualise et enregistre automatiquement quel que soit le choix*/
    puts("");
    if(!strcmp(choix,"choix_heure"))    //Dfinir heure
    {
        do
        {     /*bcl de gestion d'erreur*/
            printf("Heures: ");
            tps->heure = (int) interpret_calc("\0");
        } while (tps->heure == NA || tps->heure == defo);
        do
        {     /*bcl de gestion d'erreur*/
            printf("Minutes: ");
            tps->minute = interpret_calc("\0");
        } while (tps->minute == NA || tps->minute == defo);
    }
    if(!strcmp(choix,"choix_date"))    //Definir date
    {
        definir(1,tps,crep);
        passage_temps (tps,crep);    /*Rtabli saison*/
        meteo (tps,1);    /*Rtabli mto*/
    }
    if(!strcmp(choix,"choix_meteo"))    //Dfinir mto
    {
        definir(2,tps,crep);
    }
    if(!strcmp(choix,"evolution_temps"))    //Faire dfiler manuellement le temps
    {
        do
        {     /*bcl de gestion d'erreur*/
            putsacc("Nombres d'heures  faire passer: ");
            temp = interpret_calc("\0");
            if (temp == defo)
                temp=0;  /*Valeur par dfaut*/
        } while (temp == NA);
        tps->minute += temp * 60;   //Compte les heures en 60 minutes
        do
        {     /*bcl de gestion d'erreur*/
            putsacc("Nombres de minutes  faire passer: ");
            temp = interpret_calc("\0");
            if (temp == defo)
                temp=0;  /*Valeur par dfaut*/
        } while (temp == NA);
        tps->minute += temp;
        tps->base=GetClock();     /*Mise  jour de la base*/
        passage_temps (tps,crep);    /*Corrige erreur de saisie (nb trop grand)*/
    }
    if(!strcmp(choix,"passer_nuit"))    //Passer la nuit
    {
        choix[49] = 'O';
        putsacc("Etes-vous sr de vouloir passer au lendemain matin? (O/N, oui par defaut): ");
        choix[49] = getchar();
        if (choix[49] == 'O' || choix[49] == 'o' || choix[49] == 10)    //10 = appui sur entre
        {
            tps->base=GetClock();     /*Mise  jour de la base, afin d'tre sr de l'heure fixe*/
            passage_temps (tps,crep);    //pour tre sur du temps avant les calculs
            temp = 60-tps->minute;  //Calcul le nombre de minutes restantes avant la fin de l'heure
            tps->minute += temp;    //Passe ces minutes restantes pour atteindre l'heure suivante
            if (tps->heure > 7)    //Si c'est le jour prcdent, aprs 7h du matin
                temp = 30-tps->heure;   //Calcul le nombre d'heures restante avant 7h le matin (30 = 24+7-1 (+1 pour l'heure passe par les minutes))
            else    //Jour suivant
                temp = 6-tps->heure;   //Calcul le nombre d'heures restante avant 7h le matin (6 = 7-1 (+1 pour l'heure passe par les minutes))
            tps->minute += temp*60; //Transforme les heures en minutes et les passes.
            passage_temps (tps,crep);    //Applique les changements de la nuit passe
        }
        if(choix[49] != 10)
            getchar();  //Absorbe l'appui sur entre
    }
    if(!strcmp(choix,"forcage_meteo"))    //Forcer le changement de la mto
        meteo (tps,1);
    if(!strcmp(choix,"facteur_temps"))    //Dfinir le facteur de vitesse du temps
    {
        printf("Facteur actuel= %.3f\n", tps->facteur);
        do
        {     /*bcl de gestion d'erreur*/
            printf("Facteur du passage de temps:");
            tps->facteur = interpret_calc("\0");
        } while (tps->facteur == NA || tps->facteur == defo);
    }
    if(!strcmp(choix,"climat"))    //Changer le climat
    {
        do
        {
            strcpy(tps->climat,Menu("Menu_climats.ini",chfunc,0,0));  /*Demande quel fichier utilis pour le climat*/
        }while(!strcmp(tps->climat,"q"));   //En cas d'erreur du menu, renvoi sur le menu. Mais interdit de quitter depuis ce menu
        definir_max (tps,crep);    /*Dfinit les maximum de chaques donnes*/
        meteo (tps,1);
    }
    if(!strcmp(choix,"liste"))    //Affiche toutes les informations du jour
    {
        afficheur_liste(tps,crep);
    }
    if(!strcmp(choix,"opt_affich"))    //Change les options d'affichage
    {
        option_affichage();
    }
    if(!strcmp(choix,"q"))    //Quitter programme
        return 1;   //Indique de quitter au main
    if(!strcmp(choix,"defaut"))    //met  jour la base
        tps->base=GetClock();
    if(!strcmp(choix,"na"))    //Fonction non oprationnelle pour le moment
    {
        putsacc("Cette fonction n'est pas encore dvelloppe.");
        Pause();
    }
    return 0;
}

void definir (int s, struct data_tps *tps, struct crepuscule *crep)
{   /*Interface utilisateur pour la dfinition des dates et mto*/
    FILE* fichier;
    char chaine[255];
    int nmois=0,nprec;
    switch (s)    /*Indicateur du choix dsir*/
    {
        case 1:    /*dfinir date*/
            puts("Choisir mois:");
            fichier = ouvre_fichier("Mois.ini","r");
            fgets(chaine,255,fichier);    /*Saute le nb de mois*/
            while (++nmois <= tps->nb_mois)    /*Boucle sur les mois*/
            {
                fgets(chaine,255,fichier);
                Efface_char(chaine,":");
                Efface_n(chaine);      //Retire le \n
                printf("%d) %s\n", nmois, acc(chaine,chfunc));
            } /*Ecrit chaque nom de mois sous forme d'un menu*/
            do
            {
                printf("?: ");
                tps->mois = 0; /*Valeur d'erreur en cas d'erreur de saisi*/
                scf = scanf("%d", &(tps->mois));    /*Choix menu = numro mois*/
                getchar();
            } while (tps->mois < 1 || tps->mois > tps->nb_mois); /*Bcl sur saisi avec gestion d'erreur*/
            do
            {     /*bcl de gestion d'erreur*/
                puts("Choisir date:");
                printf("?: ");
                scf = scanf("%d", &(tps->date));    /*Saisi nouvelle date*/
                getchar();
            } while (!scf);
            fclose(fichier);
            /*Placement lune en fonction de la date du mois*/
            if (tps->date <= 16)
            {
                tps->lune = (tps->date-16)/-0.15; /*Dfinit le % de lune en fonction de la date*/
                tps->sens_lune = -1;
            }
            if (tps->date >= 17)
            {
                tps->lune = (tps->date-17)/0.15; /*Dfinit le % de lune en fonction de la date*/
                tps->sens_lune = 1;
            }
            passage_temps(tps,crep);   /*Actualise le temps, corrige les erreurs de saisi*/
            break;
        case 2:    /*dfinir mto*/
            nprec=1;
            fichier = ouvre_fichier(tps->climat,"r");
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Temprature:") != 0);
            putsacc("Choisir temprature:\n");
            fgets(chaine,255,fichier);
            do
            {
                Efface_char(chaine,":");
                Efface_char(chaine,":");
                Efface_n(chaine);      //Retire le \n
                printf("%d) %s\n", nprec++, acc(chaine,chfunc));   /*Ecrit chaque terme sous forme d'un menu*/
                fgets(chaine,255,fichier);
            } while (chaine[0] != '<');    /*Boucle sur toutes les donnes jusqu'au <*/
            do
            {
                printf("?: ");
                tps->temperature = 0; /*Valeur d'erreur en cas d'erreur de saisi*/
                scanf("%d", &(tps->temperature));    /*Choix menu = numro temprature*/
                getchar();
            } while (tps->temperature < 1 || tps->temperature > nprec-1); /*Bcl sur saisi avec gestion d'erreur*/
            puts("Choisir vitesse du vent:");
            nprec=1;
            rewind(fichier);
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Vent:") != 0);
            fgets(chaine,255,fichier);
            do
            {
                Efface_char(chaine,":");
                Efface_char(chaine,":");
                Efface_n(chaine);      //Retire le \n
                printf("%d) %s\n", nprec++, acc(chaine,chfunc));   /*Ecrit chaque terme sous forme d'un menu*/
                fgets(chaine,255,fichier);
            } while (chaine[0] != '<');    /*Boucle sur toutes les donnes jusqu'au <*/
            do
            {
                printf("?: ");
                tps->vent = 0; /*Valeur d'erreur en cas d'erreur de saisi*/
                scanf("%d", &(tps->vent));    /*Choix menu = numro vent*/
                getchar();
            } while (tps->vent < 1 || tps->vent > nprec-1); /*Bcl sur saisi avec gestion d'erreur*/
            tps->sens_vent = NbAlea1b(8);   /*Dtermine alatoirement le sens du vent*/
            putsacc("Choisir prcipitation:\n");
            nprec=1;
            rewind(fichier);
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Prcipitation:") != 0);
            fgets(chaine,255,fichier);
            do
            {
                Efface_char(chaine,":");
                Efface_char(chaine,":");
                Efface_n(chaine);      //Retire le \n
                printf("%d) %s\n", nprec++, acc(chaine,chfunc));   /*Ecrit chaque terme sous forme d'un menu*/
                fgets(chaine,255,fichier);
            } while (chaine[0] != '<');    /*Boucle sur toutes les donnes jusqu'au <*/
            do
            {
                printf("?: ");
                tps->precipitation = 0; /*Valeur d'erreur en cas d'erreur de saisi*/
                scanf("%d", &(tps->precipitation));    /*Choix menu = numro prcipitation*/
                getchar();
            } while (tps->precipitation < 1 || tps->precipitation > nprec-1); /*Bcl sur saisi avec gestion d'erreur*/
    }
}

int string (int s, struct data_tps *tps)
{   /*Fait correspondre les numros aux valeurs string*/
    FILE* fichier;
    FILE* effets_source;
    FILE* effets_store;
    char chaine[255];
    char chaine2[255];
    int nprec=0,val,effet, i;
    switch (s)    /*Indicateur de l'affichage dsir*/
    {
        case 1:    /*Affiche les mois*/
            fichier = ouvre_fichier("Mois.ini","r");    /*Ouvre le fichier des noms de mois*/
            fgets(chaine,255,fichier);    /*Saute le total de mois*/
            do
            {
                fgets(chaine,255,fichier);
                val = atoi(chaine);   /*Lit le numro du mois*/
                if (val == tps->mois)   /*Si le numro correspond*/
                {
                    Efface_char(chaine,":");
                    Efface_n(chaine);      //Retire le \n
                }   /*Il reste le nom du mois!*/
                else
                    val=0;
            } while (!val); /*Bcl tant que le bon mois n'est pas trouv*/
            putsacc(chaine);
            val=-1;    /*Indique que l'affichage est dj fait*/
            break;
        case 2:    /*Affiche la temprature*/
            val = tps->temperature;
            fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Temprature:") != 0);
            break;            /*Recherche les tempratures*/
        case 3:    /*Affiche le vent*/
            val = tps->vent;
            fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Vent:") != 0);
            break;            /*Recherche les vents*/
        case 4:    /*Affiche la prcipitation*/
            val = tps->precipitation;
            fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Prcipitation:") != 0);
            break;            /*Recherche les prcipitations*/
        case 5:    /*Affiche la saison*/
            val = tps->saison;
            fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
            do
            {
                fgets(chaine,255,fichier);
                Efface_n(chaine);      //Retire le \n
            } while (strcmp(chaine,">Saison:") != 0);   /*Recherche les saisons*/
            break;
        case 6:    /*Affiche les jours de semaines*/
            fichier = ouvre_fichier("Semaine.ini","r");    /*Ouvre le fichier des jours de semaine*/
            fgets(chaine,255,fichier);    /*Saute le total de jours de semaine*/
            do
            {
                fgets(chaine,255,fichier);
                val = atoi(chaine);   /*Lit le numro du jour*/
                if (val == tps->jsemaine)   /*Si le numro correspond*/
                {
                    Efface_char(chaine,":");
                    Efface_n(chaine);      //Retire le \n
                }   /*Il reste le nom du jour de semaine!*/
                else
                    val=0;
            } while (!val); /*Bcl tant que le bon jour n'est pas trouv*/
            putsacc(chaine);
            val=-1;    /*Indique que l'affichage est dj fait*/
            break;
    }
    if(val != -1)  /*Si l'affichage est  faire*/
    {
        do   /*Si c'est pas un mois ou un jour de semaine*/
        {
            fgets(chaine,255,fichier);
            if (chaine[0] == '<')
                return (1);        /*Si le numro n'est pas trouv, affiche erreur*/
            nprec = atoi(chaine);   /*Lit le numro de la ligne*/
            if (nprec == val)   /*Si le numro correspond*/
            {
                Efface_char(chaine,":");
                if(s==2 || s==3 || s==4)    //Seulement pour temprature, vent et prcipitation. Gestion de l'affichage des effets
                {
                    Efface_char(chaine,"f");
                    effet = atoi(chaine);   /*Lit le numro de l'effet*/
                    Efface_char(chaine,":");    //Supprime l'indication de l'effet pour l'affichage
                    if(effet && tps->chg_meteo) //Seulement si la mto a t modifie
                    {
                        effets_source = ouvre_fichier("Effets_climat.cl","r");    //Ouvre le fichier des effets du climat
                        effets_store = ouvre_fichier("Effets.txt","a+");    //Ouvre le fichier pour affichage des effets
                        do
                        {
                            fgets(chaine2,255,effets_source);
                            i = atoi(chaine2);   //Lit le numro d'effet de la ligne
                            if (i == effet)   //Si le numro correspond
                            {
                                fgets(chaine2,255,effets_source);   //Saute la ligne du commentaire
                                do
                                {
                                    Efface_char(chaine2," ");    //Efface '- '
                                    fprintf(effets_store,"%s",chaine2); //Copie la ligne dans le fichier
                                    fgets(chaine2,255,effets_source);   //Prend la ligne suivante
                                }while(!isdigit(chaine2[0]));  //Copie les lignes tant qu'il ne retombe pas sur un chiffre en dbut de ligne (Effet suivant)
                            }
                            else
                                i=0;
                        } while (!i); //Bcl tant que le bon effet n'est pas trouv
                        fclose(effets_source);
                        fclose(effets_store);
                    }
                }
                Efface_n(chaine);      //Retire le \n
            }   /*Il reste le mot!*/
            else
                nprec=0;
        } while (!nprec); /*Bcl tant que le bon numro n'est pas trouv*/
        putsacc(chaine);
    }
    fclose(fichier);
    return 0;
}

void definir_max (struct data_tps *tps, struct crepuscule *crep)
{
    FILE* fichier;
    char cond_meteo[255];
    fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
    fgets(cond_meteo,255,fichier);
    Efface_char(cond_meteo,"=");
    crep->latitude = atof(cond_meteo);  //Lit la latitude
    if(crep->latitude < -65)    //Au dela de la limite de 65 de latitude, des erreurs peuvent apparatre dans les calculs.
        crep->latitude = -65;
    if(crep->latitude > 65)
        crep->latitude = 65;
    fgets(cond_meteo,255,fichier);
    Efface_char(cond_meteo,"=");
    crep->longitude = atof(cond_meteo);  //Lit la longitude
    if(crep->longitude < -180)    //La longitude s'tend de -180  180
        crep->longitude = -180;
    if(crep->longitude > 180)
        crep->longitude = 180;
    fgets(cond_meteo,255,fichier);
    Efface_char(cond_meteo,"=");
    crep->Aut_H_ete = 0;
    if(cond_meteo[0] == 'O' || cond_meteo[0] == 'o');  //Vrifie si l'heure d't est observe ou non
        crep->Aut_H_ete = 1;
    fgets(cond_meteo,255,fichier);
    Efface_char(cond_meteo,"=");
    crep->m_decal_h = atoi(cond_meteo);  //Lit l'ventuel dcalage de fuseau horaire
    do
    {    /*Lecture des temprature*/
        fgets(cond_meteo,255,fichier);
        Efface_n(cond_meteo);      //Retire le \n
    } while (strcmp(cond_meteo,">Temprature:") != 0);
    while (cond_meteo[0] != '<')
    {    /*Recherche du maximum*/
        tps->max_temp = atoi(cond_meteo);
        fgets(cond_meteo,255,fichier);
    }
    do
    {    /*Lecture des vents*/
        fgets(cond_meteo,255,fichier);
        Efface_n(cond_meteo);      //Retire le \n
    } while (strcmp(cond_meteo,">Vent:") != 0);
    while (cond_meteo[0] != '<')
    {    /*Recherche du maximum*/
        tps->max_vent = atoi(cond_meteo);
        fgets(cond_meteo,255,fichier);
    }
    do
    {    /*Lecture des prcipitations*/
        fgets(cond_meteo,255,fichier);
        Efface_n(cond_meteo);      //Retire le \n
    } while (strcmp(cond_meteo,">Prcipitation:") != 0);
    while (cond_meteo[0] != '<')
    {    /*Recherche du maximum*/
        tps->max_precip = atoi(cond_meteo);
        fgets(cond_meteo,255,fichier);
    }
}

void meteo (struct data_tps *tps, int chang)
{
    FILE* fichier;
    int vartemps, vartemperature=0, varvent=0, i, b1, b2, tempvent, temptemp, tempprec, x;
    int t,v,p;  //Variable pour vrif du changement de mto.
    int *tabval;
    char cond_meteo[255];
    t = tps->temperature;   //Stocke l'tat de la mto avant changement
    v = tps->vent;
    p = tps->precipitation;
    fichier = ouvre_fichier(tps->climat,"r");    /*Ouvre le fichier du climat*/
    do
    {
        vartemps = NbAlea1b(3);    /*Variation de la temprature*/
    }while(vartemps == 2 && chang == 1);  /*Force le changement si chang = 1*/
    switch (vartemps)
    {
        case 1:
            tps->temperature--;    /*Hausse de la temprature*/
            vartemperature=1;    /*indique temprature en hausse*/
            break;
        case 3:
            tps->temperature++;    /*Baisse de la temprature*/
            vartemperature=-1;    /*indique temprature en baisse*/
    }            /*Si le rsultat est 2, la temprature reste stable*/
    do
    {    /*Vrifie que la temprature correspond  la saison*/
        fgets(cond_meteo,255,fichier);
        Efface_n(cond_meteo);      //Retire le \n
    } while (strcmp(cond_meteo,">Temprature par saison:") != 0);    /*Recherche les tempratures pour chaque saison*/
    do
    {
        fgets(cond_meteo,255,fichier);
    } while (cond_meteo[1]-48 != tps->saison);    /*-48 correspond au code ascii. Recheche la saison*/
    Efface_char(cond_meteo,"t");
    b1 = atoi(cond_meteo);        /*Temprature max pour la saison*/
    Efface_char(cond_meteo,"t");
    b2 = atoi(cond_meteo);        /*Temprature mini pour la saison*/
    if (tps->temperature < b1)
        tps->temperature = b1;    /*Recadre les tempratures pour la saison*/
    if (tps->temperature > b2)
        tps->temperature = b2;
    vartemps = NbAlea1b(10);     /*Variation du vent*/
    switch (vartemps)
    {
        case 1:
        case 2:
            tps->vent++;
            varvent=1;       /*indique vent en hausse*/
            break;
        case 7:
        case 8:
        case 9:
        case 10:
            tps->vent--;
            varvent=-1;      /*indique vent en baisse*/
    }            /*Si le rsultat est 3,4,5,6 le vent reste stable*/
    if (tps->vent < 1)
        tps->vent = 1;
    if (tps->vent > tps->max_vent)
        tps->vent = tps->max_vent;
    tps->sens_vent = NbAlea1b(8);   /*Dtermine alatoirement le sens du vent*/
    if (NbAlea1b(3) < 3)
    {
        do
        {    /*Recherche des prcipitations*/
            fgets(cond_meteo,255,fichier);
            Efface_n(cond_meteo);      //Retire le \n
        } while (strcmp(cond_meteo,">Causes des prcipitations:") != 0);    /*Recherche les causes de prcipitations*/
        do
        {
            tempprec = 0;
            temptemp = 0;
            tempvent = 0;
            fgets(cond_meteo,255,fichier);
            if (cond_meteo[0] == '<')
                break;     /*Si on arrive au bout des prcipitations, arrt de la boucle*/
            do
            {
                x=0;    /*x utilis comme variable temporaire*/
                b1=0;   /*b1 rutilis comme indice de variable des donnes*/
                if (cond_meteo[0] == '+')
                {  /*Passe le +*/
                    for(i=0;i<(int)strlen(cond_meteo);i++)
                        cond_meteo[i] = cond_meteo[i+1];
                }
                if (cond_meteo[0] == 'p')
                    b1=1;            /*=prcipitation*/
                if (cond_meteo[0] == 't')
                    b1=2;            /*=temprature*/
                if (cond_meteo[0] == 'v')
                    b1=3;            /*=vent*/
                for(i=0;i<(int)strlen(cond_meteo);i++)
                    cond_meteo[i] = cond_meteo[i+1];
                if (isalpha(cond_meteo[0]) != 0)
                {
                    if (cond_meteo[0] == 'a')
                        x = -1;  /*Indique augmentation, var*/
                    if (cond_meteo[0] == 'b')
                        x = -2;  /*Indique baisse, var*/
                }
                else
                    x = atoi(cond_meteo);
                if (b1 == 1)
                    tempprec = x;
                if (b1 == 2)
                    temptemp = x;
                if (b1 == 3)
                    tempvent = x;
                if (strstr(cond_meteo,"+") != NULL)
                    strcpy(cond_meteo,strstr(cond_meteo,"+"));
            } while (cond_meteo[0] == '+');
            b2=0;   /*b2 rutilis comme variable de vrification du test*/
            if (tempprec == 0 || tempprec == tps->precipitation) /*donne pas incluse dans le test ou donne requise exacte*/
                b2++;
            if (temptemp == 0 || temptemp == tps->temperature) /*donne pas incluse dans le test ou donne requise exacte*/
                b2++;
            if (temptemp == -1 && vartemperature == 1)
                b2++;        /*donne requise exacte*/
            if (temptemp == -2 && vartemperature == -1)
                b2++;        /*donne requise exacte*/
            if (tempvent == 0 || tempvent == tps->vent) /*donne pas incluse dans le test ou donne requise exacte*/
                b2++;
            if (tempvent == -1 && varvent == 1)
                b2++;        /*donne requise exacte*/
            if (tempvent == -2 && varvent == -1)
                b2++;        /*donne requise exacte*/
            if (b2 == 3)
                strcpy(cond_meteo,strstr(cond_meteo,"="));
        } while (cond_meteo[0] != '=');
        do
        {
            if (cond_meteo[0] == '<')
                break;     /*Si on est au bout des prcipitations, arrt de la boucle*/
            for(i=0;i<(int)strlen(cond_meteo);i++)            /*Passe le = ou ;*/
                cond_meteo[i] = cond_meteo[i+1];
            if (cond_meteo[0] == 'p')
            {
                for(i=0;i<(int)strlen(cond_meteo);i++)        /*Passe le p*/
                    cond_meteo[i] = cond_meteo[i+1];
                    tps->precipitation = atoi(cond_meteo);
            }
            if (cond_meteo[0] == 't')
            {
                for(i=0;i<(int)strlen(cond_meteo);i++)        /*Passe le t*/
                    cond_meteo[i] = cond_meteo[i+1];
                    tps->temperature = atoi(cond_meteo);
            }
            if (cond_meteo[0] == 'v')
            {
                for(i=0;i<(int)strlen(cond_meteo);i++)        /*Passe le v*/
                    cond_meteo[i] = cond_meteo[i+1];
                    tps->vent = atoi(cond_meteo);
            }
            if (cond_meteo[0] == 'd')
            {
                for(i=0;i<(int)strlen(cond_meteo);i++)        /*Passe le d*/
                    cond_meteo[i] = cond_meteo[i+1];
                x = atoi(cond_meteo);      /*x rutilis comme nombre de valeur dans l'alatoire*/
                ER = (int) (tabval = (int*) calloc(x,sizeof(int)));
                Erreur(1);
                do
                {            /*Recherche de la donne  considrer*/
                    for(i=0;i<(int)strlen(cond_meteo);i++)
                        cond_meteo[i] = cond_meteo[i+1];
                } while (isalpha(cond_meteo[0]) == 0);
                if (cond_meteo[0] == 'p')   /*b1 rutilis comme indice de variable des donnes*/
                    b1=1;            /*=prcipitation*/
                if (cond_meteo[0] == 't')
                    b1=2;            /*=temprature*/
                if (cond_meteo[0] == 'v')
                    b1=3;            /*=vent*/
                for(i=0;i<(int)strlen(cond_meteo);i++)      /*Passe l'indice de donne*/
                    cond_meteo[i] = cond_meteo[i+1];
                for(b2=0;b2<x;b2++) /*b2 rutilis comme variable de boucle*/
                {
                    for(i=0;i<(int)strlen(cond_meteo);i++)      /*Passe le , ou {*/
                        cond_meteo[i] = cond_meteo[i+1];
                    tabval[b2] = atoi(cond_meteo);
                    if (strstr(cond_meteo,",") != NULL)    /*Si ce n'est pas la fin*/
                        strcpy(cond_meteo,strstr(cond_meteo,","));
                    else
                        strcpy(cond_meteo,strstr(cond_meteo,"}"));
                }
                b2 = NbAlea1b(x);  /*b2 rutilis comme valeur alatoire*/
                if (b1 == 1)
                    tps->precipitation = tabval[b2-1];
                if (b1 == 2)
                    tps->temperature = tabval[b2-1];
                if (b1 == 3)
                    tps->vent = tabval[b2-1];
                for(i=0;i<(int)strlen(cond_meteo);i++)      /*Passe le }*/
                    cond_meteo[i] = cond_meteo[i+1];
            }
            if (strstr(cond_meteo,";") != NULL)    /*Si il y a une suite*/
                strcpy(cond_meteo,strstr(cond_meteo,";"));
        } while (cond_meteo[0] == ';');
    }
    //Vrifie si la mto a t modifie.
    if(t != tps->temperature || v != tps->vent || p != tps->precipitation)
        tps->chg_meteo=1;   //La mto  change
    fclose(fichier);
}

void details_mois (struct data_tps *tps, struct crepuscule *crep)
{
    FILE* fichier;
    char chaine[255];
    int val;
    crep->jour=0;
    fichier = ouvre_fichier("Mois.ini","r");    /*Ouvre le fichier des noms de mois*/
    fgets(chaine,255,fichier);    /*Saute le total de mois*/
    do
    {
        fgets(chaine,255,fichier);
        val = atoi(chaine);   /*Lit le numro du mois*/
        if (val == tps->mois)   /*Si le numro correspond*/
             break;
        else
        {
            Efface_char(chaine,"=");
            crep->jour += atoi(chaine);  // Ajoute le nombre de jour de ce mois au total de jours
            val=0;
        }
    } while (!val); /*Bcl tant que le bon mois n'est pas trouv*/
    crep->jour += tps->date;  //Ajoute au total la date du mois courant.
    Efface_char(chaine,"=");
    tps->jmois = atoi(chaine);
    Efface_char(chaine,"=");
    tps->saison = atoi(chaine);
    fgets(chaine,255,fichier);
    if(chaine[0] != '-')
        tps->jfete = 0;    /*Pas de jour de fte pour ce mois*/
    while(chaine[0] == '-')    /*Tant qu'il y a des jours de fte*/
    {
        Efface_char(chaine,"-");
        val = atoi(chaine);    /*Prend la date du jour de fte*/
        if(val >= tps->date)
        {
            tps->jfete = val;   /*Prend le prochain jour de fte*/
            Efface_char(chaine,"=");
            strcpy(tps->nom_fete,chaine);    /*Prend le nom du jour de fte*/
            Efface_n(tps->nom_fete);      //Retire le \n
            break;
        }
        fgets(chaine,255,fichier);
    }
    fclose(fichier);
}

void Khepri (struct crepuscule *crep)
{
    /*Le nom de cette fonction lui a t donn en hommage  Khpri, petit tre innocent et fragile dbordant de joie et de bont.
    Il s'en est all  seulement 6 mois, ce 17 fvrier 2010. C'est durant ce weekend que j'tudiais tant bien que mal toutes ces fonctions complexes.
    Un tragdie qui marquera  jamais mon coeur et mon me, l'injustice est une ralit de notre monde.*/
    //Une grande partie de ces formules sont issues du site http://pagesperso-orange.fr/jean-paul.cornec/heures_lc.htm
    double pi180,invpi180,latitude,longitude,M,C,L,R,Equ_tps,DEC,Ho,HoH;
    pi180 = M_PI/180;
    invpi180 = 180/M_PI;
    latitude = crep->latitude;
    longitude = crep->longitude;
    if(crep->latitude < 0)  //Si indicateur de latitude au Sud, rend la valeur positive pour les calculs
        latitude *= -1;
    if(crep->longitude < 0)  //Si indicateur de longitude  l'Ouest, rend la valeur positive pour les calculs
        longitude *= -1;
    crep->decal_h = crep->m_decal_h+ceil((crep->longitude-7.5)/15);   //Calcule le fuseau horaire en fonction de la longitude. decal_h = (Long-7,5)/15 arrondi au suprieur.
    crep->H_ete=0;
    if(crep->jour>83 && crep->jour<298 && crep->Aut_H_ete)    //Si priode du changement d'heure et changement d'heure observ
        crep->H_ete=1;  //Dcale l'heure d'une heure en avant, pour l'heure d't.
    //Calcul de M. M est l'anomalie moyenne en degrs. Mesure spcifique au corps orbitant.
    M = 357+0.9856*crep->jour;   //M = 357 + 0,9856*j
//DEBUG: printf("\nM= %f\n",M);
    //Calcul de C. C est l'quation du centre en degrs. Influence de l'ellipticit de l'orbite terrestre.
    C = 1.914*sin(pi180*M)+0.02*sin(2*pi180*M);   //C = 1,914 x sin(pi/180*M) + 0,02 x sin(2*pi/180*M)
//DEBUG: printf("C= %f\n",C);
    //Calcul de L. L est la longitude vraie du Soleil en degrs.
    L = 280+C+0.9856*crep->jour;   //L = 280 + C + 0,9856 x j
//DEBUG: printf("L= %f\n",L);
    //Calcul de R. R est la rduction  l'quateur en degrs. Influence de l'inclinaison de l'axe terrestre.
    R = -2.465*sin(pi180*2*L)+0.053*sin(pi180*4*L);   //R = -2,465 x sin(pi/180*2L) + 0,053 x sin(pi/180*4L)
//DEBUG: printf("R= %f\n",R);
    //Calcul de l'quation du temps en min. Mouvement apparent relatif du soleil par rapport au soleil moyen.
    Equ_tps = (C+R)*4; //Equ = (C + R) x 4
//DEBUG: printf("Equ= %f\n",Equ_tps);
    //Calcul de la dclinaison du soleil en degrs.
    DEC = asin(0.3978*sin(pi180*L))*invpi180; //DEC = asin(0,3978 x sin(pi/180*L))*180/PI
//DEBUG: printf("DEC= %f\n",DEC);
    //Calcul de l'angle horaire du soleil en dgrs. Diffrence entre le temps sidral et l'ascension droite du soleil.
    Ho = acos((-0.01454-sin(pi180*DEC)*sin(pi180*latitude))/(cos(pi180*DEC)*cos(pi180*latitude)))*invpi180;  //Ho = acos((-0,01454 - sin ( pi/180*Dec ) * sin ( pi/180*Lat ) ) / ( cos ( pi/180*Dec ) * cos ( pi/180*Lat ) ))*180/PI
//DEBUG: printf("Ho= %f\n",Ho);
    //Conversion de l'angle horaire en heure.
    HoH = Ho/15;
//DEBUG: printf("HoH= %f\n\n",HoH);
    //Calcul de la fin du lev du soleil
    crep->lever[0] = ((12-HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h)*60)/60; //((12-HoH+Chg H+equ tps/60+Long*4/60+Dc H)*60)/60
    if(crep->lever[0] < 0) //Valeur ngative
        crep->lever[0] = 24+crep->lever[0];
    if(crep->lever[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->lever[0] -= 24;  //Retranche 24
    //Calcul du dbut du couch du soleil
    crep->coucher[0] = ((12+HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h)*60)/60; //((12+HoH+Chg H+equ tps/60+Long*4/60+Dc H)*60)/60
    if(crep->coucher[0] < 0) //Valeur ngative
        crep->coucher[0] = 24+crep->coucher[0];
    if(crep->coucher[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->coucher[0] -= 24;  //Retranche 24
    //Calcul de la dure du jour
    crep->duree[0] = (2*HoH); //(2*HoH)
    //Calcul du dbut du crpuscule astronomique, dbut du lever du soleil
    //Recalcul de l'angle horaire en remplaant -0,01454 par -0,309
    Ho = acos((-0.309-sin(pi180*DEC)*sin(pi180*latitude))/(cos(pi180*DEC)*cos(pi180*latitude)))*invpi180;  //Ho = acos((-0,01454 - sin ( pi/180*Dec ) * sin ( pi/180*Lat ) ) / ( cos ( pi/180*Dec ) * cos ( pi/180*Lat ) ))*180/PI
    HoH = Ho/15;
    crep->debut_crep_astro[0] = (12-HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12-HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->debut_crep_astro[0] < 0) //Valeur ngative
        crep->debut_crep_astro[0] = 24+crep->debut_crep_astro[0];
    if(crep->debut_crep_astro[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->debut_crep_astro[0] -= 24;  //Retranche 24
    //Calcul de la fin du du crpuscule astronomique, fin du couch du soleil
    crep->fin_crep_astro[0]= (12+HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12+HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->fin_crep_astro[0] < 0) //Valeur ngative
        crep->fin_crep_astro[0] = 24+crep->fin_crep_astro[0];
    if(crep->fin_crep_astro[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->fin_crep_astro[0] -= 24;  //Retranche 24
    //Calcul du dbut du crpuscule nautique, suivant le crpuscule astronomique.
    //Recalcul de l'angle horaire en remplaant -0,01454 par -0,208
    Ho = acos((-0.208-sin(pi180*DEC)*sin(pi180*latitude))/(cos(pi180*DEC)*cos(pi180*latitude)))*invpi180;  //Ho = acos((-0,01454 - sin ( pi/180*Dec ) * sin ( pi/180*Lat ) ) / ( cos ( pi/180*Dec ) * cos ( pi/180*Lat ) ))*180/PI
    HoH = Ho/15;
    crep->debut_crep_naut[0] = (12-HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12-HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->debut_crep_naut[0] < 0) //Valeur ngative
        crep->debut_crep_naut[0] = 24+crep->debut_crep_naut[0];
    if(crep->debut_crep_naut[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->debut_crep_naut[0] -= 24;  //Retranche 24
    //Calcul de la fin du du crpuscule nautique, prcdent le crpuscule astronomique
    crep->fin_crep_naut[0] = (12+HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12+HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->fin_crep_naut[0] < 0) //Valeur ngative
        crep->fin_crep_naut[0] = 24+crep->fin_crep_naut[0];
    if(crep->fin_crep_naut[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->fin_crep_naut[0] -= 24;  //Retranche 24
    //Calcul du dbut du crpuscule civil, suivant le crpuscule nautique et prcdent le lever complet du soleil.
    //Recalcul de l'angle horaire en remplaant -0,01454 par -0,105
    Ho = acos((-0.105-sin(pi180*DEC)*sin(pi180*latitude))/(cos(pi180*DEC)*cos(pi180*latitude)))*invpi180;  //Ho = acos((-0,01454 - sin ( pi/180*Dec ) * sin ( pi/180*Lat ) ) / ( cos ( pi/180*Dec ) * cos ( pi/180*Lat ) ))*180/PI
    HoH = Ho/15;
    crep->debut_crep_civil[0] = (12-HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12-HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->debut_crep_civil[0] < 0) //Valeur ngative
        crep->debut_crep_civil[0] = 24+crep->debut_crep_civil[0];
    if(crep->debut_crep_civil[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->debut_crep_civil[0] -= 24;  //Retranche 24
    //Calcul de la fin du du crpuscule civil, prcdent le crpuscule nautique et suivant le dbut du coucher du soleil
    crep->fin_crep_civil[0] = (12+HoH+crep->H_ete+Equ_tps/60+longitude*4/60+crep->decal_h); //(12+HoCH+Chg H+equ tps/60+Long*4/60+Dc H)
    if(crep->fin_crep_civil[0] < 0) //Valeur ngative
        crep->fin_crep_civil[0] = 24+crep->fin_crep_civil[0];
    if(crep->fin_crep_civil[0] > 24) //Valeur suprieure  24h, pour des longitudes extrmes
        crep->fin_crep_civil[0] -= 24;  //Retranche 24
    //Calcul de la dure de l'aube. L'aube commence au dbut du crpuscule astronomique, passe par le crpuscule nautique puis s'achve  la fin du crpuscule civil.
    if(isnan(crep->debut_crep_astro[0]))
    {   //Pas de crpuscule astronomique
        if(isnan(crep->debut_crep_naut[0]))
        {   //Pas de crpuscule nautique
            if(isnan(crep->debut_crep_civil[0]))
            {   //Pas de crpuscule civil (pas de nuit!)
                crep->duree_aube[0] = 0;   //Impossible de calculer la dure de l'aube, il n'y  pas de nuit.
            }
            else
                crep->duree_aube[0] = crep->lever[0]-crep->debut_crep_civil[0];    //lever-debut_crep_civil
        }
        else
            crep->duree_aube[0] = crep->lever[0]-crep->debut_crep_naut[0];    //lever-debut_crep_nautique
    }
    else
        crep->duree_aube[0] = crep->lever[0]-crep->debut_crep_astro[0];    //lever-debut_crep_astronomique
    //Calcul de la dure du couch du soleil. Le coucher commence au dbut du crpuscule civil, passe par le crpuscule nautique puis s'achve  la fin du crpuscule astronomique.
    crep->crep_nuit = 1;    //Par dfaut la nuit commence  la fin du crpuscule astronomique
    if(isnan(crep->fin_crep_astro[0]))
    {   //Pas de crpuscule astronomique
        crep->crep_nuit = 2;    //La nuit commence  la fin du crpuscule nautique
        if(isnan(crep->fin_crep_naut[0]))
        {   //Pas de crpuscule nautique
            crep->crep_nuit = 3;    //La nuit commence  la fin du crpuscule civil
            if(isnan(crep->fin_crep_civil[0]))
            {   //Pas de crpuscule civil (pas de nuit!)
                crep->crep_nuit = 0;    //La nuit ne commence pas... Pas de calcul possible
                crep->duree_tombe_nuit[0] = 0;   //Impossible de calculer la dure du couch, il n'y  pas de nuit.
            }
            else
            {
                crep->duree_tombe_nuit[0] = crep->fin_crep_civil[0]-crep->coucher[0];    //fin_crep_astro-coucher
                if(crep->duree_tombe_nuit[0] < 0)  //La fin du crpuscule astronomique arrive aprs minuit ce qui entraine une erreur de calcul
                    crep->duree_tombe_nuit[0] = crep->fin_crep_civil[0]+24-crep->coucher[0]; //On ajoute 24 pour rtablir le calcul
            }
        }
        else
        {
            crep->duree_tombe_nuit[0] = crep->fin_crep_naut[0]-crep->coucher[0];    //fin_crep_astro-coucher
            if(crep->duree_tombe_nuit[0] < 0)  //La fin du crpuscule astronomique arrive aprs minuit ce qui entraine une erreur de calcul
                crep->duree_tombe_nuit[0] = crep->fin_crep_naut[0]+24-crep->coucher[0]; //On ajoute 24 pour rtablir le calcul
        }
    }
    else
    {
        crep->duree_tombe_nuit[0] = crep->fin_crep_astro[0]-crep->coucher[0];    //fin_crep_astro-coucher
        if(crep->duree_tombe_nuit[0] < 0)  //La fin du crpuscule astronomique arrive aprs minuit ce qui entraine une erreur de calcul
            crep->duree_tombe_nuit[0] = crep->fin_crep_astro[0]+24-crep->coucher[0]; //On ajoute 24 pour rtablir le calcul
    }
    crep->lever[2] = (modf(crep->lever[0],&crep->lever[1]))*60; //Spare les heures des dcimales et les converti en minutes.
    crep->coucher[2] = (modf(crep->coucher[0],&crep->coucher[1]))*60;
    crep->duree[2] = (modf(crep->duree[0],&crep->duree[1]))*60;
    crep->debut_crep_astro[2] = (modf(crep->debut_crep_astro[0],&crep->debut_crep_astro[1]))*60;
    crep->fin_crep_astro[2] = (modf(crep->fin_crep_astro[0],&crep->fin_crep_astro[1]))*60;
    crep->debut_crep_naut[2] = (modf(crep->debut_crep_naut[0],&crep->debut_crep_naut[1]))*60;
    crep->fin_crep_naut[2] = (modf(crep->fin_crep_naut[0],&crep->fin_crep_naut[1]))*60;
    crep->debut_crep_civil[2] = (modf(crep->debut_crep_civil[0],&crep->debut_crep_civil[1]))*60;
    crep->fin_crep_civil[2] = (modf(crep->fin_crep_civil[0],&crep->fin_crep_civil[1]))*60;
    crep->duree_aube[2] = (modf(crep->duree_aube[0],&crep->duree_aube[1]))*60;
    crep->duree_tombe_nuit[2] = (modf(crep->duree_tombe_nuit[0],&crep->duree_tombe_nuit[1]))*60;
}

void Nuit_crepuscules (struct data_tps *tps, struct crepuscule *crep)
{
    float tps_dec;
    tps->nuit=0;    //Par dfaut, il fait jour
    if(tps->heure <= crep->lever[1])
    {   //Matin
        if(tps->heure < crep->lever[1])
            tps->nuit=3;    //Si avant soleil lev, crpuscule civil
        if(floor(tps->minute) < floor(crep->lever[2]))
            tps->nuit=3;
        if(tps->heure <= crep->debut_crep_civil[1])
        {
            if(tps->heure < crep->debut_crep_civil[1])
                tps->nuit=2;    //Si avant dbut crpuscule civil, crpuscule nautique
            if(floor(tps->minute) < floor(crep->debut_crep_civil[2]))
                tps->nuit=2;
        }
        if(tps->heure <= crep->debut_crep_naut[1])
        {
            if(tps->heure < crep->debut_crep_naut[1])
                tps->nuit=1;    //Si avant dbut crpuscule nautique, crpuscule astronomique
            if(floor(tps->minute) < floor(crep->debut_crep_naut[2]))
                tps->nuit=1;
        }
        if(tps->heure <= crep->debut_crep_astro[1])
        {
            if(tps->heure < crep->debut_crep_astro[1])
                tps->nuit=7;    //Si avant dbut crpuscule astronomique, nuit
            if(floor(tps->minute) < floor(crep->debut_crep_astro [2]))
                tps->nuit=7;
        }
    }
    if(tps->heure >= crep->coucher[1])
    {   //Soir
        if(tps->heure > crep->coucher[1])
            tps->nuit=4;    //Si aprs couch du soleil, crpuscule civil
        if(floor(tps->minute) >= floor(crep->coucher[2]))
            tps->nuit=4;
        if(tps->heure >= crep->fin_crep_civil[1])
        {
            if(tps->heure > crep->fin_crep_civil[1])
                tps->nuit=5;    //Si aprs fin crpuscule civil, crpuscule nautique
            if(floor(tps->minute) >= floor(crep->fin_crep_civil[2]))
                tps->nuit=5;
        }
        if(tps->heure >= crep->fin_crep_naut[1])
        {
            if(tps->heure > crep->fin_crep_naut[1])
                tps->nuit=6;    //Si aprs fin crpuscule nautique, crpuscule astronomique
            if(floor(tps->minute) >= floor(crep->fin_crep_naut[2]))
                tps->nuit=6;
        }
        if(tps->heure >= crep->fin_crep_astro[1])
        {
            if(tps->heure > crep->fin_crep_astro[1])
                tps->nuit=7;    //Si aprs fin crpuscule astronomique, nuit
            if(floor(tps->minute) >= floor(crep->fin_crep_astro [2]))
                tps->nuit=7;
        }
    }
    //Gestion de l'volution en % des crpuscules
    if(tps->nuit != 7 && tps->nuit != 0)  //Calcul l'volution du crpuscule seulement si ce n'est ni la nuit, ni le jour (donc un crpuscule!)
    {
        tps_dec = tps->heure + tps->minute/60;  //Le temps actuel est ramen  une seule valeur, dcimale
        if(tps->nuit < 4)   //Lever du soleil
        {
            tps_dec -= crep->debut_crep_astro[0];   //Soustrait au temps actuel le dbut des crpuscules, afin d'avoir l'avancement du crpuscule en temps
            crep->evo_crep = tps_dec*100/crep->duree_aube[0];
        }
        if(tps->nuit > 3)   //Coucher du soleil
        {
            tps_dec -= crep->coucher[0];   //Soustrait au temps actuel le dbut des crpuscules, afin d'avoir l'avancement du crpuscule en temps
            crep->evo_crep = tps_dec*100/crep->duree_tombe_nuit[0];
        }
    }
    //Gestion des crpuscules inexistants
    if(crep->crep_nuit != 1)   //Si crep_nuit = 1, la nuit commence aprs le crpuscule astronomique, c'est normal
    {
        if(crep->crep_nuit == 0)   //Si crep_nuit = 0, le soleil ne se couche pas, pas de nuit.
            tps->nuit = 0;  //Il fait jour
        if(crep->crep_nuit == 2)   //Si crep_nuit = 2, la nuit commence aprs le crpuscule nautique. Donc pas de crpuscule astronomique
        {
            if(tps->nuit == 1) //Lever crpuscule astronomique
            {
                tps->nuit = 2;  //Crpuscule nautique
                if(crep->evo_crep < 33)
                    crep->evo_crep = 33;    //La nuit n'est pas complte, le jour est lev  33% minimum
            }
            if(tps->nuit == 6) //Coucher crpuscule astronomique
            {
                tps->nuit = 5;  //Crpuscule nautique
                if(crep->evo_crep > 66)
                    crep->evo_crep = 66;    //La nuit n'est pas complte, la nuit est tombe  66% maximum
            }
        }
        if(crep->crep_nuit == 3)   //Si crep_nuit = 3, la nuit commence aprs le crpuscule civil. Donc pas de crpuscule nautique ni astronomique
        {
            if(tps->nuit == 1 || tps->nuit == 2) //Lever crpuscule astronomique ou nautique
            {
                tps->nuit = 3;  //Crpuscule civil
                if(crep->evo_crep < 66)
                    crep->evo_crep = 66;    //La nuit n'est pas complte, le jour est lev  66% minimum
            }
            if(tps->nuit == 6 || tps->nuit == 5) //Coucher crpuscule astronomique ou nautique
            {
                tps->nuit = 4;  //Crpuscule civil
                if(crep->evo_crep > 33)
                    crep->evo_crep = 33;    //La nuit n'est pas complte, la nuit est tombe  33% maximum
            }
        }
    }
}

void Horloge_vague (struct data_tps *tps, struct crepuscule *crep)
{
    FILE* fichier;
    int i,j,k, esp, moments;
    float val;
    float *heures;
    char affichage[255];
    char calc[50];
    char variable[10];
    fichier = ouvre_fichier("Horloge_vague.ini","r");
    fgets(affichage,255,fichier);
    Efface_char(affichage,"="); //Efface Total=
    moments = atoi(affichage);  //Prend le total de valeur
    ER = (int) (heures = (float*) calloc(moments+2,sizeof(float)));
    Erreur(1);
    for(i=1;i<moments+1;i++)
    {   //Lit toutes les valeurs
        fgets(affichage,255,fichier);
        Efface_char(affichage,":");
        j=0;
        calc[0] = '\0'; //Initialise la chaine calc
        while(affichage[j] != ':')  //Tant qu'il reste du texte dans le calcul
        {
            if(affichage[j] == '$')
            {
                j++;    //Saute le $
                k=0;
                while(affichage[j] != '$')
                {   //recopie la variable jusqu'au prochain $
                    variable[k++] = affichage[j++];
                }
                variable[k] = '\0'; //Termine la chaine
                if(!strcmp(variable,"lever"))
                    val = crep->lever[0];
                if(!strcmp(variable,"coucher"))
                    val = crep->coucher[0];
                if(!strcmp(variable,"deb_astro"))
                    val = crep->debut_crep_astro[0];
                if(!strcmp(variable,"fin_astro"))
                    val = crep->fin_crep_astro[0];
                if(!strcmp(variable,"deb_naut"))
                    val = crep->debut_crep_naut[0];
                if(!strcmp(variable,"fin_naut"))
                    val = crep->fin_crep_naut[0];
                if(!strcmp(variable,"deb_civil"))
                    val = crep->debut_crep_civil[0];
                if(!strcmp(variable,"fin_civil"))
                    val = crep->fin_crep_civil[0];
                snprintf(variable, 10, "%f", val);
                strcat(calc,variable);
            }
            else   //Autres valeur (chiffres, + - () etc
            {
                snprintf(variable,2,"%c",affichage[j]);
                strcat(calc,variable);
            }
            j++;    //Passe  la case suivante
        }
        heures[i] = interpret_calc(calc);   //Effectue le calcul lu dans le fichier
        if(heures[i] > 23)  //Corrige les valeurs pour rester sur les heures du jour
            heures[i] -= 24;
        if(heures[i] < 0)
            heures[i] += 24;
    }
    heures[moments+1] = heures[1]; //Pour assurer la boucle 24h du test du moment, la dernire valeur du tableau correspond  la premire
    heures[0] = heures[moments]; //Et inversement
    val = tps->heure + tps->minute/60; //Converti le temps heure:minute en dcimal et stocke dans val
    j = moments;    //j prend le total de valeur
    for(i=1;i<j+1;i++)
    {   //Boucle sur l'ensemble des valeurs stocks dans heures[]
        if(val>=heures[i])   //Si l'heure dpasse l'heure de dpart du moment i
        {
            if(val<heures[i+1]) //mais n'est pas encore arrive au suivant
                moments = i;  //Ce moment est considr comme prsent
            else
            {
                if(heures[i+1] < heures[i]) // Si l'heure suivante est infrieur  celle actuelle. C'est que la valeur qui suit a pass les 24h.
                {   //Cela fausse le calcul. On refait le calcul sans considrer la boucle 24h
                    if(val<heures[i+1]+24)  //Recalcul de l'heure non atteinte, avec +24h pour annuler la boucle 24h
                        moments = i;  //Ce moment est considr comme prsent
                }
            }
        }
        else    //non if(val>heures[i])   //Si l'heure dpasse l'heure de dpart du moment i
        {
            if(heures[i+1] < heures[i]) // Si l'heure suivante est infrieur  celle actuelle. C'est que la valeur qui suit a pass les 24h.
            {   //Cela fausse le calcul.
                if(val<heures[i+1]) //On vrifie si l'heure est encore en dessous de l'heure suivante
                    moments = i;  //Ce moment est considr comme prsent
            }
        }
    }
    rewind(fichier);
    fgets(affichage,255,fichier);
    do
    {
        fgets(affichage,255,fichier);
        esp = atoi(affichage);   //Lit le numro du moment
    } while (esp != moments); //Bcl tant que la bonne ligne n'est pas trouve
    Efface_char(affichage,":");
    Efface_char(affichage,":"); //Garde seulement le texte  afficher
    Efface_n(affichage);    //Enlve le \n de fin de ligne
    free(heures);
    fclose(fichier);
    //Affichage du texte, centr par rapport  l'heure.
    affichage[33] = '\0';   //Limite la longueur de la chaine  33 caractres
    esp = (floor(34-strlen(affichage))/2);
    printf("\n");
    for(i=0;i<esp;i++)
    {
        if((i == 10 && strlen(affichage) < 10) || (i == 11 && strlen(affichage) < 9))
            printf("*");
        else
            printf(" ");
    }
    printf("%s", acc(affichage,chfunc));
    esp += 36-esp*2-strlen(affichage);    //Ajoute des espaces supplmentaires pour combler jusqu' la temprature
    for(i=0;i<esp;i++)
    {
        if((i == (4-floor(strlen(affichage)/2)) && strlen(affichage) < 8) || (i == (5-floor(strlen(affichage)/2)) && strlen(affichage) < 10))
            printf("*");
        else
            printf(" ");
    }
}

void afficheur_liste (struct data_tps *tps, struct crepuscule *crep)
{
    putsacc("\n--Dtails des informations de la journe en cours--\n");
    putsacc("\nHeure: ");
    if (tps->heure < 10)
        printf("0");
    printf("%dH", tps->heure);
    if (floor(tps->minute) < 10)
        printf("0");
    printf("%.0f\n", floor(tps->minute));
    Nuit_crepuscules(tps,crep); //Dtermine si jour/nuit/lever/coucher et l'avancement des crpuscules le cas chant
    if(tps->nuit == 0)   //Jour
        putsacc("Journe.");
    else if(tps->nuit == 7)   //Nuit
    {
        if(crep->crep_nuit != 1)    //Si un crpuscule n'existe pas, le nuit n'est pas full. Indique le % de nuit
            printf("Nuit %0.f%%. ",crep->evo_crep);
        else
            printf("Nuit. ");
    }
    else if(tps->nuit < 4)   //Lever du soleil
        printf("%s du soleil %0.f%%. ", acc("Lev",chfunc),crep->evo_crep);
    else if(tps->nuit > 3)   //Coucher du soleil
        printf("%s du soleil %0.f%%. ", acc("Couch",chfunc),crep->evo_crep);
    putsacc("\nDcalage horaire: ");
    if(crep->decal_h+crep->m_decal_h >= 0)
        printf("+");
    printf("%d\n", crep->decal_h+crep->m_decal_h);
    putsacc("L'heure d't ");
    if(crep->H_ete)
        putsacc("est observe, +1h\n");
    else
        putsacc("n'est pas observe.\n");
    printf("Jour de la semaine: ");
    string(6,tps);
    printf("\nDate du jour: %d (%d)", tps->date, crep->jour);
    if (tps->date == tps->jfete)    //Si c'est un jour de fte
        printf("   %s", acc(tps->nom_fete,chfunc));    //Affiche le nom du jour de fte
    printf("\nMois: (%d), ",tps->mois);
    string (1,tps);
    printf("\nSaison: ");
    string (5,tps);
    printf("\n");
    printf("Lune pleine %s %.0f%%",acc("",chfunc),tps->lune);
    if(tps->lune < 1)
        printf(" nouvelle lune");
    if(tps->lune > 45 && tps->lune < 55)
        printf(" quartier de lune");
    if(tps->lune > 99)
        printf(" pleine lune");
    if(tps->lune <= 33)
        putsacc(", -3 dtection");
    if(tps->lune > 33 && tps->lune < 67)
        putsacc(", -2 dtection");
    if(tps->lune >= 67 && tps->nuit != 0)    //N'affiche pas le malus pour la pleine lune en plein jour
        putsacc(", -1 dtection");
    if(tps->sens_lune > 0)
        printf("\nLe cycle de lune est croissant\n");
    else
        putsacc("\nLe cycle de lune est dcroissant\n");
    putsacc("Temprature actuelle: ");
    string (2,tps);
    printf("\nVitesse du vent: ");
    string (3,tps);
    if(tps->vent > 1) //Si Le vent n'est pas nul
    {
        printf("Le vent souffle depuis ");
        switch (tps->sens_vent)
        {
            case 1:
                printf("le Nord");
                break;
            case 2:
                printf("le Nord-Est");
                break;
            case 3:
                printf("l'Est");
                break;
            case 4:
                printf("le Sud-Est");
                break;
            case 5:
                printf("le Sud");
                break;
            case 6:
                printf("le Sud-Ouest");
                break;
            case 7:
                printf("l'Ouest");
                break;
            case 8:
                printf("le Nord-Ouest");
                break;
        }
        printf(")");
    }
    putsacc("\nPrcipitation: ");
    string (4,tps);
    printf("\nClimat actuel: %s\n", acc(tps->climat,chfunc));
    printf("Il reste %dh avant l'", tps->alea_meteo);
    putsacc("volution de la mto.\n");
    putsacc("Dbut du crpuscule astronomique (Dbut du lev du soleil): ");
    printf("%.0fh%.0f\n", crep->debut_crep_astro[1],floor(crep->debut_crep_astro[2]));
    putsacc("Dbut du crpuscule nautique: ");
    printf("%.0fh%.0f\n", crep->debut_crep_naut[1],floor(crep->debut_crep_naut[2]));
    putsacc("Dbut du crpuscule civil: ");
    printf("%.0fh%.0f\n", crep->debut_crep_civil[1],floor(crep->debut_crep_civil[2]));
    putsacc("Soleil lev: ");
    printf("%.0fh%.0f\n", crep->lever[1],floor(crep->lever[2]));
    putsacc("Dure de l'aube: ");
    printf("%.0fh%.0f\n", crep->duree_aube[1],floor(crep->duree_aube[2]));
    putsacc("Dure de la journe: ");
    printf("%.0fh%.0f\n", crep->duree[1],floor(crep->duree[2]));
    putsacc("Dbut du couch du soleil: ");
    printf("%.0fh%.0f\n", crep->coucher[1],floor(crep->coucher[2]));
    putsacc("Fin du crpuscule civil: ");
    printf("%.0fh%.0f\n", crep->fin_crep_civil[1],floor(crep->fin_crep_civil[2]));
    putsacc("Fin du crpuscule nautique: ");
    printf("%.0fh%.0f\n", crep->fin_crep_naut[1],floor(crep->fin_crep_naut[2]));
    putsacc("Fin du crpuscule astronomique (Fin du couch du soleil): ");
    printf("%.0fh%.0f\n", crep->fin_crep_astro[1],floor(crep->fin_crep_astro[2]));
    putsacc("Dure de la tombe de la nuit: ");
    printf("%.0fh%.0f\n", crep->duree_tombe_nuit[1],floor(crep->duree_tombe_nuit[2]));
    if(crep->crep_nuit)
    {
        putsacc("La nuit commence aprs le crpuscule ");
        if(crep->crep_nuit == 1)
            printf("astronomique (nuit normale)\n");
        if(crep->crep_nuit == 2)
            printf("nautique\n");
        if(crep->crep_nuit == 3)
        printf("civil\n");
    }
    else
        putsacc("Le soleil ne se couche pas !\n");
    printf("Facteur de vitesse du temps: %.3f\n", tps->facteur);
    printf("Le mois en cours compte %d jours.\n", tps->jmois);
    printf("L'%s compte %d mois.\n", acc("anne",chfunc), tps->nb_mois);
    printf("Les semaines comptent %d jours.\n", tps->nb_semaine);
    printf("Latitude: %f\n", crep->latitude);
    printf("Longitude: %f\n", crep->longitude);
    Pause();
}

void option_affichage ()
{
    FILE* file_affich;
    char chaine[255];
    int i, affich_base[16], affich[16], choix;
    file_affich = ouvre_fichier("Affichage.ini","r");
    for(i=0;i<16;i++)
    {
        fgets(chaine,255,file_affich);
        Efface_char(chaine,"=");
        affich[i] = atoi(chaine);   //Lit les indications d'affichage
        affich_base[i] = affich[i]; //Fait une copie de ce qui est lu dans le fichier
    }
    fclose(file_affich);
    do
    {
        putsacc("\nModifier les lments  afficher  l'cran:");
        for(i=0;i<16;i++)
        {
            printf("\n%d) ", i+1);
            switch (i)
            {
                case 0:
                    printf("Vitesse du temps");
                    break;
                case 1:
                    putsacc("Heures du Lever/coucher et dure du jour");
                    break;
                case 2:
                    putsacc("Indication du moment de la journe, Jour/nuit/crpuscules");
                    break;
                case 3:
                    printf("Cycle de lune");
                    break;
                case 4:
                    printf("Date du jour");
                    break;
                case 5:
                    printf("Jour de la semaine");
                    break;
                case 6:
                    putsacc("Jour de ftes");
                    break;
                case 7:
                    printf("Heure et minutes");
                    break;
                case 8:
                    printf("Mois");
                    break;
                case 9:
                    printf("Saison");
                    break;
                case 10:
                    printf("Horloge vague");
                    break;
                case 11:
                    putsacc("Temprature");
                    break;
                case 12:
                    printf("Vitesse du vent");
                    break;
                case 13:
                    printf("Sens du vent");
                    break;
                case 14:
                    putsacc("Prcipitations");
                    break;
                case 15:
                    putsacc("Effets de la mto");
                    break;
            }
            if(affich[i])
                putsacc(". (Affich)");
            else
                putsacc(". (Non affich)");
        }
        printf("\n17) Retour.");
        do
        {     /*bcl de gestion d'erreur*/
            printf("\n?: ");
            choix = (int) interpret_calc("\0");
            if(choix < 0 || choix > 17)
                choix = NA;
        } while (choix == NA || choix == defo);
        if(choix == 17) //Retour au menu principal
            choix = 0;  //Quitte la boucle
        else
        {   //Inverse l'affichage pour l'lment slectionn
            if(affich[choix-1])
                affich[choix-1] = 0;
            else
                affich[choix-1] = 1;
        }
    }while(choix);
    for(i=0;i<16;i++)
    {
        if(affich_base[i] != affich[i])
            choix = 1;  //Indique un changement dans les options d'affichage
    }
    if(choix)   //En cas de changement dans les options, rcrit le fichier
    {
        file_affich = ouvre_fichier("Affichage.ini","w");
        fprintf(file_affich,"Vitesse du temps=%d\n",affich[0]);
        fprintf(file_affich,"Lever/coucher/dure=%d\n",affich[1]);
        fprintf(file_affich,"Jour/nuit/crpuscules=%d\n",affich[2]);
        fprintf(file_affich,"Cycle de lune=%d\n",affich[3]);
        fprintf(file_affich,"Date=%d\n",affich[4]);
        fprintf(file_affich,"Jour de la semaine=%d\n",affich[5]);
        fprintf(file_affich,"Jour de ftes=%d\n",affich[6]);
        fprintf(file_affich,"Heure/minutes=%d\n",affich[7]);
        fprintf(file_affich,"Mois=%d\n",affich[8]);
        fprintf(file_affich,"Saison=%d\n",affich[9]);
        fprintf(file_affich,"Horloge vague=%d\n",affich[10]);
        fprintf(file_affich,"Temprature=%d\n",affich[11]);
        fprintf(file_affich,"Vent=%d\n",affich[12]);
        fprintf(file_affich,"Sens du vent=%d\n",affich[13]);
        fprintf(file_affich,"Prcipitations=%d\n",affich[14]);
        fprintf(file_affich,"Effets de la mto=%d\n",affich[15]);
        fclose(file_affich);
    }
}
