/* Programme de conversion de personnage par le menu contextuel pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.rf.lv
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.6*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Fichier.h"
#include "Utilitaire.h"
#include "Jdr.h"
#include "Chaines.h"

FILE* ouvre_fichier_sans_accent (char chemin[255], const char mode[]);

int main (int argc,char *argv[])
{
    FILE* Fichier_source;
    FILE* Fichier_html;
    FILE* Fragments;
    FILE* Fichier_txt;
    FILE* logerreur;
    char chaine[255];
    char chaine2[255];
    char* nomfichier;
    char chemin[255];
    int tabindex[50]; /*Pour la fonction index_ch*/
    int nb_index;
    int borne, i;
    affichage_arg = 1;  //Affichage complet par defaut
    init_historique_saisie();
    if(argc == 3)
    {
        Efface_char(argv[2],"=");
        affichage_arg = atoi(argv[2]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
        Titre (argc,argv,"Conversion de personnages","Programme de conversion de personnages en html pour Donjons et dragons","0F");
    if(argc>1)   /*Arguments*/
    {
        if(argc != 3 && argc != 2)  //Si l'argument d'affichage n'est pas prsent, il sera ignor et considr par dfaut  1
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Convert txthtml.exe, nombre d'arguments incorrect !");
            Pause();
            exit(1);
        }
        Efface_char(argv[1],"=");
        ER = (int) (nomfichier = (char*) calloc(strlen(argv[1])*2,sizeof(char)));
        Erreur(1);
        strcpy(nomfichier,argv[1]); /*Prend le nom de la feuille de perso, en 1er argument*/
    }
    if(argc==1)
    {   /*Le programme n'a pas en argument le nom du fichier, lancement du programme seul*/
        putsacc("Entrez le nom complet du fichier txtp  convertir en html\n?: ");
        nomfichier = getsdyn(nomfichier);
    }
    strcpy(chaine,argv[0]);
    nb_index = index_ch(chaine,"\\",tabindex); /*Cherche les emplacements de \ pour trouver le dernier*/
    if(nb_index==0) //Si pas de \, convert txthtml se trouve dans son dossier
        strcpy(chemin,"..\\..");
    else
    {   //Convert txthtml n'est pas appel dans son dossier
        for(i=0;i<tabindex[nb_index-3]+1;i++)
        {
            chemin[i] = chaine[i];  /*En partant du chemin du programme actuel, remonte jusqu'au dossier de Servus domini*/
        }
    }
    if(affichage_arg < 3)
    {
        putsacc(nomfichier);
        puts("");
        puts("");
    }
    sprintf(chaine,"%s\\Donnes\\Sources html\\Source base_conv.htm", chemin);
    Fichier_source = ouvre_fichier_sans_accent(chaine,"r");
    Fichier_txt = ouvre_fichier(nomfichier,"r");
    nomfichier[strlen(nomfichier)-4] = '\0';
    strcat(nomfichier,"html");
    Fichier_html = ouvre_fichier(nomfichier,"w");
    sprintf(chaine,"%s\\Donnes\\Sources html\\Fragments_conv.htm", chemin);
    Fragments = ouvre_fichier_sans_accent(chaine,"r");
    sprintf(chaine,"%s\\Utilitaires\\Convert txthtml\\Erreurs.log", chemin);
    logerreur = ouvre_fichier(chaine,"w");
    do
    {
        fgets(chaine,255,Fichier_source);
        if (chaine[0] == '#')
        {
            for(i=0;i<(int)strlen(chaine);i++)
                chaine[i] = chaine[i+1];
            borne = atoi(chaine);
            rewind(Fichier_txt);
            switch (borne)
            {
                case 1:
                    /*Titre du fichier*/
                    changeslash(nomfichier);
                    if(strstr(nomfichier,"\\") != NULL || strstr(nomfichier,"/") != NULL)
                    {
                        #ifdef WIN32    //win
                        strcpy(nomfichier,strrchr(nomfichier,'\\'));
                        Efface_char(nomfichier,"\\");
                        #else   //linux
                        strcpy(nomfichier,strrchr(nomfichier,'/'));
                        Efface_char(nomfichier,"/");
                        #endif
                    }
                    fprintf(Fichier_html,"%s",nomfichier);
                    strcpy(chaine2,"NULL");
                    borne=1;
                    break;
                case 2:
                    /*Classe de personnage*/
                    strcpy(chaine2,"Classe de personnage: ");
                    borne=0;
                    break;
                case 3:
                    /*Race du personnage*/
                    strcpy(chaine2,"Race: ");
                    borne=0;
                    break;
                case 4:
                    /*Sexe du personnage*/
                    strcpy(chaine2,"Sexe: ");
                    borne=0;
                    break;
                case 5:
                    /*Poids*/
                    strcpy(chaine2,"Poids: ");
                    borne=0;
                    break;
                case 6:
                    /*Taille*/
                    strcpy(chaine2,"Taille: ");
                    borne=0;
                    break;
                case 7:
                    /*Age*/
                    strcpy(chaine2,"Age: ");
                    borne=0;
                    break;
                case 8:
                    /*Alignement*/
                    strcpy(chaine2,"Alignement: ");
                    borne=0;
                    break;
                case 9:
                    /*Force*/
                    strcpy(chaine2,"Force: ");
                    borne=0;
                    break;
                case 10:
                    /*Dextrit*/
                    strcpy(chaine2,"Dextrit: ");
                    borne=0;
                    break;
                case 11:
                    /*Constitution*/
                    strcpy(chaine2,"Constitution: ");
                    borne=0;
                    break;
                case 12:
                    /*Intelligence*/
                    strcpy(chaine2,"Intelligence: ");
                    borne=0;
                    break;
                case 13:
                    /*Sagesse*/
                    strcpy(chaine2,"Sagesse: ");
                    borne=0;
                    break;
                case 14:
                    /*Charisme*/
                    strcpy(chaine2,"Charisme: ");
                    borne=0;
                    break;
                case 15:
                    /*Langues*/
                    strcpy(chaine2,"Langues parles:");
                    borne=-15;
                    break;
                case 16:
                    /*Vision*/
                    while(strstr(chaine,"Charisme: ") == NULL) /*C'est la ligne suivante*/
                    {    /*Recherche de la ligne correspondante*/
                        if (fgets(chaine,255,Fichier_txt) == NULL)
                        {
                            fprintf(logerreur,"!!!Erreur dans %s, impossible de trouver \"Charisme: \" dans le fichier au format .txt\n", nomfichier);
                            if(affichage_arg < 3)
                            {
                                printf("!!!Erreur dans %s", nomfichier);
                                putsacc(", impossible de trouver \"Charisme: \" dans le fichier au format .txt\n");
                                Pause();
                            }
                            free(nomfichier);
                            exit(1);
                        }
                    }
                    fgets(chaine,255,Fichier_txt);
                    fprintf(Fichier_html,"%s",chaine);  /*Affiche la vision*/
                    strcpy(chaine2,"NULL");
                    borne=1;
                    break;
                case 17:
                    /*Capacits spciales*/
                    strcpy(chaine2,"Capacits spciales:");
                    borne=-17;
                    break;
                case 18:
                    /*Armure*/
                    strcpy(chaine2,"Armure: ");
                    borne=18;
                    break;
                case 19:
                    /*Bouclier*/
                    strcpy(chaine2,"Bouclier: ");
                    borne=19;
                    break;
                case 20:
                    /*Arme primaire*/
                    strcpy(chaine2,"Arme principale: ");
                    borne=20;
                    break;
                case 21:
                    /*Arme secondaire*/
                    strcpy(chaine2,"Arme secondaire: ");
                    borne=21;
                    break;
                case 22:
                    /*Arme tertiaire*/
                    strcpy(chaine2,"Arme tertiaire: ");
                    borne=22;
                    break;
                case 23:
                    /*Niveau*/
                    strcpy(chaine2,"Niveau: ");
                    borne=0;
                    break;
                case 24:
                    /*Points de vie*/
                    strcpy(chaine2,"Points de vie: ");
                    borne=0;
                    break;
                case 25:
                    /*Jet d'attaque*/
                    strcpy(chaine2,"Jet d'attaque: ");
                    borne=0;
                    break;
                case 26:
                    /*JS rflexe*/
                    strcpy(chaine2," Rflexe: ");
                    borne=0;
                    break;
                case 27:
                    /*JS vigueur*/
                    strcpy(chaine2," Vigueur: ");
                    borne=0;
                    break;
                case 28:
                    /*JS volont*/
                    strcpy(chaine2," Volont: ");
                    borne=0;
                    break;
                case 29:
                    /*Dons*/
                    strcpy(chaine2,"Dons:");
                    borne=-29;
                    break;
                case 30:
                    /*Comptences*/
                    strcpy(chaine2,"Comptences:");
                    borne=-30;
                    break;
                case 31:
                    /*Equipements*/
                    strcpy(chaine2,"#Equipements:");
                    borne=-31;
                    break;
                case 32:
                    /*Nombre d'objets magiques*/
                    while(strstr(chaine,"objets magiques  dterminer.") == NULL)
                    {    /*Recherche de la ligne correspondante*/
                        if (fgets(chaine,255,Fichier_txt) == NULL)
                        {
                            borne=-1; /*Impossible de trouver "objets magiques  dterminer". Pas d'affichage*/
                            break;
                        }
                    }
                    if(borne>0) /*Si "objets magiques  dterminer" est trouv*/
                        fprintf(Fichier_html,"%s",chaine);  /*Affiche les objets magiques*/
                    strcpy(chaine2,"NULL");
                    borne=1;
                    break;
                case 33:
                    /*Traits physiques*/
                    strcpy(chaine2,"Age: ");
                    borne=-33;
                    break;
                case 34:
                    /*XP*/
                    strcpy(chaine2,"Points d'exprience: ");
                    borne=34;
                    break;
                case 35:
                    /*Nom du perso*/
                    strcpy(chaine2,"Nom:");
                    borne=0;
                    break;
                case 36:
                    /*Attaques secondaires*/
                    while(strstr(chaine,"Attaque supplmentaire:") == NULL)
                    {    /*Recherche de la ligne correspondante*/
                        if (fgets(chaine,255,Fichier_txt) == NULL)
                        {
                            borne=-1;  /*La chaine n'est pas trouve, pas d'affichage de ce type*/
                            break;
                        }
                    }
                    if (borne>1)
                    {
                        do
                        {   //Boucle tant qu'il y a des attaques sup  afficher
                            Efface_char(chaine,":");
                            Efface_char(chaine," ");
                            while(borne != atoi(chaine2))
                            {    /*Recherche de la ligne correspondante dans les fragments html*/
                                fgets(chaine2,255,Fragments);
                                Efface_char(chaine2,"#");
                            }
                            fgets(chaine2,255,Fragments);
                            fprintf(Fichier_html,"%s",chaine2);
                            fgets(chaine2,255,Fragments);
                            fprintf(Fichier_html,"%s",chaine);   //Place l'attaque secondaire
                            fgets(chaine2,255,Fragments);
                            fprintf(Fichier_html,"%s",chaine2);
                            rewind(Fragments);
                            fgets(chaine,255,Fichier_txt);
                        }while(strstr(chaine,"Attaque supplmentaire:") != NULL);
                    }
                    strcpy(chaine2,"NULL");
                    borne=1;
                    break;
            }
            rewind(Fichier_txt);
            if (borne==0)
            {   //Placement de la chaine  la place de la balise
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        fprintf(logerreur,"!!!Erreur dans %s, impossible de trouver \"%s\" dans le fichier au format .txt\n", nomfichier,chaine2);
                        if(affichage_arg < 3)
                        {
                            printf("!!!Erreur dans %s, impossible de trouver \"", nomfichier);
                            putsacc(chaine2);
                            putsacc("\" dans le fichier au format .txt\n");
                            Pause();
                        }
                        free(nomfichier);
                        exit(1);
                    }
                }
                Efface_char(chaine,":");
                Efface_char(chaine," ");
                fprintf(Fichier_html,"%s",chaine);
            }
            if (borne>1)
            {   //Placement de la chaine  condition que le personnage en dispose, utilise les fragments
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        borne=-1;  /*La chaine n'est pas trouve, pas d'affichage de ce type*/
                        break;
                    }
                }
                if (borne>1)
                {
                    Efface_char(chaine,":");
                    Efface_char(chaine," ");
                    while(borne != atoi(chaine2))
                    {    /*Recherche de la ligne correspondante dans les fragments html*/
                        fgets(chaine2,255,Fragments);
                        Efface_char(chaine2,"#");
                    }
                    fgets(chaine2,255,Fragments);
                    while(chaine2[0] != '#')    /*Boucle tant qu'il ne tombe pas sur les fragments suivants*/
                    {
                        if (chaine2[0] == '~')  /*Si il faut placer la string*/
                            fprintf(Fichier_html,"%s",chaine);
                        else
                            fprintf(Fichier_html,"%s",chaine2);
                        fgets(chaine2,255,Fragments);
                    }
                    rewind(Fragments);
                }
            }
            else if (borne<0)
            {   //Placement de la chaine en boucle jusqu' >
                borne *= -1;      /*Rtabli la valeur positive*/
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,Fichier_txt) == NULL)
                    {
                        fprintf(logerreur,"!!!Erreur dans %s, impossible de trouver \"%s\" dans le fichier au format .txt\n", nomfichier,chaine2);
                        if(affichage_arg < 3)
                        {
                            printf("!!!Erreur dans %s, impossible de trouver \"", nomfichier);
                            putsacc(chaine2);
                            putsacc("\" dans le fichier au format .txt\n");
                            Pause();
                        }
                        free(nomfichier);
                        exit(1);
                    }
                }
                fgets(chaine,255,Fichier_txt);
                while(chaine[0] != '>')
                {
                    while(borne != atoi(chaine2))
                    {    /*Recherche de la ligne correspondante dans les fragments html*/
                        fgets(chaine2,255,Fragments);
                        Efface_char(chaine2,"#");
                    }
                    fgets(chaine2,255,Fragments);
                    while(chaine2[0] != '#')    /*Boucle tant qu'il ne tombe pas sur les fragments suivants*/
                    {
                        if (chaine2[0] == '~')  /*Si il faut placer la string*/
                            fprintf(Fichier_html,"%s",chaine);
                        else
                            fprintf(Fichier_html,"%s",chaine2);
                        fgets(chaine2,255,Fragments);
                    }
                    rewind(Fragments);
                    fgets(chaine,255,Fichier_txt);
                }
            }
        }
        else
            fprintf(Fichier_html,"%s",chaine);
    }while(strstr(chaine,"</html>") == NULL);
    free(nomfichier);
    fclose(logerreur);
    fclose(Fichier_source);
    fclose(Fichier_html);
    fclose(Fragments);
    fclose(Fichier_txt);
    return 0;
}

FILE* ouvre_fichier_sans_accent (char chemin[255], const char mode[])
{
    FILE* fichier;
    changeslash(chemin);    //Inerse les slash pour linux (le cas chant)
    #ifndef WIN32    //linux
    char chemin_acc[255];
    strcpy(chemin_acc,linux_acc(chemin,chfunc));    //Corrige les accents pour linux
    strcpy(chemin,chemin_acc);
    #endif
    if ((fichier = fopen (chemin,mode)) == NULL)    /*Ouvre le fichier*/
    {
        if(affichage_arg < 3)
        {
            #ifdef WIN32    //win
            printf("\n!!! Une erreur est survenue durant l'ouverture du fichier %s, en mode %s", acc(chemin,chfunc), mode);
            #else   //linux
            printf("\n!!! Une erreur est survenue durant l'ouverture du fichier %s, en mode %s", chemin_acc, mode); //Les accents ont dj t modifi pour l'affichage linux
            #endif
            Pause();                /*Envoie un message d'erreur  l'utilisateur*/
        }
        exit(1);                /*Puis quitte le programme*/
    }
    else
        return (fichier);        /*Envoie le pointeur de fichier si pas d'erreur d'ouverture*/
}
