/* Programme de mise  jour des personnages.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "Utilitaire.h"
#include "Jdr.h"
#include "Chaines.h"

void Trait_physique (FILE* Fichier_txt, struct info_perso *donnees);    /*Dtermine les traits physiques du personnage et les inscrit dans le fichier texte*/
int verif_val_gen_alea (int* index, char* ligne, int alea);  /*gen_alea, dtermine si la ligne actuelle est celle correspondant au jet de d*/
int jet_de_des_gen_alea (int* index, char* ligne);       /*gen_alea, Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
char* string_gen_alea (int index, char* ligne); /*gen_alea, Affiche le rsultat*/
char* gen_alea (const char* nomfichier, char* ligne);      /*Appel le gen alea en ligne de commande*/

int main (int argc,char *argv[])
{
    struct info_perso perso;
    FILE* liste;
    FILE* fichier;
    FILE* fperso;
    FILE* tempfile;
    FILE* logerreur;
    int choix;
    char chemin[255];
    char chaine[255];
    char chaine2[255];
    char chaine3[255];
    char indic[10];
    int nbligne, i,j,k, maj, capspe[2];
    float IMCtab[7];
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"MAJ perso","Programme de mise  jour des feuilles de personnages pour Donjons et dragons",color_sd("MAJ perso",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\..\\Phrases de jdr.txt");
    #endif
    do
    {
        putsacc("1) Choisir un dossier ou un personnage\n");
        putsacc("2) Reprendre la mise  jour des personnages (En cas de bug)\n");
        choix = 0;
        while (choix == 0) /*Scurit erreur de saisi*/
        {
            printf("?: ");
            choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
                exit(0);
            switch (choix)
            {
                case 1:
                    putsacc("\nNoter le chemin du dossier  traiter (ou de la feuille de personnage (.txtp)):\n?: ");
                    getsfix(chemin,255);
                    if(chemin[strlen(chemin)-5] == '.' && chemin[strlen(chemin)-4] == 't' && chemin[strlen(chemin)-3] == 'x' && chemin[strlen(chemin)-2] == 't' && chemin[strlen(chemin)-1] == 'p')
                    {
                        liste = ouvre_fichier("liste.txt","w");
                        fprintf(liste,"%s\n", chemin);
                        fclose(liste);
                    }
                    else
                    {
                        liste = ouvre_fichier("Liste.txt","w");
                        listing_doss(chemin,liste,1,"txtp",0); //Appel la commande de listing de dossier en rcursif avec un filtre txtp
                        fclose(liste);
                    }
                case 2:
                    liste = ouvre_fichier("Liste.txt","r");
                    fichier = ouvre_fichier("Couleurs.ini","r+");
                    fgets(chaine,255,fichier);
                    Efface_char(chaine,":");
                    nbligne = atoi(chaine);       /*Lit le nombre de perso dj cres*/
                    fclose(fichier);
                    for(i=0;i<nbligne;i++)    /*Saute les persos dj cres*/
                        fgets(chaine,255,liste);
                    logerreur = ouvre_fichier("Erreurs.log","a+");
                    fprintf(logerreur,"--\n");
                    while(!feof(liste))
                    {
                        if(fgets(chemin,255,liste)) /*Evite de rpter la dernire ligne*/
                        {
                            printf("\n->%s",chemin);
                            nbligne++;
                            maj=0;  //Par dfaut, aucune mise  jour effectue sur le fichier
                            Efface_n(chemin);      //Retire le \n
                            fperso = ouvre_fichier(chemin,"r");  //Ouvre la feuille de perso
                            tempfile = ouvre_fichier("temp.tmp","w");
                            strcpy(indic,"dbut");  //Indique dbut de fichier
                            capspe[0]=0;capspe[1]=0;
                            while(!feof(fperso))
                            {
                                if(fgets(chaine,255,fperso)) /*Evite de rpter la dernire ligne*/
                                {
                                    if(strstr(chaine,"Nom:"))
                                    {   //Stocke le nom du personnage
                                        strcpy(chaine2,chaine);
                                        Efface_char(chaine2,":");
                                        Efface_char(chaine2," ");    /*Efface le texte avant : */
                                        Efface_n(chaine2);      //Retire le \n
                                        strcpy(perso.nom,chaine2); /*Stocke la valeur lue*/
                                    }
                                    if(strstr(chaine,"Niveau:"))
                                    {   //Stocke le niveau du personnage
                                        strcpy(chaine2,chaine);
                                        Efface_char(chaine2,":");
                                        Efface_char(chaine2," ");    /*Efface le texte avant : */
                                        perso.niveau = atoi(chaine2); /*Stocke la valeur lue*/
                                    }
                                    if(strstr(chaine,"Race:"))
                                    {   //Stocke la race du personnage
                                        strcpy(chaine2,chaine);
                                        Efface_char(chaine2,":");
                                        Efface_char(chaine2," ");    /*Efface le texte avant : */
                                        if(strstr(chaine2,",")) //Si , probablement prsence d'un archtype dans la race
                                            chaine2[index_ch_first(chaine2,",")] = '\0'; //Retire tout aprs la ,
                                        else
                                            Efface_n(chaine2);      //Retire le \n
                                        strcpy(perso.race,chaine2); /*Stocke la valeur lue*/
                                    }
                                    if(strstr(chaine,"Sexe:"))
                                    {   //Stocke le sexe du personnage
                                        strcpy(chaine2,chaine);
                                        Efface_char(chaine2,":");
                                        Efface_char(chaine2," ");    /*Efface le texte avant : */
                                        Efface_n(chaine2);      //Retire le \n
                                        strcpy(perso.sexe,chaine2); /*Stocke la valeur lue*/
                                    }
/*Nom dbut de feuille*/            if(!strcmp(indic,"dbut") && strstr(chaine,"Nom:") == NULL)
                                    {   //Si premire ligne mais pas Nom: affich, alors le nom n'est pas affich en premire ligne, ncessit de mise  jour
                                        putsacc(".Ajout du nom en dbut de feuille.\n");
                                        maj=1;  //Une mise  jour effectue
                                        fseek(fperso,-(strlen(chaine)+1),SEEK_CUR);    //Revient en arrire pour ignorer la ligne, et la relire au prochain tour
                                        strcpy(chaine,chemin);
                                        if(strstr(chaine,"\\") != NULL)
                                        {
                                            strcpy(chaine,strrchr(chaine,'\\'));    //Prend seulement le nom du fichier, sans le chemin
                                            Efface_char(chaine,"\\");
                                        }
                                        strcpy(chaine2,chaine);
                                        i=0;
                                        while(chaine[i++] != ',');
                                        chaine[i-1] = '\0'; //Garde seulement le dbut du nom de fichier, avant la virgule (en principe le nom!)
                                        fichier = ouvre_fichier("..\\..\\Cration de personnages\\Professions.ini","r");
                                        j=0;
                                        while(!feof(fichier))
                                        {   //Vrifie si le nom isol est une profession (cas des anciennnes classe de peuple o le nom est plac aprs la profession)
                                            fgets(chaine3,255,fichier);
                                            if(strstr(chaine3,chaine) != NULL)
                                            {
                                                j=1;    //La chaine est trouve dans la liste des professions. Donc ce n'est pas le nom!
                                                break;
                                            }
                                        }
                                        if(j==1)
                                        {   //Le nom n'est pas en premier
                                            strcpy(chaine,chaine2); //Reprend la chaine complte
                                            Efface_char(chaine,",");
                                            Efface_char(chaine," ");    //Efface avant la virgule
                                            i=0;
                                            while(chaine[i++] != ' ');
                                            while(chaine[i++] != ' '); //Passe les 2 espaces
                                            chaine[i-1] = '\0';     //Efface aprs les 2 espaces, il reste que le nom!
                                        }
                                        fclose(fichier);
                                        fprintf(tempfile,"Nom: %s\n",chaine);
                                        strcpy(perso.nom,chaine);
                                    }
/*Affichage magicien, puis spe*/    else if(strstr(chaine,"Classe de personnage:") != NULL)
/*Ou accent prtre et rdeur*/      {
/*Ou Homme d'armes*/                    strcpy(chaine3,chaine);
                                        if(strstr(chaine,"Abjurateur") != NULL || strstr(chaine,"Devin") != NULL || strstr(chaine,"Enchanteur") != NULL || strstr(chaine,"Evocateur") != NULL || strstr(chaine,"Illusionniste") != NULL || strstr(chaine,"Invocateur") != NULL || strstr(chaine,"cromancien") != NULL || strstr(chaine,"Transmutateur") != NULL)
                                        {   //Vrifie la prsence d'une classe de magicien spcialis
/*MAJ Magicien spe*/                        if(strstr(chaine,"Magicien,") == NULL)
                                            {   //Si il ne trouve pas Magicien, alors le nom de classe est incorrect et ncessite une mise  jour
                                                putsacc(".Ajout de \"Magicien, \" avant la classe spcialise.\n");
                                                maj=1;  //Une mise  jour effectue
                                                Efface_char(chaine,":");    //Efface classe de personnage:
                                                Efface_char(chaine," ");
                                                sprintf(chaine3,"Classe de personnage: Magicien, %s", chaine); //Ajoute Magicien,  la classe de perso
/*MAJ accent*/                                  if(strstr(chaine3,"Magicien, Necromancien") != NULL)
                                                {
                                                    i = index_ch_first(chaine3,"Necromancien");    //Cherche l'index du mot
                                                    chaine3[i+1] = '';  //Place l'accent
                                                    putsacc(".Ajout de l'accent sur Magicien, Ncromancien.\n");
                                                }
                                            }
                                        }
/*MAJ Soldat -> Militaire*/             else if(strstr(chaine,"Soldat") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Remplacement Soldat par Militaire.\n");
                                            Efface_char(chaine,",");    //Efface Soldat
                                            sprintf(chaine3,"Classe de personnage: Militaire,%s", chaine); //Reconstruit la classe en remplaant Soldat par Militaire
                                            strcpy(chaine,chaine3); //Reconstitue chaine pour le test des accents
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Pretre") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"Pretre");    //Cherche l'index du mot
                                            chaine[i+2] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Prtre.\n");
                                            strcpy(chaine3,chaine);
/*MAJ accent*/                              if(strstr(chaine3,"Malefique") != NULL)
                                            {
                                                i = index_ch_first(chaine3,"Malefique");    //Cherche l'index du mot
                                                chaine3[i+3] = '';  //Place l'accent
                                                putsacc(".Ajout de l'accent sur Prtre, Malfique.\n");
                                            }
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Rodeur") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"Rodeur");    //Cherche l'index du mot
                                            chaine[i+1] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Rdeur.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Combattant metamorphe") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"metamorphe");    //Cherche l'index du mot
                                            chaine[i+1] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Combattant mtamorphe.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Guerrier, Specialiste") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"Specialiste");    //Cherche l'index du mot
                                            chaine[i+2] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Guerrier, Spcialiste.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, arbaletrier leger") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"arbaletrier");    //Cherche l'index du mot
                                            chaine[i+5] = '';  //Place l'accent
                                            chaine[i+13] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, arbaltrier lger.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, arbaletrier lourd") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"arbaletrier");    //Cherche l'index du mot
                                            chaine[i+5] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, arbaltrier lourd.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, arbaletrier monte") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"arbaletrier");    //Cherche l'index du mot
                                            chaine[i+5] = '';  //Place l'accent
                                            chaine[i+16] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, arbaltrier mont.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, archer monte") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"monte");    //Cherche l'index du mot
                                            chaine[i+4] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, archer mont.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, cavalier leger") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"leger");    //Cherche l'index du mot
                                            chaine[i+1] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, cavalier lger.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, fantassin leger") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"leger");    //Cherche l'index du mot
                                            chaine[i+1] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, fantassin lger.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Militaire, ingenieur") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"ingenieur");    //Cherche l'index du mot
                                            chaine[i+3] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Militaire, ingnieur.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ accent*/                          else if(strstr(chaine,"Samourai") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            i = index_ch_first(chaine,"Samourai");    //Cherche l'index du mot
                                            chaine[i+7] = '';  //Place l'accent
                                            putsacc(".Ajout de l'accent sur Samoura.\n");
                                            strcpy(chaine3,chaine);
                                        }
/*MAJ Homme d'arme -> Homme d'armes*/   else if(strstr(chaine,"Homme d'arme") != NULL && strstr(chaine,"Homme d'armes") == NULL)
                                        {   //Si il manque le s  la fin de Homme d'armes
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout du 's'  la fin de Homme d'armes.\n");
                                            j = index_ch_first(chaine,"Homme d'arme");
                                            j += 12;
                                            for(i=strlen(chaine)+1;i>j;i--)
                                                chaine[i] = chaine[i-1];    //Dcale la chaine pour crer un espace pour le s
                                            chaine[j] = 's';    //Place le s
                                            strcpy(chaine3,chaine);
                                        }
                                        fprintf(tempfile,"%s",chaine3);   //Inscrit la chaine ventuellement modifie
                                        //Stocke la classe du personnage
                                        Efface_char(chaine3,":");
                                        Efface_char(chaine3," ");    /*Efface le texte avant : */
                                        Efface_n(chaine3);      //Retire le \n
                                        strcpy(perso.classe,chaine3); /*Stocke la valeur lue*/
                                    }
/*Ajout ligne Traits physiques:*/   else if(!strcmp(indic,"Niveau"))
                                    {
                                        if(strstr(chaine,"Traits physiques:") == NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout de la ligne \"Traits physiques:\"\n");
                                            fprintf(tempfile,"Traits physiques:\n");   //Place la ligne
                                            fprintf(tempfile,"%s",chaine);   //Place la chaine lue, correspondant  la race
                                        }
                                        else
                                            fprintf(tempfile,"%s",chaine);   //Sinon copie directe
                                        indic[0] = '.'; //Change indic, le niveau est dpass
                                    }
/*Correction Fminin, Masculin*/    else if(strstr(chaine,"Sexe:") != NULL)
                                    {
                                        if(strstr(chaine,"Feminin") != NULL || strstr(chaine,"Femelle") != NULL || strstr(chaine,"Mle") != NULL || strstr(chaine,"Male") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            if(strstr(chaine,"Feminin") != NULL || strstr(chaine,"Femelle") != NULL)
                                            {
                                                putsacc(".Correction sexe Fminin.\n");
                                                strcpy(chaine2,"Fminin");
                                            }
                                            if(strstr(chaine,"Mle") != NULL || strstr(chaine,"Male") != NULL)
                                            {
                                                putsacc(".Correction sexe Masculin.\n");
                                                strcpy(chaine2,"Masculin");
                                            }
                                            fprintf(tempfile,"Sexe: %s\n",chaine2);
                                            strcpy(perso.sexe,chaine2); /*Stocke la valeur lue*/
                                        }
                                        else
                                            fprintf(tempfile,"%s",chaine);   //Sinon copie directe
                                    }
/*poid->poids*/                     else if(strstr(chaine,"Poid:") != NULL || (strstr(chaine,"Poids:") != NULL && strstr(chaine,"(") == NULL))
/*Ou absence de l'IMC*/             {   //Soit poid, soit poids mais pas d'IMC
/*MAJ poid*/                            if(strstr(chaine,"Poid:") != NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Correction poid->poids.\n");
                                            j = index_ch_first(chaine,"d");
                                            j++;
                                            for(i=strlen(chaine)+1;i>j;i--)
                                                chaine[i] = chaine[i-1];    //Dcale la chaine pour crer un espace pour le s
                                            chaine[j] = 's';    //Place le s
                                        }
/*MAJ IMC*/                             if(strstr(chaine,"(") == NULL)
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout de l'indice de masse corporelle (IMC).\n");
                                            strcpy(chaine2,chaine);
                                            Efface_char(chaine2,":");
                                            Efface_char(chaine2," ");
                                            i = atoi(chaine2);   //Lit le poids du personnage
                                            fgets(chaine2,255,fperso);   //Prend la ligne de la taille
                                            fseek(fperso,-(strlen(chaine2)+1),SEEK_CUR);    //Revient en arrire pour ignorer la ligne, et la relire au prochain tour
                                            Efface_char(chaine2,":");
                                            Efface_char(chaine2," ");
                                            if(strstr(chaine2,",") != NULL)    //Taille en m et non cm, prsence d'une virgule!
                                            {
                                                j = index_ch_first(chaine2,",");
                                                chaine2[j] = '.';   //Remplace la virgule par un .
                                            }
                                            IMCtab[0] = atof(chaine2);  //Lit la taille du personnage
                                            if(strstr(chaine2,".") == NULL)    //Taille en cm
                                                IMCtab[0] = IMCtab[0]/100;  //Taille en mtres au lieu de cm
                                            IMCtab[6] = (i/(IMCtab[0]*IMCtab[0]));    /*IMC = poids/taille au carr. Taille divis par 100 pour avoir en mtre*/
                                            //Recherche des infos sur l'IMC
                                            fichier = ouvre_fichier("..\\..\\Donnes\\Poids_taille_age.ini","r");
                                            while (strstr(chaine2,perso.race) == NULL)
                                            {    /*Recherche la ligne de la race*/
                                                fgets(chaine2,255,fichier);
                                            }
                                            while (strstr(chaine2,perso.sexe) == NULL)
                                            {    /*Recherche la ligne du sexe*/
                                                fgets(chaine2,255,fichier);
                                            }
                                            fgets(chaine2,255,fichier);  //Saute la ligne #classe 1
                                            fgets(chaine2,255,fichier);            /*Saisi la ligne contenant les donnes*/
                                            strcpy(chaine2,strstr(chaine2,"IMC="));
                                            /*Lit les 6 valeur d'IMC*/
                                            Efface_char(chaine2,"=");
                                            IMCtab[0] = atof(chaine2);
                                            for (j=1;j<6;j++)
                                            {
                                                Efface_char(chaine2,",");
                                                IMCtab[j] = atof(chaine2);
                                            }
                                            Efface_n(chaine);      //Retire le \n
                                            if(IMCtab[6] < IMCtab[0])
                                                strcat(chaine," (Dnutrition)\n");
                                            else if(IMCtab[6] < IMCtab[1])
                                                strcat(chaine," (Maigreur)\n");
                                            else if(IMCtab[6] < IMCtab[2])
                                                strcat(chaine," (Corpulence normale)\n");
                                            else if(IMCtab[6] < IMCtab[3])
                                                strcat(chaine," (Surpoids)\n");
                                            else if(IMCtab[6] < IMCtab[4])
                                                strcat(chaine," (Obsit modre)\n");
                                            else if(IMCtab[6] < IMCtab[5])
                                                strcat(chaine," (Obsit svre)\n");
                                            else   /*Suprieur ou gal  perso.bonus_carac[5]*/
                                                strcat(chaine," (Obsit morbide ou massive)\n");
                                            fclose(fichier);
                                        }
                                        fprintf(tempfile,"%s",chaine);   //Replace la chaine modifie
                                    }
/*Catgorie de taille*/             else if(strstr(chaine,"Taille:") != NULL && strstr(chaine,"(") == NULL)
                                    {
                                        maj=1;  //Une mise  jour effectue
                                        putsacc(".Ajout de la catgorie de taille.\n");
                                        Efface_n(chaine);      //Retire le \n
                                        sprintf(chaine2,"..\\..\\Donnes\\Races\\%s.txt", perso.race);
                                        fichier = ouvre_fichier(chaine2,"r");   //Ouvre le fichier de race
                                        for(i=0;i<6;i++)
                                            fgets(chaine2,255,fichier); //Saute les ligne du fichier de race jusqu' la catgorie de taille
                                        Efface_char(chaine2,":"); //Garde seulement la catgorie de taille de la race
                                        Efface_n(chaine2);      //Retire le \n
                                        fprintf(tempfile,"%s (%s)\n", chaine, chaine2);   //Replace la chaine modifie
                                        fclose(fichier);
                                    }
/*Traits physiques*/                else if(!strcmp(indic,"Age"))
                                    {
                                        if(chaine[0] == '>' || (strstr(chaine,"Nez:") != NULL && isdigit(chaine[6])) || strstr(chaine,"Caractristiques:") != NULL)
                                        {   //Soit aucun trait physique, soit ancien traits physiques avec numro, soit affichage direct des carac
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout des traits physiques.\n");
                                            if(strstr(chaine,"Nez:") != NULL && isdigit(chaine[6]))    //Si c'est les anciens traits physiques (3 traits avec numro)
                                            {
                                                for(i=0;i<3;i++)
                                                    fgets(chaine,255,fperso);   //Saute les 3 lignes de l'ancien affichage de traits physiques
                                            }
                                            Trait_physique(tempfile,&perso);
                                            if(strstr(chaine,"Caractristiques:") != NULL)
                                                fprintf(tempfile,">\n");  //Inscrit le > si il n'existe pas
                                            fprintf(tempfile,"%s",chaine);
                                        }
                                        else
                                            fprintf(tempfile,"%s",chaine);   //Sinon copie directe
                                        indic[0] = '.'; //Change indic, les traits physiques sont passs
                                    }
/*Suppression VD*/                  else if(strstr(chaine,"Vitesse de dplacement:") != NULL)
                                    {
                                        maj=1;  //Une mise  jour effectue
                                        putsacc(".Suppression de la vitesse de dplacement.\n");
                                    }
/*Dtails des DV*/                  else if(strstr(chaine,"Points de vie:") != NULL)
                                    {   //Ligne des PV
                                        if(strstr(chaine,"DV=") == NULL)
                                        {   //Si DV= n'est pas trouv, alors pas de dtail des DV
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout des dtails sur les DV.\n");
                                            Efface_n(chaine);      //Retire le \n
                                            strcat(chaine," (DV=0+");   //DV raciaux = 0 (car les DV raciaux ont t ajouts en mme temps que le dtails des DV)
                                            strcat(chaine,inttochar(perso.niveau, chfunc));     //Place le niveau, comme nombre de ds pour DV classe
                                            fichier = ouvre_fichier("..\\..\\Cration de personnages\\Professions.ini","r");
                                            j=0;
                                            while(!feof(fichier))
                                            {   //Vrifie si la classe est une profession
                                                fgets(chaine3,255,fichier);
                                                if(strstr(chaine3,perso.classe) != NULL)
                                                {
                                                    j=1;    //La chaine est trouve dans la liste des professions.
                                                    break;
                                                }
                                            }
                                            if(j==1)
                                                strcpy(chaine2,"..\\..\\Donnes\\Classes populaires\\");
                                            else
                                                strcpy(chaine2,"..\\..\\Donnes\\Classes\\");
                                            strcat(chaine2,perso.classe);
                                            strcat(chaine2,".txt");
                                            fichier = ouvre_fichier(chaine2,"r");   //Ouvre le fichier de classe
                                            do
                                            {   //Recherche la ligne du DV de classe
                                                fgets(chaine2,255,fichier);
                                            }while(strstr(chaine2,"#PV:") == NULL);
                                            Efface_char(chaine2,"d");
                                            strcat(chaine,"d");
                                            strcat(chaine,inttochar(atoi(chaine2), chfunc));    //Affiche le d de vie de classe
                                            fclose(fichier);
                                            strcat(chaine,"+0)\n");   //Bonus au PV racial = 0 (car les DV raciaux ont t ajouts en mme temps que le dtails des DV)
                                            fprintf(tempfile,"%s",chaine);   //Replace la chaine modifie
                                        }
                                        else
                                            fprintf(tempfile,"%s",chaine);   //Sinon copie directe
                                    }
/*XP*/                              else if(!strcmp(indic,"XP"))
                                    {
                                        if(strstr(chaine,"objets magiques  dterminer.") != NULL)
                                        {   //Si c'est la ligne des objets magiques
                                            fprintf(tempfile,"%s",chaine);   //Copie la ligne dans le fichier temp
                                            fgets(chaine,255,fperso);   //Puis prend la ligne suivante
                                        }
                                        if(strstr(chaine,"Points d'exprience:") != NULL)
                                        {
                                            if(chaine[21] == '?')
                                            {   //XP = ?
                                                maj=1;  //Une mise  jour effectue
                                                putsacc(".Remplacement XP ? par XP 0.\n");
                                                chaine[21] = '0';
                                            }
                                            fprintf(tempfile,"%s",chaine);   //Copie la ligne (ventuellement modifie) dans le fichier temp
                                        }
                                        else   //Ligne de l'XP absente!
                                        {
                                            maj=1;  //Une mise  jour effectue
                                            putsacc(".Ajout de l'XP.\n");
                                            fprintf(tempfile,"Points d'exprience: 0\n");
                                            fseek(fperso,-(strlen(chaine)+1),SEEK_CUR);    //Revient en arrire pour ignorer la ligne, et la relire au prochain tour
                                        }
                                        indic[0] = '.'; //Change indic, l'XP est pass
                                    }
/*Modification dans cap spe*/       else if(strstr(indic,"Capsp") != NULL)
                                    {
                                        if(!strcmp(indic,"Capspfin"))
                                            indic[0] = '.'; //Change indic, la fin des capacits spciales est dpasse
                                        if(!strcmp(indic,"Capsp") && chaine[0] == '>')    //Fin des cap spe
                                            strcpy(indic,"Capspfin");    //Indique fin des cap spe
/*Bonus perforation*/                   if(strstr(perso.classe,"Barbare") != NULL || strstr(perso.classe,"Samoura") != NULL || strstr(perso.classe,"Combattant mtamorphe") != NULL || strstr(perso.classe,"Guerrier") != NULL)
                                        {
                                            if(strstr(chaine,"Science du combat"))  //Si il trouve science du combat, pas de MAJ ncessaire
                                                capspe[0] = 1;
                                            if(!strcmp(indic,"Capspfin"))
                                            {  //Fin des capacits spciales atteinte
                                                if(!capspe[0] && perso.niveau > 4)
                                                {   //Si pas trouv science du combat et perso de niveau 5 ou +
                                                    maj=1;  //Une mise  jour effectue
                                                    putsacc(".Ajout de science du combat (bonus perforation).\n");
                                                    fprintf(tempfile,"Science du combat (+%d perforation)\n", (int) floor(perso.niveau/5));
                                                }
                                            }
                                        }
/*Dieu pour paladin*/                   if(strstr(perso.classe,"Paladin") != NULL)
                                        {
                                            if(strstr(chaine,"Dieu:"))  //Si il trouve Dieu:, pas de MAJ ncessaire
                                                capspe[0] = 1;
                                            if(!strcmp(indic,"Capspfin"))
                                            {  //Fin des capacits spciales atteinte
                                                if(!capspe[0])
                                                {   //Si pas trouv Dieu:
                                                    maj=1;  //Une mise  jour effectue
                                                    putsacc(".Ajout du dieu pour paladin.\n");
                                                    strcpy(chaine2,gen_alea("..\\Donnes\\Tables alatoires\\Dieu paladins.tbl",chfunc));   /*Tire le dieu*/
                                                    fprintf(tempfile,"Dieu: %s\n", chaine2);    //Affiche le dieu pour le paladin
                                                }
                                            }
                                        }
/*Dieu pour prtre*/                    if(strstr(perso.classe,"Prtre") != NULL)
                                        {
                                            if(strstr(chaine,"Dieu:"))  //Si il trouve Dieu:, pas de MAJ ncessaire
                                                capspe[0] = 1;
                                            if(!strcmp(indic,"Capspfin"))
                                            {  //Fin des capacits spciales atteinte
                                                if(!capspe[0])
                                                {   //Si pas trouv Dieu:
                                                    maj=1;  //Une mise  jour effectue
                                                    putsacc(".Ajout du dieu pour prtre.\n");
                                                    strcpy(chaine2,gen_alea("..\\Donnes\\Tables alatoires\\Dieu.tbl",chfunc));   /*Tire le dieu*/
                                                    fprintf(tempfile,"Dieu: %s\n", chaine2);    //Affiche le dieu pour le prtre
                                                }
                                            }
                                        }
/*Domaines de sorts pour prtre*/       if(strstr(perso.classe,"Prtre") != NULL)
                                        {
                                            if(strstr(chaine,"Domaines:"))  //Si il trouve Domaines:, pas de MAJ ncessaire
                                                capspe[1] = 1;
                                            if(!strcmp(indic,"Capspfin"))
                                            {  //Fin des capacits spciales atteinte
                                                if(!capspe[1])
                                                {   //Si pas trouv Domaines:
                                                    maj=1;  //Une mise  jour effectue
                                                    putsacc(".Ajout des domaines pour le prtre.\n");
                                                    //Si un fichier de sorts existe dj, lit les domaines qui y sont nots
                                                    strcpy(chaine2,chemin);
                                                    i=0;j=0;
                                                    while(i != (int)strlen(chaine2))
                                                    {
                                                        if(chaine2[i++] == '\\')
                                                            j = i;    //Localise la fin du chemin du fichier
                                                    }
                                                    chaine2[j] = '\0';   //Termine la chaine juste aprs le dernier \, pour isoler le chemin seulement
                                                    strcat(chaine2,perso.nom);
                                                    strcat(chaine2," sorts.txt");
                                                    j=0;    //Par dfaut, fichier inexistant
                                                    if((fichier = fopen(chaine2,"r")) != NULL)
                                                    {   //Fichier de sort existant et ouvert
                                                        fgets(chaine2,255,fichier);
                                                        if(strstr(chaine2,"Domaine de sorts:") != NULL)
                                                        {   //Si domaine de sorts trouv, lecture des 2 domaines
                                                            j=1;    //Les domaines seront lus dans le fichier de sorts
                                                            putsacc("..Lecture des domaines dans le fichier de sorts du personnage.\n");
                                                            for(i=0;i<2;i++)
                                                            {   //Boucle sur les 2 domaines
                                                                Efface_char(chaine2,"#");
                                                                if(i==0)
                                                                {   //Isole le 1er domaine
                                                                    strcpy(chaine3,chaine2);
                                                                    k=0;
                                                                    while(chaine3[k++] != ',');
                                                                    chaine3[k-1] = '\0'; //Coupe la chaine  la virgule aprs le 1er domaine
                                                                }
                                                                else
                                                                {   //Isole le 2e domaine
                                                                    strcat(chaine3," (,");   //Spare les 2 domaines par une virgule et ajoute " (" pour le strstr dans domaines.ini
                                                                    strcat(chaine3,chaine2);
                                                                    Efface_n(chaine);      //Retire le \n
                                                                    strcat(chaine3," (");   //Ajoute " (" pour le strstr dans domaines.ini
                                                                }
                                                            }
                                                            fclose(fichier);
                                                            fichier = ouvre_fichier("..\\..\\Donnes\\Domaines de sorts\\Domaines.ini","r");
                                                            for(i=0;i<2;i++)
                                                            {   //Boucle sur les 2 domaines
                                                                rewind(fichier);
                                                                if(i==0)    //1er domaine
                                                                {
                                                                    k=0;
                                                                    while(chaine3[k++] != ','); //Cherche la sparation des 2 domaines
                                                                    chaine3[k-1] = '\0';    //Termine la chaine  la virgule pour isoler le 1er domaine
                                                                }
                                                                else    //2e domaine
                                                                {
                                                                    chaine3[strlen(chaine3)] = ','; //Replace la virgule entre les 2 domaines
                                                                    Efface_char(chaine3,",");   //Isole le 2e domaine
                                                                }
                                                                do
                                                                {
                                                                    if(fgets(chaine2,255,fichier) == NULL)
                                                                    {
                                                                        maj=0;
                                                                        fprintf(logerreur,"Erreur dans %s, domaine %s impossible a trouver.\n", chemin,chaine3);
                                                                        printf("!!!Erreur, impossible de trouver le domaine %s\n", acc(chaine3,chfunc));
                                                                        break;
                                                                    }
                                                                }while(strstr(chaine2,chaine3) == NULL);
                                                                if(maj) //Si pas d'erreur
                                                                {
                                                                    if(i==0)
                                                                        fprintf(tempfile,"Domaines: %s",chaine2);
                                                                    else
                                                                        fprintf(tempfile,"%s",chaine2);
                                                                }
                                                            }
                                                            fclose(fichier);

                                                        }
                                                    }
                                                    if(!j)  //Si fichier inexistant ou infos non prsentes
                                                    {
                                                        putsacc("..Dtermination des domaines de sorts.\n");
                                                        fichier = ouvre_fichier(chemin,"r");    //Ouvre une seconde fois la feuille de perso
                                                        while(!feof(fichier))
                                                        {
                                                            fgets(chaine2,255,fichier);
                                                            if(strstr(chaine2,"Dieu:"))
                                                            {   //La feuille de perso a un dieu
                                                                j=1;
                                                                break;
                                                            }
                                                        }
                                                        fclose(fichier);
                                                        if(!j)   //Si la feuille de perso n'avait pas de dieu
                                                        {
                                                            fclose(tempfile);
                                                            fichier = ouvre_fichier("temp.tmp","r");    //Rouvre le fichier temp pour lire le dieu
                                                            while(!feof(fichier))
                                                            {
                                                                fgets(chaine2,255,fichier);
                                                                if(strstr(chaine2,"Dieu:"))   //Dieu trouv
                                                                    break;
                                                            }
                                                            fclose(fichier);
                                                            tempfile = ouvre_fichier("temp.tmp","a+");  //Rouvre le fichier temp pour continuer son criture
                                                        }
                                                        Efface_char(chaine2," ");   //Efface dieu:
                                                        j=index_ch_first(chaine2,",");
                                                        chaine2[j] = '\0';  //Termine la chaine  la premire virgule pour garder seulement le nom du dieu
                                                        /*Tirer les 2 domaines*/
                                                        sprintf(chaine3,"..\\Donnes\\Domaines de sorts\\%s.tbl", chaine2);
                                                        gen_alea(chaine3,chaine2);   /*Tire le 1er domaine (stock dans chaine2)*/
                                                        do
                                                        {
                                                            gen_alea(chaine3,chfunc);   /*Tire le 2e domaine (stock temporairement dans chfunc)*/
                                                        }while(!strcmp(chaine2,chfunc));  /*Retire tant que les 2 domaines sont identiques*/
                                                        Efface_char(chaine2,":");
                                                        Efface_char(chfunc,":");
                                                        fprintf(tempfile,"Domaines: %s\n",chaine2);
                                                        fprintf(tempfile,"%s\n",chfunc);
                                                    }
                                                }
                                            }
                                        }
                                        fprintf(tempfile,"%s",chaine);   //Affiche la ligne
                                    }
                                    else    //Si aucune condition remplie au pralable
                                    {
                                        if(strstr(chaine,"Niveau:") != NULL)    //Ligne du niveau
                                            strcpy(indic,"Niveau");    //Indique niveau lu
                                        if(strstr(chaine,"Age:") != NULL)    //Ligne de l'ge
                                            strcpy(indic,"Age");    //Indique age lu
                                        //Identification de la ligne de l'XP
                                        if(strstr(chaine,"Comptences:") != NULL)    //Ligne des comptences
                                            strcpy(indic,"Comp");    //Indique comptences
                                        if(!strcmp(indic,"Comp") && strstr(chaine,">") != NULL)    //Fin des comptences
                                            strcpy(indic,"XP");    //Indique comptences lues et emplacement de l'XP
                                        //Fin d'identification de la ligne de l'XP
                                        if(strstr(chaine,"Capacits spciales:") != NULL)    //Ligne des cap spe
                                            strcpy(indic,"Capsp");    //Indique cap spe
                                        if(strstr(chaine,"#Equipements:") != NULL)    //Ligne des cap spe
                                            strcpy(indic,"Equip");    //Indique cap spe
                                        fprintf(tempfile,"%s",chaine);  //Copie directement la ligne dans le fichier temp
                                    }
                                    if(!strcmp(indic,"dbut"))  //Si indic vaut dbut, donc premire ligne
                                        indic[0] = '.'; //Change indic, la premire ligne tant lue
                                }
                            }
                            fclose(tempfile);
                            fclose(fperso);
                            if(maj) //Si maj=1, une mise a t effectue
                            {
                                putsacc(".Recriture du fichier txtp\n");
                                tempfile = ouvre_fichier("temp.tmp","r");
                                fperso = ouvre_fichier(chemin,"w");   //recriture du txtp
                                while(!feof(tempfile))
                                {
                                    if(fgets(chaine,255,tempfile)) /*Evite de rpter la dernire ligne*/
                                        fprintf(fperso,"%s",chaine);   //Recopie le temp dans le txtp (faute de trouver une fonction de dplacement de fichier portable!)
                                }
                                fclose(tempfile);
                                fclose(fperso);
                                strcpy(chaine,chemin);
                                chaine[strlen(chaine)-4] = '\0';    //Coupe txtp
                                strcat(chaine,"html");  //Et remplace par html, pour vrifier la prsence d'une feuille html
                                if((fichier = fopen(chaine,"r")) != NULL)
                                {   //Fichier html existant
                                    putsacc(".Recriture du fichier html\n");
                                    fclose(fichier);
                                    #ifdef WIN32    /*win*/
                                        sprintf(chaine,"cd \"..\\Convert txthtml\" && \"Convert txthtml.exe\" Perso=\"%s\" Affichage=3", chemin);
                                    #else /*linux*/
                                        sprintf(chaine,"cd \"../Convert txthtml\" && \"./Convert txthtml\" Perso=\"%s\" Affichage=3", chemin);
                                    #endif
                                    system(chaine);     //Effectue la conversion txtp->html
                                    fichier = ouvre_fichier("..\\Convert txthtml\\Erreurs.log","r");
                                    while(!feof(fichier))
                                    {   //Copie les erreurs du programme dans le log de MAJ perso
                                        if(fgets(chaine,255,fichier)) /*Evite de rpter la dernire ligne*/
                                        {
                                            putsacc(chaine);
                                            fprintf(logerreur,"%s",chaine);
                                        }
                                    }
                                    fclose(fichier);
                                }
                                strcpy(chaine,chemin);
                                i=0;
                                while(i != (int)strlen(chaine))
                                {
                                    if(chaine[i++] == '\\')
                                        j = i;    //Localise la fin du chemin du fichier
                                }
                                chaine[j] = '\0';   //Termine la chaine juste aprs le dernier \, pour isoler le chemin seulement
                                strcat(chaine,perso.nom);
                                strcat(chaine," sorts.txt");
                                if((fichier = fopen(chaine,"r")) != NULL)
                                {   //Fichier de sort existant
                                    putsacc(".Mise  jour du fichier de sort\n");
                                    fclose(fichier);
                                    #ifdef WIN32    /*win*/
                                        sprintf(chaine,"cd \"..\\MAJ sorts\" && \"MAJ_sorts.exe\" perso=\"%s\" Affichage=3", chemin);
                                    #else /*linux*/
                                        sprintf(chaine,"cd \"../MAJ sorts\" && \"./MAJ_sorts\" perso=\"%s\" Affichage=3", chemin);
                                    #endif
                                    system(chaine);     //Effectue la mise  jour de la liste de sorts
                                    fichier = ouvre_fichier("..\\MAJ sorts\\Erreurs.log","r");
                                    while(!feof(fichier))
                                    {   //Copie les erreurs du programme dans le log de MAJ perso
                                        if(fgets(chaine,255,fichier)) /*Evite de rpter la dernire ligne*/
                                        {
                                            putsacc(chaine);
                                            fprintf(logerreur,"%s",chaine);
                                        }
                                    }
                                    fclose(fichier);
                                }
                            }
                            fichier = ouvre_fichier("Couleurs.ini","r+");
                            fseek(fichier,6,0);  /*Dplace le curseur */
                            fprintf(fichier,"%daaaaa",nbligne);          /* et incrmente le nombre de perso cres*/
                            fclose(fichier);
                        }
                    }
                    fclose(logerreur);
                    fclose(liste);
                    putsacc("\nMise  jour acheve.\n\n");
                    fichier = ouvre_fichier("Couleurs.ini","r+");
                    fprintf(fichier,"Liste:0aaaaaaaaa");
                    fclose(fichier);

                    break;
                default:
                    choix = 0;
            }
        }
    }while(1);
    return 0;
}

void Trait_physique (FILE* Fichier_txt, struct info_perso *donnees)
{
    FILE* fichiertable;     /*Pointe le mme fichier, mais sert  utiliser les tables alatoires*/
    FILE* Trait_physiques;  /*Pointe le mme fichier, mais sert aux lignes des diffrents traits physiques*/
    char chaine[255];
    char Trait[255];
    int index, alea, compt0, cpt0;    /*Pour gen alea*/
    sprintf(chaine,"..\\..\\Donnes\\Traits physiques\\Trait physiques %s %s.tbl", donnees->race, donnees->sexe);
    fichiertable = ouvre_fichier(chaine,"r");
    Trait_physiques = ouvre_fichier(chaine,"r");
    fgets(Trait,255,Trait_physiques);    /*Saisi le premier trait physique*/
    do
    {
        Trait[0] = '#';    /*Remplace le '_' par un '#' pour la recherche des tables*/
        Efface_n(Trait);      //Retire le \n
        rewind(fichiertable);
        fgets(chaine,255,fichiertable);
        while (strcmp(chaine,Trait))    /*Repre la table du trait physique slectionn*/
        {
            fgets(chaine,255,fichiertable);
            if (chaine[0] == '#')
                Efface_n(chaine);      //Retire le \n
        }
        /*Gen alea modifi*/
        index=-1;
        compt0=0;
        fgets(chaine,255,fichiertable);
        alea = jet_de_des_gen_alea(&index,chaine);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            compt0++;
            while (verif_val_gen_alea (&index, chaine, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(chaine,255,fichiertable);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (chaine[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            compt0++;
            alea = jet_de_des_gen_alea(&index,chaine); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        strcpy(chaine,string_gen_alea (index,chaine));   /*Isole la chaine de caractre*/
        Trait[0] = ' ';    /*Remplace le '#' par un espace*/
        fprintf(Fichier_txt,"%s: ", Trait);
        fprintf(Fichier_txt,"%s.\n", chaine);
        fgets(Trait,255,Trait_physiques);    /*Saisi le trait physique suivant*/
    }while(Trait[0] != '.');
    fclose(fichiertable);
    fclose(Trait_physiques);
}

int verif_val_gen_alea (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int jet_de_des_gen_alea (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[++*index] == 'd'))      /*Si un d doit tre lanc*/
    {
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

char* string_gen_alea (int index, char* ligne)
{
    int i=0;
    char string[255];
    strcpy(string,ligne);
    while (index < (int)strlen(string))    /*Copie ce qui doit tre renvoy dans "string"*/
        ligne[i++] = string[index++];
    ligne[i-1] = '\0';
    return ligne;
}

char* gen_alea (const char* nomfichier, char* ligne)
{
    FILE* temp;
    #ifdef WIN32    /*win*/
        sprintf(ligne,"cd \"..\\..\\Gnrateur alatoire\" && Gnrateur_alatoire.exe Table=\"%s\" Nombre=1 Affichage=3", nomfichier);
    #else /*linux*/
        sprintf(ligne,"cd \"../../Gnrateur alatoire\" && ./Gnrateur_alatoire Table=\"%s\" Nombre=1 Affichage=3", nomfichier);
    #endif
    system(ligne); /*Appel le gnrateur alatoire en ligne de commande*/
    temp = ouvre_fichier("..\\..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
    do
    {
        fgets(ligne,255,temp);  /*Lit le rsultat du gnrateur alatoire*/
    }while(ligne[0] == '#');    //Saute les titres
    Efface_n(ligne);      //Retire le \n
    fclose(temp);
    return ligne;
}
