/* Programme de mise  jour des listes de sorts.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include "Utilitaire.h"
#include "Jdr.h"
#include "Chaines.h"

int main (int argc,char *argv[])
{
    FILE* source;
    FILE* cible;
    FILE* sorts;
    FILE* logerreur;
    struct info_perso perso;
    char feuille_perso[255];
    char fichier_sorts[255];
    char chaine [255];
    char chaine2 [255];
    char temp [255];
    int i,j, fin=0, space, lignes=0, lignes_vierge, val, erreur=0;
    affichage_arg = 1;  //Affichage complet par defaut
    if(argc == 3)
    {
        Efface_char(argv[2],"=");
        affichage_arg = atoi(argv[2]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\..\\Phrases de jdr.txt");
        #endif
        Titre (argc,argv,"MAJ sorts","Programme de mise  jour des listes de sorts pour Donjons et dragons",color_sd("MAJ sorts",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\..\\Phrases de jdr.txt");
        #endif
    }
    if(argc>1)   /*Arguments*/
    {
        if(argc != 3 && argc != 2)  //Si l'argument d'affichage n'est pas prsent, il sera ignor et considr par dfaut  1
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de MAJ_sorts.exe, nombre d'arguments incorrect !");
            Pause();
            exit(1);
        }
        Efface_char(argv[1],"=");
        strcpy(feuille_perso,argv[1]); /*Prend le nom de la feuille de perso, en 1er argument*/
    }
    if(argc==1)
    {   /*Si pas d'argument*/
        putsacc("\nDonner le chemin et nom de la feuille de perso du personnage concern (.txtp):\nSi la feuille de perso est au format html, utiliser le convertisseur html->txtp prsent dans le dossier Utilitaires.\n?: ");
        getsfix(feuille_perso,255);
    }
    scan_feuille_perso(feuille_perso,&perso);
    i=0;
    while(perso.classe[i++] != ',');
    perso.classe[i-1] = '\0';
    sprintf(fichier_sorts,"..\\..\\Donnes\\Sorts\\%s\\Sorts de niv.0.txt", perso.classe);   //Construit le chemin des fichiers de sorts
    sprintf(feuille_perso,"%s%s sorts.txt", perso.chemin, perso.nom); //Construit le nom du fichier source
    source = ouvre_fichier(feuille_perso,"r");
    cible = ouvre_fichier("temp.tmp","w");
    do
    {   //Cherche le premier niveau de sort dans le fichier source
        fgets(chaine,255,source);
        fprintf(cible,"%s",chaine);
    }while(chaine[0] != '>');
    logerreur = ouvre_fichier("Erreurs.log","w");
    for(i=0;i<10;i++)    //Bcl sur les 10 niveaux de sorts
    {
        Efface_char(chaine,"u");    //Efface jusqu'au u de niveau
        Efface_char(chaine," ");
        i = atoi(chaine);   //i prend directement le premier niveau de sort de la feuille (afin d'viter les erreurs du niveau 0 inexistant)
        lignes++;
        fichier_sorts[strlen(fichier_sorts)-5] = i+48;    //Incrmente le nom du fichier de sorts
        sorts = ouvre_fichier(fichier_sorts,"r");
        fgets(chaine,255,source);
        while(chaine[0] != '>') //Lit les sorts jusqu'au prochain niveau de sorts
        {
            lignes++;
            if(strlen(chaine) > 1)
            {   //Si il y a un sort sur cette ligne
                space=0;val=0;
                while(chaine[0] == ' ' || isdigit(chaine[0])) //Tant que la ligne commence par un espace, un numro (utilis pour indiquer les sorts en mmoire)
                {
                    if(chaine[0] == ' ')
                    {
                        Efface_char(chaine," ");    //Supprime l'espace
                        space++;    //Compte le nombre d'espace
                    }
                    else
                    {
                        val = atoi(chaine);
                        while(isdigit(chaine[0]))
                        {
                            for(j=0;j<(int)strlen(chaine);j++)
                                chaine[j] = chaine[j+1]; //Efface les chiffres
                        }
                    }
                }
                if(chaine[0] != '(')
                    chaine[index_ch_first(chaine,"(")] = '\0';  //Supprime tout aprs la premire parenthse
                else    //Si le sort commence par une parenthse
                {
                    chaine[0] = '*';    //Change la parenthse en *
                    chaine[index_ch_first(chaine,"(")] = '\0';  //Supprime tout aprs la premire parenthse
                    chaine[0] = '(';    //Replace la parenthse
                }
                rewind(sorts);
                do
                {
                    if(fgets(chaine2,255,sorts) == NULL)
                    {   //Prend le sort suivant dans la liste et vrifie la fin de fichier
                        fin=1;
                        break;
                    }
                    if(strlen(chaine2) == 1)
                    {   //Prend le sort suivant dans la liste et vrifie la fin de liste
                        fin=1;
                        break;
                    }
                    if(chaine2[0] == '>')
                        continue;   //Ignore la ligne
                    Efface_char(chaine2,":");
                    strcpy(temp,chaine2);
                    if(temp[0] != '(')
                        temp[index_ch_first(temp,"(")] = '\0';  //Supprime tout aprs la premire parenthse
                    else    //Si le sort commence par une parenthse
                    {
                        temp[0] = '*';    //Change la parenthse en *
                        temp[index_ch_first(temp,"(")] = '\0';  //Supprime tout aprs la premire parenthse
                        temp[0] = '(';    //Replace la parenthse
                    }
                }while(strcmp(temp,chaine) != 0); //Bcl tant qu'il ne trouve pas le sort
                if(fin==1)
                {
                    fin=0;
                    fprintf(logerreur,"!!!Erreur dans le fichier %s, impossible de trouver le sorts correspondant  %s\n",feuille_perso,chaine);
                    if(affichage_arg < 3)
                    {
                        printf("!!!Erreur dans le fichier ");
                        putsacc(feuille_perso);
                        putsacc(", impossible de trouver le sorts correspondant  ");
                        putsacc(chaine);
                        puts("");
                        Pause();
                    }
                    erreur=1;
                    if(fgets(chaine,255,source) == NULL)
                    {   //Prend le sort suivant et vrifie la fin de fichier
                        fin=1;
                        break;
                    }
                    continue;  //Passe direct au sort suivant
                }
                if(val) //Si valeur numrique avant sort
                    fprintf(cible,"%d",val);
                for(;space>0;space--)
                    fprintf(cible," ");
                while(strstr(chaine2,"#!."))    //Gestion des composantes coteuse
                {
                    strcpy(temp,strstr(chaine2,"#!."));  //Copie la ligne et la tronque
                    chaine2[index_ch_first(chaine2,"#")] = '\0';   //Efface les composantes
                    Efface_char(temp,".");
                    space=1;  //Par dfaut, composante matrielle M
                    if(temp[0] == 'F')
                        space=2; //Composante de type focaliseur F
                    Efface_char(temp,".");
                    Efface_char(temp,".");
                    if(space==1)
                        strcat(chaine2,"M=");
                    else
                        strcat(chaine2,"F=");
                    strcat(chaine2,temp);
                }
                fprintf(cible,"%s",chaine2);
                lignes_vierge=0;
            }
            else
            {
                fprintf(cible,"\n");
                lignes_vierge++;
            }
            if(fgets(chaine,255,source) == NULL)
            {   //Prend le sort suivant et vrifie la fin de fichier
                fin=1;
                break;
            }
        }
        if(fin == 1)
        {
            fclose(sorts);
            break;
        }
        else
            fprintf(cible,"%s",chaine);
        fclose(sorts);
    }
    fclose(logerreur);
    fclose(source);
    fclose(cible);
    if(!erreur)
    {   //Change la liste de sort uniquement si il n'y a pas d'erreur
        lignes_vierge++;
        lignes++;
        source = ouvre_fichier("temp.tmp","r");
        cible = ouvre_fichier(feuille_perso,"w");
        for(;lignes!=lignes_vierge-1;lignes--)
        {   //Copie la liste de sorts dans le fichier d'origine, et supprime les lignes vierges en trop  la fin du fichier
            if(fgets(chaine,255,source) != NULL)    //Evite de rpter la dernire ligne
                fprintf(cible,"%s",chaine);
        }
        fclose(source);
        fclose(cible);
    }
    if(affichage_arg < 3)
    {
        if(erreur)
            putsacc("\nLa mise  jour a rencontre des erreurs, corriger le fichier d'origine.");
        else
            putsacc("\nMise  jour termine.");
    }
    if(argc==1)   /*Si pas d'argument*/
        Pause();
    return 0;
}
