/* Programme de test de tables alatoires.
Programm par Maniack Crudelis.
http://www.crudelis.rf.lv
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include "Utilitaire.h"
#include "Fichier.h"
#include "Rand.h"
#include "Jdr.h"

int moteur_principal (FILE* fichiertable);   /*Moteur de parcours de la table*/

int main (int argc,char *argv[])
{
    FILE* fichiertable;
    char* nomfichier=NULL;
    int erreur;
    Init_srand();
    init_historique_saisie();
    Titre(argc,argv,"Testeur de tables alatoires","Programme de test de tables alatoires","F8");
    if(argc==1)
    {   /*Le programme n'a pas en argument le nom du fichier, lancement du programme seul*/
        putsacc("Entrez le nom complet de la table alatoire  vrifier\n?: ");
        nomfichier = getsdyn(nomfichier);
    }
    else
    {   /*Le programme est lanc avec l'argument (clic droit)*/
        ER = (int) (nomfichier = (char*) calloc(strlen(argv[1])*2,sizeof(char)));
        Erreur(1);
        strcpy(nomfichier,argv[1]);
    }
    fichiertable = ouvre_fichier(nomfichier,"r");
    puts("Test de la table en cours.");
    erreur = moteur_principal(fichiertable);
    fclose(fichiertable);
    if (erreur != 2)
        putsacc("La table alatoire ne contient aucune erreur.\n");
    free(nomfichier);
    Pause();
    return 0;
}

int moteur_principal (FILE* fichiertable)
{
    char ligne[255];
    char ligne2[255];
    int type_table=1; /*1:Table classique, 2:Table de trait physique, 3:Table d'objets magiques, 4:Table de gemmes, 5:Table de rencontres*/
    int des[100], valeur_test[100], indic_test=0, nb_ligne=1, i, j, fin=0;
    fgets(ligne,255,fichiertable);    /*Prend la premire ligne*/
    strcpy(ligne2,ligne);
    if(ligne[0] == '_')
        type_table = 2;  /*Table de trait physique*/
    else if(ligne[0] == 'p' && ligne[1] == 'p')
        type_table = 3;  /*Table d'objets magiques*/
    else if(ligne[0] == '#')
        type_table = 4;  /*Table de gemmes*/
    else if(ligne[0] == '%')
    {
        type_table = 5;  /*Table de rencontres*/
        fgets(ligne,255,fichiertable);   /*Saute la ligne du %*/
        nb_ligne++;
    }
    do
    {
        indic_test=0;
        if(type_table == 2 || type_table == 4)
        {  /*Table de trait physique ou table de gemmes*/
            while(ligne[0] != '#')
            {  /*Recherche la table alatoire suivante*/
                if(fgets(ligne,255,fichiertable) == NULL)
                {   /*Si fin de fichier*/
                    fin = 1;
                    break;
                }
                nb_ligne++;
            }
            if (fin == 1)
                break; /*Si fin de fichier, quitte la boucle gnrale*/
            fgets(ligne,255,fichiertable);  /*Prend la ligne suivante, dbut de la table*/
            strcpy(ligne2,ligne);
        }
        if(type_table == 3)
        {  /*Table d'objets magiques*/
            while(ligne[0] != 'p' || ligne[1] != 'p')
            {  /*Recherche la table alatoire suivante*/
                if(fgets(ligne,255,fichiertable) == NULL)
                {   /*Si fin de fichier*/
                    fin = 1;
                    break;
                }
                nb_ligne++;
            }
            if (fin == 1)
                break; /*Si fin de fichier, quitte la boucle gnrale*/
            strcpy(ligne2,ligne);
            Efface_char(ligne,":"); /*Efface pp et les :*/
        }
        Efface_char(ligne,"dd");    /*Efface dd*/
        des[indic_test] = atoi(ligne);    /*Prend la valeur du d*/
        valeur_test[indic_test]=1;
        Efface_char(ligne,":");
        do
        {
//printf(ligne);
//printf("des:%d\nindic_test:%d\nnb_ligne:%d\nvaleur_test=%d\n",des[indic_test], indic_test,nb_ligne, valeur_test[indic_test]);
            while(ligne[0] == '0')    /*Saute les 0*/
            {
                if(ligne[1] == ':')
                    Efface_char(ligne,":"); //Ancienne norme :0
                else
                    Efface_char(ligne,"."); //Nouvelle norme .0
            }
            if (valeur_test[indic_test] != atoi(ligne))
            {    /*Si la valeur n'est pas bonne*/
                putsacc("Erreur  ");
                printf("la ligne %d (valeur incorrecte)\n", nb_ligne);    /*Signale une erreur*/
                putsacc(ligne2);        /*Affiche la ligne complte*/
                fin = 2;
                break;
            }
            for(i=0;i<(int)strlen(ligne);i++)
            {    /*Vrifie la prsence de -*/
                if(isdigit(ligne[0]))  /*Si le caractre est un chiffre*/
                {
                    for(j=0;j<(int)strlen(ligne);j++)
                        ligne[j] = ligne[j+1];  /*Efface le chiffre*/
                }
                else if (ligne[0] == '-')  /*Si le caractre est un -*/
                {
                    Efface_char(ligne,"-");
                    valeur_test[indic_test] = atoi(ligne);   /*Prend la seconde valeur*/
                    break;
                }
                else if (ligne[0] == ':')  /*Si le caractre est un :*/
                    break;
            }
            valeur_test[indic_test]++;    /*Incrmente la valeur test*/
            Efface_char(ligne,":");
            if (ligne[0] == '#' || ligne[0] == '>')  /*Si il y  un commentaire dans la table*/
            {
                if (ligne[1] != ' ')
                {    /*Si il manque l'espace*/
                    putsacc("Erreur  ");
                    printf("la ligne %d (Espace manquant aprs mot cl)\n", nb_ligne);    /*Signale une erreur*/
                    putsacc(ligne2);        /*Affiche la ligne complte*/
                    fin = 2;
                    break;
                }
                fgets(ligne,255,fichiertable);    /*Prend la ligne suivante*/
                strcpy(ligne2,ligne);
                nb_ligne++;  /*Incrmente le numro de ligne*/
                while(ligne[0] == '0')    /*Saute les 0*/
                    Efface_char(ligne,":");
            }
            if (ligne[0] == 't' && ligne[1] == 't' && ligne[2] != '0')  //Mot cl tt ou tt+
            {
                if (ligne[0] == 't' && ligne[1] == 't' && ligne[2] == '+' && ligne[3] != ' ')
                {    /*Si il manque l'espace*/
                    putsacc("Erreur  ");
                    printf("la ligne %d (Espace manquant aprs mot cl tt+)\n", nb_ligne);    /*Signale une erreur*/
                    putsacc(ligne2);        /*Affiche la ligne complte*/
                    fin = 2;
                    break;
                }
                if (ligne[0] == 't' && ligne[1] == 't' && ligne[2] != '+' && ligne[2] != ' ')
                {    /*Si il manque l'espace*/
                    putsacc("Erreur  ");
                    printf("la ligne %d (Espace manquant aprs mot cl tt)\n", nb_ligne);    /*Signale une erreur*/
                    putsacc(ligne2);        /*Affiche la ligne complte*/
                    fin = 2;
                    break;
                }
            }
            if (ligne[0] == 'd' && ligne[1] == 'd')    /*Si il y  un nouveau d  lancer*/
            {
                indic_test++; /*Incrmente l'arborescence*/
                Efface_char(ligne,"dd");    /*Efface dd*/
                des[indic_test] = atoi(ligne);    /*Prend la valeur du d*/
                valeur_test[indic_test]=1;
                Efface_char(ligne,":");
            }
            else    /*Si aucun d n'est relanc*/
            {
                fgets(ligne,255,fichiertable);    /*Prend la ligne suivante*/
                strcpy(ligne2,ligne);
                nb_ligne++;  /*Incrmente le numro de ligne*/
            }
            while(valeur_test[indic_test] > des[indic_test])   /*Si toutes les valeurs du ds sont effectues*/
                indic_test--;
        }while(indic_test >= 0);   /*Boucle gnrale termine*/
        if (fin != 2)
        {
            if (type_table == 1 || type_table == 5)
                fin = 1;
        }
    }while(!fin);
    return fin;
}
